import React, { Component} from 'react';
import { connect } from 'dva';
import PropTypes from 'prop-types';
import {Spin,Modal,Button } from 'antd';
import { Table } from 'fl-pro';
import './less/index.less';
import SearchForm from '../SearchForm';
import Config from './config';
class ComModal extends Component {
    // 声明类型
    static propTypes = {
        // closeModal:PropTypes.func,
        // submitData:PropTypes.func.isRequired,
        getFormValue:PropTypes.func.isRequired,
    }
    constructor(props) {
        super(props);
        this.state = {
            selectedRowKeys:[],
            selectData:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            condition:[]
        }
    }

    componentDidMount(){
        // if(this.props.params&&this.props.params.tableData&&this.props.params.tableData.checkList&&this.props.params.tableData.checkList.length>0){
        //     this.setState({
        //         selectedRowKeys:this.props.params.tableData.checkList.map((item)=>{
        //             return item.memberId
        //         }),
        //         selectData:this.props.params.tableData.checkList
        //     })
        // }
    }

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },()=>{
            this.props.getFormValue(values,this.state.postData,true)
        });
    }

    // 列表查询
    searchFun  = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },()=>{
            this.props.getFormValue(condition,postData,true)
        });
    }

    // 分页查询
    searchPagination= (postData)=> {
        const {condition} = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.props.getFormValue(condition,postData,true)
        });
    }

    // 获取查询表单数据
    getFormData=(params)=>{
        this.setState({
          condition: params,
        },()=>{
            this.props.getFormValue(params,this.state.postData,false)
        })
    }

    renderTable=(tableConfig)=>{
        const { dataResource } = this.props;
        const { selectedRowKeys,postData } = this.state;
        const { rowKey,columns,scroll} = tableConfig.defaultConfig;
        const { showPagination,paginationConfig,type } = tableConfig
        const pagination = {
            ...paginationConfig,
            total:dataResource.total,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination(postData);
                })
            },
            onChange: (current) => {
                postData.PageIndex=current;
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination(postData);
                })
               
            },
        };
        const rowSelection = {
            selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectData:selectedRows,
                    selectedRowKeys
                })
            },
            getCheckboxProps: record => ({
            //   disabled: record.name === 'Disabled User',
            //   name: record.name,
            }),
        };
        switch (type){
            case 0:
            return <Table 
                rowKey={rowKey}
                columns={columns}
                dataSource={dataResource&&dataResource.dataSource?dataResource.dataSource:[]}
                scroll={scroll?scroll:null}
                pagination={showPagination?pagination:false}
            />
            case 1:
                return <Table 
                    rowSelection={{
                        type: "checkbox",
                        ...rowSelection,
                    }}
                    rowKey={rowKey}
                    columns={columns}
                    dataSource={dataResource&&dataResource.dataSource?dataResource.dataSource:[]}
                    scroll={scroll?scroll:null}
                    pagination={showPagination?pagination:false}
                />

            case 2:
                return <Table 
                    rowSelection={{
                        type: "radio",
                        ...rowSelection,
                    }}
                    rowKey={rowKey}
                    columns={columns}
                    dataSource={dataResource&&dataResource.dataSource?dataResource.dataSource:[]}
                    scroll={scroll?scroll:null}
                    pagination={showPagination?pagination:false}
                /> 
            default:
                return <Table 
                rowKey={rowKey}
                columns={columns}
                dataSource={dataResource&&dataResource.dataSource?dataResource.dataSource:[]}
                scroll={scroll?scroll:null}
                pagination={showPagination?pagination:false}
            />
        }
    }




    render() {
        const {loading} = this.props;
        const { modalConfig,formConfig,tableConfig } = Config[this.props.name]
        const {selectData,selectedRowKeys} = this.state;
        return(
            <div>
                <Modal
                    className="CommonModal"
                    width={modalConfig&&modalConfig.width}
                    zIndex={modalConfig&&modalConfig.zIndex}
                    title={modalConfig&&modalConfig.title}
                    okText={modalConfig&&modalConfig.okText}
                    cancelText={modalConfig&&modalConfig.cancelText}
                    visible={true}
                    onCancel={this.props.closeModal}
                    footer={
                    <div>
                        {modalConfig.showCancelBtn?<Button key="back" onClick={this.props.closeModal}>
                            {modalConfig&&modalConfig.cancelText}
                        </Button>:''}
                        {modalConfig.showOkBtn?<Button key="submit" type="primary" onClick={
                             ()=>{
                                if(selectData&&selectedRowKeys&&this.props.submitData){
                                    this.props.submitData(selectData,selectedRowKeys)
                                }
                            }
                        }>
                            {modalConfig&&modalConfig.okText}
                        </Button>:''}
                    </div>
                    }
                >
                    {
                        formConfig.FormName?<SearchForm 
                        name={formConfig.FormName}
                        init={this.init}
                        search = {this.searchFun}
                        getFormData={this.getFormData}
                    />:''}
                    <Spin spinning={loading.effects[tableConfig&&tableConfig.url]}>
                        {this.renderTable(tableConfig)}
                    </Spin>
                </Modal>
            </div>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(ComModal);


