# 公共Modal组件 带表格及查询表单的弹窗组件
## default 组件默认的配置key(唯一标识)
|参数                   |类型                |说明                        |
|----------------------|--------------------|----------------------------|
|modalConfig                   |object              |modal的属性          |
|modalConfig.width             |string              |modal宽度            |
|modalConfig.zIndex            |number              |modal层级            |
|modalConfig.title             |string              |modal的标题          |
|modalConfig.showOkBtn         |boolean             |是否显示确定按钮      |
|modalConfig.showCancelBtn     |boolean             |是否显示取消按钮      |
|modalConfig.okText            |string              |确定按钮的文案        |
|modalConfig.cancelText        |string              |取消按钮的文案        |
|formConfig                    |object              |modal中查询表单的配置，该表单引用的是 SearchForm 组件              |
|formConfig.FormName           |string              |是该查询表单在SearchForm 配置中的唯一标识，如果为空或者不配置，则组件不加载查询表单|
|tableConfig                   |object              |modal 中表格的配置项              |
|tableConfig.type              |number              |对应的是加载表格的类型，0：无多选也无单选的表格  1：带多选框的表格 2：带单选框的表格；|
|tableConfig.url               |string              |表格的loading控制，传该表格的请求type |
|tableConfig.showPagination    |boolean             |是否显示分页           |
|tableConfig.paginationConfig  |object            |分页的配置项,见antd       |
|tableConfig.defaultConfig     |object               |表格的配置，见antd     |

用法示例：

    组件引入：
    import ComModal from '../../../components/ComModal';


    组件使用：
    {showComModal?<ComModal name={modalName}  getFormValue={this.getFormValue} closeModal={this.closeModal}  dataResource={this.state.dataResource} submitData={this.submitData}/>:''}

    方法注解：
    name：modal组件标识，通过该标识加载对应的配置项
    getFormValue：获取查询表单数据 
    closeModal：关闭modal的方法
    dataResource：modal中表格的数据源
    submitData：确定的时候提交数据的方法
