
import statusText from '../../utils/statusText';
import commonFun from '../../utils/utils';
export default {
    default:{
        modalConfig:{ 
            width:'800px',
            zIndex:'',
            title:'提示',
            showOkBtn:true,
            showCancelBtn:true,
            okText:'确定',
            cancelText:'取消',
        },
        formConfig:{
            FormName:'default',
        },
        tableConfig:{
            type:0,
            url:'',
            showPagination:true,
            paginationConfig:{
                hideOnSinglePage:false,
                total:0,
            },
            defaultConfig:{
                rowKey:'',
                columns:[],
                scroll:{y:420}
            },
        }
    },
    templateName:{
        modalConfig:{ 
            width:'600px',
            zIndex:'',
            title:'模板列表',
            showOkBtn:true,
            showCancelBtn:true,
            okText:'确定',
            cancelText:'取消',
        },
        formConfig:{
            FormName:'templateName',
        },
        tableConfig:{
            type:2,
            url:'goods/GetTemplateList',
            showPagination:true,
            paginationConfig:{
                hideOnSinglePage:false,
            },
            defaultConfig:{
                rowKey:'id',
                columns:[
                    {
                        key:"1",
                        title: '模板名称',
                        align: 'left',
                        dataIndex:"addressName",
                    },
                ],
                scroll:{y:300}
            },
        }
    },
    groupCardName:{
        modalConfig:{ 
            width:'800px',
            zIndex:'',
            title:'库存组分组列表',
            showOkBtn:true,
            showCancelBtn:true,
            okText:'确定',
            cancelText:'取消',
        },
        formConfig:{
            FormName:'goodsStockGroup',
        },
        tableConfig:{
            type:2,
            url:'cardStock/GetCardGroupList',
            showPagination:true,
            paginationConfig:{
                hideOnSinglePage:false,
            },
            defaultConfig:{
                rowKey:'id',
                columns:[
                    {
                        key:"1",
                        title: '分组名称',
                        align: 'left',
                        dataIndex:"groupName",
                        width:200
                    },
                    {
                        key:"2",
                        title: '面值',
                        align: 'left',
                        dataIndex:"faceValue",
                        render:(text)=>{
                            return commonFun.toDecimal4(text)
                        }
                    },
                    {
                        key:"3",
                        title: '分组类型',
                        align: 'left',
                        dataIndex:"mode",
                        render:(text,record)=>{
                            return statusText['Mode']["card"][text]
                        }
                    },{
                        key:"4",
                        title: '绑定商品量',
                        align: 'left',
                        dataIndex:"productCount",
                    },{
                        key:"5",
                        title: '备注',
                        align: 'left',
                        dataIndex:"remarks",
                    }
                ],
                scroll:{y:300}
            },
        }
    },
    groupRechargeName:{
        modalConfig:{ 
            width:'800px',
            zIndex:'',
            title:'库存组分组列表',
            showOkBtn:true,
            showCancelBtn:true,
            okText:'确定',
            cancelText:'取消',
        },
        formConfig:{
            FormName:'goodsStockGroup',
        },
        tableConfig:{
            type:2,
            url:'rechargeStock/GetDirectChargeGroupList',
            showPagination:true,
            paginationConfig:{
                hideOnSinglePage:false,
            },
            defaultConfig:{
                rowKey:'id',
                columns:[
                    {
                        key:"1",
                        title: '分组名称',
                        align: 'left',
                        dataIndex:"groupName",
                        width:200
                    },
                    {
                        key:"2",
                        title: '分组类型',
                        align: 'left',
                        dataIndex:"mode",
                        render:(text,record)=>{
                            return statusText['Mode']["recharge"][text]
                        }
                    },{
                        key:"3",
                        title: '绑定商品量',
                        align: 'left',
                        dataIndex:"productCount",
                    },{
                        key:"4",
                        title: '备注',
                        align: 'left',
                        dataIndex:"remarks",
                    }
                ],
                scroll:{y:300}
            },
        }
    },
    looktoRechargeGoods:{
        modalConfig:{ 
            width:'800px',
            zIndex:'',
            title:'关联商品信息',
            showOkBtn:false,
            showCancelBtn:true,
            okText:'',
            cancelText:'确定',
        },
        formConfig:{
            FormName:'',
        },
        tableConfig:{
            type:0,
            url:'rechargeStock/GetFpDirectChargeProduct',
            showPagination:true,
            paginationConfig:{
                hideOnSinglePage:false,
            },
            defaultConfig:{
                rowKey:'id',
                columns:[
                    {
                        key:"1",
                        title: 'FP商品编号',
                        align: 'left',
                        dataIndex:"productId",
                        width:200
                    },
                    {
                        key:"2",
                        title: 'FP商品名称',
                        align: 'left',
                        dataIndex:"productName",
                    },{
                        key:"3",
                        title: '库存组编号',
                        align: 'left',
                        dataIndex:"groupCode",
                    },
                    {
                        key:"4",
                        title: '库存组名称',
                        align: 'left',
                        dataIndex:"groupName",
                        width:200
                    },
                    {
                        key:"5",
                        title: '库存组货源数',
                        align: 'left',
                        dataIndex:"groupCount",
                    }
                ],
                scroll:{y:300}
            },
        }
    },
    looktoCardGoods:{
        modalConfig:{ 
            width:'800px',
            zIndex:'',
            title:'关联商品信息',
            showOkBtn:false,
            showCancelBtn:true,
            okText:'',
            cancelText:'确定',
        },
        formConfig:{
            FormName:'',
        },
        tableConfig:{
            type:0,
            url:'cardStock/GetFpCardProduct',
            showPagination:true,
            paginationConfig:{
                hideOnSinglePage:false,
            },
            defaultConfig:{
                rowKey:'id',
                columns:[
                    {
                        key:"1",
                        title: 'FP商品编号',
                        align: 'left',
                        dataIndex:"productId",
                        width:200
                    },
                    {
                        key:"2",
                        title: 'FP商品名称',
                        align: 'left',
                        dataIndex:"productName",
                    },{
                        key:"3",
                        title: '库存组编号',
                        align: 'left',
                        dataIndex:"groupCode",
                    },
                    {
                        key:"4",
                        title: '库存组名称',
                        align: 'left',
                        dataIndex:"groupName",
                        width:200
                    },
                    {
                        key:"5",
                        title: '库存组货源数',
                        align: 'left',
                        dataIndex:"groupCount",
                    }
                ],
                scroll:{y:300}
            },
        }
    },
}