import React from 'react';
import { connect } from 'dva';
import {
  Spin, Form, Input, Modal, message, Divider, Tag
} from 'antd';
import statusToText from '../../utils/statusText';
const FormItem = Form.Item;
class MemberDetail extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      detailData: {}
    }
  }
  componentWillMount(){
    const {rowInfo} = this.props;
    this.props.dispatch({
      type: 'member/GetInfo',
      payload: {
        id: rowInfo.id
      }
    }).then(res => {
      if (res.code === '0') {
        this.setState({
          detailData: res.data
        })
      } else {
        message.error(res.message);
      }
    })
  }
  handleClose = () => {
    this.props.cancelModel();
  }
  render() {
    const { detailData } = this.state;
    const formItemLayout = {
      labelCol: { span: 6 },
      wrapperCol: { span: 18 },
    };
    return (
      <Modal
        title='商户信息'
        visible
        width="550px"
        onCancel={this.handleClose}
        maskClosable={false}
        footer={null}
      >
      <Spin spinning={!!this.props.loading.models.member}>
      <Form className="memeberDetail">
        <FormItem {...formItemLayout} label="名称">
          <span>{detailData.aliasName}</span>
        </FormItem>
        <FormItem {...formItemLayout} label="手机号">
          <span>{detailData.tel}</span>
        </FormItem>
        <FormItem {...formItemLayout} label="商户状态">
          <span>{statusToText.MemberStatus[detailData.auditStatus]}</span>
        </FormItem>
        <FormItem {...formItemLayout} label="认证类型">
          <span>{statusToText.AuthenticationType[detailData.authenticationType]}</span>
        </FormItem>
        <FormItem {...formItemLayout} label="认证状态">
          <span>{statusToText.AuthenticationStatus[detailData.authenticationStatus]}</span>
        </FormItem>
        <FormItem {...formItemLayout} label="QQ">
          <span>{detailData.qq}</span>
        </FormItem>
        <FormItem {...formItemLayout} label="邮箱">
          <span>{detailData.email}</span>
        </FormItem>
        <FormItem {...formItemLayout} label="创建时间">
          <span>{detailData.registerDate}</span>
        </FormItem>
      </Form>
      </Spin>
      </Modal>
    );
  }
}
const mapStateToProps = (state) => {
  return {
    ...state,
  };
}
export default connect(mapStateToProps)(Form.create()(MemberDetail));

