import React from 'react';
import { connect } from 'dva';
import {
  Spin, Form, Input, Modal, message, Divider, Tag, Select
} from 'antd';
const FormItem = Form.Item;
const productTypeText = {
  '卡密': '3',
  '实时采卡': '3',
  '卡密直充': '4',
  '在线直充': '4',
}
class CommodityPool extends React.Component {
  constructor(props) {
    super(props);
    this.state={
      buttonClick: true
    }
  }
  handleClose = () => {
    this.props.cancelModel();
  }
  save = () => {
    const { rowInfo } = this.props;
    this.props.form.validateFields((err, values) => {
      if (!err) {
        if(this.state.buttonClick){ //防止重复点击
          this.setState({buttonClick:false},()=>{
            this.props.dispatch({
              type: 'stock/PushProductPool',
              payload: {
                ...values,
                SupProductSourceId: rowInfo.id
              }
            }).then(res => {
              this.setState({buttonClick: true});
              if (res.code === '0') {
                message.success('发布成功');
                this.props.getData();
                this.props.cancelModel();
              } else {
                message.error(res.message);
              }
            })
          })
        }
      }
    })
  }
  render() {
    const { rowInfo } = this.props;
    const { getFieldDecorator } = this.props.form;
    const formItemLayout = {
      labelCol: { span: 3 },
      wrapperCol: { span: 18 },
    };
    return (
      <Modal
        title='发布至商品池'
        visible
        width="500px"
        onCancel={this.handleClose}
        maskClosable={false}
        onOk={this.save}
      >
        <Form>
          <FormItem {...formItemLayout} label="商品属性">
            {getFieldDecorator('poolType', {
              initialValue: productTypeText[rowInfo.supProductType] || ''
            })(
              <Select
                placeholder="请选择"
                style={{ width: 150, margin: '0 10px' }}
                disabled
                >
                <Select.Option value={''}>请选择</Select.Option>
                <Select.Option value={'3'}>卡密</Select.Option>
                <Select.Option value={'4'}>直充</Select.Option>
              </Select>
            )}
          </FormItem>
        </Form>
      </Modal>
    );
  }
}
const mapStateToProps = (state) => {
  return {
    ...state,
  };
}
export default connect(mapStateToProps)(Form.create()(CommodityPool));

