import 'babel-polyfill';
import dva from 'dva';
import createLoading from 'dva-loading';
const createHistory = require('history').createBrowserHistory;
import { message } from 'antd';
import './sprite/common.less';
import { default as common } from './models/common';
import { default as goods } from './models/goods';
import { default as price } from './models/price';
import { default as search } from './models/search';
import { default as report } from './models/report';
import { default as stock } from './models/stock';
import { default as activity } from './models/activity';
import { default as cardStock } from './models/cardStock';
import { default as rechargeStock } from './models/rechargeStock';
// 1. Initialize
// =======================
const app = dva({
  history: createHistory(),
  onError(e, dispatch) {
    message.error(e.message, 3);
  },
});

// 2. Plugins
// =======================
app.use(createLoading());

// 3. Model
// =======================
app.model(common);

app.model(goods);

app.model(price);

app.model(search);

app.model(report);

app.model(activity);

app.model(stock);

app.model(cardStock);

app.model(rechargeStock);


// 4. Router
// =======================
app.router(require('./Router'));

// 5. Start
// =======================
app.start('#app');
