import { routerRedux } from 'dva/router';
import * as activityService from '../services/activity';
import { message } from 'antd';
export default {
    namespace: 'activity',
    state: {
        
    },
    subscriptions: {
        setup({
        history,
        dispatch
        }, onError) {}
    },
    effects: {
        // 获取活动列表
        *GetActivityList(action, { call, put }) {
            const regRes = yield call(activityService.GetActivityList, action.payload);
            yield put({
                type: 'activity',
                GetActivityList: regRes
            });
        },

        // 获取活动详情
        *GetActivityDetail(action, { call, put }) {
            const regRes = yield call(activityService.GetActivityDetail, action.payload);
            yield put({
                type: 'activity',
                GetActivityDetail: regRes
            });
        },
        
        // 获取活动关联的商品
        *GetActivityRelationProductList(action, { call, put }) {
            const regRes = yield call(activityService.GetActivityRelationProductList, action.payload);
            yield put({
                type: 'activity',
                GetActivityRelationProductList: regRes
            });
        },

        // 获取平台商品列表
        *GetSupProductRelationProductList(action, { call, put }) {
            const regRes = yield call(activityService.GetSupProductRelationProductList, action.payload);
            yield put({
                type: 'activity',
                GetSupProductRelationProductList: regRes
            });
        },

        // 获取活动申请列表
        *GetActivityApplyList(action, { call, put }) {
            const regRes = yield call(activityService.GetActivityApplyList, action.payload);
            yield put({
                type: 'activity',
                GetActivityApplyList: regRes
            });
        },

        // 提交活动报名
        *SubmitActivityApply(action, { call, put }) {
            const regRes = yield call(activityService.SubmitActivityApply, action.payload);
            yield put({
                type: 'activity',
                SubmitActivityApply: regRes
            });
        },

         // 重新提交活动报名
         *ReSubmitActivityApply(action, { call, put }) {
            const regRes = yield call(activityService.ReSubmitActivityApply, action.payload);
            yield put({
                type: 'activity',
                ReSubmitActivityApply: regRes
            });
        },

        
        *StasticActivityApplyCount(action, { call, put }) {
            const regRes = yield call(activityService.StasticActivityApplyCount, action.payload);
            yield put({
                type: 'activity',
                StasticActivityApplyCount: regRes
            });
        },

        //获取进货商列表
        *GetActivityApplyMemberList(action, { call, put }) {
            const regRes = yield call(activityService.GetActivityApplyMemberList, action.payload);
            yield put({
                type: 'activity',
                GetActivityApplyMemberList: regRes
            });
        },


        

        

        


        
        
        

    },
    reducers: {
        activity(state, payload) {
            return {
                ...state,
                ...payload
            };
        }
    }
};
