import { routerRedux } from 'dva/router';
import * as cardStockService from '../services/cardStock';
import { message } from 'antd';
export default {
    namespace: 'cardStock',
    state: {
       
    },
    subscriptions: {
        setup({
        history,
        dispatch
        }, onError) {}
    },
    effects: {
        // 卡密商品池分组列表
        *GetCardGroupList(action, { call, put }) {
            const regRes = yield call(cardStockService.GetCardGroupList, action.payload);
            yield put({
                type: 'cardStock',
                GetCardGroupList: regRes
            });
        },

        // 创建分组
        *CreateCardGroup(action, { call, put }) {
            const regRes = yield call(cardStockService.CreateCardGroup, action.payload);
            yield put({
                type: 'cardStock',
                CreateCardGroup: regRes
            });
        },

        // 更新分组
        *UpdateCardGroup(action, { call, put }) {
            const regRes = yield call(cardStockService.UpdateCardGroup, action.payload);
            yield put({
                type: 'cardStock',
                UpdateCardGroup: regRes
            });
        },

        // 删除分组
        *DeleteCardGroup(action, { call, put }) {
            const regRes = yield call(cardStockService.DeleteCardGroup, action.payload);
            yield put({
                type: 'cardStock',
                DeleteCardGroup: regRes
            });
        },

        // 分组商品明细
        *GetCardGroupProductDetailList(action, { call, put }) {
            const regRes = yield call(cardStockService.GetCardGroupProductDetailList, action.payload);
            yield put({
                type: 'cardStock',
                GetCardGroupProductDetailList: regRes
            });
        },

        // 卡密商品池商品列表
        *GetCardPoolProductList(action, { call, put }) {
            const regRes = yield call(cardStockService.GetCardPoolProductList, action.payload);
            yield put({
                type: 'cardStock',
                GetCardPoolProductList: regRes
            });
        },

        // 插入卡密分组商品明细
        *CreateCardGroupProductDetail(action, { call, put }) {
            const regRes = yield call(cardStockService.CreateCardGroupProductDetail, action.payload);
            yield put({
                type: 'cardStock',
                CreateCardGroupProductDetail: regRes
            });
        },
        
        *CreateCardGroupProductDetail(action, { call, put }) {
            const regRes = yield call(cardStockService.CreateCardGroupProductDetail, action.payload);
            yield put({
                type: 'cardStock',
                CreateCardGroupProductDetail: regRes
            });
        },
        
        *UpdateCardGroupProduct(action, { call, put }) {
            const regRes = yield call(cardStockService.UpdateCardGroupProduct, action.payload);
            yield put({
                type: 'cardStock',
                UpdateCardGroupProduct: regRes
            });
        },

        *DeleteCardGroupProductDetail(action, { call, put }) {
            const regRes = yield call(cardStockService.DeleteCardGroupProductDetail, action.payload);
            yield put({
                type: 'cardStock',
                DeleteCardGroupProductDetail: regRes
            });
        },

        *GetCardOwnerGroupList(action, { call, put }) {
            const regRes = yield call(cardStockService.GetCardOwnerGroupList, action.payload);
            yield put({
                type: 'cardStock',
                GetCardOwnerGroupList: regRes
            });
        },

        *DeleteCardPoolProduct(action, { call, put }) {
            const regRes = yield call(cardStockService.DeleteCardPoolProduct, action.payload);
            yield put({
                type: 'cardStock',
                DeleteCardPoolProduct: regRes
            });
        },

        *CheckCardGroupProduct(action, { call, put }) {
            const regRes = yield call(cardStockService.CheckCardGroupProduct, action.payload);
            yield put({
                type: 'cardStock',
                CheckCardGroupProduct: regRes
            });
        },
        
        *GetFpCardProduct(action, { call, put }) {
            const regRes = yield call(cardStockService.GetFpCardProduct, action.payload);
            yield put({
                type: 'cardStock',
                GetFpCardProduct: regRes
            });
        },
        
        *PublishSupProductToProduct(action, { call, put }) {
            const regRes = yield call(cardStockService.PublishSupProductToProduct, action.payload);
            yield put({
                type: 'cardStock',
                PublishSupProductToProduct: regRes
            });
        },
        
        
        
        
        
        

    },
    reducers: {
        cardStock(state, payload) {
            return {
                ...state,
                ...payload
            };
        }
    }
};
