import { routerRedux } from 'dva/router';
import * as goodsService from '../services/goods';
import { message } from 'antd';
export default {
    namespace: 'goods',
    state: {
       
    },
    subscriptions: {
        setup({
        history,
        dispatch
        }, onError) {}
    },
    effects: {
        //   获取获取商品名称搜索下拉组件数据源
        *getGoodsList(action, { call, put }) {
            const regRes = yield call(goodsService.getGoodsList, action.payload);
            yield put({
                type: 'goods',
                getGoodsList: regRes
            });
        },
        //   获取获取商品管理列表
        *GetgoodsResource(action, { call, put }) {
            const regRes = yield call(goodsService.GetgoodsResource, action.payload);
            yield put({
                type: 'goods',
                GetgoodsResource: regRes
            });
        },

        // 获取库存组数据
        *GetInventoryGroupsList(action, { call, put }) {
            const regRes = yield call(goodsService.GetInventoryGroupsList, action.payload);
            yield put({
                type: 'goods',
                GetInventoryGroupsList: regRes
            });
        },

        // 获取商品详情
        *GetProductDetail(action, { call, put }) {
            const regRes = yield call(goodsService.GetProductDetail, action.payload);
            yield put({
                type: 'goods',
                GetProductDetail: regRes
            });
        },

        // 批量设置商品的销售状态
        *BatchSetSaleStatus(action, { call, put }) {
            const regRes = yield call(goodsService.BatchSetSaleStatus, action.payload);
            yield put({
                type: 'goods',
                BatchSetSaleStatus: regRes
            });
        },

        // 分页获取商品模板
        *GetTemplateList(action, { call, put }) {
            const regRes = yield call(goodsService.GetTemplateList, action.payload);
            yield put({
                type: 'goods',
                GetTemplateList: regRes
            });
        },

        // 新增商品
        *ProductCreate(action, { call, put }) {
            const regRes = yield call(goodsService.ProductCreate, action.payload);
            yield put({
                type: 'goods',
                ProductCreate: regRes
            });
        },

        // 获取话费流量区域数据
        *GetAreaList(action, { call, put }) {
            const regRes = yield call(goodsService.GetAreaList, action.payload);
            yield put({
                type: 'goods',
                GetAreaList: regRes
            });
        },
        
        
        // 編輯商品
        *ProductUpdate(action, { call, put }) {
            const regRes = yield call(goodsService.ProductUpdate, action.payload);
            yield put({
                type: 'goods',
                ProductUpdate: regRes
            });
        },
        


        
        
        

    },
    reducers: {
        goods(state, payload) {
            return {
                ...state,
                ...payload
            };
        }
    }
};
