import { routerRedux } from 'dva/router';
import * as priceService from '../services/price';
import { message } from 'antd';
export default {
    namespace: 'price',
    state: {
       
    },
    subscriptions: {
        setup({
        history,
        dispatch
        }, onError) {}
    },
   
    effects: {
        // 获取密价组管理列表
        *GetpriceResource(action, { call, put }) {
            const regRes = yield call(priceService.GetpriceResource, action.payload);
            yield put({
                type: 'price',
                GetpriceResource: regRes
            });
        },
        // 添加密价组
        *addPriceGroup(action, { call, put }) {
            const regRes = yield call(priceService.addPriceGroup, action.payload);
            yield put({
                type: 'price',
                addPriceGroup: regRes
            });
        },

        // 编辑密价组
        *EditPriceGroup(action, { call, put }) {
            const regRes = yield call(priceService.EditPriceGroup, action.payload);
            yield put({
                type: 'price',
                EditPriceGroup: regRes
            });
        },
        
        // 删除密价组
        *DeletePriceGroup(action, { call, put }) {
            const regRes = yield call(priceService.DeletePriceGroup, action.payload);
            yield put({
                type: 'price',
                DeletePriceGroup: regRes
            });
        },

        // 获取商户管理列表
        *GetMerchantsResource(action, { call, put }) {
            const regRes = yield call(priceService.GetMerchantsResource, action.payload);
            yield put({
                type: 'price',
                GetMerchantsResource: regRes
            });
        },

        // 允许密价应用列表
        *GetBusinessInfo(action, { call, put }) {
            const regRes = yield call(priceService.GetBusinessInfo, action.payload);
            yield put({
                type: 'price',
                GetBusinessInfo: regRes
            });
        },

        

        // 批量删除商户
        *DeletetMerchants(action, { call, put }) {
            const regRes = yield call(priceService.DeletetMerchants, action.payload);
            yield put({
                type: 'price',
                DeletetMerchants: regRes
            });
        },

        // 获得待加入密价组商户列表
        *GetMemberList(action, { call, put }) {
            const regRes = yield call(priceService.GetMemberList, action.payload);
            yield put({
                type: 'price',
                GetMemberList: regRes
            });
        },

        // 添加密价组商户
        *AddProductSpMember(action, { call, put }) {
            const regRes = yield call(priceService.AddProductSpMember, action.payload);
            yield put({
                type: 'price',
                AddProductSpMember: regRes
            });
        },

        // 获取当前密价商户下密价商品应用
        *GetBusinessInfoIntoMember(action, { call, put }) {
            const regRes = yield call(priceService.GetBusinessInfoIntoMember, action.payload);
            yield put({
                type: 'price',
                GetBusinessInfoIntoMember: regRes
            });
        },

         // 获取商户商品密价详情列表
         *GetSecretProductPageList(action, { call, put }) {
            const regRes = yield call(priceService.GetSecretProductPageList, action.payload);
            yield put({
                type: 'price',
                GetSecretProductPageList: regRes
            });
        },

        // 获取商户可添加的商品列表(排除已添加商品)
        *GetMemberSecretPriceProductList(action, { call, put }) {
            const regRes = yield call(priceService.GetMemberSecretPriceProductList, action.payload);
            yield put({
                type: 'price',
                GetMemberSecretPriceProductList: regRes
            });
        },

        // 添加商户密价商品
        *AddMemberSecretPriceProduct(action, { call, put }) {
            const regRes = yield call(priceService.AddMemberSecretPriceProduct, action.payload);
            yield put({
                type: 'price',
                AddMemberSecretPriceProduct: regRes
            });
        },

        // 删除密价商品
        *DeleteMemberProductSecretPrice(action, { call, put }) {
            const regRes = yield call(priceService.DeleteMemberProductSecretPrice, action.payload);
            yield put({
                type: 'price',
                DeleteMemberProductSecretPrice: regRes
            });
        },

        // 获取供货商品列表
        *GetSupProductList(action, { call, put }) {
            const regRes = yield call(priceService.GetSupProductList, action.payload);
            yield put({
                type: 'price',
                GetSupProductList: regRes
            });
        },

        // 更新商户商品密价
        *UpdateMemberProductSecretPrice(action, { call, put }) {
            const regRes = yield call(priceService.UpdateMemberProductSecretPrice, action.payload);
            yield put({
                type: 'price',
                UpdateMemberProductSecretPrice: regRes
            });
        },

        // 移除密价商品
        *RemoveMemberProductSecretPrice(action, { call, put }) {
            const regRes = yield call(priceService.RemoveMemberProductSecretPrice, action.payload);
            yield put({
                type: 'price',
                RemoveMemberProductSecretPrice: regRes
            });
        },

        // 设置商品可购买
        *SetEnableBuy(action, { call, put }) {
            const regRes = yield call(priceService.SetEnableBuy, action.payload);
            yield put({
                type: 'price',
                SetEnableBuy: regRes
            });
        },

        // 设置折扣密价
        *SetMemberProductRebateSecretPrice(action, { call, put }) {
            const regRes = yield call(priceService.SetMemberProductRebateSecretPrice, action.payload);
            yield put({
                type: 'price',
                SetMemberProductRebateSecretPrice: regRes
            });
        },

        // 设置折扣密价
        *SetMemberProductSecretPrice(action, { call, put }) {
            const regRes = yield call(priceService.SetMemberProductSecretPrice, action.payload);
            yield put({
                type: 'price',
                SetMemberProductSecretPrice: regRes
            });
        },
        
        // 获取可以同步商品密价的商户列表
        *GetSynchronousMemberList(action, { call, put }) {
            const regRes = yield call(priceService.GetSynchronousMemberList, action.payload);
            yield put({
                type: 'price',
                GetSynchronousMemberList: regRes
            });
        },
        // 同步密价
        *SynchronousMemberProductSecretPrice(action, { call, put }) {
            const regRes = yield call(priceService.SynchronousMemberProductSecretPrice, action.payload);
            yield put({
                type: 'price',
                SynchronousMemberProductSecretPrice: regRes
            });
        },

        // 待处理密价列表
        *GetQuotationSheetManageList(action, { call, put }) {
            const regRes = yield call(priceService.GetQuotationSheetManageList, action.payload);
            yield put({
                type: 'price',
                GetQuotationSheetManageList: regRes
            });
        },

        //
        *CreateSecretPrice(action, { call, put }) {
            const regRes = yield call(priceService.CreateSecretPrice, action.payload);
            yield put({
                type: 'price',
                CreateSecretPrice: regRes
            });
        },
        
        // 获取报价单商品明细
        *QuotationSheetProductDetailInOperator(action, { call, put }) {
            const regRes = yield call(priceService.QuotationSheetProductDetailInOperator, action.payload);
            yield put({
                type: 'price',
                QuotationSheetProductDetailInOperator: regRes
            });
        },

        // 后台管理应用列表接口
        *GetAppsList(action, { call, put }) {
            const regRes = yield call(priceService.GetAppsList, action.payload);
            yield put({
                type: 'price',
                GetAppsList: regRes
            });
        },

        
        
        
    },
    reducers: {
        price(state, payload) {
            return {
                ...state,
                ...payload
            };
        }
    }
};
