import { routerRedux } from 'dva/router';
import * as rechargeStockService from '../services/rechargeStock';
import { message } from 'antd';
export default {
    namespace: 'rechargeStock',
    state: {
       
    },
    subscriptions: {
        setup({
        history,
        dispatch
        }, onError) {}
    },
    effects: {
        // 直充商品池分组列表
        *GetDirectChargeGroupList(action, { call, put }) {
            const regRes = yield call(rechargeStockService.GetDirectChargeGroupList, action.payload);
            yield put({
                type: 'rechargeStock',
                GetDirectChargeGroupList: regRes
            });
        },

        // 创建分组
        *CreateDirectChargeGroup(action, { call, put }) {
            const regRes = yield call(rechargeStockService.CreateDirectChargeGroup, action.payload);
            yield put({
                type: 'rechargeStock',
                CreateDirectChargeGroup: regRes
            });
        },

        // 修改分组
        *UpdateDirectChargeGroup(action, { call, put }) {
            const regRes = yield call(rechargeStockService.UpdateDirectChargeGroup, action.payload);
            yield put({
                type: 'rechargeStock',
                UpdateDirectChargeGroup: regRes
            });
        },

        // 删除分组
        *DeleteDirectChargeGroup(action, { call, put }) {
            const regRes = yield call(rechargeStockService.DeleteDirectChargeGroup, action.payload);
            yield put({
                type: 'rechargeStock',
                DeleteDirectChargeGroup: regRes
            });
        },

        // 分组商品明细
        *GetDirectChargeDetailToGroupList(action, { call, put }) {
            const regRes = yield call(rechargeStockService.GetDirectChargeDetailToGroupList, action.payload);
            yield put({
                type: 'rechargeStock',
                GetDirectChargeDetailToGroupList: regRes
            });
        },

        *GetDirectChargeDetailExcludeGroup(action, { call, put }) {
            const regRes = yield call(rechargeStockService.GetDirectChargeDetailExcludeGroup, action.payload);
            yield put({
                type: 'rechargeStock',
                GetDirectChargeDetailExcludeGroup: regRes
            });
        },

        *CreateDirectChargeGroupDetail(action, { call, put }) {
            const regRes = yield call(rechargeStockService.CreateDirectChargeGroupDetail, action.payload);
            yield put({
                type: 'rechargeStock',
                CreateDirectChargeGroupDetail: regRes
            });
        },

        *UpdateGroupProductDetailSort(action, { call, put }) {
            const regRes = yield call(rechargeStockService.UpdateGroupProductDetailSort, action.payload);
            yield put({
                type: 'rechargeStock',
                UpdateGroupProductDetailSort: regRes
            });
        },

        *DeleteDirectChargeGroupDetail(action, { call, put }) {
            const regRes = yield call(rechargeStockService.DeleteDirectChargeGroupDetail, action.payload);
            yield put({
                type: 'rechargeStock',
                DeleteDirectChargeGroupDetail: regRes
            });
        },

        *DeleteDirectChargeProductPool(action, { call, put }) {
            const regRes = yield call(rechargeStockService.DeleteDirectChargeProductPool, action.payload);
            yield put({
                type: 'rechargeStock',
                DeleteDirectChargeProductPool: regRes
            });
        },
        
        *GetDirectChargeOwnerGroupList(action, { call, put }) {
            const regRes = yield call(rechargeStockService.GetDirectChargeOwnerGroupList, action.payload);
            yield put({
                type: 'rechargeStock',
                GetDirectChargeOwnerGroupList: regRes
            });
        },

        *CheckDirectChargeProduct(action, { call, put }) {
            const regRes = yield call(rechargeStockService.CheckDirectChargeProduct, action.payload);
            yield put({
                type: 'rechargeStock',
                CheckDirectChargeProduct: regRes
            });
        },

        
        *GetFpDirectChargeProduct(action, { call, put }) {
            const regRes = yield call(rechargeStockService.GetFpDirectChargeProduct, action.payload);
            yield put({
                type: 'rechargeStock',
                GetFpDirectChargeProduct: regRes
            });
        },
        
        
        
        
        
        
        

        

        
        


    },
    reducers: {
        rechargeStock(state, payload) {
            return {
                ...state,
                ...payload
            };
        }
    }
};
