import { routerRedux } from 'dva/router';
import * as reportService from '../services/report';
import { message } from 'antd';
export default {
    namespace: 'report',
    state: {
    },
    subscriptions: {
        setup({
        history,
        dispatch
        }, onError) {}
    },
    effects: {
        // 获取所有供货商户
        *GetPurchaserMemberList(action, { call, put }) {
            const regRes = yield call(reportService.GetPurchaserMemberList, action.payload);
            yield put({
                type: 'report',
                GetPurchaserMemberList: regRes
            });
        },

        // 根据进货商户获取平台商品
        *GetProductByMemberList(action, { call, put }) {
            const regRes = yield call(reportService.GetProductByMemberList, action.payload);
            yield put({
                type: 'report',
                GetProductByMemberList: regRes
            });
        },

        // 申请报备
        *ApplySupReport(action, { call, put }) {
            const regRes = yield call(reportService.ApplySupReport, action.payload);
            yield put({
                type: 'report',
                ApplySupReport: regRes
            });
        },

        // 更新报备状态
        *UpdateSupReportInfo(action, { call, put }) {
            const regRes = yield call(reportService.UpdateSupReportInfo, action.payload);
            yield put({
                type: 'report',
                UpdateSupReportInfo: regRes
            });
        },
    },
    reducers: {
        report(state, payload) {
            return {
                ...state,
                ...payload
            };
        }
    }
};
