import { routerRedux } from 'dva/router';
import * as searchService from '../services/search';
import { message } from 'antd';
export default {
    namespace: 'search',
    state: {
    },
    subscriptions: {
        setup({
        history,
        dispatch
        }, onError) {}
    },
    effects: {
        // 获取商户搜索商品搜索数据
        *GetDataResource(action, { call, put }) {
            const regRes = yield call(searchService.GetDataResource, action.payload);
            yield put({
                type: 'search',
                GetDataResource: regRes
            });
        },

        // 获取导入记录列表
        *GetRecrdList(action, { call, put }) {
            const regRes = yield call(searchService.GetRecrdList, action.payload);
            yield put({
                type: 'search',
                GetRecrdList: regRes
            });
        },

        // 获取导入详情列表
        *GetImportSecretDetail(action, { call, put }) {
            const regRes = yield call(searchService.GetImportSecretDetail, action.payload);
            yield put({
                type: 'search',
                GetImportSecretDetail: regRes
            });
        },

        
        // 重新导入
        *ReImportSecret(action, { call, put }) {
            const regRes = yield call(searchService.ReImportSecret, action.payload);
            yield put({
                type: 'search',
                ReImportSecret: regRes
            });
        },

        // 判断是否有正在导入的密价
        *HaveImportSecret(action, { call, put }) {
            const regRes = yield call(searchService.HaveImportSecret, action.payload);
            yield put({
                type: 'search',
                HaveImportSecret: regRes
            });
        },

        
        

        

        
        

    },
    reducers: {
        search(state, payload) {
            return {
                ...state,
                ...payload
            };
        }
    }
};
