import { routerRedux } from 'dva/router';
import * as stockService from '../services/stock';
import { message } from 'antd';
export default {
    namespace: 'stock',
    state: {
       
    },
    subscriptions: {
        setup({
        history,
        dispatch
        }, onError) {}
    },
    effects: {
        //库存商品管理
        *GetList(action, { call, put }) {
          const regRes = yield call(stockService.GetList, action.payload);
          return regRes;
        },
        //查看当前商品对应的库存组下平台商品
        *GetGroupProductBySupProductId(action, { call, put }) {
          const regRes = yield call(stockService.GetGroupProductBySupProductId, action.payload);
          return regRes;
        },
        //供货商品发布到商品池
        *PushProductPool(action, { call, put }) {
          const regRes = yield call(stockService.PushProductPool, action.payload);
          return regRes;
        },
        //设置商品属性
        *SetProductAttr(action, { call, put }) {
          const regRes = yield call(stockService.SetProductAttr, action.payload);
          return regRes;
        },
        //供货商品一键发布到平台自有商品
        *PublishSupProductToProduct(action, { call, put }) {
          const regRes = yield call(stockService.PublishSupProductToProduct, action.payload);
          return regRes;
        },
        //查询Sup商品标签
        *GetSupProductTag(action, { call, put }) {
          const regRes = yield call(stockService.GetSupProductTag, action.payload);
          return regRes;
        },
        // 库存分页列表查询
        *GetStockLockApplyList(action, { call, put }) {
            const regRes = yield call(stockService.GetStockLockApplyList, action.payload);
            yield put({
                type: 'stock',
                GetStockLockApplyList: regRes
            });
        },
        // 库存锁定选择商品
        *GetInventoryProductList(action, { call, put }) {
            const regRes = yield call(stockService.GetInventoryProductList, action.payload);
            yield put({
                type: 'stock',
                GetInventoryProductList: regRes
            });
        },

        // 添加库存锁定
        *AddStockLockApply(action, { call, put }) {
            const regRes = yield call(stockService.AddStockLockApply, action.payload);
            yield put({
                type: 'stock',
                AddStockLockApply: regRes
            });
        },

        // 库存详情列表查询
        *GetStockLockApplyDetailList(action, { call, put }) {
            const regRes = yield call(stockService.GetStockLockApplyDetailList, action.payload);
            yield put({
                type: 'stock',
                GetStockLockApplyDetailList: regRes
            });
        },

        // 补充库存锁定接口
        *SupplementStockLockApply(action, { call, put }) {
            const regRes = yield call(stockService.SupplementStockLockApply, action.payload);
            yield put({
                type: 'stock',
                SupplementStockLockApply: regRes
            });
        },
        // 释放库存锁定接口
        *ReleaseStockLockApply(action, { call, put }) {
            const regRes = yield call(stockService.ReleaseStockLockApply, action.payload);
            yield put({
                type: 'stock',
                ReleaseStockLockApply: regRes
            });
        },

        

        

        
        
        

        
        

    },
    reducers: {
        stock(state, payload) {
            return {
                ...state,
                ...payload
            };
        }
    }
};
