import axios from '../utils/axios';
import Api from '../configs/api';
import { message } from 'antd';

// 库存分页列表查询
export function GetStockLockApplyList(data) {
  return axios.get(Api.GetStockLockApplyList, {
    params: data
  })
}

// 库存锁定选择商品
export function GetInventoryProductList(data) {
  return axios.get(Api.GetInventoryProductList, {
    params: data
  })
}

// 添加库存锁定
export function AddStockLockApply (data) {
  return axios({
    method: 'post',
    url: Api.AddStockLockApply,
    data: data
  })
}

// 库存详情列表查询
export function GetStockLockApplyDetailList(data) {
  return axios.get(Api.GetStockLockApplyDetailList, {
    params: data
  })
}


// 补充库存锁定接口
export function SupplementStockLockApply (data) {
  return axios({
    method: 'post',
    url: Api.SupplementStockLockApply,
    data: data
  })
}

// 释放库存锁定接口
export function ReleaseStockLockApply (data) {
  return axios({
    method: 'post',
    url: Api.ReleaseStockLockApply,
    data: data
  })
}

// 获取供货商品列表，带分页、搜索
export function GetList(data) {
  return axios.get(Api.GetList, {
    params: data
  })
}

// 查看当前商品对应的库存组下平台商品
export function GetGroupProductBySupProductId(data) {
  return axios.get(Api.GetGroupProductBySupProductId, {
    params: data
  })
}

// 供货商品发布到商品池
export function PushProductPool (data) {
  return axios({
    method: 'post',
    url: Api.PushProductPool,
    data: data
  })
}

// 设置商品属性
export function SetProductAttr (data) {
  return axios({
    method: 'post',
    url: Api.SetProductAttr,
    data: data
  })
}

// 供货商品一键发布到平台自有商品
export function PublishSupProductToProduct (data) {
  return axios({
    method: 'post',
    url: Api.PublishSupProductToProduct,
    data: data
  })
}

// 查询Sup商品标签
export function GetSupProductTag(data) {
  return axios.get(Api.GetSupProductTag, {
    params: data
  })
}















// // 发送手机验证码
// export function SendVerifyCode (data) {
//   return axios({
//     method: 'post',
//     url: Api.SendVerifyCode,
//     data: data
//   })
// }










