import React from 'react';
import { Select } from 'antd';
const Option = Select.Option;

function cutWord(len, text, record, index) {
  text = text || '';
  return <span title={text}>
    {text.length > len ? text.slice(0, len) + '...' : text}
  </span>
}

function cutWordByWidth(width, text, record, index) {
  width -= 17;
  width = width < 20 ? 20 : width;

  text = text || '';
  return <div className='ellipsis' title={text} style={{ width }}>
    {text}
  </div>
}

function convertEnum(enumObj, text, record, index) {
  text = text;
  if (enumObj && enumObj[text + '']) {
    text = enumObj[text + '']
  }

  return <span title={text}>
    {text}
  </span>
}

function convertImg(text, record, index) {
  return <img src={text} />
}

function timeshow(text, record, index) {
  if (text === '0001-01-01 00:00:00') {
    return <span></span>
  }else{
    return <span>{text}</span>
  }
}

function enumRenderWithSelect(enumObj) {
  var xopts = [];

  if (!enumObj) return;

  for (var key in enumObj) {
    xopts.push(
      <Option key={key} title={enumObj[key]} value={key}>{enumObj[key]}</Option>
    )
  }

  return xopts;
}

function getScrollHeight() {
  var h = document.body.clientHeight - 220;

  return h < 100 ? 100 : h;
}

function getScrollWidth(columns, defaultWidth) {
  // 设置自适应宽度列的宽度（通常为最后一列）
  defaultWidth = defaultWidth || 150;
  if (defaultWidth < 150) {
    defaultWidth = 150;
  }
  const wArr = columns.map(each => parseInt(each.width)); //eslint-disable-line
  let scrollWidth = 0;
  wArr.forEach(each => {
    scrollWidth += each || defaultWidth;
  });

  return scrollWidth;
}

function getScrollWidthx(columns) {
  var wArr = columns.map(each => parseInt(each.width));
  var scrollWidth = 0;
  wArr.forEach(each => {
    scrollWidth += each || 150;
  })

  return scrollWidth;
}

export {
  cutWord,
  cutWordByWidth,
  convertEnum,
  enumRenderWithSelect,
  getScrollHeight,
  getScrollWidth,
  timeshow,
  convertImg,
};
