
import React from 'react';
import { message } from 'antd';
export default {
  // 检查手机号
  checkTel: function (mobile) {
    if (!mobile) {
      message.error('请输入手机号');
      return false;
    }
    if (/^1\d{10}$/.test(mobile)) {
      return true;
    }
    message.error('请输入正确的手机号');
    return false;
  },
  // 检查验证码
  checkCode: function (captcha) {
    if (!captcha) {
      message.error('请输入验证码');
      return false;
    }
    return true;
  },
  // 超过位数显示...
  stringCutOut(str, num) {
    if (str.length > num) return str.substring(0, num) + '...';
    return str;
  },
  getPhoneCode: function (mobile, that, type) {
    //如果定时器不存在则执行发送验证码操作
    if (that.state.isSendCode) {
      //表示已经发送了验证码
      that.setState({
        isSendCode: false
      });
      var me = that;
      let time = 60;
      //定时器
      let timer = setInterval(function () {
        time--;
        me.setState({
          getVerifyCode: '重新获取' + time + 's'
        });
        //如果为0
        if (!time) {
          clearInterval(timer);
          timer = null;
          me.setState({
            getVerifyCode: '获取验证码'
          });
          //设置定时器不存在
          me.setState({
            isSendCode: true
          });
        }
      }, 1000);
      //调用发送验证码
      const { props } = that;
      props.dispatch({
        type: 'game/sendMobileCode', payload: {
          mobile,
          type
        }
      });
    }
  },
  // 加
  accAdd: function (arg1, arg2) {
    var r1, r2, m;
    try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 }
    try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 }
    m = Math.pow(10, Math.max(r1, r2))
    return (Math.round(arg1 * m) + Math.round(arg2 * m)) / m
  }
  ,
  // 除
  accDiv: function (arg1, arg2) {
    var t1 = 0, t2 = 0, r1, r2;
    var t1 = 0, t2 = 0, r1, r2;
    try {
      t1 = arg1.toString().split(".")[1].length;
    }
    catch (e) {
    }
    try {
      t2 = arg2.toString().split(".")[1].length;
    }
    catch (e) {
    }
    try {
      r1 = Number(arg1.toString().replace(".", ""));
      r2 = Number(arg2.toString().replace(".", ""));
    }
    catch (e) {
    }
    return (r1 / r2) * pow(10, t2 - t1);
  }
  ,
  // 减
  Subtr: function (arg1, arg2) {
    var r1, r2, m, n;
    try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 }
    try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 }
    m = Math.pow(10, Math.max(r1, r2));
    n = (r1 >= r2) ? r1 : r2;
    return ((arg1 * m - arg2 * m) / m).toFixed(n);
  }
  ,
  // 乘
  accMul: function (arg1, arg2) {
    var m = 0, s1 = arg1.toString(), s2 = arg2.toString();

    try { m += s1.split(".")[1].length } catch (e) { }

    try { m += s2.split(".")[1].length } catch (e) { }

    return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m)
  },
  // 给原生传递数据
  loadURL: function (url) {
    var iFrame;
    var u = navigator.userAgent;
    var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; //android终端
    var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
    if (isAndroid) {
      //安卓终端使用iframe
      iFrame = document.createElement("iframe");
      iFrame.setAttribute("src", url);
      iFrame.setAttribute("style", "display:none;");
      iFrame.setAttribute("height", "0px");
      iFrame.setAttribute("width", "0px");
      iFrame.setAttribute("frameborder", "0");
      document.body.appendChild(iFrame);
      // 发起请求后这个 iFrame 就没用了，所以把它从 dom 上移除掉
      iFrame.parentNode.removeChild(iFrame);
      iFrame = null;
    } else if (isiOS) {
      //iOS终端直接页面跳转
      window.location.href = url;
      // setTimeout(() => {
      //   // window.location.href = ' itms://itunes.apple.com/gb/app/yi-dong-cai-bian/id391945719?mt=8'; // 跳转淘宝
      // }, 500);
    } else {
      window.location.href = url;
    }
  },
  latestTime(v, nowServerTime, that) {
    // 倒计时
    function leftTimer(enddate) {
      var leftTime = (new Date(enddate)) - new Date(); //计算剩余的毫秒数
      var days = parseInt(leftTime / 1000 / 60 / 60 / 24, 10); //计算剩余的天数
      var hours = parseInt(leftTime / 1000 / 60 / 60 % 24, 10); //计算剩余的小时
      var minutes = parseInt(leftTime / 1000 / 60 % 60, 10);//计算剩余的分钟
      var seconds = parseInt(leftTime / 1000 % 60, 10);//计算剩余的秒数
      days = checkTime(days);
      hours = checkTime(hours);
      minutes = checkTime(minutes);
      seconds = checkTime(seconds);
      let latestTextArr = [days, hours, minutes, seconds];
      if (days >= 0 || hours >= 0 || minutes >= 0 || seconds >= 0) return that.setState({
        latestTextArr
      })
      if (days <= 0 && hours <= 0 && minutes <= 0 && seconds <= 0) {
        clearInterval(that.timer);
      }
    }
    function checkTime(i) { //将0-9的数字前面加上0，例1变为01
      if (i < 10) {
        i = "0" + i;
      }
      return i;
    }
    function latestTime() {
      if (that.timer) clearInterval(that.timer);
      var date1 = nowServerTime, data2 = new Date(v.getFullYear() + '-' + (v.getMonth() + 1) + '-' + v.getDate() + ' ' + v.getHours() + ':' + v.getMinutes() + ':' + v.getSeconds());
      if (data2 < date1) return;//设置的时间小于现在时间退出
      that.timer = setInterval(function () { leftTimer(data2) }, 1000);
    }
    latestTime();
  }
};
