    // import menuObj from './crumbMenu.js';
    const reg = /(((^https?:(?:\/\/)?)(?:[-;:&=\+\$,\w]+@)?[A-Za-z0-9.-]+|(?:www.|[-;:&=\+\$,\w]+@)[A-Za-z0-9.-]+)((?:\/[\+~%\/.\w-_]*)?\??(?:[-\+=&;%@.\w_]*)#?(?:[\w]*))?)$/g;

    function isObj(object) {
        return object && typeof(object) == 'object' && Object.prototype.toString.call(object).toLowerCase() == "[object object]";
    }

    function isArray(object) {
        return object && typeof(object) == 'object' && object.constructor == Array;
    }

    function getLength(object) {
        var count = 0;
        for(var i in object) count++;
        return count;
    }

    function CompareObj(objA, objB, flag) {
        for(var key in objA) {
            if(!flag) //跳出整个循环
                break;
            if(!objB.hasOwnProperty(key)) {
                flag = false;
                break;
            }
            if(!isArray(objA[key])) { //子级不是数组时,比较属性值
                if(objB[key] != objA[key]) {
                    flag = false;
                    break;
                }
            } else {
                if(!isArray(objB[key])) {
                    flag = false;
                    break;
                }
                var oA = objA[key],
                    oB = objB[key];
                if(oA.length != oB.length) {
                    flag = false;
                    break;
                }
                for(var k in oA) {
                    if(!flag) //这里跳出循环是为了不让递归继续
                        break;
                    flag = CompareObj(oA[k], oB[k], flag);
                }
            }
        }
        return flag;
    }


    //瀑布流函数
    function getByClass(parent,className){
        var boxArr = new Array();//用来获取所有class为box的元素
        var oElement = parent.getElementsByTagName('*');
        for (var i = 0; i <oElement.length; i++) {
            if(oElement[i].className == className){
                boxArr.push(oElement[i]);
            }
        }
        return boxArr;
    }


    //获取当前最小值得下标
    function getMinhIndex(array,min){
        for(var i in array){
            if(array[i] == min)
                return i;
        }
    }

    var commonFun = {};

    commonFun.regMoney =/^0$|^[1-9]\d{0,17}$|^[1-9]\d{0,17}\.{1}\d{1,4}$|^0\.{1}\d{1,4}$/g;  //最大的数字为
    commonFun.maxMoney = '99999999999999.9999';
    commonFun.keyUpAmount=(ev)=>{
    var target = ev.target;
    var moneyVal = target.value;
    target.value=moneyVal.replace(/[^0-9.]/g,'');
    if(target.value>=commonFun.maxMoney){
        target.value=commonFun.maxMoney;
    }
    }

    commonFun.CompareJSON=function(objA, objB) {
        if(!isObj(objA) || !isObj(objB)) return false; //判断类型是否正确
        if(getLength(objA) != getLength(objB)) return false; //判断长度是否一致
        return CompareObj(objA, objB, true); //默认为true
    };

    // commonFun.menuObj = menuObj;
    commonFun.hasClass = function (obj, cls) {
        return obj
            .className
            .match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
    };
    commonFun.addClass = function (obj, cls) {
        if (!this.hasClass(obj, cls))
            obj.className += " " + cls;
    };
    commonFun.removeClass = function (obj, cls) {
        if (this.hasClass(obj, cls)) {
            var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
            obj.className = obj
                .className
                .replace(reg, ' ');
        }
    }

    commonFun.countDownLoan = function (option, callback) {
        let defaultOpt = {
            btnDom: '',
            time: 60,
            textCounting: '秒',
            isAfterText: '重新发送'
        };
        let options = Object.assign({}, defaultOpt, option),
            downtimer;
        let countBtn = options.btnDom;

        let countDownStart = function () {
            let isInputButton = countBtn
                .tagName
                .toUpperCase() == 'INPUT';
            if (isInputButton) {
                countBtn.value = options.time + options.textCounting;
            } else {
                countBtn.innerText = options.time + options.textCounting
            }
            countBtn.setAttribute('disabled', 'disabled');
            commonFun.addClass(countBtn, 'count-downing');

            if (options.time == 0) {
                //结束倒计时
                clearInterval(downtimer);
                callback && callback();
                if (isInputButton) {
                    countBtn.value = options.isAfterText;
                } else {
                    countBtn.innerText = options.isAfterText;
                }
                countBtn.removeAttribute('disabled');
                commonFun.removeClass(countBtn, 'count-downing');
            } else {
                options.time = options.time - 1;
            }

        }
        if (options.time > 0) {
            countDownStart(); //立即调用一次，解决延迟加载的问题
            downtimer = setInterval(function () {
                countDownStart();
            }, 1000);
        }
    }
    //根据路由确定面包屑的菜单
    // commonFun.deepJsonMenu = function (page) {
    //     if (!page) {
    //         return;
    //     }
    //     var result = {},
    //         obj = commonFun.menuObj;
    //     var menu = page.split('/'),
    //         testObj = {};
    //     var firstLevel = obj[menu[0]];
    //     var otherObj = firstLevel;
    //     testObj[0] = firstLevel;
    //     for (var i = 1, len = menu.length; i < len; i++) {
    //         testObj[i] = otherObj.subMenu[menu[i]];
    //         otherObj = testObj[i];
    //     }
    //     return testObj;
    // }
    //根据url获取到同级别的属性
    // commonFun.filterJsonForUrl = function (page) {
    //     var result = {};
    //     var menuObj = commonFun.menuObj;
    //     (function walkTree(obj, page) {
    //         for (var key in obj) {
    //             if (obj[key].url) {
    //                 if (obj[key].url.replace('#', '') == page.replace('#', '')) {
    //                     result = obj[key];
    //                     break;
    //                 }
    //             }
    //             if (obj[key].subMenu) {
    //                 walkTree(obj[key].subMenu, page);
    //             }
    //         }
    //     })(menuObj, page);
    //     return result;
    // }

    commonFun.isUrl = function (path) {
        return reg.test(path);
    }

    //根据路由，加载顶部的哪个模块
    // commonFun.activeTopMenu = function () {
    //     let topmenu = {
    //         personalAccount: 'personal',
    //         API: 'product',
    //         h5: 'html',
    //         code: 'code',
    //         pop: 'pop'
    //     };
    //     let hash = location.hash,
    //         currentMenu = '';
    //
    //     for (let opt in topmenu) {
    //         if (topmenu[opt] == hash.replace(/#\//g, '').split('/')[0]) {
    //             currentMenu = topmenu[opt];
    //         }
    //     }
    //     return currentMenu;
    //
    // }

    commonFun.getBusinessApplicationId = function(AppCode){
        const applicationList = JSON.parse(localStorage.getItem('applicationList'));
        var id = '';
        for(var i=0; i<applicationList.length; i++){
            if(applicationList[i].AppCode == AppCode){
                id = applicationList[i].Id;
                break;
            }
        }
        return id;
    }

    // 获取地址栏参数
    commonFun.GetQueryString=function (paramStr,name) {
        if(!paramStr){
        return;
        }
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        var r = paramStr.match(reg);
        if (r != null) return decodeURIComponent(r[2]); return null;
    }
    //验证是否为IP
    commonFun.isValidIP=function(ip) {
        var reg = /^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$/
        return reg.test(ip);
    }
    //验证是否为正确的邮箱
    commonFun.isValidEmail= function(email){
    var reg = /^[a-zA-Z0-9_-]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/;
    return reg.test(email);
    }
    // 验证身份证有效性
    commonFun.IdentityCodeValid=function(code) {
        let city={11:"北京",12:"天津",13:"河北",14:"山西",15:"内蒙古",21:"辽宁",22:"吉林",23:"黑龙江 ",31:"上海",32:"江苏",33:"浙江",34:"安徽",35:"福建",36:"江西",37:"山东",41:"河南",42:"湖北 ",43:"湖南",44:"广东",45:"广西",46:"海南",50:"重庆",51:"四川",52:"贵州",53:"云南",54:"西藏 ",61:"陕西",62:"甘肃",63:"青海",64:"宁夏",65:"新疆",71:"台湾",81:"香港",82:"澳门",91:"国外 "};
        let pass= true;

        if (!code || !/\d{17}[\d|x]/i.test(code)) {
            pass = false;
        }

        else if(!city[code.substr(0,2)]){
            pass = false;
        }
        else{
            //18位身份证需要验证最后一位校验位
            if(code.length == 18){
                code = code.split('');
                //∑(ai×Wi)(mod 11)
                //加权因子
                let factor = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2 ];
                //校验位
                let parity = [ 1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2 ];
                let sum = 0;
                let ai = 0;
                let wi = 0;
                for (let i = 0; i < 17; i++)
                {
                    ai = code[i];
                    wi = factor[i];
                    sum += ai * wi;
                }
                if(parity[sum % 11] != code[17]){
                    pass =false;
                }
            }
        }
        return pass;
    }
    //格式化金额
    commonFun.formatMoney=function(s, n) {
        if(s==='' || s=='underfined') {
            return;
        }
        n = n > 0 && n <= 20 ? n : 4;
        s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
        var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];
        var t = "";
        for (let i = 0; i < l.length; i++) {
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
        }
        return t.split("").reverse().join("") + "." + r;
    }

    commonFun.IEVersion=function() {
        var userAgent = navigator.userAgent; //取得浏览器的userAgent字符串
        var isIE = userAgent.indexOf("compatible") > -1 && userAgent.indexOf("MSIE") > -1; //判断是否IE<11浏览器
        var isEdge = userAgent.indexOf("Edge") > -1 && !isIE; //判断是否IE的Edge浏览器
        var isIE11 = userAgent.indexOf('Trident') > -1 && userAgent.indexOf("rv:11.0") > -1;
        if(isIE) {
            var reIE = new RegExp("MSIE (\\d+\\.\\d+);");
            reIE.test(userAgent);
            var fIEVersion = parseFloat(RegExp["$1"]);
            if(fIEVersion == 7) {
                return 7;
            } else if(fIEVersion == 8) {
                return 8;
            } else if(fIEVersion == 9) {
                return 9;
            } else if(fIEVersion == 10) {
                return 10;
            } else {
                return 6;//IE版本<=7
            }
        } else if(isEdge) {
            return 'edge';//edge
        } else if(isIE11) {
            return 11; //IE11
        }else{
            return -1;//不是ie浏览器
        }
    }
    //滚动条在Y轴上的滚动距离
    commonFun.getScrollTop=function(){
    　　var scrollTop = 0, bodyScrollTop = 0, documentScrollTop = 0;
    　　if(document.body){
    　　　　bodyScrollTop = document.body.scrollTop;
    　　}
    　　if(document.documentElement){
    　　　　documentScrollTop = document.documentElement.scrollTop;
    　　}
    　　scrollTop = (bodyScrollTop - documentScrollTop > 0) ? bodyScrollTop : documentScrollTop;
    　　return scrollTop;
    }
    commonFun.formatTodayDate= function(date){
        var d = date ? new Date(date) : new Date(),
        month = '' + (d.getMonth() + 1),
        day = '' + d.getDate(),
        year = d.getFullYear();

        if (month.length < 2) month = '0' + month;
        if (day.length < 2) day = '0' + day;
        return {
            beginTime:[year, month, day].join('-') + ' ' + '00:00:00',
            endTime:[year, month, day].join('-') + ' ' + '23:59:59',
            today:[year, month, day].join('-')
        }
    }
    // 设置时间格式
    commonFun.getDate = (date) => {
        return date ? date.format('YYYY-MM-DD HH:mm:ss') :'';
    }

    //商品分类级联菜单 ，
    //通过 一级分类查找 二级分类ID
    //通过 二级分类 查找一级分类ID
    commonFun.getCurrentCategoryByThird = function (productData, thirdId) {
        let filterObj = {};
        productData.forEach((option, index) => {
            const isThisfilterSecond = option.childList.filter((item, ind) => {
                const isThisfilterThird = item.thirdList.filter((value, idx) => {
                    return value.thirdId == thirdId;
                });
                if (isThisfilterThird.length) {
                    return item
                }
            })
            if (isThisfilterSecond.length) {
                filterObj = isThisfilterSecond[0];
                return 
            }
        })
        return filterObj;
    }

    commonFun.getCurrentCategoryBySecond = function (productData, secondId) {
        const filterFirst = productData.filter((option, index) => {
            const isThisfilterSecond = option.childList.filter((item, ind) => {
                return item.secondId == secondId;
            });
            if (isThisfilterSecond.length) {
                return option;
            }
        })
        return {
            firstId: filterFirst[0].firstId,
            childList: filterFirst[0].childList
        };
    }
    commonFun.getSecondCategoryByFirst = function (productData, firstId) {
        const getSecondList = productData.filter((option, index) => {
            return option.firstId == firstId;
        });
        return getSecondList[0].childList;
    }

    commonFun.waterFull=function(parent,children){
        var oParent = document.getElementById(parent);
        var oBoxs = getByClass(oParent,children);
        //计算整个页面显示的列数
        var oBoxW = oBoxs[0].offsetWidth;
        var cols = Math.floor(document.documentElement.clientWidth/oBoxW);
        //设置main的宽度，并且居中
        oParent.style.cssText = 'width:'+oBoxW * cols +'px; margin: 0 auto';
        //找出高度最小的图片，将下一个图片放在下面
        //定义一个数组，存放每一列的高度，初始化存的是第一行的所有列的高度
        var arrH = [];
        for(var i = 0; i< oBoxs.length ; i++){
            if(i < cols){
                arrH.push(oBoxs[i].offsetHeight);
            }
            else{
                var minH = Math.min.apply(null,arrH);
                var minIndex = getMinhIndex(arrH,minH);
                oBoxs[i].style.position = 'absolute';
                oBoxs[i].style.top= minH + 'px';
                oBoxs[i].style.left = minIndex * oBoxW + 'px';
                arrH[minIndex] += oBoxs[i].offsetHeight;
            }
        }
    }

    commonFun.CommonText = {
        MemberPrimaryTypeObj:{
            1:'收入',
            2:'支出',
            3:'资金冻结',
            4:'资金解冻'
        },
        statusObj:{
            0:'未处理',
            1:'成功',
            2:'失败'
        },
        MemberChildPrimaryTypeObj:{
            1:'加款收入',
            2:'加款冻结',
            3:'加款解冻',
            4:'提现支出',
            5:'提现冻结支出',
            6:'提现撤销收入',
            7:'订单冻结支出',
            8:'订单失败解冻收入',
            9:'手工退款收入',
            10:'进货支出',
            11:'售后退款'
        },
        MarkObj:{
            '1':'+',
            '0':' ',
            '-1':'-'
        },
        AuditStatusObj:{
            0:'待审核',
            1:'审核未通过',
            2:'审核通过'
        },
        AuditStatusObj2:{
            0:'待审核',
            1:'审核通过',
            2:'审核未通过'
        },
        //后期需要把 AuditStatusObj 与 AuditStatusObj2 统一合并下
        OrderOuterStatus:{
            1:'未处理',
            2:'处理中',
            3:'成功',
            4:'失败',
            5:'退款',
            6:'补充'
        },
        OperationType: {
            1: '创建卡券批次',
            2: '生成优惠券',
            3: '下载优惠券',
            4: '删除卡券批次',
            5: '禁用优惠券'
        }
    }
    commonFun.toDecimal4= function (x) {
        if (x == 0) {
            return x;
        }
        if (!x) {
            return '';
        }
        var s = x.toString();
        var rs = s.indexOf('.');
        if (rs < 0) {
            //为整数时
            return s + '.0000';
        } else {
            var o = s.split('.')[0];
            var d = s.split('.')[1];
            var L = d.length;
            var temp = d;
            for (var i = L; i < 4; i++) {
                temp += '0';
            }
            return o + '.' + temp;
        }
    }

    // 数据大了有精度问题
    commonFun.formatMoney = function (s, n) {
        if (!s || s == '' || s == 'underfined') {
            return 0;
        }
        n = n > 0 && n <= 20 ? n : 4;
        s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
        var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];
        var t = "";
        for (let i = 0; i < l.length; i++) {
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
        }
        return t.split("").reverse().join("") + "." + r;
    }

    commonFun.calc = function (arg1, symbol, arg2) {
        if (!arg1 && arg1 !== 0 && arg1 !== "0") {
            return "";
        }
        if (!arg2 && arg2 !== 0 && arg2 !== "0") {
            return "";
        }
        switch (symbol) {
            case "+":
                return commonFun.accAdd(arg1, arg2);
            case "-":
                return commonFun.Subtr(arg1, arg2);
            case "*":
                return commonFun.accMul(arg1, arg2);
            case "/":
                return commonFun.accDiv(arg1, arg2);
        }
    }

    // 除法
    commonFun.accDiv= function (arg1, arg2) {
        var t1 = 0, t2 = 0, r1, r2;
        try { t1 = arg1.toString().split(".")[1].length } catch (e) { }
        try { t2 = arg2.toString().split(".")[1].length } catch (e) { }
        r1 = Number(arg1.toString().replace(".", ""))
        r2 = Number(arg2.toString().replace(".", ""))
        return commonFun.accMul((r1 / r2), Math.pow(10, t2 - t1));
    }
    // 乘法
    commonFun.accMul= function (arg1, arg2) {
        var m = 0, s1 = arg1.toString(), s2 = arg2.toString();
        try { m += s1.split(".")[1].length } catch (e) { }
        try { m += s2.split(".")[1].length } catch (e) { }
        return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m)
    }
    // 加法
    commonFun.accAdd= function (arg1, arg2) {
        var r1, r2, m;
        try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 }
        try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 }
        m = Math.pow(10, Math.max(r1, r2))
        return (arg1 * m + arg2 * m) / m
    }
    // 减法
    commonFun. Subtr= function (arg1, arg2) {
        var r1, r2, m, n;
        try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 }
        try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 }
        m = Math.pow(10, Math.max(r1, r2));
        n = (r1 >= r2) ? r1 : r2;
        return ((arg1 * m - arg2 * m) / m).toFixed(n);
    }
export default commonFun;
