import React from 'react';
import { connect } from 'dva';
import {Form,Input,message,Row,Col,Select,DatePicker,Button,Radio,Spin } from  "antd";
import moment from 'moment';
const { Option } = Select;
const { TextArea } = Input;
import './less/GoodsEdit.less';
import BreadCrumb from '../../../components/Breadcrumb';
import commonFun from '../../../utils/utils';
import statusText from '../../../utils/statusText';
import ComModal from '../../../components/ComModal';
class GoodsEdit extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            page:commonFun.GetQueryString(location.search.split('?')[1], "page"),
            categoryIdL1List:[],
            categoryIdL2List:[],
            categoryIdL3List:[],
            categoryIdL4List:[],
            dataList:{},
            productTypeList:[// 库存类型数据
                { name: '卡密', value:'3' },
                { name: '直充', value: '4'}
            ], 
            invoiceTypeList:[
                {
                    name:"寄售",
                    value:'0'
                },
                {
                    name:"自营",
                    value:'1'
                }
            ],
            InvoiceArr1 : [
                { type: "1", rate: "3", unit: "%" },
                { type: "2", rate: "3", unit: "%" },
                { type: "1", rate: "6", unit: "%" },
                { type: "2", rate: "6", unit: "%" },
                { type: "1", rate: "10", unit: "%" },
                { type: "2", rate: "10", unit: "%" },
                { type: "1", rate: "13", unit: "%" },
                { type: "2", rate: "13", unit: "%" },
                { type: "1", rate: "16", unit: "%" },
                { type: "2", rate: "16", unit: "%" }
            ],
            InvoiceArr0 : [
                { type: "1", rate: "0", unit: "%" },
                { type: "0", rate: "", unit: "" }
            ],
            saleStatusList:[
                { name: '上架', value: '2' },
                { name: '下架', value: '1' },
                { name: '官方维护', value: '3' },
                { name: '库存维护', value: '4' }
            ],
            stockStatusList:[
                { name: '断货', value: '1' },
                { name: '警报', value: '2' },
                { name: '充足', value: '3' }
            ],
            ParentId:0,
            categoryType:0,
            categoryTagList:[
                { name: '话费', value: 1 },
                { name: '流量', value: 2 },
                { name: '其他', value: 3 },
            ],
            AreaList:[],
            VirtualOperatorList:[
                {
                    name:"移动",
                    value:"移动"
                },
                {
                    name:"联通",
                    value:"联通"
                }, {
                    name:"电信",
                    value:"电信"
                }, {
                    name:"虚拟",
                    value:"虚拟"
                }
            ],
            PacketTypeList:[
                {
                    name:"分省",
                    value:1
                },{
                    name:"全国",
                    value:3
                }
            ],
            PacketKindList:[
                {
                    name:"小时",
                    value:1
                },{
                    name:"日",
                    value:2
                },
                {
                    name:"7天",
                    value:3
                },{
                    name:"月",
                    value:4
                },
                {
                    name:"季度",
                    value:5
                },{
                    name:"半年",
                    value:6
                },
                {
                    name:"年",
                    value:7
                }
            ],
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            total:0,
            cardGroupList:[],
            directChargeGroupList:[],
            selectGroupData:[],
            showComModal:false,
            dataResource:{
                dataSource:[],
                total:0
            },
            templateselectData:[],
            modalName:'', // 公共modal组件标识
            showtelrate:false, // 显示话费属性
            showtelrateRequire:false, // 话费附属属性是否必填
            showflow:false, // 显示流量属性
            showflowRequire:false, // 流量附属属性是否必填
            showOperatorName:false, // 厂商名称
            categoryTag:'',
            areaVal:'',
            InvoiceTypeDisabled:false,
            showoperatorNameType:false,
            showGroupId:false,
            isSubmit:false,
            showproductType:3,
            isRenderOnce:false
        }
	}

    componentDidMount (){
        const {page}= this.state;
        if(page&&page=='edit'){
            this.GetProductDetail();
        }else{
            this.getProductCategoryListByParentId(0)
            this.GetAreaList()
        }
        
    }
    
    // 获取商品详情
    GetProductDetail = ()=>{
        let id = commonFun.GetQueryString(location.search.split('?')[1], "id");
        this.props.dispatch({
            type: 'goods/GetProductDetail', 
            payload: {
                id
            } 
        });
    }

    renderInvoiceTypeList = (val)=>{
        const { InvoiceArr0,InvoiceArr1 } = this.state;
        let arr= []
        if(val=='0'){
            arr= InvoiceArr0&&InvoiceArr0.map((item)=>{
                return {
                    label:item.rate + item.unit + statusText.SecondInvoiceType[item.type],
                    value:item.type + '/' + item.rate
                }
            })
        }else  if(val=='1'){
            arr= InvoiceArr1&&InvoiceArr1.map((item)=>{
                return {
                    label:(item.rate + item.unit + statusText.SecondInvoiceType[item.type]),
                    value:item.type + '/' + item.rate
                }
            })
        }
        this.setState({
            SecondInvoiceTypeList:arr
        })
    }
    // 编辑数据回填
    renderDetail=()=>{
        const { id,productName,faceValue,productType,price,groupName,groupId,invoiceType,secondInvoiceType,invoiceRate,saleStatus, stockStatus,categoryTag,templateName,templateId,productUnit,
            subscriptsIcon,area,virtualOperator,operatorName,packetType,packetSize,rechargeTimes,currentMonthExpires,packetKind,protectBeginTime,protectEndTime,content } = this.state.dataList;
        if(!this.state.dataList||!id){
            message.destroy();
            message.warning("获取该编辑商品信息失败")
            return false
        } 
        console.log(area,categoryTag)
        this.props.form.setFieldsValue({
            productName,
            faceValue,
            productType,
            price,
            groupName,
            groupId,
            invoiceType,
            invoiceRate,
            saleStatus,
            templateName,
            templateId,
            stockStatus,
            categoryTag,
            productUnit,
            subscriptsIcon,
            area,
            virtualOperator,
            operatorName,
            packetType,
            packetSize,
            currentMonthExpires,
            packetKind,
            protectBeginTime:protectBeginTime?moment(moment(protectBeginTime).format('YYYY-MM-DD HH:mm:ss')):null,
            protectEndTime:protectEndTime?moment(moment(protectEndTime).format('YYYY-MM-DD HH:mm:ss')):null,
            content
        })
        this.setState({
            showproductType:productType,
            isRenderOnce:true,
            areaVal:area,
            categoryTag
        },()=>{
            this.getProductCategoryListByParentId(0)
        })
        this.renderInvoiceTypeList(invoiceType)
        if(invoiceType==='0'||invoiceType===0){
            if(secondInvoiceType=='0'&&invoiceRate==null){
                this.props.form.setFieldsValue({
                    secondInvoiceType:secondInvoiceType+'/'
                })
            }else{
                this.props.form.setFieldsValue({
                    secondInvoiceType:secondInvoiceType+'/'+invoiceRate
                })
            }
        }else if(invoiceType==1){
            if(!invoiceRate||invoiceRate=='0'){
                this.props.form.setFieldsValue({
                    secondInvoiceType:''
                })
            }else{
                this.props.form.setFieldsValue({
                    secondInvoiceType:secondInvoiceType+'/'+invoiceRate
                })
            }
        }
           
        if(rechargeTimes>0){
            this.props.form.setFieldsValue({
                rechargeTimes:-1,
                rechargeTimesipt:rechargeTimes
            })
        }else{
            this.props.form.setFieldsValue({
                rechargeTimes,
            })
        }
    }

    

    GetAreaList=()=>{
        this.props.dispatch({
            type: 'goods/GetAreaList', 
            payload: {
                ParentId : 0
            } 
        });
    }

    // 获取商品分类
    getcategory = (val,type)=>{
        const { categoryIdL2List,categoryIdL3List  } = this.state;
        switch(type){
            case 1:
                this.setState({
                    areaVal:''
                },()=>{
                    this.resetData()
                    this.controlColumnDisplayNew()
                    this.props.form.setFieldsValue({
                        categoryIdL2:'',
                        categoryIdL3:'',
                        categoryIdL4:'',
                        categoryTag:null,
                        area:''
                    })
                })
            break;
            case 2:
                let obj = categoryIdL2List.find((item)=>{
                    return item.value==val
                })
                this.props.form.setFieldsValue({
                    categoryIdL3:'',
                    categoryIdL4:'',
                })
                this.setState({
                    showtelrate:true,
                    categoryTag:obj.categoryTag,
                    areaVal:'全国'
                },()=>{
                    this.resetData()
                    this.controlColumnDisplayNew(obj.categoryTag||3)
                    if (!val && val !== 0) {
                        this.props.form.setFieldsValue({
                            operatorName:''
                        })
                    } else{
                        if(obj.categoryTag == 1 || obj.categoryTag == 2){
                            if(obj.name== "中国移动" || obj.name== "中国联通" || obj.name== "中国电信"){
                                this.props.form.setFieldsValue({
                                    operatorName:obj.name
                                })
                            }else if(obj.name== '虚拟话费'){
                                this.props.form.setFieldsValue({
                                    operatorName:'中国移动'
                                })
                            }else{
                                this.props.form.setFieldsValue({
                                    operatorName:''
                                })
                            }
                        }
                    }
                })
                this.props.form.setFieldsValue({
                    categoryTag:obj.categoryTag||3,
                    area:'全国'
                })
            break;
            case 3 :
                if (this.state.categoryTag == 1 || this.state.categoryTag == 2) {
                    let obj = categoryIdL3List.find((item)=>{
                        return item.value==val
                    })
                    this.setState({
                        areaVal:obj.name
                    },()=>{
                        this.props.form.setFieldsValue({
                            area:obj.name
                        })
                    })
                }
                break;
        }
        this.setState({
            categoryType:type,
            isRenderOnce:false
        },()=>{
            this.getProductCategoryListByParentId(val)
        })
    }

    getProductCategoryListByParentId=(val)=>{
        this.props.dispatch({
            type: 'common/GetProductCategoryListByParentId', 
            payload: {
                ParentId:val,
                CategoryName:''
            } 
        });
    }

    // 选四级分类
    selectCategoryIdL4 =(val,categoryIdL4)=>{
        if(categoryIdL4&&categoryIdL4.length>0){
            let data = categoryIdL4.find((item)=>{
                return item.value==val
            })
            if(!data&&!data.value){
                message.destroy();
                message.warning("请选择商品分类")
                return;
            }
            this.props.form.setFieldsValue({
                faceValue:data.faceValue
            })
        }
    }
    selectInvoiceTypeList=(val)=>{
        const { InvoiceArr0,InvoiceArr1,selectGroupData } = this.state;
        let arr= []
        if(!this.props.form.getFieldsValue(["groupId"])['groupId']){
            this.setState({
                InvoiceTypeDisabled:true
            },()=>{
                this.props.form.setFieldsValue({
                    invoiceType:''
                })
                message.destroy();
                message.warning("请选择库存之后再操作！")
            })
            return 
        }
        if(val=='0'){
            arr= InvoiceArr0&&InvoiceArr0.map((item)=>{
                return {
                    label:item.rate + item.unit + statusText.SecondInvoiceType[item.type],
                    value:item.type + '/' + item.rate
                }
            })
        }else  if(val=='1'){
            arr= InvoiceArr1&&InvoiceArr1.map((item)=>{
                return {
                    label:(item.rate + item.unit + statusText.SecondInvoiceType[item.type]),
                    value:item.type + '/' + item.rate
                }
            })
        }
        this.setState({
            SecondInvoiceTypeList:arr,
        },()=>{
            this.props.form.setFieldsValue({
                secondInvoiceType:''
            })
        })
    }

    initcategoryTag=(val)=>{
        switch(val){
            case 1:
            return "话费"
            break;
            case 2:
            return "流量"
            break;
            default:
            return "其他"
            break; 
        }
    }
 
    Trim=(str)=>{
        return str.replace(/(^\s*)|(\s*$)/g, "");
    }

    validFunction = (rule, value, callback) => {
        let patter = /[^\d\.]/;
        if(rule.field=="faceValue" || rule.field == 'price'){
            if(value&&patter.test(value)){
                callback("请输入数字");
            }
        } 
    }

    chooseGroupName=()=>{
        const params = this.props.form.getFieldsValue(["productType","faceValue"])
        const {postData,condition } = this.state;
        this.initModalData()
        if(!params.productType){
            message.destroy()
            message.warning("请选择库存类型！")
            return;
        }else if(!params.faceValue){
            message.destroy()
            message.warning("请选择商品面值！")
            return ;
        }else{
            const data ={
                ...postData,
                ...condition,
                faceValue:params.faceValue
            }
            if(params.productType=='3'){
                this.setState({
                    modalName:'groupCardName',
                    showComModal:true
                },()=>{
                    this.getModalData('cardStock/GetCardGroupList',data)
                })
            }else  if(params.productType=='4'){
                this.setState({
                    modalName:'groupRechargeName',
                    showComModal:true
                },()=>{
                    this.getModalData('rechargeStock/GetDirectChargeGroupList',data)
                })
            }
        }
    }

    // 直充选择模板
    chooseTemplateName=()=>{
        const {selectGroupData,postData,condition,dataList} = this.state;
        this.initModalData()
        if(this.props.form.getFieldsValue(['groupId'])['groupId']){
            this.setState({
                showComModal:true,
                modalName:'templateName'
            },()=>{
                let  params =null;
                if(this.state.page=='edit'){
                    if(selectGroupData&&selectGroupData.length>0&&selectGroupData[0].templateIds){
                        params={
                            ...postData,
                            ...condition,
                            ids: selectGroupData[0].templateIds
                        }
                    }else{
                        params={
                            ...postData,
                            ...condition,
                            ids:dataList&&dataList.templateIds?JSON.parse(dataList.templateIds):[]
                        }
                    }
                }else{
                    params={
                        ...postData,
                        ...condition,
                        ids: selectGroupData[0].templateIds
                    }
                }
                
                this.getModalData('goods/GetTemplateList',params)
            })
        }else{
            message.destroy()
            message.warning("请选择库存之后再操作！")
            return ;
        }
    }


    getFormValue=(condition,postData,isrefresh)=>{
        const {selectGroupData,modalName,dataList} = this.state;
        const paramsobj = this.props.form.getFieldsValue(["productType","faceValue"])
        this.setState({
            condition,
            postData,
        },()=>{
            if(isrefresh){
                if(modalName=='templateName'){
                    let  params =null;
                    if(this.state.page=='edit'){
                        if(selectGroupData&&selectGroupData.length>0&&selectGroupData[0].templateIds){
                            params={
                                ...postData,
                                ...condition,
                                ids: selectGroupData[0].templateIds
                            }
                        }else{
                            params={
                                ...postData,
                                ...condition,
                                ids:dataList&&dataList.templateIds?JSON.parse(dataList.templateIds):[]
                            }
                        }
                    }else{
                        params={
                            ...postData,
                            ...condition,
                            ids: selectGroupData[0].templateIds
                        }
                    }
                    this.getModalData('goods/GetTemplateList',params)
                }else if(modalName=='groupCardName'){
                    const data ={
                        ...postData,
                        ...condition,
                        faceValue:paramsobj.faceValue
                    }
                    this.getModalData('cardStock/GetCardGroupList',data)
                }else if(modalName=='groupRechargeName'){
                    const data ={
                        ...postData,
                        ...condition,
                        faceValue:paramsobj.faceValue
                    }
                    this.getModalData('rechargeStock/GetDirectChargeGroupList',data)
                } 
            }
        })
    }

    initModalData=()=>{
        this.setState({
            modalName:'',
            showComModal:false,
            dataResource:{
                dataSource:[],
                total:0
            }
        })
    }

    closeModal=()=>{
        this.setState({
            showComModal:false
        })
    }

    getModalData=(url,params)=>{
        this.props.dispatch({
            type: url, 
            payload: {
                ...params
            } 
        });
    }

    submitData=(selectData,selectedRowKeys)=>{
        const { modalName } = this.state;
        if(modalName=='templateName'){
            this.setState({
                templateselectData:selectData
            },()=>{
                this.props.form.setFieldsValue({
                    templateName:selectData[0].addressName,
                    templateId:selectData[0].id
                },()=>{
                    this.closeModal()
                })
            })
        }else if(modalName=='groupCardName'||modalName=='groupRechargeName'){
            if(!selectData||selectData.length<=0){
                message.destroy();
                message.warning("请选择库存组")
                return false;
            }else{
                this.setState({
                    selectGroupData:selectData,
                    showComModal:false,
                    InvoiceTypeDisabled:false
                },()=>{
                    this.props.form.setFieldsValue({
                        invoiceType:String(selectData[0].invoiceType),
                        groupName:selectData[0].groupName,
                        groupId:selectData[0].id,
                        templateName:'',
                        templateId:''
                    },()=>{
                        this.renderInvoiceTypeList(String(selectData[0].invoiceType))
                    })
                    
                })
            }
        }
    }

    goBack = ()=>{
        this.props.history.push('/goodsList')
    }

    confirmData=()=>{
        const _this = this;
        const {　selectGroupData,templateselectData,page,dataList　}　= this.state;
        this.setState({
            isSubmit:true
        })
        this.props.form.validateFields((err, value) => {
            if(!err){
                if (value.faceValue <= 0) {
                    message.destroy();
                    message.warning('商品面值必须大于0!');
                    this.setState({
                        isSubmit:false
                    })
                    return;
                }
                if(page=="add"){
                    const str = value.secondInvoiceType
                    value.groupId = selectGroupData[0].id
                    value.groupName = selectGroupData[0].groupName
                    value.secondInvoiceType= str.split('/')[0]
                    value.invoiceRate = str.split('/')[1]
                    if(value.rechargeTimes ==-1){
                        value.rechargeTimes=value.rechargeTimesipt
                    }
                    delete value.rechargeTimesipt
                    value.id='';
                    _this.props.dispatch({
                        type: 'goods/ProductCreate', 
                        payload: {
                        ...value
                        } 
                    });
                }else if(page=="edit"){
                    if(dataList&&dataList.id){
                        const str = value.secondInvoiceType
                        value.id=dataList.id;
                        value.secondInvoiceType= str.split('/')[0]
                        value.invoiceRate = str.split('/')[1]
                        if(value.rechargeTimes ==-1){
                            value.rechargeTimes=value.rechargeTimesipt
                        }
                        delete value.rechargeTimesipt
                    }else{
                        this.setState({
                            isSubmit:false
                        })
                        return false
                    }
                    _this.props.dispatch({
                        type: 'goods/ProductUpdate', 
                        payload: {
                        ...value
                        } 
                    });
                }
            }else{
                this.setState({
                    isSubmit:false
                })
            }
        });
    }

    // 选择库存类型时清除库存组数据
    changeproductType =(val)=>{
        this.props.form.setFieldsValue({
            groupName:'',
            groupId:'',
            productType:val,
            templateId:'',
            templateName:''
        })
        this.setState({
            showproductType:val
        })
    }


    resetData=()=>{
        this.props.form.setFieldsValue({
            area:'全国',
            operatorName:'',
            packetType:'3',
            packetSize:'',
            rechargeTimes:'0',
            rechargeTimesipt:'',
            currentMonthExpires:'1',
            packetKind:'1'
        })
    }

    changeSaleStatus=(val)=>{
        if(val!='3'){
            this.props.form.setFieldsValue({
                protectBeginTime:null,
                protectEndTime:null
            })
        }
    }

    controlColumnDisplayNew =(checkedType, OperatorName)=>{
        const {categoryIdL2List} =this.state;
        this.setState({
            showtelrate:false,
            showflow:false
        })
        switch(checkedType){
            case 1:
                //话费
                this.setState({
                    showtelrate:true,
                    showtelrateRequire:true,
                    showoperatorNameType:true
                },()=>{
                    this.props.form.setFieldsValue({
                        area:'全国',
                        virtualOperator:'',
                    })
                })
            break;
            case 2:
                //流量  
                this.setState({
                    showflow:true,
                    showflowRequire:true,
                    showoperatorNameType:true
                })
            break;
            case 3:
                //其他
                let val = this.props.form.getFieldsValue(["categoryIdL2"])
                let name = '';
                if(val&&categoryIdL2List&&categoryIdL2List.length>0){
                    categoryIdL2List.map((item)=>{
                        if(item.value==val.categoryIdL2){
                            name = item.name
                        }
                    })
                }
                this.setState({
                    showOperatorName:true
                },()=>{
                    this.props.form.setFieldsValue({
                        operatorName:name
                    })
                })
            break; 
        }
        if (OperatorName) {
            this.setState({
                showOperatorName:true
            },()=>{
                this.props.form.setFieldsValue({
                    operatorName:OperatorName
                })
            })
        }
    }
    

	componentWillReceiveProps(nextProps) {
        const { props } = this;
        const { GetProductDetail,GetTemplateList,ProductCreate,GetAreaList,ProductUpdate} = nextProps.goods;
        const { GetCardGroupList } = nextProps.cardStock;
        const { GetDirectChargeGroupList } = nextProps.rechargeStock;
        const { GetProductCategoryListByParentId } = nextProps.common;
        // 获取商品详情
        if (GetProductDetail && GetProductDetail !== this.props.goods.GetProductDetail) {
            if(GetProductDetail.code==="0"){
              this.setState({
                dataList:GetProductDetail.data
              },()=>{
                    this.controlColumnDisplayNew(GetProductDetail.data.categoryTag,GetProductDetail.data.operatorName)
                    this.GetAreaList()
              })  
            }else{
                message.destroy();
                message.warning(GetProductDetail.message);
            }
        }
        // 获取商品分类
        if (GetProductCategoryListByParentId && GetProductCategoryListByParentId !== this.props.common.GetProductCategoryListByParentId) {
            if(GetProductCategoryListByParentId.code==="0"){
              switch (this.state.categoryType){
                case 0 :
                    this.setState({
                        categoryIdL1List:GetProductCategoryListByParentId.data&&GetProductCategoryListByParentId.data.list.length>0&&GetProductCategoryListByParentId.data.list.map((item)=>{
                            return {
                                name:item.name,
                                value:item.id
                            }
                        })
                    },()=>{
                        if(this.state.page == 'edit'&&this.state.isRenderOnce){
                            this.props.form.setFieldsValue({
                                categoryIdL1: Number(this.state.dataList.categoryIdL1),
                            })
                            this.setState({
                                categoryType:1
                            },()=>{
                                this.getProductCategoryListByParentId(this.state.dataList.categoryIdL1)
                            })
                        }
                    })
                   
                break;
                case 1: 
                this.setState({
                    categoryIdL2List:GetProductCategoryListByParentId.data&&GetProductCategoryListByParentId.data.list.length>0&&GetProductCategoryListByParentId.data.list.map((item)=>{
                        return {
                            name:item.name,
                            value:item.id,
                            categoryTag:item.categoryTag
                        }
                    })
                },()=>{
                    if(this.state.page == 'edit'&&this.state.isRenderOnce){
                        this.props.form.setFieldsValue({
                            categoryIdL2: Number(this.state.dataList.categoryIdL2),
                        })
                        this.setState({
                            categoryType:2
                        },()=>{
                            this.getProductCategoryListByParentId(this.state.dataList.categoryIdL2)
                        })
                    }
                })
                break;
                case 2: 
                this.setState({
                    categoryIdL3List:GetProductCategoryListByParentId.data&&GetProductCategoryListByParentId.data.list.length>0&&GetProductCategoryListByParentId.data.list.map((item)=>{
                        return {
                            name:item.name,
                            value:item.id
                        }
                    })
                },()=>{
                    if(this.state.page == 'edit'&&this.state.isRenderOnce){
                        this.props.form.setFieldsValue({
                            categoryIdL3: Number(this.state.dataList.categoryIdL3),
                        })
                        this.setState({
                            categoryType:3
                        },()=>{
                            this.getProductCategoryListByParentId(this.state.dataList.categoryIdL3)
                        })
                    }
                    // 当商品分类为手机话费时，区域 自动拉取商品三级地区分类
                    if (this.state.categoryTag == 1 || this.state.categoryTag == 2) {
                        this.props.form.setFieldsValue({
                            area:this.state.areaVal
                        })
                    }
                })
                break;
                case 3: 
                this.setState({
                    categoryIdL4List:GetProductCategoryListByParentId.data&&GetProductCategoryListByParentId.data.list.length>0&&GetProductCategoryListByParentId.data.list.map((item)=>{
                        return {
                            name:item.name,
                            value:item.id,
                            faceValue:item.faceValue
                        }
                    })
                },()=>{
                    if(this.state.page == 'edit'&&this.state.isRenderOnce){
                        this.props.form.setFieldsValue({
                            categoryIdL4: Number(this.state.dataList.categoryIdL4),
                        })
                    }
                })
                break;
              }
             
            }else{
                message.destroy();
                message.warning(GetProductCategoryListByParentId.message);
            }
        }

        if (GetCardGroupList && GetCardGroupList !== this.props.cardStock.GetCardGroupList) {
            if(GetCardGroupList.code==="0"){
                const { dataResource } =this.state;
                dataResource.dataSource=GetCardGroupList.data.list||[]
                dataResource.total = GetCardGroupList.data.total
                this.setState({
                    dataResource
                })
            }else{
                message.destroy();
                message.warning(GetCardGroupList.message);
            }
        }

        if (GetDirectChargeGroupList && GetDirectChargeGroupList !== this.props.rechargeStock.GetDirectChargeGroupList) {
            if(GetDirectChargeGroupList.code==="0"){
                const { dataResource } =this.state;
                dataResource.dataSource=GetDirectChargeGroupList.data.list||[]
                dataResource.total = GetDirectChargeGroupList.data.total
                this.setState({
                    dataResource
                })
            }else{
                message.destroy();
                message.warning(GetDirectChargeGroupList.message);
            }
        }

        if (GetTemplateList && GetTemplateList !== this.props.goods.GetTemplateList) {
            if(GetTemplateList.code==="0"){
                const { dataResource } =this.state;
                dataResource.dataSource=GetTemplateList.data.list||[]
                dataResource.total = GetTemplateList.data.total
                this.setState({
                    dataResource
                })
            }else{
                message.destroy();
                message.warning(GetTemplateList.message);
            }
        }

        if (ProductCreate && ProductCreate !== this.props.goods.ProductCreate) {
            this.setState({
                isSubmit:false
            })
            if(ProductCreate.code==="0"){
               message.destroy();
               message.success("保存成功")
               this.goBack()
            }else{
                message.destroy();
                message.warning(ProductCreate.message);
            }
        }

        if (GetAreaList && GetAreaList !== this.props.goods.GetAreaList) {
            if(GetAreaList.code==="0"){
                this.setState({
                        AreaList:GetAreaList.data.list||[]
                },()=>{
                    if(this.state.page=='edit'){
                        this.renderDetail()
                    }
                })
            }else{
                message.destroy();
                message.warning(GetAreaList.message);
            }
        }

        if (ProductUpdate && ProductUpdate !== this.props.goods.ProductUpdate) {
            this.setState({
                isSubmit:false
            })
            if(ProductUpdate.code==="0"){
               message.destroy();
               message.success("编辑成功")
               this.goBack()
            }else{
                message.destroy();
                message.warning(ProductUpdate.message);
            }
        }

        

        

        
    }

	render() {
        const { getFieldDecorator,getFieldsValue } = this.props.form;
        const {loading} = this.props;
        const {categoryIdL1List,categoryIdL2List,categoryIdL3List,categoryIdL4List,dataList,productTypeList,invoiceTypeList,SecondInvoiceTypeList,saleStatusList,stockStatusList,categoryTagList, AreaList,VirtualOperatorList,PacketTypeList,PacketKindList,showComModal,modalName,showtelrate,showflow,InvoiceTypeDisabled,showtelrateRequire,showflowRequire,showOperatorName,showoperatorNameType,isSubmit} = this.state;
        const breadcrumbList = [
            {
                name:"商品管理",
                href:"/goodsList"
            },
            {
                name:this.state.page=='add'?"新增商品":"编辑商品",
                href:""
            }
        ];
        const formItemLayout = {
            labelCol: {
              span:8
            },
            wrapperCol: {
              span:16
            },
        }
        const formItemLayout1 = {
            labelCol: {
              span:3
            },
            wrapperCol: {
              span:21
            },
        }
        
		return (
			<div className="GoodsEdit">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="GoodsEdit-containter">
                <Spin spinning={(this.props.loading.effects['goods/GetProductDetail']||this.props.loading.effects['common/GetProductCategoryListByParentId']||this.props.loading.effects['goods/GetAreaList'])} >
                    <Form   className="formbox">
                        <div className="firstBox">
                            <h4 className="toptitle">
                                <i className="fa fa-th"></i> 
                                商品主属性
                            </h4>
                            <Row className="firstRow" gutter={16}>
                                <Col span={20} offset={2} >
                                    <Col span={8}>
                                        <Form.Item {...formItemLayout}    label="商品分类">
                                            {getFieldDecorator('categoryIdL1', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择商品分类',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    id="Category1"
                                                    className="formInput"
                                                    placeholder="请选择商品分类"
                                                    onChange={(e)=>{
                                                        this.getcategory(e,1)
                                                    }}
                                                >
                                                {
                                                    categoryIdL1List&&categoryIdL1List.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={5}>
                                        <Form.Item >
                                            {getFieldDecorator('categoryIdL2', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择商品分类',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择商品分类"
                                                    onChange={(e)=>{
                                                        this.getcategory(e,2)
                                                    }}
                                                >
                                                {
                                                    categoryIdL2List&&categoryIdL2List.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={5}>
                                        <Form.Item >
                                            {getFieldDecorator('categoryIdL3', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择商品分类',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择商品分类"
                                                    onChange={(e)=>{
                                                        this.getcategory(e,3)
                                                    }}
                                                >
                                                {
                                                    categoryIdL3List&&categoryIdL3List.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={5}>
                                        <Form.Item >
                                            {getFieldDecorator('categoryIdL4', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择商品分类',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择商品分类"
                                                    onChange={(e)=>{this.selectCategoryIdL4(e,categoryIdL4List)}}
                                                >
                                                {
                                                    categoryIdL4List&&categoryIdL4List.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                </Col>
                                <Col  span={20} offset={2}>
                                    <Col span={8} >
                                        <Form.Item {...formItemLayout}    label="商品名称">
                                            {getFieldDecorator('productName', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请输入商品名称',
                                                    }
                                                ],
                                            })(
                                                <Input className="formInput" placeholder="请输入商品名称"/>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={8} offset={7}>
                                        <Form.Item {...formItemLayout}    label="商品面值（元）">
                                            {getFieldDecorator('faceValue', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请输入商品面值',
                                                    },
                                                    // {validator: this.validFunction}
                                                ],
                                            })(
                                                <Input className="formInput" readOnly placeholder="请输入商品面值"/>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={8} >
                                        <Form.Item {...formItemLayout}  label="库存类型">
                                            {getFieldDecorator('productType', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择库存类型',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择库存类型"
                                                    onChange={this.changeproductType}
                                                >
                                                {
                                                    productTypeList&&productTypeList.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={8} offset={7}>
                                        <Form.Item {...formItemLayout}   label="商品单价">
                                            {getFieldDecorator('price', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请输入商品单价',
                                                    },
                                                    { pattern:new RegExp(/^0$|^[1-9]\d{0,15}$|^[1-9]\d{0,15}\.{1}\d{1,4}$|^0\.{1}\d{1,4}$/,"g"), message: '只能输入正数且最多四位小数'} 
                                                ],
                                            })(
                                                <Input className="formInput" placeholder="请输入商品单价"/>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={8} >
                                        <Form.Item {...formItemLayout}   label="库存组">
                                            {getFieldDecorator('groupName', {
                                                rules: [
                                                    {
                                                        required: showflow?false:true,
                                                        message: '请选择库存组',
                                                    },
                                                ],
                                            })(
                                                <Input className="formInput"  readOnly onClick={this.chooseGroupName} placeholder="+"/>
                                            )}
                                        </Form.Item>
                                      
                                    </Col>
                                    <Col span={0}>
                                        <Form.Item {...formItemLayout}   label="库存组Id">
                                            {getFieldDecorator('groupId', {
                                                rules: [
                                                    {
                                                        required: showflow?false:true,
                                                        message: '请选择库存组Id',
                                                    },
                                                ],
                                            })(
                                                <Input className="formInput"  readOnly/>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={5} offset={8}>
                                        <Form.Item {...formItemLayout}    label="票据类型">
                                            {getFieldDecorator('invoiceType', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择票据类型',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择票据类型"
                                                    onChange={this.selectInvoiceTypeList}
                                                    disabled={InvoiceTypeDisabled}
                                                >
                                                {
                                                    invoiceTypeList&&invoiceTypeList.map(d => <Option key={d.value} value ={ d.value }>{d.name}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={3}>
                                        <Form.Item {...formItemLayout}  >
                                            {getFieldDecorator('secondInvoiceType', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择二级票据类型',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择二级票据类型"
                                                >
                                                {
                                                    SecondInvoiceTypeList&&SecondInvoiceTypeList.map((item,i) => <Option value={item.value} key={i}>{item.label}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={8}>
                                        <Form.Item {...formItemLayout}  label="销售状态">
                                            {getFieldDecorator('saleStatus', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择销售状态',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择销售状态"
                                                    onChange={this.changeSaleStatus}
                                                >
                                                {
                                                    saleStatusList&&saleStatusList.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={8} offset={7}>
                                        <Form.Item {...formItemLayout}  label="库存状态">
                                            {getFieldDecorator('stockStatus', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择库存状态',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择库存状态"
                                                >
                                                {
                                                    stockStatusList&&stockStatusList.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={8} >
                                        <Form.Item  {...formItemLayout}   label="分类标签">
                                            {getFieldDecorator('categoryTag', {
                                                rules: [
                                                    {
                                                        required: false,
                                                        message: '请选择分类标签',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择分类标签"
                                                    disabled
                                                >
                                                {
                                                    categoryTagList&&categoryTagList.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={this.state.showproductType=='4'?8:0} offset={7}>
                                        <Form.Item  {...formItemLayout}  label="模板">
                                            {getFieldDecorator('templateName', {
                                                rules: [
                                                    {
                                                        required: this.state.showproductType=='4',
                                                        message: '请选择模板',
                                                    },
                                                ],
                                            })(
                                                <Input className="formInput"  readOnly onClick={this.chooseTemplateName} placeholder="+"/>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={0}>
                                        <Form.Item  {...formItemLayout}  label="模板Id">
                                            {getFieldDecorator('templateId', {
                                                rules: [
                                                    {
                                                        required: this.state.showproductType=='4',
                                                        message: '请选择模板Id',
                                                    },
                                                ],
                                            })(
                                                <Input className="formInput"  readOnly />
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={8} offset={this.state.showproductType=='4'?0:7}>
                                        <Form.Item {...formItemLayout}    label="商品单位">
                                            {getFieldDecorator('productUnit', {
                                                rules: [
                                                    {
                                                        required: false,
                                                        message: '请输入商品单位',
                                                    }
                                                ],
                                            })(
                                                <Input className="formInput" placeholder="请输入商品单位"/>
                                            )}
                                        </Form.Item>
                                    </Col>
                                    <Col span={8} offset={this.state.showproductType=='4'?7:0}>
                                        <Form.Item {...formItemLayout}    label="角标">
                                            {getFieldDecorator('subscriptsIcon', {
                                                rules: [
                                                    {
                                                        required: false,
                                                        message: '请输入角标',
                                                    }
                                                ],
                                            })(
                                                <Input className="formInput" placeholder="请输入角标"/>
                                            )}
                                        </Form.Item>
                                    </Col>
                                </Col>
                            </Row>
                        </div>
                        <div className="firstBox" >
                            <h4 className="toptitle">
                                <i className="fa fa-th"></i> 
                                商品附属属性
                            </h4>
                            <Row gutter={16}>
                                <Col span={20} offset={2}>
                                   {(showtelrate||showflow)&&<Col span={8}>
                                        <Form.Item {...formItemLayout}   label="区域">
                                            {getFieldDecorator('area', {
                                                rules: [
                                                    {
                                                        required: showtelrateRequire||showflowRequire,
                                                        message: '请选择区域',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                className="formInput"
                                                placeholder="请选择区域"
                                            >
                                                {
                                                AreaList&&AreaList.map(d => <Option key={d.areaName} value={d.areaName}>{d.areaName}</Option>)
                                                }
                                            </Select>
                                            )}
                                        </Form.Item>
                                    </Col>}
                                    {showtelrate&&<Col span={8} offset={8}>
                                        <Form.Item  {...formItemLayout}   label="运营商名称">
                                            {getFieldDecorator('virtualOperator', {
                                                rules: [
                                                    {
                                                        required: false,
                                                        message: '请选择运营商名称',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择运营商名称"
                                                >
                                                    {
                                                    VirtualOperatorList&&VirtualOperatorList.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                    }
                                                </Select>
                                            )}
                                        </Form.Item>
                                    </Col>}
                                   {((showtelrate||showflow||showOperatorName)&&!showoperatorNameType)&&<Col span={8} offset={showflow?7:0}>
                                        <Form.Item {...formItemLayout}    label="厂商名称">
                                            {getFieldDecorator('operatorName', {
                                                rules: [
                                                    {
                                                        required: showtelrateRequire||showflowRequire||showOperatorName,
                                                        message: '请输入厂商名称',
                                                    }
                                                ],
                                            })(
                                               <Input className="formInput" placeholder="请输入厂商名称"/>
                                            )}
                                        </Form.Item>
                                    </Col>}
                                    {((showtelrate||showflow||showOperatorName)&&showoperatorNameType)&&<Col span={8} offset={showflow?7:0}>
                                        <Form.Item {...formItemLayout}    label="厂商名称">
                                            {getFieldDecorator('operatorName', {
                                                rules: [
                                                    {
                                                        required: showtelrateRequire||showflowRequire||showOperatorName,
                                                        message: '请输入厂商名称',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请输入厂商名称"
                                                >
                                                    <Option key='中国移动' value='中国移动'>中国移动</Option>
                                                    <Option key='中国联通' value='中国联通'>中国联通</Option>
                                                    <Option key='中国电信' value='中国电信'>中国电信</Option>
                                                </Select>
                                            )}
                                        </Form.Item>
                                    </Col>}
                                    {showflow&&<Col span={8}>
                                        <Form.Item {...formItemLayout}     label="流量类型">
                                            {getFieldDecorator('packetType', {
                                                rules: [
                                                    {
                                                        required:showflowRequire,
                                                        message: '请选择流量类型',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择流量类型"
                                                >
                                                    {
                                                    PacketTypeList&&PacketTypeList.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                    }
                                                </Select>
                                            )}
                                        </Form.Item>
                                    </Col>}    
                                    {showflow&&<Col span={8} offset={7}>
                                        <Form.Item  {...formItemLayout}   label="流量大小（M）">
                                            {getFieldDecorator('packetSize', {
                                                rules: [
                                                    {
                                                        required: showflowRequire,
                                                        message: '请输入流量大小（M）',
                                                    },
                                                    { pattern:new RegExp(/(^[1-9]\d*$)/,"g"), message: '只能输入正整数'}
                                                ],
                                            })(
                                                <Input className="formInput" placeholder="请输入流量大小（M）"/>
                                            )}
                                        </Form.Item>
                                    </Col>}
                                  {showflow&&<Col span={10}>
                                        <Col span={17}>
                                            <Form.Item  {...formItemLayout}   label="充值次数">
                                                    {getFieldDecorator('rechargeTimes', {
                                                        rules: [
                                                            {
                                                                required: showflowRequire,
                                                                message: '请选择充值次数',
                                                            }
                                                        ],
                                                    })(
                                                        <Radio.Group>
                                                            <Radio value={0}>不限</Radio>
                                                            <Radio value={-1}>当月限充次数</Radio>
                                                        </Radio.Group>
                                                    )}
                                                </Form.Item>
                                        </Col>
                                        {showflow&&<Col span={7}>
                                            <Form.Item  >
                                                {getFieldDecorator('rechargeTimesipt', {
                                                    rules: [
                                                        {
                                                            required:this.props.form.getFieldsValue(['rechargeTimes'])['rechargeTimes']==-1?true:false,
                                                            message: '请输入当月限充次数',
                                                        },
                                                        { pattern:new RegExp(/(^[1-9]\d*$)/,"g"), message: '只能输入正整数'}

                                                    ],
                                                })(
                                                    <Input placeholder="请输入当月限充次数"/>
                                                )}
                                            </Form.Item>
                                        </Col>}
                                    </Col>}
                                   {showflow&&<Col span={8} offset={5}>
                                        <Form.Item  {...formItemLayout}   label="是否当月失效">
                                            {getFieldDecorator('currentMonthExpires', {
                                                rules: [
                                                    {
                                                        required: true,
                                                        message: '请选择是否当月失效',
                                                    }
                                                ],
                                            })(
                                                <Radio.Group>
                                                    <Radio value={1}>是</Radio>
                                                    <Radio value={0}>否</Radio>
                                                </Radio.Group>
                                            )}
                                        </Form.Item>
                                    </Col>}
                                  {showflow&&<Col span={8}>
                                        <Form.Item  {...formItemLayout}   label="流量性质">
                                            {getFieldDecorator('packetKind', {
                                                rules: [
                                                    {
                                                        required: showflowRequire,
                                                        message: '请选择流量性质',
                                                    }
                                                ],
                                            })(
                                                <Select
                                                    className="formInput"
                                                    placeholder="请选择流量性质"
                                                >
                                                    {
                                                    PacketKindList&&PacketKindList.map(d => <Option key={d.value} value={d.value}>{d.name}</Option>)
                                                    }
                                                </Select>
                                            )}
                                        </Form.Item>
                                    </Col>}
                                </Col>
                            </Row>
                        </div>
                        <div className="firstBox">
                            <h4 className="toptitle">
                                <i className="fa fa-sun-o"></i>
                                商品维护风险
                            </h4>
                            <div className="formbox  lastForm">
                                <Row gutter={16} >
                                    <Col span={20} offset={2}>
                                        <Col span={8}>
                                            <Form.Item {...formItemLayout}    label="维护期开始时间">
                                                {getFieldDecorator('protectBeginTime', {
                                                    rules: [
                                                        {
                                                            required:this.props.form.getFieldsValue(['saleStatus'])['saleStatus']=='3'?true:false,
                                                            message: '请选择维护期开始时间',
                                                        }
                                                    ],
                                                })(
                                                    <DatePicker disabled={this.props.form.getFieldsValue(['saleStatus'])['saleStatus']=='3'?false:true}   format="YYYY-MM-DD HH:mm:ss"/>
                                                )}
                                            </Form.Item>
                                        </Col>
                                        <Col span={8} offset={8}>
                                            <Form.Item {...formItemLayout}    label="维护期结束时间">
                                                {getFieldDecorator('protectEndTime', {
                                                    rules: [
                                                        {
                                                            required:this.props.form.getFieldsValue(['saleStatus'])['saleStatus']=='3'?true:false,
                                                            message: '请选择维护期结束时间',
                                                        }
                                                    ],
                                                })(
                                                    <DatePicker disabled={this.props.form.getFieldsValue(['saleStatus'])['saleStatus']=='3'?false:true}  format="YYYY-MM-DD HH:mm:ss"/>
                                                )}
                                            </Form.Item>
                                        </Col>
                                    </Col>
                                </Row>
                            </div>
                        </div>
                        <div className="firstBox" style={{paddingBottom:"20px"}}>
                            <h4 className="toptitle">
                                <i className="fa fa-bookmark"></i> 
                                其他
                            </h4>
                            <div className="formbox">
                                <Row gutter={16}>
                                    <Col span={20} offset={2}>
                                        <Form.Item {...formItemLayout1}    label="商品详情">
                                            {getFieldDecorator('content', {
                                                rules: [
                                                    {
                                                        required:false,
                                                        message: '请输入商品详情',
                                                    }
                                                ],
                                            })(
                                                <TextArea rows={6}/>
                                            )}
                                        </Form.Item>
                                    </Col>
                                </Row>
                            </div>
                        </div>
                        <div className="fourth" style={{paddingBottom:"20px"}}>
                            <h4 className="toptitle"></h4>
                            <div className="footer">
                                {<Button key="submit" className="okBtn" type="primary"  loading={isSubmit} onClick={this.confirmData}>
                                    保存
                                </Button>}
                                {<Button key="back" style={{marginRight:'20px'}} onClick={this.goBack}>
                                    取消
                                </Button>}
                            </div>
                        </div>
                    </Form>
                    </Spin>
                </div>
                {showComModal?<ComModal name={modalName}  getFormValue={this.getFormValue} closeModal={this.closeModal}  dataResource={this.state.dataResource} submitData={this.submitData}/>:''}                     
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(GoodsEdit));