import React from 'react';
import { connect } from 'dva';
import {Spin,Form,message,Button,Modal,Row,Radio } from  "antd";
import { Table } from 'fl-pro';
import './less/GoodsList.less';
import { ExportButton } from "fl-pro";
import BreadCrumb from '../../../components/Breadcrumb';
import SearchForm from '../../../components/SearchForm';
import InventoryGroups from '../InventoryGroups';
import findIndex from 'lodash/findIndex';
import commonFun from '../../../utils/utils';
import statusText from '../../../utils/statusText';
class GoodsList extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            goodsNameList:[],
            selectedRowData:[],
            selectedRowKeys:[],
            total:0,
            goodsResource:[],
            showInventoryGroups:false,
            InventoryGroupsList:null,
            categoryIdL1List:[],
            categoryIdL2List:[],
            ParentId:0,
            categoryType:0,
            InvoiceTypeList:[
                {
                    name:"寄售",
                    value:"0"
                },
                {
                    name:"自营",
                    value:"1"
                }
            ],
            SecondInvoiceTypeList:[],
            radioValue:2 ,
            isshowRadio:false      
        }
	}

    componentDidMount (){
        const {ParentId}= this.state;
        this.props.dispatch({
            type: 'common/GetProductCategoryListByParentId', 
            payload: {
                ParentId,
                CategoryName:''
            } 
        });
    }

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.getgoodsResource()
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getgoodsResource()
        });
    }

    getFormData=(params)=>{
        let str = params.SecondInvoiceType
        params.SecondInvoiceType=str?str.split("-")[0]:str
        params.InvoiceRate = str?str.split("-")[1]:''
        this.setState({
          condition: params,
        })
    }

    initselectData=(item,e)=>{
        switch(item.id){
            case 'ProductName':
            this.setState({
                goodsNameList:[],
            })
            break;
            case 'CategoryIdL1':
                this.setState({
                    categoryIdL1List:[],
                })
            break;
            default:
            return false;
            break;
        }
    }

    // 获取商品名称搜索下拉组件数据源
    getGoodsList = (item,value)=>{
        switch(item.id){
            case 'ProductName':
            this.props.dispatch({
                type: 'common/getGoodsList', 
                payload: {
                    id:value
                } 
            });
            break;
            case 'CategoryIdL1':
                this.setState({
                    categoryType:1
                },()=>{
                    if(value){
                        this.props.dispatch({
                            type: 'common/GetProductCategoryListByParentId', 
                            payload: {
                                ParentId:value,
                                CategoryName:''
                            } 
                        });
                    }else{
                        this.setState({
                            categoryIdL2List:[]
                        })
                    }
                    this.child.props.form.resetFields(['CategoryIdL2']);
                })
            break;
            case 'InvoiceType':
                if(value=='0'){
                    this.setState({
                        SecondInvoiceTypeList:[
                            {
                                name:"0%普票",
                                value:"1"
                            },
                            {
                                name:"无票",
                                value:"0"
                            }
                        ]
                    }) 
                }else if(value=="1"){
                    this.setState({
                        SecondInvoiceTypeList:[
                            {
                                name:"3%普票",
                                value:"1-3"
                            },
                            {
                                name:"3%专票",
                                value:"2-3"
                            },
                            {
                                name:"6%普票",
                                value:"1-6"
                            },
                            {
                                name:"6%专票",
                                value:"2-6"
                            },
                            {
                                name:"10%普票",
                                value:"1-10"
                            },
                            {
                                name:"10%专票",
                                value:"2-10"
                            },
                            {
                                name:"13%普票",
                                value:"1-13"
                            },
                            {
                                name:"13%专票",
                                value:"2-13"
                            },
                            {
                                name:"16%普票",
                                value:"1-16"
                            },
                            {
                                name:"16%专票",
                                value:"2-16"
                            },
                        ]
                    }) 
                 } 
                break;
            default:
            return false;
            break;
        }
       
    }

    // 获取商品管理列表
    getgoodsResource = ()=>{
        const {postData,condition } =this.state;
        this.props.dispatch({
            type: 'goods/GetgoodsResource', 
            payload: {
                ...postData,
                ...condition 
            } 
        });
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getgoodsResource()
        });
    }

    // 编辑
    handleEdit=(record)=>{
        this.props.history.push('/goodsList/edit?page=edit&id='+record.id)
    }

    // 查看库存组
    handleLook=(record)=>{
        let params={
            InventoryGroupsList:record,
            showInventoryGroups:true
        }
        this.setState({
            InventoryGroupsList:params,
            showInventoryGroups:true
        })
    }

    closeInventoryGroups=()=>{
        this.setState({
            showInventoryGroups:false
        })
    }
    

    setSaleStatus=()=>{
        const { selectedRowData } = this.state;
        if(selectedRowData&&selectedRowData.length>0){
            this.setState({
                isshowRadio:true
            })
        }else{
            message.warning("请选择要设置销售状态的商品")
        }
    }

    onChangeRadioValue=(e)=>{
        this.setState({
            radioValue:e.target.value
        })
    }

    submitSaleStatus=()=>{
        const { selectedRowData,radioValue } = this.state;
        if(selectedRowData&&selectedRowData.length>0){
            this.props.dispatch({
                type: 'goods/BatchSetSaleStatus', 
                payload: {
                    ids:selectedRowData.map((item)=>{
                        return {
                            id:item.id,
                            productName:item.productName
                        }
                    }),
                    value:radioValue
                } 
            });
        }  
    }

    addGoods=()=>{
        this.props.history.push('/goodsList/edit?page=add')
    }



	componentWillReceiveProps(nextProps) {
        const { props } = this;
        const { getGoodsList ,GetgoodsResource,BatchSetSaleStatus } = nextProps.goods;
        const { GetProductCategoryListByParentId } = nextProps.common;
        // 获取商品名称搜索下拉组件数据源
        if (getGoodsList && getGoodsList !== this.props.goods.getGoodsList) {
            if(getGoodsList.code==="0"){
              this.setState({
                goodsNameList:getGoodsList.data&&getGoodsList.data.list&&getGoodsList.data.list.length>0&&getGoodsList.data.list.map((item)=>{
                    return {
                        value:item.id,
                        text:item.goosName
                    }
                })
              })
            }else{
                message.destroy();
                message.warning(getGoodsList.message);
            }
        }

        // 获取商品管理列表
        if (GetgoodsResource && GetgoodsResource !== this.props.goods.GetgoodsResource) {
            if(GetgoodsResource.code==="0"){
              this.setState({
                goodsResource:GetgoodsResource.data.list,
                total:GetgoodsResource.data.total
              })
            }else{
                message.destroy();
                message.warning(GetgoodsResource.message);
            }
        }

        // 获取商品分类
        if (GetProductCategoryListByParentId && GetProductCategoryListByParentId !== this.props.common.GetProductCategoryListByParentId) {
            if(GetProductCategoryListByParentId.code==="0"){
              switch (this.state.categoryType){
                case 0 :
                    this.setState({
                        categoryIdL1List:GetProductCategoryListByParentId.data&&GetProductCategoryListByParentId.data.list.length>0&&GetProductCategoryListByParentId.data.list.map((item)=>{
                            return {
                                name:item.name,
                                value:item.id
                            }
                        })
                    })
                break;
                case 1: 
                this.setState({
                    categoryIdL2List:GetProductCategoryListByParentId.data&&GetProductCategoryListByParentId.data.list.length>0&&GetProductCategoryListByParentId.data.list.map((item)=>{
                        return {
                            name:item.name,
                            value:item.id
                        }
                    })
                })
                break;
              }
            }else{
                message.destroy();
                message.warning(GetProductCategoryListByParentId.message);
            }
        }

        if (BatchSetSaleStatus && BatchSetSaleStatus !== this.props.goods.BatchSetSaleStatus) {
            if(BatchSetSaleStatus.code==="0"){
                message.destroy()
                message.success("设置成功")
                this.setState({
                    isshowRadio:false,
                    selectedRowKeys:[]
                })
                this.getgoodsResource()
            }else{
                message.destroy();
                message.warning(BatchSetSaleStatus.message);
            }
        }
        
        
    }

	render() {
        const { getFieldDecorator } = this.props.form;
        const {loading} = this.props;
        const {goodsNameList,selectedRowData,selectedRowKeys,total,postData,condition,goodsResource,showInventoryGroups,InventoryGroupsList,categoryIdL1List,categoryIdL2List,InvoiceTypeList,SecondInvoiceTypeList,isshowRadio } = this.state;
        const breadcrumbList = [
            {
                name:"商品管理",
                href:""
            },
            {
                name:"商品管理",
                href:""
            }
        ];
        let goodsName = [
            {
                name: '一级分类',
                index: 7,
                type: 7,
                id: 'CategoryIdL1',
                placeholder:'请选择一级分类',
                items: [{name:"一级分类",value:''},...categoryIdL1List],
                FunctionOj:{
                    initFun:this.initselectData,
                    setSelectData:this.getGoodsList
                }
            },
            {
                name: '二级分类',
                index: 7,
                type: 7,
                id: 'CategoryIdL2',
                placeholder:'请选择二级分类',
                items: [{name:"二级分类",value:''},...categoryIdL2List],
                FunctionOj:{
                    setSelectData:this.getGoodsList
                }
            },
            {
                name: '票据类型',
                index: 7,
                type: 7,
                id: 'InvoiceType',
                placeholder:'请选择票据类型',
                items:[{name:"票据类型",value:''},...InvoiceTypeList], 
                FunctionOj:{
                    setSelectData:this.getGoodsList
                }
            },
            {
                name: '二级票据类型',
                index: 7,
                type: 7,
                id: 'SecondInvoiceType',
                placeholder:'请选择二级票据类型',
                formItems:"max",
                items: [{name:"二级票据类型",value:''},...SecondInvoiceTypeList],
                FunctionOj:{
                    setSelectData:this.getGoodsList
                }
            },
        ];
        
        let columns = [
            {
                key:"1",
                title: '商品编号',
                width:150,
                align: 'left',
                dataIndex:"id",
                fixed: 'left',
            },
            {
                key:"2",
                title: '商品名称',
                width:300,
                align: 'left',
                dataIndex:"productName",
            },
            {
                key:"3",
                title: '单价（元）',
                align: 'left',
                dataIndex:"price",
                render:(text)=>{
                    return commonFun.toDecimal4(text)
                }
            },
            {
                key:"4",
                title: '面值（元）',
                align: 'left',
                dataIndex:"faceValue",
                render:(text)=>{
                    return commonFun.toDecimal4(text)
                }
            },
            {
                key:"5",
                title: '商品属性',
                align: 'left',
                dataIndex:"productType",
                render:(text)=>{
                    return statusText.ProductType[text]
                }
            },
            {
                key:"6",
                title: '销售状态',
                align: 'left',
                dataIndex:"saleStatus",
                render:(text)=>{
                    return statusText.SaleStatus[text]
                }
            },
            {
                key:"7",
                title: '库存状态',
                align: 'left',
                dataIndex:"stockStatus",
                render:(text)=>{
                    return statusText.StockStatus[text]
                }
            },
            {
                key:"8",
                title: '票据类型',
                align: 'left',
                dataIndex:"invoiceType",
                render:(text,record)=>{
                    return statusText.InvoiceType[text]    
                }
                // render:(text)=>{
                //     if(text==1){
                //         return <span>自营</span>
                //     }else if(text==0){
                //         return <span>寄售</span>
                //     }else{
                //         return <span>--</span>
                //     }
                // }
            },
            {
                key:"9",
                title: '二级票据类型',
                width:120,
                align: 'left',
                dataIndex:"secondInvoiceType",
                render:(text,record)=>{
                    if (record.secondInvoiceType === "0" || record.secondInvoiceType === 0) {
                        return  "无票";
                    } else if (record.secondInvoiceType == 1) {
                        return record.invoiceRate*100 + "%普票";
                    } else if (record.secondInvoiceType == 2) {
                        return record.invoiceRate*100 + "%专票";
                    } else {
                        return "";
                    }
                }
            },
            {
                key:"10",
                title: '所属库存组',
                width:300,
                align: 'left',
                dataIndex:"groupName",
            },
            {
                key:"11",
                title: '操作',
                width:150,
                align: 'center',
                fixed: 'right',
                render:(text,record)=>(
                    <div style={{color:"#4b9ae0"}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_goodList_edit' }) !== -1)&&record.fpMemberId?<i  className="iconfont" style={{cursor:"pointer",marginRight:"14px",fontSize:"16px"}}   title="编辑" onClick={()=>{this.handleEdit(record)}}>&#xe616;</i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_look_stockGroup' }) !== -1)?<i  className="iconfont" style={{cursor:'pointer',fontSize:'16px'}}  title="查看库存组" onClick={()=>{this.handleLook(record)}}>&#xe611;</i>:''}
                    </div>
                )
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };

        const rowSelection = {
            selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
              this.setState({
                selectedRowData:selectedRows,
                selectedRowKeys
              })
            },
            getCheckboxProps: record => ({
              disabled: !record.fpMemberId
            }),
        };
		return (
			<div className="Goods">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="Goods-containter">
                    <Spin spinning={loading.effects['goods/GetgoodsResource']}>
                    <SearchForm name="goods"
                        addData={goodsName} 
                        onRef={(ref) => { this.child = ref }}
                        init={this.init} 
                        // initselectData={this.initselectData}
                        // SetDataResource={this.getGoodsList}
                        search={this.search} 
                        getFormData={this.getFormData} 
                    />
                    <div style={{textAlign:"right",marginBottom:"10px"}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_goodList_export' }) !== -1)?<ExportButton
                        url={`${configs.host.api}/api/Product/ExportProductList`}
                        merchantId={localStorage.getItem('MerchantId')}
                        params={Object.assign({},postData,condition)} 
                        className="addBtn"
                        >导出</ExportButton>:""}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_goodList_addGoods' }) !== -1)?<Button style={{marginLeft:'10px'}} type="primary" ghost  onClick={this.addGoods}>新增商品</Button>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_goodList_online' }) !== -1)?<Button style={{marginLeft:'10px'}} type="primary" disabled={selectedRowData&&selectedRowData.length>0?false:true} onClick={this.setSaleStatus}>批量上下架</Button>:''}
                    </div>
                    <Table 
                        columns={columns}
                        rowSelection={rowSelection}
                        dataSource={goodsResource?goodsResource:[]}
                        pagination={pagination}
                        scroll={{x:1800}}
                    />
                    </Spin>
                </div>
                {
                    showInventoryGroups? <InventoryGroups params={InventoryGroupsList} closeInventoryGroups={this.closeInventoryGroups}/>:''
                }
                {isshowRadio&&
                    <Modal
                        className="addReport"
                        width="500px"
                        title="批量上下架"
                        okText="保存"
                        cancelText="取消"
                        visible={true}
                        onCancel={()=>{
                            this.setState({
                                isshowRadio:false
                            })
                        }}
                        onOk={
                            this.submitSaleStatus
                        }
                     >
                     <Row style={{marginBottom:'10px'}}>
                         <Radio.Group onChange={this.onChangeRadioValue} value={this.state.radioValue}>
                            <Radio value={1}>下架</Radio>
                            <Radio value={2}>上架</Radio>
                        </Radio.Group>
                     </Row>
                 </Modal>
                }
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(GoodsList));
