import React from 'react';
import { connect } from 'dva';
import { Modal,Form,message,Spin  } from "antd";
import { Table  } from 'fl-pro';
import './InventoryGroups.less';
import commonFun from '../../../utils/utils';
import statusText from '../../../utils/statusText';
class InventoryGroups extends React.Component {
	constructor(props) {
    super(props);
    this.state={
      dataSource:[]
    }
	}
	componentWillMount() {
    this.getInventoryGroupsList()
  }

  // 获取库存组数据
  getInventoryGroupsList=()=>{
      const {InventoryGroupsList} = this.props.params;
      this.props.dispatch({
          type: 'goods/GetInventoryGroupsList',
          payload: {
            id:InventoryGroupsList.id
          }
      });
  }

    // 关闭模态框
    closeModal = () => {
        this.props.methodsTotal.hideModal();
    }

    // 继续充值
    handleAgain=()=>{
        this.props.methodsTotal.handleAgain();
    }
    
	componentWillReceiveProps(nextProps) {
        const {GetInventoryGroupsList } = nextProps.goods;
        // 获取库存组数据
        if (GetInventoryGroupsList && GetInventoryGroupsList !== this.props.goods.GetInventoryGroupsList) {
            if (GetInventoryGroupsList.code == '0') {
              this.setState({
                dataSource:GetInventoryGroupsList.data.poolProductList
              })
            } else {
                message.destroy();
                message.warning(GetInventoryGroupsList.message);
            }
        }
    }

	render() {
    const {InventoryGroupsList,showInventoryGroups} = this.props.params;
    const {dataSource} =this.state;

    let columns = [
      {
          key:"1",
          title: '商品编号',
          width:150,
          align: 'left',
          dataIndex:"supProductId",
      },
      {
          key:"2",
          title: '商品名称',
          width:300,
          align: 'left',
          dataIndex:"supProductName",
      },
      {
          key:"3",
          title: '单价（元）',
          align: 'left',
          dataIndex:"supProductPrice",
          render:(text)=>{
            return commonFun.toDecimal4(text)
          }
      },
      {
          key:"4",
          title: '面值（元）',
          align: 'left',
          dataIndex:"supProductFaceValue",
          render:(text)=>{
            return commonFun.toDecimal4(text)
          }
      },
      {
        key:"5",
        title: '销售状态',
        align: 'left',
        dataIndex:"supProductSaleStatus",
        render:(text,record)=>{
          return statusText.KmSaleStatus[text]
        }
      },
      {
        key:"6",
        title: '库存状态',
        align: 'left',
        dataIndex:"supProductStockStatus",
        render:(text,record)=>{
          return statusText.KmStockStatus[text]
        }
      },
      {
        key:"7",
        title: '剩余库存量',
        align: 'left',
        dataIndex:"remainingStockNum",
      }
    ];
		return (
            <div className="InventoryGroups">
                <Modal
                    wrapClassName="modal-server"
                    width="1200px"
                    title={InventoryGroupsList.groupName}
                    okText="确定"
                    cancelText="取消"
                    visible={showInventoryGroups}
                    onCancel={() =>{
                        this.props.closeInventoryGroups();
                    }}
                    onOk={
                        ()=>{
                          this.props.closeInventoryGroups();
                        }
                    }
                    >
                      <Spin spinning={this.props.loading.effects['goods/GetInventoryGroupsList']}>
                        <Table dataSource={dataSource?dataSource:[]} columns={columns}  pagination={false} rowKey="index"/>
                      </Spin>
                </Modal>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(InventoryGroups));