import React, { Component } from 'react';
import { connect } from 'dva';
import {Spin,Button,message,Checkbox} from 'antd';
import { Table } from 'fl-pro';
import './less/AddPriceMerchants.less';
import SearchForm from '../../../components/SearchForm';
import commonFun from '../../../utils/utils';
class AddPriceMerchants extends Component {
    constructor(props) {
        super(props);
        this.state = {
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            MemberDataList:[],
            total:0,
            selectedRowData:[],
            DepartmentList:[],
            PositionList:[],
            screenHeight:960,
            selectedRowKeys:[],
            CurrentMonthExpiresList:[
                { label: '是', value: '1' },
                { label: '否', value: '0' },
            ],
            productSpGroupName:sessionStorage.getItem("merchants")?JSON.parse(sessionStorage.getItem("merchants")).name:'',

        }
    }
    
    componentDidMount (){
        this.setState({screenHeight:window.innerHeight});
    }

    componentWillUnmount() {
        //一定要最后移除监听器，以防多个组件之间导致this的指向紊乱
        window.removeEventListener('resize', this.handleResize.bind(this)) ;
    }


    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.GetMemberList();
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetMemberList()
        });
    }

     // 分页查询
     searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetMemberList()
        });
    }

    handleResize = e => {
        this.setState({screenHeight:e.target.innerHeight});
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 获取员工管理列表
    GetMemberList=()=>{
        const { postData, condition} = this.state;
        let ProductSpGroupId = commonFun.GetQueryString(location.search.split('?')[1], "GroupId");
        this.props.dispatch({
            type: 'price/GetMemberList', 
            payload: {
                ...postData,
                ...condition, 
                ProductSpGroupId
            } 
        }); 
    }
    getDataResource=(dataResource,keyList)=>{
        let arr=[]
        if(dataResource&&keyList&&dataResource.length>0&&keyList.length>0){
            dataResource.map((item)=>{
                keyList.map((el)=>{
                    if(item.memberId==el){
                        arr.push(item)
                    }
                })
            })
            return arr;
        }else{
            return [];
        }
    }

    confirmData=()=>{
        const {selectedRowData,selectedRowKeys,productSpGroupName,MemberDataList} = this.state;
        let productSpGroupId = commonFun.GetQueryString(location.search.split('?')[1], "GroupId");
        let productSpMember=[];
        let logProductSpMemberList=[];
        let selectData = []
        if(selectedRowKeys&&selectedRowKeys.length>0){
            selectData=this.getDataResource(MemberDataList,selectedRowKeys)
            let num=0;
            selectData.map((op)=>{
                if(op.checkedList&&op.checkedList.length>0){
                    num++
                }
            })
            if(selectData.length==num){
                selectData.map((item)=>{
                    let clientIdList=[];
                    let spMemberAppList=[];
                    if(item.appList&&item.appList.length>0){
                        item.appList.map((el)=>{
                            if(el.checked){
                                clientIdList.push(el.clientId)  
                            }
                        })
                    }
                    productSpMember.push({
                        memberId:item.memberId,
                        clientIdList
                    })
                    if(item.appList&&item.appList.length>0){
                        item.appList.map((el)=>{
                            if(el.checked){
                                spMemberAppList.push(
                                    {
                                        clientId:el.clientId,
                                        appName:el.appName
                                    }
                                ) 
                            }
                        })
                    }
                    logProductSpMemberList.push({
                        membercCode:item.memberCode,
                        memberName:item.memberName,
                        spMemberAppList
                    })
                })
            }else{
                message.destroy();
                message.warning("请添加应用")
                return false
            }
        }else{
            message.destroy();
            message.warning("请选择要添加的密价商户")
            return false
        }
        let postData={
            productSpGroupId,
            productSpGroupName,
            productSpMember,
            logProductSpMemberList,
            createdBy:''
        }
        this.props.dispatch({
            type: 'price/AddProductSpMember',
            payload: {
               ...postData
            }
        });
    }

    diff=(arr1,arr2)=>{
        var a = [];
        var b = [];
        for(var i=0;i<arr2.length;i++){
            a[arr2[i]]=true;
        }
        
        for(var i=0;i<arr1.length;i++){
            if(!a[arr1[i]]){
                b.push(arr1[i]);
            }
        }
        return b
    }

    changeCheckData=(e,record)=>{
        const {MemberDataList,selectedRowKeys} = this.state;
        if(record.appList&&record.appList.length>0){
            if(e&&e.length>0){
                if(record.appList.length>e.length){
                    record.appList.map((item)=>{
                        if(e.indexOf(item.clientId)==-1){
                            item.checked=0
                        }else{
                            item.checked=1
                        }
                    })
                }else{
                    record.appList.map((item)=>{
                        item.checked = 1
                    })
                } 
            }else{
                record.appList.map((item)=>{
                    item.checked = 0
                })
            }
        }
        record.checkedList=e;
        // 应用全选
        let arr=[]
        // if(record && record.checkedList && record.appList && record.checkedList.length==record.appList.length){ 
        //     if(selectedRowKeys.indexOf(record.memberId)==-1){
        //         selectedRowKeys.push(record.memberId)
        //     }
        // }else{
        //     if(record&&!record.checkedList.length){
        //        if(selectedRowKeys&&selectedRowKeys.length>0){
        //         selectedRowKeys.map((item,i)=>{
        //             if(item==record.memberId){
        //                 selectedRowKeys.splice(i,1)
        //             }
        //         })
        //        }
        //     }
        // }
        if(record&&!record.checkedList.length){
            if(selectedRowKeys&&selectedRowKeys.length>0){
                selectedRowKeys.map((item,i)=>{
                    if(item==record.memberId){
                        selectedRowKeys.splice(i,1)
                    }
                })
            }
        }else{
            if(record&&record.checkedList.length>0){
                if(selectedRowKeys.indexOf(record.memberId)==-1){
                    selectedRowKeys.push(record.memberId)
                }
            }
        }
        this.setState({
            MemberDataList,
            selectedRowKeys
        })
    }

    setcheckBoxControl=()=>{
        const { selectedRowKeys,MemberDataList } = this.state;
        let dataArr = []
        // 选中应用的数据
        if(MemberDataList&&MemberDataList.length>0){
            MemberDataList.map((el)=>{
                if(el.checkedList&&el.checkedList.length>0){
                    dataArr.push(el.memberId)
                }
            })
       }

        if(dataArr&&selectedRowKeys&&selectedRowKeys.length>dataArr.length){
            // 正选
            let arr = this.diff(selectedRowKeys,dataArr)
            if(MemberDataList&&MemberDataList.length>0&&arr&&arr.length>0){
                arr.map((item)=>{
                    MemberDataList.map((el)=>{
                        if(el.memberId==item){
                            el.checkedList = el.appList&&el.appList.length>0&&el.appList.map((p)=>{
                                return p.clientId
                            })
                            el.appList= el.appList&&el.appList.length>0&&el.appList.map((m)=>{
                                m.checked=1
                                return m
                            })
                        }
                    })
                })
            }
        }else{
            // 反选
            if(dataArr&&dataArr.length>0){
                dataArr.map((el,index)=>{
                    if(selectedRowKeys&&selectedRowKeys.length>0){
                        selectedRowKeys.map((item,i)=>{
                            if(el==item){
                                dataArr.splice(index,1)
                            }
                        })
                    }
                })
            }
            let reduceArr = this.diff(dataArr,selectedRowKeys)
            if(MemberDataList&&MemberDataList.length>0){
                MemberDataList.map((el)=>{
                    if(reduceArr&&reduceArr.length>0){
                        reduceArr.map((item)=>{
                            if(el.memberId == item){
                                el.checkedList=[]
                            }
                        })
                    }
                })
            }
        }
        this.setState({
            MemberDataList
        })
    }


    componentWillReceiveProps(nextProps){
        const { GetMemberList,AddProductSpMember} = nextProps.price;
        // 获得待加入密价组商户列表 
        if (GetMemberList && GetMemberList !== this.props.price.GetMemberList) {
            if(GetMemberList.code==="0"){
                if(GetMemberList.data&&GetMemberList.data.list&&GetMemberList.data.list.length>0){
                    GetMemberList.data.list.map((item,i)=>{
                        item.key=i
                        let checkArr=[]
                        if(item.appList&&item.appList.length>0){
                            item.appList.map((el)=>{
                                if(el.checked){
                                    checkArr.push(el.clientId)
                                    el.disabled=true 
                                }
                            })
                            item.checkedList= checkArr;
                        }
                        if(item.checkedList&&item.checkedList.length>0){
                            item.disabled=true
                        }
                        return item
                    })

                    this.setState({
                        MemberDataList:GetMemberList.data.list||[],
                        total:GetMemberList.data.total
                    })
                }
                if(GetMemberList&&GetMemberList.data&&GetMemberList.data.list&&GetMemberList.data.list.length>0){
                    let selectData=[]
                    GetMemberList.data.list.map((el)=>{
                        if(el.checkedList&&el.checkedList.length>0){
                            selectData.push(el.memberId)
                        }
                    })
                    this.setState({
                        selectedRowKeys:selectData
                    })
                }
            }else{
                message.destroy();
                message.warning(GetMemberList.message);
            }
        }

        if (AddProductSpMember && AddProductSpMember !== this.props.price.AddProductSpMember) {
            if(AddProductSpMember.code==="0"){
                message.destroy();
                message.success("添加成功")
                this.props.handleAddCancel()
            }else{
                message.destroy();
                message.warning(AddProductSpMember.message);
            }
        }

    }


    render() {
        const {postData,MemberDataList,total,screenHeight,selectedRowKeys} = this.state;
        const {loading} = this.props;
        let columns = [
            {
                key:"1",
                title: '商户名称',
                width:200,
                align: 'left',
                dataIndex:"memberName",
            },
            {
                key:"2",
                title: '商户号',
                width:200,
                align: 'left',
                dataIndex:"memberCode"
            },
            {
                key:"3",
                title: '应用',
                align: 'left',
                render:(record)=>{
                    if(record.appList&&record.appList.length>0){
                        return <Checkbox.Group  onChange={(e)=>{this.changeCheckData(e,record)}} value={record.checkedList}   style={{ width: '100%',overflow:"hidden" }}>
                            {   
                                record.appList.map((item,i)=>{
                                    return <Checkbox style={{float:"left"}} disabled={item.disabled}  key={i} value={item.clientId}>{item.appName}</Checkbox>
                                })
                            }
                         </Checkbox.Group>
                      
                    }
                }
            }
        ];

        const pagination = {
            total,
            hideOnSinglePage: true,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current;
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
               
            },
        };

        const rowSelection = {
            selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRowKeys,
                    selectedRowData:selectedRows
                },()=>{
                    this.setcheckBoxControl() 
                }) 
            },
            getCheckboxProps: record => ({
                disabled: record.disabled, 
            }),
        
        };
        return(
            <div className="AddPriceMerchants">
                <div className="AddPriceMerchants-containter">
                    <SearchForm name="priceMerchants"
                     init={this.init} 
                     search={this.search} 
                     getFormData={this.getFormData} 
                    />
                    <Spin spinning={loading.effects['price/GetMemberList']}>
                        <div className="tableBox">
                            <Table 
                                rowKey="memberId"
                                columns={columns}
                                dataSource={MemberDataList?MemberDataList:[]}
                                pagination={pagination}
                                rowSelection={rowSelection}
                            />
                        </div>
                    </Spin>
                </div>
                <div className="footerstaff">
                    <Button type="primary" className="btnok" onClick={this.confirmData}>确定</Button>
                    <Button className="btncancel" onClick={this.props.handleAddCancel}>取消</Button>
                </div>
            </div>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(AddPriceMerchants);


