import React from 'react';
import { connect } from 'dva';
import {Spin,Tabs,Form  } from  "antd";
const { TabPane } = Tabs;
import './less/index.less';
import {withRouter} from "react-router-dom";
import BreadCrumb from '../../../components/Breadcrumb';
import SearchForm from '../../../components/SearchForm';
import MerchantsSearch from '../MerchantsSearch';
import GoodsSearch from '../GoodsSearch';
class CommonTabs extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            postData1:{
                pageIndex: 1,
                pageSize: 10,
            },
            tabType:'1',
            dataResource:[],
            total:0
        }
    }
    
    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.getDataResource()
        });
    }

    // 查询
    search = () => {
        const { postData,condition,postData1,tabType } = this.state;
        if(tabType=='1'){
            postData.PageIndex=1
            this.setState({ 
                condition,
                postData 
            },() => {
                this.getDataResource()
            });
        }else{
            postData1.PageIndex=1
            this.setState({ 
                condition,
                postData1 
            },() => {
                this.getDataResource()
            });
        }
        
    }

     // 分页查询
     searchPagination= (postDatas)=> {
        const { condition,postData1,postData,tabType } = this.state;
        this.setState({ 
            condition,
            postData1:tabType=='1'?postData1:postDatas, 
            postData:tabType=='1'?postDatas:postData
        },() => {
            this.getDataResource()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    callback=(type)=>{
        const {postData,postData1 } = this.state;
        this.setState({
            tabType:type,
            postData,
            postData1
        },()=>{
            this.getDataResource()
        })
    }

    getnewData=(type)=>{
        this.setState({
            tabType:type
        },()=>{
            this.getDataResource()
        })
    }

    // 获取列表数据源
    getDataResource = ()=>{
        const {postData,condition,tabType,postData1 } =this.state;
        if(tabType=='1'){
            this.props.dispatch({
                type: 'search/GetDataResource', 
                payload: {
                    ...postData,
                    ...condition,
                    tabType
                } 
            });
        }else{
            this.props.dispatch({
                type: 'search/GetDataResource', 
                payload: {
                    ...postData1,
                    ...condition,
                    tabType
                } 
            });
        }
    }

    componentWillReceiveProps(nextProps) {
        const {GetDataResource, } = nextProps.search;
        // 获取列表数据源
        if (GetDataResource && GetDataResource !== this.props.price.GetDataResource) {
            if(GetDataResource.code==="0"){
              this.setState({
                dataResource:GetDataResource.data.list,
                total:GetDataResource.data.total
              })
            }else{
                message.destroy();
                message.warning(GetDataResource.message);
            }
        }

    }

	render() {
        const { tabType,postData,postData1,condition,dataResource,total }= this.state;
        const { loading } = this.props;
        const breadcrumbList = [
            {
                name:"密价搜索",
                href:""
            },
            {
                name:tabType&&tabType=='2'?"商品搜索":"商户搜索",
                href:""
            }
        ];
		return (
			<div className="commontabs">
                <BreadCrumb paramsList={breadcrumbList} />
                <div className="commontabs-containter">
                    <SearchForm name={tabType&&tabType=='2'?'goodsSearch':'merchantsSearch'}
                        init={this.init} 
                        search={this.search} 
                        getFormData={this.getFormData} 
                    />
                    <Tabs onChange={this.callback} type="card" defaultActiveKey={tabType}>
                        <TabPane tab="商户搜索" key="1" >
                        {tabType=='1'&&<Spin spinning={loading.effects['search/GetDataResource']}>
                                <MerchantsSearch total={total} dataResource={dataResource} condition={condition} postData={postData}  searchPagination={this.searchPagination}/>
                            </Spin>}
                        </TabPane>
                        <TabPane tab="商品搜索" key="2" >
                            {tabType=='2'&&<Spin spinning={loading.effects['search/GetDataResource']}>
                                <GoodsSearch total={total} dataResource={dataResource} condition={condition} postData={postData1} searchPagination={this.searchPagination} getnewData={this.getnewData}/>
                            </Spin>}
                        </TabPane>
                    </Tabs>
                </div>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(CommonTabs));