import React from 'react';
import { connect } from 'dva';
import {Modal,Form,Input,message} from  "antd";
import { Table  } from 'fl-pro';
const { confirm } = Modal;
import './less/GoodsSearch.less';
import findIndex from 'lodash/findIndex';
class GoodsSearch extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            dataList:[],
            oldSecretProductList:[],
        }
    }

    
    componentWillReceiveProps(nextProps){
        const { dataResource } = nextProps;
        const {UpdateMemberProductSecretPrice} = nextProps.price;
        if(dataResource&& dataResource !== this.props.dataResource){
            if(dataResource&&dataResource.length>0){
                this.setState({
                    dataList:dataResource.map((item)=>{
                        item.showSecretPrice=false;
                        return item;
                    }),
                    oldSecretProductList:dataResource?JSON.parse(JSON.stringify(dataResource)):'' 
                })
            }else{
                this.setState({
                    dataList:[]
                })
            }
        }
        // 更新密价
        if (UpdateMemberProductSecretPrice && UpdateMemberProductSecretPrice !== this.props.price.UpdateMemberProductSecretPrice) {
            if(UpdateMemberProductSecretPrice.code==="0"){
                message.destroy();
                message.success("更新密价成功");
                this.props.getnewData('2')
            }else{
                message.destroy();
                message.warning(UpdateMemberProductSecretPrice.message);
            }
        }
    }

    setSecretPriceValue=(record)=>{
        const _this = this;
        const {dataList,oldSecretProductList} = this.state;
        let istrue=false
        let oldsecretPrice=''
        if(oldSecretProductList&&oldSecretProductList.length>0){
            oldSecretProductList.map((el)=>{
                if(el.productSpMemberDetailId==record.productSpMemberDetailId){
                    if(el.secretPrice){
                        istrue=true;
                        oldsecretPrice=el.secretPrice
                    }
                }
            })
        }
        if(dataList&&dataList.length>0){
            dataList.map((item)=>{
                item.disabled=false
            })
        }
        this.setState({
            dataList
        })
        let postData= {
            logInfo: {
                productSpGroupId: record.spGroupId,
                productSpGroupName: record.spGroupName,
                memberCode: record.memberCode,
                memberName: record.memberName,
                clientId: record.clientId,
                appName: record.appName
            },
            priceList: [
                {
                    productSpMemberDetailId:record.productSpMemberDetailId ,
                    secretPrice:record.secretPrice
                }
            ],
            memberId:record.memberId
        }
        if(record.secretPrice){
            if(record.secretPrice==oldsecretPrice){
                return false
            }
            confirm({
                title: '修改密价',
                content: `确定修改密价为${record.secretPrice}？`,
                okText:"确定",
                cancelText:"取消",
                onOk() {
                        if (record.secretPrice > record.faceValue * 1.15 || record.secretPrice <         record.faceValue * 0.85) {
                            confirm({
                                title: '修改密价',
                                content: `本次修改密价超出安全范围，是否确认？`,
                                okText:"确定",
                                cancelText:"取消",
                                onOk() {
                                    _this.props.dispatch({
                                        type: 'price/UpdateMemberProductSecretPrice', 
                                        payload: {
                                            ...postData
                                        } 
                                    });
                                },
                                onCancel() {
                                    record.secretPrice = oldsecretPrice
                                        _this.setState({
                                            dataList
                                    })
                                }
                            })
                        }else{
                            _this.props.dispatch({
                                type: 'price/UpdateMemberProductSecretPrice', 
                                payload: {
                                    ...postData
                                } 
                            });
                        }
                     
                },
                onCancel() {
                    record.secretPrice = oldsecretPrice
                        _this.setState({
                            dataList
                    })
                },
            });
        }else{
            message.destroy();
            message.warn("密价不能为空")
            if(dataList&&dataList.length>0){
                dataList.map((item,i)=>{
                    if(item.productSpMemberDetailId==record.productSpMemberDetailId&&istrue){
                        item.showSecretPrice=true;
                        item.secretPrice=oldsecretPrice
                    }else{
                        item.showSecretPrice=false
                    }
                })
            }
        }
    }

    handleChange = (value, record) => {
        const {oldSecretProductList} = this.state;
        let istrue=false
        if(oldSecretProductList&&oldSecretProductList.length>0){
            oldSecretProductList.map((el)=>{
                if(el.productSpMemberDetailId==record.productSpMemberDetailId){
                    if(el.secretPrice){
                        istrue=true
                    }
                }
            })
        }
        for (var i in value) {
            if(i=='secretPrice'){
                value[i] = value[i].replace(/[^\d.]/g, ""); //清除"数字"和"."以外的字符
                value[i] = value[i].replace(/^\./g, ""); //验证第一个字符是数字
                value[i] = value[i].replace(/\.{2,}/g, "."); //只保留第一个, 清除多余的
                value[i] = value[i].replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
                value[i] = value[i].replace(/^(\-)*(\d+)\.(\d\d\d\d).*$/, '$1$2.$3'); //只能输入四个小数
            }
            record[i] = value[i];//这一句是必须的，不然状态无法更改
            
            this.setState({
                dataList: this.state.dataList.map((item, key) => item.productSpMemberDetailId == record.productSpMemberDetailId ? {...item, [i]: value[i],showSecretPrice:istrue?true:false} : item)
            })
        }
    }

     // 设置密价
     setSecretPrice = (record,index)=>{
        const { dataList } =this.state;
        if(dataList&&dataList.length>0){
            dataList.map((item,i)=>{
                if(item.productSpMemberDetailId==record.productSpMemberDetailId){
                    item.showSecretPrice=true,
                    item.disabled=false
                }else{
                    item.disabled=true
                }
            })
            this.setState({
                dataList,
            },()=>{
                let input= document.getElementsByClassName("Inputs")
                for(var i=0;i<input.length;i++){
                    let id= input[i].dataset.id
                    if(id == record.productSpMemberDetailId){
                        input[i].focus();
                    }
                }
            })
        }
    }

    setSecretFocus = (record)=>{
        const { dataList } = this.state;
        if(dataList&&dataList.length>0){
            dataList.map((item,i)=>{
                if(item.productSpMemberDetailId==record.productSpMemberDetailId){
                    item.disabled=false
                }else{
                    item.disabled=true
                }
            })
        }
        this.setState({
            dataList
        })
    }

	render() {
        const {dataResource,postData,condition,total} =  this.props
        const {dataList} = this.state;
        let columns = [
            {
                key:"1",
                title: '序号',
                width:60,
                dataIndex: 'key',
                align: 'center',
                render: (text, record, index) => {
                    if(postData){
                        return (postData.pageIndex-1) *postData.pageSize + index + 1
                    }
                }
            }, 
            {
                key:"2",
                title: '商品名称',
                width:300,
                align: 'left',
                dataIndex:"productName",
            },
            {
                key:"3",
                title: '密价组',
                align: 'left',
                dataIndex:"spGroupName",
            },
            {
                key:"4",
                title: '商户名称',
                align: 'left',
                dataIndex:"memberName",
            },
            {
                key:"5",
                title: '商户号',
                align: 'left',
                dataIndex:"memberCode",
            },
            {
                key:"6",
                title: '应用名称',
                align: 'left',
                dataIndex:"appName",
            },
            {
                key:"7",
                title: '商品编号',
                align: 'left',
                dataIndex:"productId",
            },
            {
                key:"8",
                title: '商品品类',
                align: 'left',
                dataIndex:"productTag",
            },
            {
                key:"9",
                title: '面值（元）',
                align: 'left',
                dataIndex:"faceValue",
            },
            {
                key:"10",
                width:120,
                title: '成本价（元）',
                align: 'left',
                dataIndex:"price",
            },
            {
                key:"11",
                title: '成本百分比',
                align: 'left',
                dataIndex:"pricePercent",
                render:(text,record)=>{
                    return record.pricePercent ? (record.pricePercent * 100).toFixed(2) + "%" : record.pricePercent;
                }
            },
            {
                key:"12",
                title: '密价（元）',
                align: 'left',
                width:120,
                dataIndex:"secretPrice",
                render:(text,record,index)=>{
                    if((findIndex(window.getAuthButtons(), { enCode: 'lr_goodssearch_setprice' }) !== -1)){
                        if(record.secretPrice||record.showSecretPrice){
                            return <Input className="Inputs" data-id={record.productSpMemberDetailId} value={text} disabled={record.disabled} onChange={(e) => this.handleChange({secretPrice: e.target.value}, record)} onFocus={()=>{this.setSecretFocus(record)}} onBlur={()=>{this.setSecretPriceValue(record)}} />
                        }else{
                            return <span style={{color:"#29b4ff",cursor:'pointer'}} onClick={()=>{
                                    this.setSecretPrice(record,index)
                                }}>设置密价</span>
                        }
                    }else{
                        return record.secretPrice
                    }
                }
            },
            {
                key:"13",
                title: '密价百分比',
                align: 'left',
                dataIndex:"secretPricePercent",
                render:(text,record)=>{
                    return record.secretPricePercent ? (record.secretPricePercent * 100).toFixed(2) + "%" : record.secretPricePercent;
                }
            },
            {
                key:"14",
                title: '利润（元）',
                align: 'left',
                dataIndex:"profit",
            },
            {
                key:"15",
                title: '利润百分比',
                align: 'left',
                dataIndex:"profitPercent",
                render:(text,record)=>{
                    return record.profitPercent ? (record.profitPercent * 100).toFixed(2) + "%" : record.profitPercent;
                }
            },
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData&&postData.pageSize,
            current: postData&&postData.pageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.pageIndex=1;
                postData.pageSize=pageSize;
                Object.assign(postData, { pageSize: pageSize })
                this.setState({ postData }, () => {
                    this.props.searchPagination(postData);
                })
            },
            onChange: (current) => {
                postData.pageIndex=current; 
                Object.assign(postData, { pageIndex: current })
                this.setState({ postData }, () => {
                    this.props.searchPagination(postData);
                })
            },
        };

		return (
			<div className="GoodsSearch">
                <div>
                    <div className="GoodsSearch-containter">
                        <Table 
                            columns={columns}
                            dataSource={dataList?dataList:[]}
                            pagination={pagination}
                            scroll={{x:1600}}
                        />
                    </div>
                </div>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(GoodsSearch));