import React from 'react';
import { connect } from 'dva';
import {Modal,Form,message,Upload  } from  "antd";
const { confirm } = Modal;
import { ExportButton,Table } from "fl-pro";
import './less/MerchantsSearch.less';
import {withRouter} from "react-router-dom";
import UploadRecords from '../UploadRecord';
import findIndex from 'lodash/findIndex';
const baseURL = configs.host.api;   // 后端地址
// 上传文件
const params = {
    name: 'file',
    action: `${baseURL}/api/ProductSpGroupMember/ImportSecret/ImportSecret`,  // 上传文件地址
    headers: { authorization: 'authorization-text' },
};
class MerchantsSearch extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            total:0,
            showUploadRecords:false,
            UploadRecordList:null,
            fileList:null,
            CheckNegativeProfit:0,
            recordData:null,
            uploadParams:null
        }
    }
    look=(record)=>{
        let merchants={
            name: record.spGroupName
        }
        sessionStorage.setItem("merchants",JSON.stringify(merchants))
        sessionStorage.setItem("memberData",JSON.stringify(record))
        this.setState({
            recordData:record
        },()=>{
            this.props.dispatch({
                type: 'search/HaveImportSecret', 
                payload: { } 
            });
        })
    }


    uploadRecord=(record)=>{
        this.setState({
            UploadRecordList:record,
            showUploadRecords:true
        })
    }

    closeUploadRecords=()=>{
        this.setState({
            showUploadRecords:false
        })
    }

    beforeUpload=(file)=>{
        const _this = this;
        return new Promise((resolve, reject) => {
            var reg = /\.xl(s|s[xmb]|t[xm]|am)$/;
            const isXls = reg.test(file.name);
            if (isXls) {
                confirm({
                    title: '提示信息',
                    content: '您确定上传吗？',
                    okText:"确定",
                    cancelText:"取消",
                    onOk() {
                        confirm({
                            title: '提示信息',
                            content: '是否需要校验商品负利润？',
                            okText:"是",
                            cancelText:"否",
                            onOk() {
                                _this.setState({
                                    CheckNegativeProfit:1
                                },()=>{
                                    return resolve(true);
                                })
                            },
                            onCancel() {
                                _this.setState({
                                    CheckNegativeProfit:0
                                },()=>{
                                    return resolve(true);
                                })
                            },
                        });
                    },
                    onCancel() {
                        return reject(false)
                    },
                });
            } else {
                message.destroy();
                message.error('只能上传excel文件');
                return reject(false)
            }
          });
          return reject(false)
    }

    handleUploadData=(record)=>{
        const {　CheckNegativeProfit }　= this.state;
        return {
            CheckNegativeProfit,
            ClientId:record.clientId,
            MemberId:record.memberId,
            ProductSpGroupMemberId:record.productSpGroupMemberId,
        }
    }

    // 导入密价
    changeImport = (info, index) => {
        let { fileList } = this.state;
        const file = info.fileList;
        fileList = file.slice(-1);
        if (info.file.status === 'done') {
          if (info.file.response.code == '0') {
            message.destroy();
            message.success("上传成功");
          } else {
            message.destroy();
            message.error(info.file.response.message);
            fileList = []
          }
        } else if (info.file.status === 'error') {
          message.destroy();
          message.error(`${info.file.name} 获取失败`);
          fileList[index] = [];
        }
        this.setState({ fileList });
    }

    componentWillReceiveProps(nextProps){
        const { HaveImportSecret } = nextProps.search;
        if(this.state.recordData){
            const { productSpGroupId,memberId,memberCode } = this.state.recordData
            if (HaveImportSecret && HaveImportSecret !== this.props.search.HaveImportSecret) {
                if(HaveImportSecret.code==="0"){
                    this.props.history.push(`/price/group/goods?GroupId=${productSpGroupId}&memberId=${memberId}&memberCode=${memberCode}`)
                }else{
                    message.destroy();
                    message.warning(HaveImportSecret.message);
                }
            }
        }
       
    }

	render() {
        const {dataResource,postData,total} =  this.props
        const {showUploadRecords,CheckNegativeProfit,UploadRecordList} =this.state;
        let columns = [
            {
                key:"1",
                title: '序号',
                width:60,
                dataIndex: 'key',
                align: 'center',
                render: (text, record, index) => {
                    if(postData){
                        return (postData.PageIndex-1) * postData.PageSize + index + 1
                    }
                }
            }, 
            {
                key:"2",
                title: '商户名称',
                width:300,
                align: 'left',
                dataIndex:"memberName",
            },
            {
                key:"3",
                title: '密价组',
                align: 'left',
                dataIndex:"spGroupName",
            },
            {
                key:"4",
                title: '商户号',
                align: 'left',
                dataIndex:"memberCode",
            },
            {
                key:"5",
                title: '应用名称',
                align: 'left',
                dataIndex:"appName",
            },
            {
                key:"6",
                title: '操作',
                width:200,
                align: 'center',
                render:(text,record)=>{
                    return <div className="ibox" style={{color:"#4b9ae0",fontSize:'16px'}}>
                    {(findIndex(window.getAuthButtons(), { enCode: 'lr_merchants_search_look' }) !== -1)?<i className="iconfont" style={{cursor:'pointer',fontSize:'16px',marginRight:'14px'}} onClick={()=>{this.look(record)}}  title="查看">&#xe611;</i>:''}
                    {(findIndex(window.getAuthButtons(), { enCode: 'lr_merchants_search_upload' }) !== -1)?<Upload
                            {...params}
                            data={
                                    ()=>this.handleUploadData(record)
                                }
                            showUploadList={false}
                            headers={{
                                "Authorization": `Bearer ${localStorage.getItem('access_token')}`,
                                'MerchantId': localStorage.getItem('MerchantId')
                            }}
                            beforeUpload={this.beforeUpload}
                            style={{width:'12px',display:'inline-block'}}
                            fileList={this.state.fileList}
                            onChange={(info) => { this.changeImport(info); }}
                            >
                            <i className="fa fa-upload fa-lg" style={{cursor:'pointer',marginRight:'14px',color:"#4b9ae0",fontSize:'16px'}} title="导入密价">
                            </i>
                        </Upload>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_merchants_search_exoprt' }) !== -1)?<div className="ExportButton" title="导出密价">
                            <ExportButton
                            loading={false}
                            url={`${configs.host.api}/api/ProductSpGroupMember/ExportSecret/ExportSecret`}
                            merchantId={localStorage.getItem('MerchantId')}
                            params={{
                                productSpGroupMemberId: record.productSpGroupMemberId,
                                memberId: record.memberId,
                                memberName: record.memberName,
                                clientId: record.clientId,
                                appName: record.appName
                            }} 
                            >
                                <i className="fa fa-download fa-lg" style={{cursor:'pointer',marginRight:'14px',color:"#4b9ae0",fontSize:'16px'}}  ></i>
                            </ExportButton> 
                        </div>:''}
                    {(findIndex(window.getAuthButtons(), { enCode: 'lr_merchants_search_record' }) !== -1)?<i className="fa fa-list-alt fa-lg" style={{cursor:'pointer',color:"#4b9ae0",fontSize:'16px'}} onClick={()=>{this.uploadRecord(record)}}  title="导入记录"></i>:''}
                    </div>
                    
                }
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData&&postData.PageSize,
            current: postData&&postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.props.searchPagination(postData);
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.props.searchPagination(postData);
                })
            },
        };
		return (
			<div className="MerchantsSearch">
                <div style={{width:'100%'}}>
                    <div className="MerchantsSearch-containter">
                        <Table 
                            columns={columns}
                            dataSource={dataResource?dataResource:[]}
                            pagination={pagination}
                        />
                    </div>
                </div>
                {showUploadRecords?<UploadRecords UploadRecordList={UploadRecordList} closeUploadRecords={this.closeUploadRecords}/>:''}
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(withRouter(MerchantsSearch)));