import React, { Component } from 'react';
import { connect } from 'dva';
import {Spin,Button,message} from 'antd';
import { Table } from 'fl-pro';
import './less/PriceGoods.less';
import SearchForm from '../../../components/SearchForm';
import commonFun from '../../../utils/utils';
class AddPriceGoods extends Component {
    constructor(props) {
        super(props);
        this.state = {
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            MemberSecretPriceProductList:[],
            total:0,
            selectedRowData:[],
            DepartmentList:[],
            PositionList:[],
            screenHeight:960,
            selectedRowKeys:[],
            CurrentMonthExpiresList:[
                { label: '是', value: '1' },
                { label: '否', value: '0' },
            ],
        }
    }
    
    componentDidMount (){
        this.setState({screenHeight:window.innerHeight});
    }

    componentWillUnmount() {
        //一定要最后移除监听器，以防多个组件之间导致this的指向紊乱
        window.removeEventListener('resize', this.handleResize.bind(this)) ;
    }


    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.GetMemberSecretPriceProductList();
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetMemberSecretPriceProductList()
        });
    }

     // 分页查询
     searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData,
            selectedRowData:[],
            selectedRowKeys:[]
        },() => {
            this.GetMemberSecretPriceProductList()
        });
    }

    handleResize = e => {
        this.setState({screenHeight:e.target.innerHeight});
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 获取商户可添加的商品列表(排除已添加商品)
    GetMemberSecretPriceProductList=()=>{
        const { postData, condition} = this.state;
        let ProductSpGroupId = commonFun.GetQueryString(location.search.split('?')[1], "GroupId");
        this.props.dispatch({
            type: 'price/GetMemberSecretPriceProductList', 
            payload: {
                ...postData,
                ...condition, 
                ...this.props.comonParams
            } 
        }); 
    }
    

    confirmData=()=>{
        const {selectedRowData,selectedRowKeys} = this.state;
        if(selectedRowData&&selectedRowData.length>0){
            this.props.dispatch({
                type: 'price/AddMemberSecretPriceProduct',
                payload: {
                    ...this.props.comonParams,
                    productList:selectedRowData.map((item,i)=>{
                        return item.id
                    }),
                }
            });
        }else{
            message.destroy();
            message.warning("请选择要添加的密价商品")
            return false
        }
    }

    changeCheckData=(e,record)=>{
        const {MemberSecretPriceProductList} = this.state;
        if(record.appList&&record.appList.length>0){
            record.appList.map((item)=>{
                if(e&&e.length>0){
                    e.map((el)=>{
                        if(el==item.clientId){
                            item.checked=1
                        }
                    })
                }
            })
        }
        record.checkedList=e;
        this.setState({
            MemberSecretPriceProductList
        })
       
    }


    componentWillReceiveProps(nextProps){
        const { GetMemberSecretPriceProductList,AddMemberSecretPriceProduct} = nextProps.price;
        // 获得待加入密价组商户列表 
        if (GetMemberSecretPriceProductList && GetMemberSecretPriceProductList !== this.props.price.GetMemberSecretPriceProductList) {
            if(GetMemberSecretPriceProductList.code==="0"){
                GetMemberSecretPriceProductList.data.list&&GetMemberSecretPriceProductList.data.list.map((item,i)=>{
                    item.key=i
                })
                this.setState({
                    MemberSecretPriceProductList:GetMemberSecretPriceProductList.data&&GetMemberSecretPriceProductList.data.list?GetMemberSecretPriceProductList.data.list:[],
                    total:GetMemberSecretPriceProductList.data.total
                })
            }else{
                message.destroy();
                message.warning(GetMemberSecretPriceProductList.message);
            }
        }

        if (AddMemberSecretPriceProduct && AddMemberSecretPriceProduct !== this.props.price.AddMemberSecretPriceProduct) {
            if(AddMemberSecretPriceProduct.code==="0"){
                message.destroy();
                message.success("添加成功")
                this.props.handleAddCancel()
            }else{
                message.destroy();
                message.warning(AddMemberSecretPriceProduct.message);
            }
        }

    }


    render() {
        const {postData,MemberSecretPriceProductList,total,screenHeight,selectedRowKeys,EditableCell,CurrentMonthExpiresList } = this.state;
        const {loading} = this.props;
        let columns = [
            {
                key:"1",
                title: '商品编号',
                width:150,
                align: 'left',
                dataIndex:"id",
            },
            {
                key:"2",
                title: '商品名称',
                width:210,
                align: 'left',
                dataIndex:"productName",
            },
            {
                key:"3",
                title: '商品价格',
                align: 'left',
                dataIndex:"productPrice",
                width:80,
            },
            {
                key:"4",
                title: '面值（元）',
                width:80,
                align: 'left',
                dataIndex:"productFaceValue",
            },
            {
                key:"5",
                title: '库存属性',
                align: 'left',
                dataIndex:"productType",
                width:80,
                render:(text)=>{
                    if(text==3){
                        return <span>卡密</span>
                    }if(text==4){
                        return <span>直充</span>
                    }else{
                        return <span>--</span>
                    }
                }
            },
            {
                key:"6",
                title: '库存状态',
                align: 'left',
                dataIndex:"stockStatus",
                width:100,
                render:(text)=>{
                    if(text==1){
                        return <span>断货</span>
                    }if(text==2){
                        return <span>警报</span>
                    }else{
                        return <span>充足</span>
                    }
                }
            },
            {
                key:"7",
                title: '销售状态',
                align: 'left',
                dataIndex:"saleStatus",
                width:100,
                render:(text)=>{
                    if(text==2){
                        return <span>上架</span>
                    }if(text==1){
                        return <span>下架</span>
                    } if(text==3){
                        return <span>官方维护</span>
                    }if(text==4){
                        return <span>库存维护</span>
                    }else{
                        return <span>--</span>
                    }
                }
            },
            {
                key:"8",
                title: '票据类型',
                align: 'left',
                dataIndex:"invoiceType",
                width:100,
                render:(text)=>{
                    if(text==0){
                        return <span>寄售</span>
                    }if(text==1){
                        return <span>自营</span>
                    }else{
                        return <span>--</span>
                    }
                }
            },
        ];

        const pagination = {
            total,
            hideOnSinglePage: true,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current;
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
               
            },
        };

        const rowSelection = {
            selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRowData:selectedRows,
                    selectedRowKeys
                })
            },
        };
        return(
            <div className="AddPriceMerchants">
                <div className="AddPriceMerchants-containter">
                    <SearchForm name="addpriceGoods"
                     init={this.init} 
                     search={this.search} 
                     getFormData={this.getFormData} 
                    />
                    <Spin spinning={loading.effects['price/GetMemberSecretPriceProductList']}>
                        <div className="tableBox">
                            <Table 
                                columns={columns}
                                dataSource={MemberSecretPriceProductList?MemberSecretPriceProductList:[]}
                                pagination={pagination}
                                rowSelection={rowSelection}
                            />
                        </div>
                    </Spin>
                </div>
                <div className="footerstaff">
                    <Button type="primary" className="btnok" onClick={this.confirmData}>确定</Button>
                    <Button className="btncancel" onClick={this.props.handleAddCancel}>取消</Button>
                </div>
            </div>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(AddPriceGoods);


