import React from 'react';
import { connect } from 'dva';
import {Spin,Modal,Form,Input,message,Button,Tabs  } from  "antd";
const { TabPane } = Tabs;
const { confirm } = Modal;
import './less/PriceGoods.less';
import { Table } from "fl-pro";
import BreadCrumb from '../../../components/Breadcrumb';
import SearchForm from '../../../components/SearchForm';
import SupplyDetail from '../SupplyDetails';
import commonFun from '../../../utils/utils';
import AddPriceGoods from './AddPriceGoods';
import SetPrice from '../SetPrice';
import SynchronousMemberList from '../SynchronousMemberList';
import findIndex from 'lodash/findIndex';
class PriceGoods extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                pageIndex: 1,
                pageSize: 10,
            },
            SecretProductList:[],
            oldSecretProductList:[],
            total:0,
            showaddPriceGoods:false,
            showSupplyDetails:false,
            productSpGroupId:commonFun.GetQueryString(location.search.split('?')[1], "GroupId"),
            productSpGroupName:sessionStorage.getItem("merchants")?JSON.parse(sessionStorage.getItem("merchants")).name:'',
            memberId:commonFun.GetQueryString(location.search.split('?')[1], "memberId"),
            memberCode:commonFun.GetQueryString(location.search.split('?')[1], "memberCode"),
            memberName:sessionStorage.getItem("memberData")?JSON.parse(sessionStorage.getItem("memberData")).memberName:'',
            memberAppName:sessionStorage.getItem("memberData")?JSON.parse(sessionStorage.getItem("memberData")).appName:'',
            BusinessInfoIntoMemberList:[],
            tabActiveList:[],
            comonParams:{},
            productSpMemberDetailId:'',
            selectedRowData:[],
            selectedRowKeys:[],
            showSetpriceModal:false,
            btnsync:true,
            btnsyncgroup:true,
            showAsyncMerchants:false,
        }
	}

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.GetBusinessInfoIntoMember()
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.pageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetSecretProductPageList()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 获取当前密价商户下密价商品应用
    GetBusinessInfoIntoMember=()=>{
        const {productSpGroupId,memberId} = this.state;
        let params={
            productSpGroupId,
            memberId
        }
        this.props.dispatch({
            type: 'price/GetBusinessInfoIntoMember', 
            payload: {
               ...params
            } 
        });
    }

    // 获取密价商品管理列表
    GetSecretProductPageList = ()=>{
        const {postData,condition,tabActiveList,productSpGroupId,memberId,productSpGroupName,memberName,memberCode } =this.state;
        let params = {
            productSpGroupMemberId:tabActiveList?tabActiveList.productSpGroupMemberId:'',
            productSpGroupId,
            productSpGroupName,
            memberCode,
            memberName,
            memberId,
            clientId:tabActiveList?tabActiveList.clientId:'',
            appName:tabActiveList?tabActiveList.appName:'',

        }
        this.setState({
            comonParams:params
        },()=>{
            this.props.dispatch({
                type: 'price/GetSecretProductPageList', 
                payload: {
                    ...postData,
                    ...condition,
                    ...params 
                } 
            });
        })
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetSecretProductPageList()
        });
    }

    // 新增
    addGoods=()=>{
        this.setState({
            showaddPriceGoods:true,
        })
    }

    callback=(type)=>{
        const { BusinessInfoIntoMemberList} = this.state;
        this.setState({
            memberAppName:type
        })
        if(BusinessInfoIntoMemberList&&BusinessInfoIntoMemberList.length>0){
            BusinessInfoIntoMemberList.map((item,i)=>{
                if(item.appName==type){
                    this.setState({
                        tabActiveList:item
                    },()=>{
                        this.GetSecretProductPageList()
                    })
                }
            })
        }
    }

    // 密价商户
    goMerchants=()=>{
        this.props.history.push("/price/group/merchants")
    }

    // 删除密价商品
    handleDele=(record)=>{
        const _this = this;
        const {selectedRowData,comonParams,memberId} = this.state;
        if(record){
            confirm({
                title: '删除商品',
                content: '确定删除该商品？',
                okText:"确定",
                cancelText:"取消",
                onOk() {
                    _this.props.dispatch({
                        type: 'price/DeleteMemberProductSecretPrice', 
                        payload: {
                            logInfo: {
                                productSpGroupId: comonParams.productSpGroupId,
                                productSpGroupName: comonParams.productSpGroupName,
                                memberCode: comonParams.memberCode,
                                memberName: comonParams.memberName,
                                clientId: comonParams.clientId,
                                appName: comonParams.appName
                            },
                           idsList:[
                               {
                                    productId:record.productId,
                                    id:record.id
                               }
                           ],
                           memberId
                        } 
                    }); 
                }
            });
        }else{
            if(selectedRowData&&selectedRowData.length>0){
                confirm({
                    title: '删除商品',
                    content: '确定删除该商品？',
                    okText:"确定",
                    cancelText:"取消",
                    onOk() {
                        _this.props.dispatch({
                            type: 'price/DeleteMemberProductSecretPrice', 
                            payload: {
                                logInfo: {
                                    productSpGroupId: comonParams.productSpGroupId,
                                    productSpGroupName: comonParams.productSpGroupName,
                                    memberCode: comonParams.memberCode,
                                    memberName: comonParams.memberName,
                                    clientId: comonParams.clientId,
                                    appName: comonParams.appName
                                },
                               idsList:selectedRowData.map((item)=>{
                                   return {
                                    productId:item.productId,
                                    id:item.id
                               }
                               }),
                               memberId
                            } 
                        }); 
                    }
                });
            }else{  
                message.destroy();
                message.warning("请选择要删除的密价商品")
            }
        }
        
       
    }

    setEnableBuy=(record)=>{
        const _this = this;
        confirm({
            title: '购买设置',
            content: `确定将该商品设置为${record.enableBuy?"不可购买":"可购买"} ？`,
            okText:"确定",
            cancelText:"取消",
            onOk() {
                _this.props.dispatch({
                    type: 'price/SetEnableBuy', 
                    payload: {
                        productSpMemberDetailIds:record.id,
                        enableBuy:record.enableBuy?0:1,
                        op: "",
                        memberId:_this.state.memberId
                    } 
                }); 
            },
            onCancel() {
              
            },
        });
    }

    closeaddPriceGoods=()=>{
        this.setState({
            showaddPriceGoods:false,
        },()=>{
            this.GetSecretProductPageList() 
        })
    }

    
    // 查看
    lookDetail=(record)=>{
        this.setState({
            showSupplyDetails:true,
            productSpMemberDetailId:record.id
        })
    }

    // 关闭弹窗
    closeshowSupplyDetails=()=>{
        this.setState({
            showSupplyDetails:false,
        },()=>{
            this.GetSecretProductPageList() 
        })
    }

    // 设置密价
    setSecretPrice = (record,index)=>{
        const { SecretProductList } =this.state;
        if(SecretProductList&&SecretProductList.length>0){
            SecretProductList.map((item,i)=>{
                if(item.id==record.id){
                    item.showSecretPrice=true,
                    item.disabled=false
                }else{
                    item.disabled=true
                }
            })
            this.setState({
                SecretProductList,
            },()=>{
                let input= document.getElementsByClassName("Inputs")
                for(var i=0;i<input.length;i++){
                    let id= input[i].dataset.id
                    if(id == record.productSpMemberDetailId){
                        input[i].focus();
                    }
                }
            })
        }
    }

    setSecretPriceValue=(record,type)=>{
        const _this = this;
        const {comonParams,SecretProductList,oldSecretProductList,memberId} = this.state;
        let istrue=false
        let oldsecretPrice=''
        if(oldSecretProductList&&oldSecretProductList.length>0){
            oldSecretProductList.map((el)=>{
                if(el.id==record.id){
                    if(el.secretPrice){
                        istrue=true;
                        oldsecretPrice=el.secretPrice
                    }
                }
            })
        }
        if(SecretProductList&&SecretProductList.length>0){
            SecretProductList.map((item)=>{
                item.disabled=false
            })
        }
        this.setState({
            SecretProductList
        })
        if(type==1){
            let postData= {
                logInfo: {
                    productSpGroupId: comonParams.productSpGroupId,
                    productSpGroupName: comonParams.productSpGroupName,
                    memberCode: comonParams.memberCode,
                    memberName: comonParams.memberName,
                    clientId: comonParams.clientId,
                    appName: comonParams.appName,
                },
                priceList: [
                    {
                        productSpMemberDetailId:record.id ,
                        secretPrice:record.secretPrice,
                    }
                ],
                memberId
            }
            if(record.secretPrice){
                if(record.secretPrice==oldsecretPrice){
                    return false
                }
                confirm({
                    title: '修改密价',
                    content: `确定修改密价为${record.secretPrice}？`,
                    okText:"确定",
                    cancelText:"取消",
                    onOk() {
                        if (record.secretPrice > record.productFaceValue * 1.15 || record.secretPrice <         record.productFaceValue * 0.85) {
                            confirm({
                                title: '修改密价',
                                content: `密价安全范围为85%-115%，本次修改密价超出安全范围，是否确认？`,
                                okText:"确定",
                                cancelText:"取消",
                                onOk() {
                                    _this.props.dispatch({
                                        type: 'price/UpdateMemberProductSecretPrice', 
                                        payload: {
                                        ...postData
                                        } 
                                    }); 
                                },
                                onCancel() {
                                    record.secretPrice = oldsecretPrice
                                        _this.setState({
                                            SecretProductList
                                    })
                                }
                            })
                        }else{
                            _this.props.dispatch({
                                type: 'price/UpdateMemberProductSecretPrice', 
                                payload: {
                                ...postData
                                } 
                            }); 
                        }
                    },
                    onCancel() {
                        record.secretPrice = oldsecretPrice
                        _this.setState({
                            SecretProductList
                        })
                    },
                });
            }else{
                message.destroy();
                message.warn("密价不能为空")
                if(SecretProductList&&SecretProductList.length>0){
                    SecretProductList.map((item,i)=>{
                        if(item.id==record.id&&istrue){
                            item.showSecretPrice=true;
                            item.secretPrice=oldsecretPrice
                        }else{
                            item.showSecretPrice=false
                        }
                    })
                }
            }
        }else if(type==2){
            record&&record.length>0&&record.map((items)=>{
                if(!items.secretPrice){
                    message.destroy();
                    message.warn("密价不能为空")
                    return;
                }
            })
            let isallOk = true
            let postData= {
                logInfo: {
                    productSpGroupId: comonParams.productSpGroupId,
                    productSpGroupName: comonParams.productSpGroupName,
                    memberCode: comonParams.memberCode,
                    memberName: comonParams.memberName,
                    clientId: comonParams.clientId,
                    appName: comonParams.appName,
                },
                priceList: record&&record.length>0&&record.map((el)=>{
                    if(el.secretPrice > el.facePrice * 1.15 || el.secretPrice < el.facePrice * 0.85){
                        isallOk=false
                    }
                    return {
                        productSpMemberDetailId:el.productSpMemberDetailId ,
                        secretPrice:el.secretPrice,
                    }
                }),
                memberId
            }

            if(isallOk){
                _this.props.dispatch({
                    type: 'price/UpdateMemberProductSecretPrice', 
                    payload: {
                       ...postData
                    } 
                }); 
            }else{
                confirm({
                    title: '修改密价',
                    content: `密价安全范围为85%-115%，本次修改密价超出安全范围，是否确认？`,
                    okText:"确定",
                    cancelText:"取消",
                    onOk() {
                        _this.props.dispatch({
                            type: 'price/UpdateMemberProductSecretPrice', 
                            payload: {
                               ...postData
                            } 
                        }); 
                    },
                    onCancel() {
                        
                    }
                })
            }
        }
    }

    removeSecretPrice=(record)=>{
        const _this = this;
        const {comonParams,selectedRowData,memberId} = this.state;
        let postData={};
        if(record){
            postData={
                logInfo: {
                    productSpGroupId: comonParams.productSpGroupId,
                    productSpGroupName: comonParams.productSpGroupName,
                    memberCode: comonParams.memberCode,
                    memberName: comonParams.memberName,
                    clientId: comonParams.clientId,
                    appName: comonParams.appName
                },
                priceList: [
                    {
                        productSpMemberDetailId:record.id 
                    }
                ],
                memberId
            }
        }else{
            if(selectedRowData&&selectedRowData.length>0){
                postData={
                    logInfo: {
                        productSpGroupId: comonParams.productSpGroupId,
                        productSpGroupName: comonParams.productSpGroupName,
                        memberCode: comonParams.memberCode,
                        memberName: comonParams.memberName,
                        clientId: comonParams.clientId,
                        appName: comonParams.appName
                    },
                    priceList: selectedRowData.map((el)=>{
                        return {
                            productSpMemberDetailId:el.id
                        }
                    }),
                    memberId
                }
            }else{
                message.destroy();
                message.warning("请选择要移除的密价商品")
                return false;
            }
           
        }
        confirm({
            title: '移除密价',
            content: `移除后商品会变回原价，请谨慎操作。`,
            okText:"确定",
            cancelText:"取消",
            onOk() {
                _this.props.dispatch({
                    type: 'price/RemoveMemberProductSecretPrice', 
                    payload: {
                       ...postData
                    } 
                }); 
            },
            onCancel() {
              
            },
        })
    }

    setAmountPrice=()=>{
        const {selectedRowData} = this.state;
        if(selectedRowData&&selectedRowData.length>0){
            this.setState({
                showSetpriceModal:true,
            })
        }else{
            message.destroy();
            message.warning("请选择要设置的密价商品")
        }
    }

    handlePriceCancel=()=>{
        this.setState({
            showSetpriceModal:false,
            selectedRowKeys:[],
            selectedRowData:[]
        },()=>{
            this.GetSecretProductPageList() 
        })
    }

    SynchronousMemberProductSecretPrice = ()=>{
        const {selectedRowData} = this.state;
        if(selectedRowData&&selectedRowData.length>0){
            this.setState({
                showAsyncMerchants:true
            })
        }else{
            message.destroy();
            message.warning("请选择需要批量同步至商户的商品！")
        }
      
    }

    closeAsyncMerchants=()=>{
        this.setState({
            showAsyncMerchants:false
        })
    }

    handleChange = (value, record) => {
        const {oldSecretProductList} = this.state;
        let istrue=false
        if(oldSecretProductList&&oldSecretProductList.length>0){
            oldSecretProductList.map((el)=>{
                if(el.id==record.id){
                    if(el.secretPrice){
                        istrue=true
                    }
                }
            })
        }
        for (var i in value) {
            if(i=='secretPrice'){
                value[i] = value[i].replace(/[^\d.]/g, ""); //清除"数字"和"."以外的字符
                value[i] = value[i].replace(/^\./g, ""); //验证第一个字符是数字
                value[i] = value[i].replace(/\.{2,}/g, "."); //只保留第一个, 清除多余的
                value[i] = value[i].replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
                value[i] = value[i].replace(/^(\-)*(\d+)\.(\d\d\d\d).*$/, '$1$2.$3'); //只能输入四个小数
            }
            record[i] = value[i];//这一句是必须的，不然状态无法更改
            
            this.setState({
                SecretProductList: this.state.SecretProductList.map((item, key) => item.id == record.id ? {...item, [i]: value[i],showSecretPrice:istrue?true:false} : item)
            })
        }
    }

    setSecretFocus = (record)=>{
        const { SecretProductList } = this.state;
        if(SecretProductList&&SecretProductList.length>0){
            SecretProductList.map((item,i)=>{
                if(item.id==record.id){
                    item.disabled=false
                }else{
                    item.disabled=true
                }
            })
        }
    }
    
	componentWillReceiveProps(nextProps) {
        const {GetSecretProductPageList,DeleteMemberProductSecretPrice,GetBusinessInfoIntoMember,UpdateMemberProductSecretPrice,RemoveMemberProductSecretPrice,SetEnableBuy } = nextProps.price;
        // 获取当前密价商户下密价商品应用
        if (GetBusinessInfoIntoMember && GetBusinessInfoIntoMember !== this.props.price.GetBusinessInfoIntoMember) {
            if(GetBusinessInfoIntoMember.code==="0"){
                let obj=null
                if(GetBusinessInfoIntoMember.data&&GetBusinessInfoIntoMember.data.list.length>0){
                    GetBusinessInfoIntoMember.data.list.map((item)=>{
                        if(item.appName==this.state.memberAppName){
                            obj= item
                        }
                    })
                }
                this.setState({
                    BusinessInfoIntoMemberList:GetBusinessInfoIntoMember.data.list,
                    tabActiveList: obj
                },()=>{
                    this.GetSecretProductPageList()
                })
            }else{
                message.destroy();
                message.warning(GetBusinessInfoIntoMember.message);
            }
        }
        // 获取密价商品管理列表
        if (GetSecretProductPageList && GetSecretProductPageList !== this.props.price.GetSecretProductPageList) {
            if(GetSecretProductPageList.code==="0"){
              this.setState({
                SecretProductList:GetSecretProductPageList.data&&GetSecretProductPageList.data.list.length&&GetSecretProductPageList.data.list.map((item)=>{
                    item.showSecretPrice=false;
                    return item;
                }),
                total:GetSecretProductPageList.data.total,
                oldSecretProductList: GetSecretProductPageList.data&&GetSecretProductPageList.data.list?JSON.parse(JSON.stringify(GetSecretProductPageList.data.list)):'' 
              })
              if (GetSecretProductPageList.data.reamark) {
                let IsTplArr = GetSecretProductPageList.data.reamark.split("@");
                var GroupIsTpl = IsTplArr[0];
                var MemberIsTpl = IsTplArr[1];
                // 模板密价组 中的 商户不允许 同步至其他商户
                if (GroupIsTpl == 1) {
                   this.setState({
                        btnsync:false
                   })
                }
                // 模板密价组中的非模板商户 不允许操作功能按钮
                if (GroupIsTpl == 1 && MemberIsTpl != 1) {
                    this.setState({
                        btnsyncgroup:false
                    })
                }
            }
            }else{
                message.destroy();
                message.warning(GetSecretProductPageList.message);
            }
        }

        // 删除
        if (DeleteMemberProductSecretPrice && DeleteMemberProductSecretPrice !== this.props.price.DeleteMemberProductSecretPrice) {
            if(DeleteMemberProductSecretPrice.code==="0"){
                message.destroy();
                message.success("删除成功");
                this.setState({
                    selectedRowKeys:[],
                    selectedRowData:[]
                },()=>{
                    this.GetSecretProductPageList() 
                })
            }else{
                message.destroy();
                message.warning(DeleteMemberProductSecretPrice.message);
            }
        }

        // 更新密价
        if (UpdateMemberProductSecretPrice && UpdateMemberProductSecretPrice !== this.props.price.UpdateMemberProductSecretPrice) {
            if(UpdateMemberProductSecretPrice.code==="0"){
                message.destroy();
                message.success("更新密价成功");
                if(this.state.SecretProductList){
                    this.state.SecretProductList.map((item)=>{
                        item.disabled=false
                    })
                }
                this.setState({
                    selectedRowKeys:[],
                    selectedRowData:[],
                    showSetpriceModal:false,
                    SecretProductList:this.state.SecretProductList
                },()=>{
                    this.GetSecretProductPageList() 
                })
            }else{
                message.destroy();
                message.warning(UpdateMemberProductSecretPrice.message);
            }
        }
        
        // 移除密价
        if (RemoveMemberProductSecretPrice && RemoveMemberProductSecretPrice !== this.props.price.RemoveMemberProductSecretPrice) {
            if(RemoveMemberProductSecretPrice.code==="0"){
                message.destroy();
                message.success("移除密价成功");
                this.setState({
                    selectedRowKeys:[],
                    selectedRowData:[],
                },()=>{
                    this.GetSecretProductPageList() 
                })
            }else{
                message.destroy();
                message.warning(RemoveMemberProductSecretPrice.message);
            }
        }

        // 设置是否可购买
        if (SetEnableBuy && SetEnableBuy !== this.props.price.SetEnableBuy) {
            if(SetEnableBuy.code==="0"){
                message.destroy();
                message.success("设置成功");
                this.GetSecretProductPageList() 
            }else{
                message.destroy();
                message.warning(SetEnableBuy.message);
            }
        }
        
    }

	render() {
        const {loading} = this.props;
        const {total,postData,SecretProductList,showaddPriceGoods,showSupplyDetails,productSpGroupId,BusinessInfoIntoMemberList,comonParams,productSpMemberDetailId,selectedRowKeys,showSetpriceModal,selectedRowData,btnsync,btnsyncgroup,showAsyncMerchants,memberId,memberAppName  } = this.state;
        const breadcrumbList = [
            {
                name:"密价管理",
                href:""
            },
            {
                name:"密价组管理",
                href:"/price/group"
            },
            {
                name:"密价商户",
                href:"/price/group/merchants?GroupId="+productSpGroupId
            },
            {
                name:"密价商品",
                href:""
            }
        ];
        let columns = [
            {
                key:"1",
                title: '序号',
                width:60,
                dataIndex: 'key',
                align: 'center',
                render: (text, record, index) => (
                (postData.pageIndex-1) * postData.pageSize + index + 1
                )
            }, 
            {
                key:"2",
                title: '商品编号',
                width:150,
                align: 'left',
                dataIndex:"productId",
            },
            {
                key:"3",
                title: '商品名称',
                width:300,
                align: 'left',
                dataIndex:"productName",
            },
            {
                key:"4",
                title: '商品销售状态',
                align: 'left',
                dataIndex:"saleStatus",
                width:120,
                render:(text)=>{
                    if(text==2){
                        return <span>上架</span>
                    }if(text==1){
                        return <span>下架</span>
                    }if(text==3){
                        return <span>官方维护</span>
                    }if(text==4){
                        return <span>库存维护</span>
                    }else{
                        return <span>--</span>
                    }
                }
            },
            {
                key:"5",
                title: '商品属性',
                align: 'left',
                dataIndex:"productType",
                render:(text)=>{
                    if(text==3){
                        return <span>卡密</span>
                    }if(text==4){
                        return <span>直充</span>
                    }else{
                        return <span>--</span>
                    }
                }
            },
            {
                key:"6",
                title: '面值（元）',
                align: 'left',
                dataIndex:"productFaceValue",
            },
            {
                key:"7",
                title: '是否可购买',
                align: 'left',
                dataIndex:"enableBuy",
                width:100,
                render:(text)=>{
                    if(text==1){
                        return <span>是</span>
                    }else{
                        return <span>否</span>
                    }
                }
            },
            {
                key:"8",
                title: '密价百分比',
                align: 'left',
                dataIndex:"percent",
                render:(text,record)=>{
                    return record.percent ? (record.percent).toFixed(4) + "%" : record.percent;
                }
            },
            {
                key:"9",
                title: '密价（元）',
                width:150,
                align: 'left',
                dataIndex:"secretPrice",
                render:(text,record,index)=>{
                    if(btnsyncgroup&&(findIndex(window.getAuthButtons(), { enCode: 'lr_goodssearch_setprice' }) !== -1)){
                        if(record.secretPrice||record.showSecretPrice){
                            return <Input className="Inputs" value={text} data-id={record.id} disabled={record.disabled} onChange={(e) => this.handleChange({secretPrice: e.target.value}, record)} onBlur={()=>{this.setSecretPriceValue(record,1)}} onFocus={()=>{this.setSecretFocus(record)}}/>
                        }else{
                            return <span style={{color:"#29b4ff",cursor:'pointer'}} onClick={()=>{
                                    this.setSecretPrice(record,index)
                                }}>设置密价</span>
                        }
                    }else{
                        return record.secretPrice
                    }
                }
            },
            {
                key:"10",
                title: '操作',
                width:150,
                align: 'center',
                fixed: 'right',
                render:(text,record)=>{
                    if(btnsyncgroup){
                        return <div style={{color:"#4b9ae0"}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_goods_look' }) !== -1)?<i className="iconfont" style={{cursor:'pointer',fontSize:'16px',marginRight:'14px'}}   title="供货详情" onClick={()=>{this.lookDetail(record)}}>&#xe611;</i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_goods_remove' }) !== -1)?<i className="fa fa-window-close-o fa-lg" style={{cursor:"pointer",marginRight:"14px",fontSize:'16px'}}  title="移除密价" onClick={()=>{this.removeSecretPrice(record)}}></i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_goods_delete' }) !== -1)?<i className="fa fa-trash-o fa-lg" style={{cursor:"pointer",marginRight:"14px",fontSize:'16px'}}   title="删除"  onClick={()=>{this.handleDele(record)}}></i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_goods_buyset' }) !== -1)?<i  style={{cursor:"pointer",fontSize:'16px'}} className="iconfont"   title="购买设置" onClick={()=>{this.setEnableBuy(record)}}>&#xe612;</i>:''}
                    </div>
                    }else{
                        return ''
                    }
                }
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };
        const rowSelection = {
            selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
              this.setState({
                selectedRowData:selectedRows,
                selectedRowKeys
              })
            },
            // getCheckboxProps: record => ({
            //   disabled: record.name === 'Disabled User', 
            //   name: record.name,
            // }),
        };
		return (
			<div className="PriceGoods">
                <BreadCrumb paramsList={breadcrumbList}/>
                    <div className="PriceGoods-containter">
                        <Spin spinning={loading.effects['price/GetSecretProductPageList']}>
                            <SearchForm name="priceGoods"
                                init={this.init} 
                                search={this.search} 
                                getFormData={this.getFormData} 
                            />
                            <div className="tabs">
                                {btnsyncgroup&&(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_goods_add' }) !== -1)?<Button type="primary"  className="addGoods"  onClick={()=>{this.addGoods()}}>
                                    新增商品
                                </Button>:""}
                                {(btnsync||btnsyncgroup)&&(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_goods_async' }) !== -1)?<Button  className="btnsync"  onClick={()=>{this.SynchronousMemberProductSecretPrice()}}>
                                    同步至商户
                                </Button>:""}
                                {btnsyncgroup&&((findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_setAmount' }) !== -1)||(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_removeAmount' }) !== -1)||(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_deteleAmount' }) !== -1))?<div className="setmount">
                                    批量设置
                                    <ul className="btngroups">
                                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_setAmount' }) !== -1)?<li  onClick={()=>{this.setAmountPrice()}}>
                                            批量设置密价
                                        </li>:''}
                                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_removeAmount' }) !== -1)?<li  onClick={()=>{this.removeSecretPrice()}}>
                                            批量移除密价
                                        </li>:''}
                                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_deteleAmount' }) !== -1)?<li  onClick={()=>{this.handleDele()}}>
                                            批量删除
                                        </li>:''}
                                    </ul>
                                </div>:""}
                               {BusinessInfoIntoMemberList? <Tabs onChange={this.callback} type="card" activeKey={memberAppName}>
                                    {
                                        BusinessInfoIntoMemberList.map((item,i)=>{
                                            return <TabPane tab={item.appName} key={item.appName} >
                                                <Table 
                                                    rowKey="id"
                                                    columns={columns}
                                                    rowSelection={rowSelection}
                                                    dataSource={SecretProductList?SecretProductList:[]}
                                                    pagination={pagination}
                                                    scroll={{x:1400}}
                                                />
                                            </TabPane>
                                        })
                                    }
                                </Tabs>:''}
                            </div>
                        </Spin>
                    </div>
                    {showSupplyDetails&&
                    <Modal
                        width="1220px"
                        title="供货详情"
                        visible={showSupplyDetails}
                        onCancel={this.closeshowSupplyDetails}
                        footer={null}
                        className="addCommodityModal"
                    >
                        <SupplyDetail closeshowSupplyDetails={this.closeshowSupplyDetails} productSpMemberDetailId={productSpMemberDetailId} memberId={memberId}/>
                    </Modal>  
                    }
                    {
                        showaddPriceGoods&&
                        <Modal
                        width="1220px"
                        title="新增商品"
                        visible={showaddPriceGoods}
                        onCancel={this.closeaddPriceGoods}
                        footer={null}
                        className="addCommodityModal"
                        >
                            <AddPriceGoods handleAddCancel={this.closeaddPriceGoods} comonParams={comonParams}/>
                        </Modal>  
                    }  
                    {showSetpriceModal&&
                        <Modal
                        width="1052px"
                        title="设置密价"
                        visible={showSetpriceModal}
                        onCancel={this.handlePriceCancel}
                        footer={null}
                        className="priceModal"
                        >
                        <SetPrice datalist={{
                            selectedRowData
                        }} handlePriceCancel={this.handlePriceCancel} setSecretPriceValue={this.setSecretPriceValue}/>
                        </Modal>  
                    } 

                    {showAsyncMerchants&&
                        <Modal
                        width="1220px"
                        title="同步至商户"
                        visible={showAsyncMerchants}
                        onCancel={this.closeAsyncMerchants}
                        footer={null}
                        className="addCommodityModal"
                        >
                            <SynchronousMemberList comonParams={comonParams} productSecretPriceList={selectedRowData} handleAddCancel={this.closeAsyncMerchants} memberId={memberId}/>
                        </Modal>  
                    }
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(PriceGoods));