import React from 'react';
import { connect } from 'dva';
import {Spin,Modal,Form,message,Button  } from  "antd";
import { Table } from 'fl-pro';
const { confirm } = Modal;
import './less/PriceGroup.less';
import BreadCrumb from '../../../components/Breadcrumb';
import SearchForm from '../../../components/SearchForm';
import AddPriceGroup from './addPriceGroup';
import findIndex from 'lodash/findIndex';
class PriceGroup extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            priceGroupdataList:[],
            total:0,
            showaddPriceGroup:false,
        }
	}

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.getpriceResource()
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getpriceResource()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 获取密价组管理列表
    getpriceResource = ()=>{
        const {postData,condition } =this.state;
        this.props.dispatch({
            type: 'price/GetpriceResource', 
            payload: {
                ...postData,
                ...condition 
            } 
        });
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getpriceResource()
        });
    }

    // 编辑
    handleEdit=(record)=>{
        this.setState({
            showaddPriceGroup:true,
            addPriceGroupList:Object.assign({},record,{title:"编辑商户密价组",showaddPriceGroup:true}),
        })
    }

    // 新增
    creatprice=()=>{
        this.setState({
            showaddPriceGroup:true,
            addPriceGroupList:{title:"创建商户密价组",showaddPriceGroup:true},
        })
    }

    // 密价商户
    goMerchants=(record)=>{
        this.props.history.push("/price/group/merchants?GroupId="+record.id+'&isTemplate='+ record.isTemplate)
        sessionStorage.setItem("merchants",JSON.stringify(record))
    }

    // 删除密价组
    handleDele=(record)=>{
        const _this = this;
        confirm({
            title: '确定删除我吗？',
            content: '确定删除我吗？',
            okText:"确定",
            cancelText:"取消",
            onOk() {
                _this.props.dispatch({
                    type: 'price/DeletePriceGroup', 
                    payload: {
                       id:record.id
                    } 
                }); 
            },
            onCancel() {
              
            },
        });
    }

    closeaddPriceGroup=()=>{
        this.setState({
            showaddPriceGroup:false,
        },()=>{
            this.getpriceResource() 
        })
    }

	componentWillReceiveProps(nextProps) {
        const { props } = this;
        const {GetpriceResource,DeletePriceGroup } = nextProps.price;
        // 获取密价组管理列表
        if (GetpriceResource && GetpriceResource !== this.props.price.GetpriceResource) {
            if(GetpriceResource.code==="0"){
              this.setState({
                priceGroupdataList:GetpriceResource.data.list,
                total:GetpriceResource.data.total
              })
            }else{
                message.destroy();
                message.warning(GetpriceResource.message);
            }
        }

        // 删除密价组
        if (DeletePriceGroup && DeletePriceGroup !== this.props.price.DeletePriceGroup) {
            if(DeletePriceGroup.code==="0"){
                message.destroy();
                message.success("删除成功");
                this.getpriceResource() 
            }else{
                message.destroy();
                message.warning(DeletePriceGroup.message);
            }
        }
    }

	render() {
        const {loading} = this.props;
        const {total,postData,priceGroupdataList,showaddPriceGroup,addPriceGroupList } = this.state;
        const breadcrumbList = [
            {
                name:"密价管理",
                href:""
            },
            {
                name:"密价组管理",
                href:""
            }
        ];
        let columns = [
            {
                key:"1",
                title: '序号',
                width:60,
                dataIndex: 'key',
                align: 'center',
                render: (text, record, index) => (
                (postData.PageIndex-1) * postData.PageSize + index + 1
                )
            }, 
            {
                key:"2",
                title: '商户密价组名称',
                width:300,
                align: 'left',
                dataIndex:"name",
            },
            {
                key:"3",
                title: '备注',
                align: 'left',
                dataIndex:"remark",
            },
            {
                key:"4",
                title: '是否模板',
                align: 'left',
                dataIndex:"isTemplate",
                width:100,
                render:(text)=>{
                    if(text==1){
                        return <span>是</span>
                    }else{
                        return <span>否</span>
                    }
                }
            },
            {
                key:"5",
                title: '操作',
                width:150,
                align: 'center',
                render:(text,record)=>(
                    <div style={{color:"#4b9ae0"}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_group_edit' }) !== -1)?<i className="iconfont" style={{cursor:"pointer",marginRight:"14px",fontSize:'16px'}}   title="编辑" onClick={()=>{this.handleEdit(record)}}>&#xe616;</i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_group_look' }) !== -1)?<i className="fa fa-group fa-lg" style={{cursor:"pointer",marginRight:"14px",fontSize:'16px'}}  title="密价商户" onClick={()=>{this.goMerchants(record)}}></i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_group_delete' }) !== -1)?<i className="fa fa-trash-o fa-lg" style={{cursor:"pointer",fontSize:'16px'}}  data-toggle="tooltip" title="删除"  onClick={()=>{this.handleDele(record)}}></i>:''}
                    </div>
                )
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };

		return (
			<div className="Goods">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="Goods-containter">
                    <Spin spinning={loading.effects['price/GetpriceResource']}>
                    <SearchForm name="priceGroup"
                        init={this.init} 
                        search={this.search} 
                        getFormData={this.getFormData} 
                    />
                    <div style={{textAlign:"right",marginBottom:"10px"}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_group_create' }) !== -1)?<Button   className="setRole"  onClick={()=>{this.creatprice()}}>
                            创建商户密价组
                        </Button>:''}
                    </div>
                    <Table 
                        columns={columns}
                        dataSource={priceGroupdataList?priceGroupdataList:[]}
                        pagination={pagination}
                    />
                    </Spin>
                </div>
                {
                    showaddPriceGroup? <AddPriceGroup params={addPriceGroupList} closeaddPriceGroup={this.closeaddPriceGroup}/>:''
                }
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(PriceGroup));