import React from 'react';
import { connect } from 'dva';
import {Modal,Form,Input,message,Button  } from  "antd";
const {TextArea} = Input;
const createForm = Form.create;
const { confirm } = Modal;
class AddPriceGroup extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            isSubmit:false
        }
	}

    componentDidMount (){
        const _this=this;
        setTimeout(()=>{
            _this.props.form.resetFields()
            if(_this.props.params.title=='编辑商户密价组'&&this.props.params.name){
                _this.props.form.setFieldsValue({
                    name:_this.props.params.name
                })
            }
            if(_this.props.params.title=='编辑商户密价组'&&this.props.params.remark){
                _this.props.form.setFieldsValue({
                    remark:_this.props.params.remark
                })
            }
        },100)
       
    }

   
    handleSubmit = (e) => {
        e.preventDefault();
        const _this=this;
        this.setState({
            isSubmit:true
        })
        _this.props.form.validateFields((err, value) => {
            if(!err){
                if(this.props.params.title=='编辑商户密价组'){
                    _this.props.dispatch({
                        type: 'price/EditPriceGroup', 
                        payload: {
                        ...value,
                        id:this.props.params.id
                        } 
                    });
                }else{
                    _this.props.dispatch({
                        type: 'price/addPriceGroup', 
                        payload: {
                        ...value,
                        id:''
                        } 
                    });
                }
            }else{
                this.setState({
                    isSubmit:false
                }) 
            }
        });
    }

	componentWillReceiveProps(nextProps) {
        const { props } = this;
        const {addPriceGroup,EditPriceGroup} = nextProps.price;
        // 添加密价组
        if (addPriceGroup && addPriceGroup !== this.props.price.addPriceGroup) {
            this.setState({
                isSubmit:false
            })
            if(addPriceGroup.code==="0"){
                message.destroy();
                message.success("添加成功"); 
                this.props.closeaddPriceGroup();
            }else{
                message.destroy();
                message.error(addPriceGroup.message);
            }
        }

        // 编辑密价组
        if (EditPriceGroup && EditPriceGroup !== this.props.price.EditPriceGroup) {
            this.setState({
                isSubmit:false
            })
            if(EditPriceGroup.code==="0"){
                message.destroy();
                message.success("编辑成功"); 
                this.props.closeaddPriceGroup();
            }else{
                message.destroy();
                message.error(EditPriceGroup.message);
            }
        }
    }

	render() {
        const { getFieldDecorator } = this.props.form;
        const {title,showaddPriceGroup } = this.props.params
        const {isSubmit } = this.state;
        const formItemLayout = {
            labelCol: {
              span:6
            },
            wrapperCol: {
              span:18
            },
        }
		return (
			<div className="AddIntegral">
                <Modal
                title={title}
                width="512px"
                visible={showaddPriceGroup}
                onCancel={this.props.closeaddPriceGroup}
                footer={[
                    <Button key="back" onClick={this.props.closeaddPriceGroup}>
                      取消
                    </Button>,
                    <Button key="submit" type="primary" loading={isSubmit} onClick={this.handleSubmit}>
                      确定
                    </Button>,
                ]}
                >
                 <div className="AddIntegralBox">
                    <Form  {...formItemLayout}>
                        <Form.Item style={{marginBottom:"16px"}}  label="商户密价组名称">
                            {getFieldDecorator('name', {
                                rules: [
                                    {
                                        required: true,
                                        message: '请输入商户密价组名称',
                                    }
                                ],
                            })(<Input className="formInput" placeholder="请输入商户密价组名称"/>)}
                        </Form.Item>
                        <Form.Item style={{marginBottom:"16px"}}  label="备注">
                            {getFieldDecorator('remark', {
                                rules: [
                                    {
                                        required: false,
                                        message: '请输入备注',
                                    }
                                ],
                            })(<TextArea rows={4} className="formInput" placeholder="请输入备注"/>)}
                        </Form.Item>
                    </Form>
                 </div>
               </Modal>   
            </div>
            )
        }
    }

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(createForm()(AddPriceGroup));