import React from 'react';
import { connect } from 'dva';
import {Spin,Modal,Form,message,Button  } from  "antd";
import { Table } from 'fl-pro';
const { confirm } = Modal;
import './less/PriceMerchants.less';
import BreadCrumb from '../../../components/Breadcrumb';
import SearchForm from '../../../components/SearchForm';
import AddPriceMerchants from '../AddPriceMerchants';
import commonFun from '../../../utils/utils';
import findIndex from 'lodash/findIndex';
class PriceMerchants extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            PriceMerchantsdataList:[],
            total:0,
            showaddMerchants:false,
            addMerchantsList:[],
            MetrchantsList:[],
            selectedRowData:[],
            isClearData:false,
            productSpGroupId:commonFun.GetQueryString(location.search.split('?')[1], "GroupId"),
            productSpGroupName:sessionStorage.getItem("merchants")?JSON.parse(sessionStorage.getItem("merchants")).name:'',
            isTemplate:sessionStorage.getItem("merchants")?JSON.parse(sessionStorage.getItem("merchants")).isTemplate:'',
            selectedRowKeys:[]
        }
	}

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.getMerchantsResource()
            this.GetBusinessInfo()
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getMerchantsResource()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 获取应用搜索下拉组件数据源
    GetBusinessInfo = ()=>{
        this.props.dispatch({
            type: 'price/GetBusinessInfo', 
            payload: {
               
            } 
        });
    }

    // 获取商户管理列表
    getMerchantsResource = ()=>{
        const {postData,condition,productSpGroupId } =this.state;
        this.props.dispatch({
            type: 'price/GetMerchantsResource', 
            payload: {
                ...postData,
                ...condition,
                ProductSpGroupId:productSpGroupId
            } 
        });
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getMerchantsResource()
        });
    }

    // 编辑
    handleEdit=(record)=>{
        this.setState({
            showaddPriceGroup:true,
            addPriceGroupList:Object.assign({},record,{title:"编辑商户密价组",showaddPriceGroup:true}),
        })
    }

    // 新增
    creatMerchants=()=>{
        this.setState({
            showaddMerchants:true,
            addMerchantsList:{title:"添加商户",showaddMerchants:true},
        })
    }

    // 删除密价组
    deleteMout=()=>{
        const _this = this;
        const {selectedRowData,productSpGroupId,productSpGroupName } =this.state;
        if(selectedRowData&&selectedRowData.length>0){
            let postData = selectedRowData.map((item)=>{
                return  {
                            id: item.id,
                            productSpGroupId,
                            productSpGroupName,
                            memberCode:item.memberCode ,
                            memberName:item.memberName ,
                            clientId:item. clientId,
                            appName: item.appName,
                            memberId:item.memberId
                        }
            })
            confirm({
                title: '确定删除我吗？',
                content: '确定删除我吗？',
                okText:"确定",
                cancelText:"取消",
                onOk() {
                    _this.props.dispatch({
                        type: 'price/DeletetMerchants', 
                        payload: {
                            idList:postData
                        } 
                    }); 
                },
                onCancel() {
                  
                },
            });
        }else{
            message.destroy();
            message.warning("请先选择要删除的商户")
        }
    }

    closeaddMerchants=()=>{
        this.setState({
            showaddMerchants:false,
        },()=>{
            this.getMerchantsResource() 
        })
    }

    goPriceGoods=(record)=>{
        const { productSpGroupId,productSpGroupName } = this.state;
        this.props.history.push("/price/group/goods?GroupId="+productSpGroupId+'&memberId='+record.memberId+'&memberCode='+record.memberCode)
        sessionStorage.setItem("memberData",JSON.stringify(record))
    }


	componentWillReceiveProps(nextProps) {
        const { props } = this;
        const {GetMerchantsResource,DeletetMerchants,GetBusinessInfo } = nextProps.price;
        // 获取商户管理列表
        if (GetMerchantsResource && GetMerchantsResource !== this.props.price.GetMerchantsResource) {
            if(GetMerchantsResource.code==="0"){
              this.setState({
                PriceMerchantsdataList:GetMerchantsResource.data.list,
                total:GetMerchantsResource.data.total
              })
            }else{
                message.destroy();
                message.warning(GetMerchantsResource.message);
            }
        }

        // 删除商户
        if (DeletetMerchants && DeletetMerchants !== this.props.price.DeletetMerchants) {
            if(DeletetMerchants.code==="0"){
                message.destroy();
                message.success("删除成功");
                this.setState({
                    selectedRowKeys:[]
                })
                this.getMerchantsResource() 
            }else{
                message.destroy();
                message.warning(DeletetMerchants.message);
            }
        }

        // 获取应用列表
        if (GetBusinessInfo && GetBusinessInfo !== this.props.price.GetBusinessInfo) {
            if(GetBusinessInfo.code==="0"){
               this.setState({
                    MetrchantsList:GetBusinessInfo.data&&GetBusinessInfo.data.map((item)=>{
                        return {
                            name:item.appName,
                            value:item.id
                        }
                    })
               })
            }else{
                message.destroy();
                message.warning(GetBusinessInfo.message);
            }
        }

        
    }

	render() {
        const {loading} = this.props;
        const {total,postData,PriceMerchantsdataList,showaddMerchants,selectedRowKeys,MetrchantsList,isTemplate } = this.state;
        const breadcrumbList = [
            {
                name:"密价管理",
                href:""
            },
            {
                name:"密价组管理",
                href:"/price/group"
            },
            {
                name:"密价商户",
                href:""
            }
        ];
        let priceMtrchants = [
            {
                name: '应用',
                index: 3,
                type: 1,
                id: 'ClientId',
                placeholder:'请选择应用',
                items: MetrchantsList,
            }
        ]
        let columns = [
            {
                key:"1",
                title: '序号',
                width:60,
                dataIndex: 'key',
                align: 'center',
                render: (text, record, index) => (
                (postData.PageIndex-1) * postData.PageSize + index + 1
                )
            }, 
            {
                key:"2",
                title: '商户名称',
                width:300,
                align: 'left',
                dataIndex:"memberName",
            },
            {
                key:"3",
                title: '商户号',
                align: 'left',
                dataIndex:"memberCode",
            },
            {
                key:"4",
                title: '应用名称',
                align: 'left',
                dataIndex:"appName",
            },
            {
                key:"5",
                title: '是否模板',
                align: 'left',
                dataIndex:"isTemplate",
                width:100,
                render:(text)=>{
                    if(text==1){
                        return <span>是</span>
                    }else{
                        return <span>否</span>
                    }
                }
            },
            {
                key:"6",
                title: '操作',
                width:150,
                align: 'center',
                render:(text,record)=>(
                    <div style={{color:"#4b9ae0",cursor:'pointer'}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_merchants_look' }) !== -1)?<i className="fa fa-sitemap fa-lg" data-toggle="tooltip" style={{fontSize:'16px'}} onClick={()=>{this.goPriceGoods(record)}} title="密价商品"></i>:""}
                    </div>
                )
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };

        const rowSelection = {
            selectedRowKeys:selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
              this.setState({
                selectedRowData:selectedRows,
                selectedRowKeys
              })
            },
            // getCheckboxProps: record => ({
            //   disabled: record.name === 'Disabled User', 
            //   name: record.name,
            // }),
        };

		return (
			<div className="priceMerchants">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="priceMerchants-containter">
                    <Spin spinning={loading.effects['price/GetMerchantsResource']}>
                    <SearchForm name="priceMerchants"
                        addData={priceMtrchants}
                        init={this.init} 
                        search={this.search} 
                        getFormData={this.getFormData} 
                    />
                    <div style={{textAlign:"right",marginBottom:"10px"}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_merchants_add' }) !== -1)&&(isTemplate!=1)?<Button  className="setRole"  style={{marginRight:"5px"}} onClick={()=>{this.creatMerchants()}}>
                            添加商户
                        </Button>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_merchants_deleteAmount' }) !== -1)?<Button   className="setRole"  onClick={()=>{this.deleteMout()}}>
                            批量删除
                        </Button>:''}
                    </div>
                    <Table 
                        columns={columns}
                        rowSelection={rowSelection}
                        dataSource={PriceMerchantsdataList?PriceMerchantsdataList:[]}
                        pagination={pagination}
                    />
                    </Spin>
                </div>
                {showaddMerchants&&
                  <Modal
                  width="1220px"
                  title="添加商户"
                  visible={showaddMerchants}
                  onCancel={this.closeaddMerchants}
                  footer={null}
                  className="addCommodityModal"
                >
                  <AddPriceMerchants handleAddCancel={this.closeaddMerchants} />
                </Modal>  
                }
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(PriceMerchants));