import React from 'react';
import { connect } from 'dva';
import {Spin,Modal,Form,message,Row,Col} from  "antd";
import { Table }  from 'fl-pro';
import './less/PricePending.less';
import BreadCrumb from '../../../components/Breadcrumb';
import SearchForm from '../../../components/SearchForm';
import findIndex from 'lodash/findIndex';
import CommonModal from '../../../components/CommonModal'
import moment from 'moment';
import commonFun from '../../../utils/utils';
class PricePending extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                pageIndex: 1,
                pageSize: 10,
            },
            conditionDetail:[],
            postDataDetail:{
                pageIndex: 1,
                pageSize: 10,
            },
            total:0,
            quotationSheetManageList:[],
            showSecretPriceDetail:false,
            SecretPriceData:[],
            params:[],
            showCreatPrice:false,
            creatPriceData:false,
            DetailInOperatorList:[],
            totalDetail:0,
            detailRecord:null,
            appsList:null
        }
	}


    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },()=>{
            this.getQuotationSheetManageList()
            this.GetAppsList()
        });
    }

    initdetail = (values) => {
        this.setState({ 
            conditionDetail: values 
        },() => {
            this.QuotationSheetProductDetailInOperator()
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.pageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getQuotationSheetManageList()
            this.GetAppsList()
        });
    }

    searchFun= () => {
        const { postDataDetail,conditionDetail } = this.state;
        postDataDetail.pageIndex=1
        this.setState({ 
            conditionDetail,
            postDataDetail 
        },() => {
            this.QuotationSheetProductDetailInOperator()
        });
    }

    getFormData=(params)=>{
        // params.timeBegin =params.CreatTime&&params.CreatTime[0]? moment(params.CreatTime[0]).format('YYYY-MM-DD HH:mm:ss') : '';
        // params.timeEnd =params.CreatTime&&params.CreatTime[1]? moment(params.CreatTime[1]).format('YYYY-MM-DD HH:mm:ss') : '';
        this.setState({
          condition: params,
        })
    }

    getFormDataDetail = (params)=>{
        this.setState({
            conditionDetail: params,
        })
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getQuotationSheetManageList()
            this.GetAppsList()
        });
    }

    searchPaginationDetail =(postDataDetail)=> {
        const {conditionDetail } = this.state;
        this.setState({ 
            conditionDetail,
            postDataDetail 
        },() => {
            this.QuotationSheetProductDetailInOperator()
        });
    }

    closeCommonModal =()=>{
        this.setState({
            showSecretPriceDetail:false
        },()=>{
            this.getQuotationSheetManageList()
            this.GetAppsList()
        })
    }

    getQuotationSheetManageList=()=>{
        const {postData,condition } =this.state;
        console.log(111,condition)
        this.props.dispatch({
            type: 'price/GetQuotationSheetManageList', 
            payload: {
                ...postData,
                ...condition
            } 
        });
    }

    GetAppsList=()=>{
        this.props.dispatch({
            type: 'price/GetAppsList', 
            payload: {
                PageIndex:1,
                PageSize:9999
            } 
        })
    }

    QuotationSheetProductDetailInOperator=()=>{
        const {postDataDetail,conditionDetail,detailRecord } =this.state;
        this.props.dispatch({
            type: 'price/QuotationSheetProductDetailInOperator', 
            payload: {
                ...postDataDetail,
                ...conditionDetail,
                quotationId:detailRecord.quotationId
            } 
        });
    }

    SecretClientFormatter=(value, row, index)=> {
        if (!value) {
            return
        }
        var SecretClientIdArr = value.split(",");
        var AllClientArr = this.state.appsList||[];
        var SecretClientNameArr = SecretClientIdArr.map(function (ClientId) {
            if(AllClientArr&&AllClientArr.length>0){
                var ClientItem = AllClientArr.find(function (item) {
                    return item.id == ClientId;
                });
            }
            return ClientItem.appName
        })
        return SecretClientNameArr.join(",")
    }

    look=(record)=>{
        const {DetailInOperatorList } = this.state;
        let params={
            width:1200,
            title:'查看-'+record.quotationId,
            FormName:'pricePendingDetail',
            url:'price/QuotationSheetProductDetailInOperator',
            tableData:{
                type:0,
                rowKey:"quotationProductId",
                checkList:[],
                dataResource:DetailInOperatorList,
                total:0,
                columns:[
                    {
                        key:"1",
                        title: '商品名称',
                        align: 'left',
                        dataIndex:"productName",
                        width:200
                    },
                    {
                        key:"2",
                        title: '商品编号',
                        align: 'left',
                        dataIndex:"productId",
                    },
                    {
                        key:"3",
                        title: '类型',
                        align: 'left',
                        dataIndex:"productType",
                        render:(text)=>{
                            if(text==3){
                                return "卡密"
                            }else if(text==4){
                                return "直充"
                            }else{
                                return ''
                            }
                        }
                    },
                    {
                        key:"4",
                        title: '面值',
                        align: 'left',
                        dataIndex:"faceValue",
                        render:(text)=>{
                            return commonFun.toDecimal4(text)
                        }
                    },
                    {
                        key:"5",
                        title: '成本价',
                        align: 'left',
                        dataIndex:"cost",
                        width:100,
                        render:(text,record)=>{
                            if (record.minCost || record.maxCost) {
                                return (record.minCost ? commonFun.calc(record.minCost, "*", 100) + "%" : "-") + " ~ " + (record.maxCost ? commonFun.calc(record.maxCost, "*", 100) + "%" : "-");
                            }
                        }
                    },{
                        key:"6",
                        title: '密价',
                        align: 'left',
                        dataIndex:"quotationValue",
                        render:(text,record)=>{
                            if (!text) {
                                return
                            } else if (record.minCost > text) {
                                return <span style={{color:"red"}}>{commonFun.calc(text, "*", 100)}%</span>
                            } else {
                                return <span>{commonFun.calc(text, "*", 100)}%</span>
                            }
                        }
                    },
                    {
                        key:"7",
                        title: '票据类型',
                        align: 'left',
                        dataIndex:"invoiceType",
                        render:(text,record)=>{
                            if (text === "0" || text === 0) {
                                return "寄售";
                            } else if (text == 1) {
                                return "自营";
                            } else {
                                return "";
                            }
                        },
                    },{
                        key:"8",
                        title: '税率',
                        align: 'left',
                        dataIndex:"invoiceRate",
                        render:(text,record)=>{
                            if (record.secondInvoiceType === "0" || record.secondInvoiceType === 0) {
                                return "无票";
                            } else if (record.secondInvoiceType == 1) {
                                return parseInt(record.invoiceRate * 100) + "%普票";
                            } else if (record.secondInvoiceType == 2) {
                                return parseInt(record.invoiceRate * 100) + "%专票";
                            } else {
                                return "";
                            }
                        },
                    },{
                        key:"9",
                        title: '采购周期',
                        align: 'left',
                        dataIndex:"purchasePeriod",
                    },{
                        key:"10",
                        title: '起订量',
                        align: 'left',
                        dataIndex:"moq",
                    },{
                        key:"11",
                        title: '终端报价',
                        align: 'left',
                        dataIndex:"terminalLimitPrice",
                    },{
                        key:"12",
                        title: '是否报备',
                        align: 'left',
                        dataIndex:"report",
                        render:(text)=>{
                            if (text === "0" || text === 0) {
                                return "否";
                            } else if (text == 1) {
                                return "是";
                            } else {
                                return "";
                            }
                        }
                    }
                ]
            }
        }
        this.setState({
            showSecretPriceDetail:true,
            params,
            detailRecord:record
        })
    }

    handleCreat=(record)=>{
        this.setState({
            showCreatPrice:true,
            creatPriceData:record,
        })
    }

    closeCreatPrice=()=>{
        this.setState({
            showCreatPrice:false
        },()=>{
            this.getQuotationSheetManageList() 
            this.GetAppsList()
        })
    }

    submitCreatPrice=()=>{
        const {quotationId,memberName,memberCode,businessPushClientId } = this.state.creatPriceData
        let postData={
            quotationId,
            memberCode,
            memberName,
            clientIds:businessPushClientId
        }
        this.props.dispatch({
            type: 'price/CreateSecretPrice', 
            payload: {
                ...postData
            } 
        });
    }


	componentWillReceiveProps(nextProps) {
        const {GetQuotationSheetManageList,CreateSecretPrice,QuotationSheetProductDetailInOperator,GetAppsList} = nextProps.price;
        // 获取待处理密价列表
        if (GetQuotationSheetManageList && GetQuotationSheetManageList !== this.props.price.GetQuotationSheetManageList) {
            if(GetQuotationSheetManageList.code==="0"){
                this.setState({
                    quotationSheetManageList:GetQuotationSheetManageList.data.list,
                    total:GetQuotationSheetManageList.data.total
                })
            }else{
                message.destroy();
                message.warning(GetQuotationSheetManageList.message);
            }
        }

        if (CreateSecretPrice && CreateSecretPrice !== this.props.price.CreateSecretPrice) {
            if(CreateSecretPrice.code==="0"){
                message.destroy();
                message.success("密价生成成功")
                this.closeCreatPrice()
            }else{
                message.destroy();
                message.warning(CreateSecretPrice.message);
            }
        }

        // 获取报价单商品明细
        if (QuotationSheetProductDetailInOperator && QuotationSheetProductDetailInOperator !== this.props.price.QuotationSheetProductDetailInOperator) {
            if(QuotationSheetProductDetailInOperator.code==="0"){
                const {params } = this.state; 
                params.tableData.total = QuotationSheetProductDetailInOperator.data.total,
                params.tableData.dataResource = QuotationSheetProductDetailInOperator.data.list
                this.setState({
                    params,
                    DetailInOperatorList:QuotationSheetProductDetailInOperator.data.list,
                })
            }else{
                message.destroy();
                message.warning(QuotationSheetProductDetailInOperator.message);
            }
        }

        if (GetAppsList && GetAppsList !== this.props.price.GetAppsList) {
            if(GetAppsList.code==="0"){
                this.setState({
                    appsList:GetAppsList.data.list
                })
            }else{
                message.destroy();
                message.warning(GetAppsList.message);
            }
        }

        
    }

	render() {
        const {loading} = this.props;
        const {total,postData,quotationSheetManageList,showSecretPriceDetail,SecretPriceData,params,showCreatPrice,creatPriceData,detailRecord} = this.state;
        const breadcrumbList = [
            {
                name:"待处理密价",
                href:""
            }
        ];
        let columns = [
            {
                key:"1",
                title: '报价编号',
                width:200,
                align: 'left',
                dataIndex:"quotationId",
            },
            {
                key:"2",
                title: '商户名称',
                align: 'left',
                dataIndex:"memberName",
            },
            {
                key:"3",
                title: '商户号',
                align: 'left',
                dataIndex:"memberCode",
            },
            {
                key:"4",
                title: '商务洽谈应用',
                align: 'left',
                dataIndex:"businessClientNames",
            },
            {
                key:"5",
                title: '商户已开通应用',
                align: 'left',
                dataIndex:"clientNames",
            },
            {
                key:"6",
                title: '已生成密价应用',
                align: 'left',
                dataIndex:"secretClientIds",
                render:(text,record)=>{
                    if(this.state.appsList&&this.state.appsList.length>0){
                        return this.SecretClientFormatter(text)
                    }else{
                        return ''
                    }
                }
            },
            {
                key:"7",
                title: '商务',
                align: 'left',
                dataIndex:"userName",
            },
            {
                key:"8",
                title: '创建时间',
                align: 'left',
                dataIndex:"createTime",
            },
            {
                key:"9",
                title: '状态',
                align: 'left',
                dataIndex:"status",
                render:(text)=>{
                    if(text==11){
                        return '待推送密价'
                    }else if(text==21){
                        return '已推送密价'
                    }else if(text==31){
                        return '已生成密价'
                    }else{
                        return ''
                    }
                }
            },
            {
                key:"10",
                title: '操作',
                width:150,
                align: 'center',
                render:(text,record)=>(
                    <div style={{color:"#4b9ae0",cursor:'pointer'}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_pending_look' }) !== -1)?<i className="fa fa-search fa-lg" style={{cursor:'pointer',marginRight:'5px',color:"#4b9ae0",fontSize:'13px'}} onClick={()=>{this.look(record)}}  title="查看"></i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_secretPrice_pending' }) !== -1)?<i className="fa fa-edit fa-lg tooltip-show" style={{cursor:"pointer",marginRight:"5px",fontSize:'13px'}}   title="一键生成密价" onClick={()=>{this.handleCreat(record)}}></i>:''}
                    </div>
                )
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.pageSize,
            current: postData.pageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.pageIndex=1;
                postData.pageSize=pageSize;
                Object.assign(postData, { pageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.pageIndex=current; 
                Object.assign(postData, { pageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };

		return (
			<div className="pricePending">
                <BreadCrumb paramsList={breadcrumbList}/>
                <p>密价由商务的同学提交过来的。</p>
                <p style={{marginBottom: "10px"}}>
                    因报价变动因素较多，在生成对应商户的密价前，麻烦各位小伙伴与对应商务小伙伴沟通下。
                </p>
                <div className="PricePending-containter">
                    <Spin spinning={loading.effects['price/GetQuotationSheetManageList']}>
                    <SearchForm name="pricePending"
                        init={this.init} 
                        search={this.search} 
                        getFormData={this.getFormData} 
                    />
                    <Table 
                        columns={columns}
                        dataSource={quotationSheetManageList?quotationSheetManageList:[]}
                        pagination={pagination}
                        scroll={{y:window.innerHeight - 450,x:1600}}
                    />
                    </Spin>
                </div>
                {showCreatPrice&&
                <Modal
                    width="600px"
                    title={"一键生成密价"}
                    visible={showCreatPrice}
                    onCancel={this.closeCreatPrice}
                    className="addCommodityModal"
                    okText="确定"
                    cancelText="取消"
                    onOk={
                        this.submitCreatPrice
                    }
                >
                    <Row style={{marginBottom:'16px'}}>
                        <Col  span={4} className="ant-form-item-label">
                            <label  title="商户号">商户号</label>
                        </Col>
                        <Col span={20} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <span className="balance">{creatPriceData&&creatPriceData.memberCode}</span>
                            </div>
                        </Col>
                    </Row>
                    <Row style={{marginBottom:'16px'}}>
                        <Col  span={4} className="ant-form-item-label">
                            <label  title="商户名称">商户名称</label>
                        </Col>
                        <Col span={20} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <span className="balance">{creatPriceData&&creatPriceData.memberName}</span>
                            </div>
                        </Col>
                    </Row>
                    <Row style={{marginBottom:'16px'}}>
                        <Col  span={4} className="ant-form-item-label">
                            <label  title="商户应用">商户应用</label>
                        </Col>
                        <Col span={20} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <span className="balance">{creatPriceData&&creatPriceData.businessClientNames}</span>
                            </div>
                        </Col>
                    </Row>
                </Modal>  
                }
                {showSecretPriceDetail?<CommonModal params={params} init={this.initdetail} searchFun={this.searchFun} searchPagination={this.searchPaginationDetail} getFormData={this.getFormDataDetail} closeModal={this.closeCommonModal} submitData={this.closeCommonModal}/>:''} 
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(PricePending));