import React, { Component } from 'react';
import { connect } from 'dva';
import {Input,Spin,Button,Radio,message  } from 'antd';
import { Table } from 'fl-pro';
import './less/setPrice.less';
import commonFun from '../../../utils/utils'
class SetPrice extends Component {
    constructor(props) {
        super(props);
        this.state = {
            dataResource:[],
            goodsList:[],
            priceTitle:"",
            redioValue:1,
            discount:0,
            priceRadio:false,
            price:0,
            isCanSubmitPrice:true,
            isCanSubmitDiscount:true,
            memberId:commonFun.GetQueryString(location.search.split('?')[1], "memberId"),
        }
    }
  
    componentDidMount (){
        let arr=[]
        if(this.props.datalist.selectedRowData&&this.props.datalist.selectedRowData.length>0){
            arr = this.props.datalist.selectedRowData.map((item)=>{
                item.productSpMemberDetailId=item.id;
                item.facePrice=item.productFaceValue
                return item
            })
        }
        this.setState({
            priceRadio:false,
            dataResource:arr?this.deepCopy(arr):[],
            goodsList:arr?this.deepCopy(arr):[],
            priceTitle:this.props.datalist?this.props.datalist.setpriceTitle:'',
        })
    }

    // 处理浅拷贝问题
    deepCopy=(obj)=>{
        if(typeof obj !== "object") return ;
        var str = JSON.stringify(obj);
        return JSON.parse(str)
    }
    
    chnageDiscountInput=(e)=>{
        this.setState({
            discount:e.target.value
        })
    }

    changepriceRaido=()=>{
        this.setState({
            priceRadio:!this.state.priceRadio
        })
    }

    chnagePriceInput=(e)=>{
        this.setState({
            price:e.target.value
        })
    }

    changeRadio=(e)=>{
        this.setState({
            redioValue: e.target.value,
            isCanSubmitDiscount:true,
            isCanSubmitPrice:true
        });
    }
    

    submitDiscount=()=>{
        const {redioValue,discount,goodsList,memberId} = this.state;
        if(redioValue===1){
            if(!discount&&discount!==0){
                message.destroy();
                message.warning("请填写要设置的折扣");
                return
            }
            this.props.dispatch({
                type: 'price/SetMemberProductRebateSecretPrice', 
                payload: {
                    productSecretPriceList:goodsList.map((el)=>{
                        return {
                            id:el.productSpMemberDetailId
                        }
                    }),
                    rebate:discount,
                    memberId
                } 
            }); 
        }
    }
    
    submitPrice=()=>{
        const {redioValue,price,goodsList,memberId} = this.state;
        if(redioValue===2){
            if(!price&&price!==0){
                message.destroy();
                message.warning("请填写要设置的价格");
                return
            }
            this.props.dispatch({
                type: 'price/SetMemberProductSecretPrice', 
                payload: {
                    productSecretPriceList:goodsList.map((el)=>{
                        return {
                            id:el.productSpMemberDetailId
                        }
                    }),
                    price,
                    memberId
                } 
            }); 
        }
    }

   

    onOk=()=>{
        const {redioValue,discount,goodsList,price} =this.state;
        let patten = /^[+-]?(0|([1-9]\d*))(\.\d+)?$/g;
        let ids = goodsList.map((item,i)=>{
            return item.productSpMemberDetailId
        });
        if(ids&&ids.length<1){
            message.warning('请到密价商品列表选择要设置密价的商品');
            return false;
        }

        if(redioValue==1){
            if(!patten.test(discount)){
                message.warning('请填写数字');
                return false;
            }
        }else if(redioValue==2){
            if(!patten.test(price)){
                message.warning('请填写数字');
                return false;
            }
        }
        this.props.setSecretPriceValue(goodsList,2)
    }

    onCancel=()=>{
        this.props.handlePriceCancel()
    }

    hangdleOnCancel=(record)=>{
        const {goodsList,dataResource} = this.state;
        let selectGoods = goodsList.filter((item,i)=> item.productId!==record.productId)
        let sourceGoods = dataResource.filter((el,i)=> el.productId!==record.productId)
        this.setState({
            goodsList:selectGoods,
            dataResource:sourceGoods
        })
    }
    

    focusDiscount=(type)=>{
        this.setState({
            redioValue:type
        })
    }
    
    componentWillReceiveProps(nextProps){
        const { SetMemberProductRebateSecretPrice,SetMemberProductSecretPrice } = nextProps.price;
        if (SetMemberProductRebateSecretPrice && SetMemberProductRebateSecretPrice !== this.props.price.SetMemberProductRebateSecretPrice) {
            if(SetMemberProductRebateSecretPrice.code==="0"){
               if(SetMemberProductRebateSecretPrice.data){
                    message.destroy();
                    message.success("设置折扣成功")
                    this.setState({
                        goodsList:SetMemberProductRebateSecretPrice.data.list,
                        isCanSubmitDiscount:false
                    })
               }
            }else{
                if(SetMemberProductRebateSecretPrice.code==="-1"){
                    message.destroy();
                    message.warning(SetMemberProductRebateSecretPrice.message);
                }
            }
        }

        if (SetMemberProductSecretPrice && SetMemberProductSecretPrice !== this.props.price.SetMemberProductSecretPrice) {
            if(SetMemberProductSecretPrice.code==="0"){
               if(SetMemberProductSecretPrice.data){
                    message.destroy();
                    message.success("设置价格成功")
                    this.setState({
                        goodsList:SetMemberProductSecretPrice.data.list,
                        isCanSubmitPrice:false
                    })
               }
            }else{
                if(SetMemberProductSecretPrice.code==="-1"){
                    message.destroy();
                    message.warning(SetMemberProductSecretPrice.message);
                }
            }
        }
    }

    render() {
        const {goodsList,priceTitle,redioValue,priceRadio,discount,price,isCanSubmitPrice,isCanSubmitDiscount} = this.state;
        let columns = [
            {
                key:"1",
                title: '商品编号',
                width:120,
                align: 'left',
                dataIndex:"productId"
            },
            {
                key:"2",
                title: '商品名称',
                width:150,
                align: 'left',
                dataIndex:"productName"
            },
            {
                key:"3",
                title: '面值',
                width:120,
                align: 'left',
                dataIndex:"facePrice"
            },
            {
                key:"9",
                title: '密价（元）',
                width:120,
                align: 'left',
                dataIndex:"secretPrice"
            },
            {
                key:"18",
                title: '操作',
                width:150,
                align: 'center',
                render:(text, record,)=>(
                    <span style={{color:"#1890ff",cursor: "pointer"}} onClick={()=>{this.hangdleOnCancel(record)}}>取消</span>
                )
            },
        ];

        const radioStyle = {
            display: 'block',
            height: '32px',
            lineHeight: '32px',
        };
        return(
            <div className="SetPrice">
                <div className="SetPrice-containter">
                    <Spin spinning={false}>
                        <div className="tableBox SetPricebox">
                            <Table 
                                className="tablesContain"
                                columns={columns}
                                dataSource={goodsList?goodsList:[]}
                                pagination={false}
                            />
                            
                        </div>
                    </Spin>
                    <div className="describtion clearfix">
                        <p style={{}}>说明：</p>
                        <p style={{color: "#666666",fontSize: "14px"}}>1、可选择设置折扣或设置价格。</p>
                        <p style={{color: "#666666",fontSize: "14px"}}>2、设置价格精确到小数点后四位，如5.3600元。</p>
                        <p style={{color: "#666666",fontSize: "14px"}}>3、折扣范围为0.0001≤折扣＜1，如0.98为98折。</p>
                        <p style={{color: "#666666",fontSize: "14px"}}>4、设置结果密价如超过小数点后四位，四舍五入。</p>
                        <p style={{color: "#666666",fontSize: "14px"}}>5、密价不可为0 ，可大于面值、成本价。</p>
                    </div>
                    <div className="formBox clearfix">
                        <div className="setPriceTitle">{priceTitle}</div>
                        <div className="radioGroups">
                            <Radio.Group onChange={this.changeRadio} value={redioValue}>
                                <Radio  className="radios radiosFirst" style={radioStyle} value={1}   >设置折扣：</Radio>
                                <Radio className="radios"  style={radioStyle} value={2} >设置价格：</Radio>
                            </Radio.Group>
                        </div>
                        <div className="formGroups">
                            <div className="setDiscount clearfix">
                                <Input value={discount} disabled={redioValue==2} className="disInput" onChange={this.chnageDiscountInput} onFocus={()=>{this.focusDiscount(1)}}/><span className="unit">折</span>
                                <Button className="disBtn" disabled={redioValue==2} type={redioValue==1?"primary":""}  ghost={redioValue==1?true:false} onClick={redioValue==1?this.submitDiscount:null}>生成价格</Button>
                            </div>
                            <div className="setDiscount setprices clearfix">
                                <Input value={price} className="disInput" disabled={redioValue==1} onChange={this.chnagePriceInput} onFocus={()=>{this.focusDiscount(2)}}/><span className="unit">元</span>
                                <Button className="disBtn" disabled={redioValue==1} type={redioValue==2?"primary":""}  ghost={redioValue==2?true:false} onClick={redioValue==2?this.submitPrice:null}>生成价格</Button>
                            </div>
                        </div>
                    </div>
                </div>
                <div className="footerprice">
                    <Button disabled={redioValue==1&&isCanSubmitDiscount || redioValue==2&&isCanSubmitPrice} type="primary" className="btnok" onClick={this.onOk}>确定</Button>
                    <Button className="btncancel" onClick={this.onCancel}>取消</Button>
                </div>
            </div>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(SetPrice);


