import React, { Component } from 'react';
import { connect } from 'dva';
import {Spin,Button,message } from 'antd';
import { Table } from 'fl-pro';
import './less/SupplyDetails.less';
class SupplyDetails extends Component {
    constructor(props) {
        super(props);
        this.state = {
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            SupProductList:[],
            total:0,
            screenHeight:960,
        }
    }
    
    componentDidMount (){
        this.setState({screenHeight:window.innerHeight});
        this.GetSupProductList()
    }

    componentWillUnmount() {
        //一定要最后移除监听器，以防多个组件之间导致this的指向紊乱
        window.removeEventListener('resize', this.handleResize.bind(this)) ;
    }

     // 分页查询
     searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetSupProductList()
        });
    }

    handleResize = e => {
        this.setState({screenHeight:e.target.innerHeight});
    }

    // 获取供货商品列表
    GetSupProductList=()=>{
        const { postData, condition} = this.state;
        this.props.dispatch({
            type: 'price/GetSupProductList', 
            payload: {
                ...postData,
                ...condition,
                productSpMemberDetailId:this.props.productSpMemberDetailId,
                memberId:this.props.memberId
            } 
        }); 
    }

    componentWillReceiveProps(nextProps){
        const { GetSupProductList,} = nextProps.price;
        // 获取供货商品列表 
        if (GetSupProductList && GetSupProductList !== this.props.price.GetSupProductList) {
            if(GetSupProductList.code==="0"){
                GetSupProductList.data.list&&GetSupProductList.data.list.map((item,i)=>{
                    item.key=i
                })
                this.setState({
                    SupProductList:GetSupProductList.data.list||[],
                    total:GetSupProductList.data.total
                })
            }else{
                message.destroy();
                message.warning(GetSupProductList.message);
            }
        }

    }


    render() {
        const {postData,SupProductList,total,screenHeight } = this.state;
        const {loading} = this.props;
        let columns = [
            {
                key:"1",
                title: '商品编号',
                align: 'left',
                dataIndex:"supProductId",
            },
            {
                key:"2",
                title: '商品名称',
                align: 'left',
                dataIndex:"supProductName",
            },
            {
                key:"3",
                title: '商户号',
                align: 'left',
                dataIndex:"memberCode"
            },
            {
                key:"4",
                title: '供应商名称',
                align: 'left',
                dataIndex:"supMemberName"
            },
            {
                key:"5",
                title: '渠道名称',
                align: 'left',
                dataIndex:"sourceType"
            },
            {
                key:"6",
                title: '商品类型',
                align: 'left',
                dataIndex:"supProductType"
            },
            {
                key:"7",
                title: '进货价（元）',
                align: 'left',
                dataIndex:"supProductPrice"
            },
            {
                key:"8",
                title: '面值（元）',
                align: 'left',
                dataIndex:"supProductFaceValue"
            },
            {
                key:"9",
                title: '票据类型',
                align: 'left',
                dataIndex:"invoiceType",
                render:(text,record)=>{
                    if(text==1){
                        return "自营"
                    }else {
                        return "寄售"
                    }
                }
            },
        ];

        const pagination = {
            total,
            hideOnSinglePage: true,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current;
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
               
            },
        };

        return(
            <div className="SupplyDetails">
                <div className="SupplyDetails-containter">
                    <Spin spinning={loading.effects['price/GetSupProductList']}>
                        <div className="tableBox">
                            <Table 
                                columns={columns}
                                dataSource={SupProductList?SupProductList:[]}
                                pagination={pagination}
                                scroll={{y:screenHeight - 550}}
                            />
                        </div>
                    </Spin>
                </div>
                <div className="footerSupplyDetails">
                    <Button type="primary" className="btnok" onClick={this.props.closeshowSupplyDetails}>确定</Button>
                    <Button className="btncancel" onClick={this.props.closeshowSupplyDetails}>取消</Button>
                </div>
            </div>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(SupplyDetails);


