import React, { Component } from 'react';
import { connect } from 'dva';
import {Spin,Button,message,Checkbox,Modal   } from 'antd';
import { Table } from 'fl-pro';
import './less/SynchronousMemberList.less';
import SearchForm from '../../../components/SearchForm';
const { confirm } = Modal;
class SynchronousMemberList extends Component {
    constructor(props) {
        super(props);
        this.state = {
            condition:[],
            postData:{
                pageIndex: 1,
                pageSize: 10,
            },
            MemberDataList:[],
            total:0,
            selectedRowData:[],
            DepartmentList:[],
            PositionList:[],
            screenHeight:960,
            selectedRowKeys:[],
            CurrentMonthExpiresList:[
                { label: '是', value: '1' },
                { label: '否', value: '0' },
            ],
        }
    }
    
    componentDidMount (){
        this.setState({screenHeight:window.innerHeight});
    }

    componentWillUnmount() {
        //一定要最后移除监听器，以防多个组件之间导致this的指向紊乱
        window.removeEventListener('resize', this.handleResize.bind(this)) ;
    }


    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.GetSynchronousMemberList();
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetSynchronousMemberList()
        });
    }

     // 分页查询
     searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetSynchronousMemberList()
        });
    }

    handleResize = e => {
        this.setState({screenHeight:e.target.innerHeight});
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 获取可以同步商品密价的商户列表(已加入密价组)
    GetSynchronousMemberList=()=>{
        const { postData, condition} = this.state;
        const {productSpGroupMemberId} = this.props.comonParams
        this.props.dispatch({
            type: 'price/GetSynchronousMemberList', 
            payload: {
                ...postData,
                ...condition, 
                productSpGroupMemberId,
                memberId:this.props.memberId
            } 
        }); 
    }
    

    confirmData=()=>{
        const {selectedRowData} = this.state;
        const _this = this;
        if(selectedRowData&&selectedRowData.length>0){
            let IdList=[]
            let arr=[]
            selectedRowData&&selectedRowData.map((el)=>{
                if(el.checkedList&&el.checkedList.length>0){
                    el.checkedList.map((p)=>{   
                        if(el.appList&&el.appList.length>0){
                            el.appList.map((m)=>{
                                if(m.clientId==p){
                                    IdList.push(m.productSpGroupMemberId)
                                }
                            })
                        }
                    })
                }
                if(IdList&&IdList.length>0){
                    arr= IdList.map((n)=>{
                       return {
                           id:n
                       }
                    })
                }
            })
            let postData={
                productSecretPriceList:this.props.productSecretPriceList&&this.props.productSecretPriceList.map((item)=>{
                    return {
                        id:item.id
                    }
                }),
                productSpGroupMemberIdList: arr,
                memberId:this.props.memberId
            }
            confirm({
                title: '确认同步？',
                content: `可能覆盖同步商户原密价商品配置，请谨慎操作。`,
                okText:"确定",
                cancelText:"取消",
                onOk() {
                    _this.props.dispatch({
                        type: 'price/SynchronousMemberProductSecretPrice',
                        payload: {
                           ...postData
                        }
                    });
                },
                onCancel() {
                  
                },
            })
        }else{
            message.destroy();
            message.warning("请选择要同步的密价商户")
            return false
        }
    }

    changeCheckData=(e,record)=>{
        const {MemberDataList} = this.state;
        if(record.appList&&record.appList.length>0){
            record.appList.map((item)=>{
                if(e&&e.length>0){
                    e.map((el)=>{
                        if(el==item.clientId){
                            item.checked=1
                        }
                    })
                }
            })
        }
        record.checkedList=e;
        this.setState({
            MemberDataList
        })
       
    }


    componentWillReceiveProps(nextProps){
        const { GetSynchronousMemberList,SynchronousMemberProductSecretPrice} = nextProps.price;
        // 获得待加入密价组商户列表 
        if (GetSynchronousMemberList && GetSynchronousMemberList !== this.props.price.GetSynchronousMemberList) {
            if(GetSynchronousMemberList.code==="0"){
                GetSynchronousMemberList.data.list&&GetSynchronousMemberList.data.list.map((item,i)=>{
                    item.key=i
                })
                this.setState({
                    MemberDataList:GetSynchronousMemberList.data&&GetSynchronousMemberList.data.list.length>0&&GetSynchronousMemberList.data.list.map((item)=>{
                        if(item.appList&&item.appList.length>0){
                            item.checkedList= item.appList.map((el)=>{
                                if(el.checked){
                                    return el.clientId
                                }
                            })
                            return item
                        }
                    }),
                    total:GetSynchronousMemberList.data.total
                })
            }else{
                message.destroy();
                message.warning(GetSynchronousMemberList.message);
            }
        }

        if (SynchronousMemberProductSecretPrice && SynchronousMemberProductSecretPrice !== this.props.price.SynchronousMemberProductSecretPrice) {
            if(SynchronousMemberProductSecretPrice.code==="0"){
                message.destroy();
                message.success("同步成功")
                this.props.handleAddCancel()
            }else{
                message.destroy();
                message.warning(SynchronousMemberProductSecretPrice.message);
            }
        }

    }


    render() {
        const {postData,MemberDataList,total,screenHeight,selectedRowKeys,EditableCell,CurrentMonthExpiresList } = this.state;
        const {loading} = this.props;
        let columns = [
            {
                key:"1",
                title: '商户名称',
                width:200,
                align: 'left',
                dataIndex:"memberName",
            },
            {
                key:"2",
                title: '商户号',
                width:200,
                align: 'left',
                dataIndex:"memberCode"
            },
            {
                key:"3",
                title: '应用',
                align: 'left',
                render:(record)=>{
                    if(record.appList&&record.appList.length>0){
                        return <Checkbox.Group onChange={(e)=>{this.changeCheckData(e,record)}} value={record.checkedList}  style={{ width: '100%',overflow:"hidden" }}>
                            {   
                                record.appList.map((item,i)=>{
                                    return <Checkbox style={{float:"left"}} key={i} value={item.clientId}>{item.appName}</Checkbox>
                                })
                            }
                         </Checkbox.Group>
                      
                    }
                }
            }
        ];

        const pagination = {
            total,
            hideOnSinglePage: true,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current;
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
               
            },
        };

        const rowSelection = {
            selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRowData:selectedRows,
                    selectedRowKeys
                },()=>{
                    let idlist=[]
                    if(MemberDataList&&MemberDataList.length>0){
                        MemberDataList.map((item)=>{
                            item.checkedList=[];
                            if(selectedRows&&selectedRows.length>0){
                                selectedRows.map((el)=>{
                                    if(el.id==item.id){
                                        item.checkedList=item.appList&&item.appList.length>0&&item.appList.map((p)=>{
                                            return p.clientId
                                        })
                                        idlist.push(item)
                                    }
                                })
                            }
                        })
                    }
                    this.setState({
                        MemberDataList
                    })
                })
            },
        };
        return(
            <div className="SynchronousMemberList">
                <div className="SynchronousMemberList-containter">
                    <SearchForm name="AsyncMerchants"
                     init={this.init} 
                     search={this.search} 
                     getFormData={this.getFormData} 
                    />
                    <Spin spinning={loading.effects['price/GetSynchronousMemberList']}>
                        <div className="tableBox">
                            <Table 
                                columns={columns}
                                dataSource={MemberDataList?MemberDataList:[]}
                                pagination={pagination}
                                rowSelection={rowSelection}
                                scroll={{y:screenHeight - 550}}
                            />
                        </div>
                    </Spin>
                </div>
                <div className="footerstaff">
                    <Button type="primary" className="btnok" onClick={this.confirmData}>确定</Button>
                    <Button className="btncancel" onClick={this.props.handleAddCancel}>取消</Button>
                </div>
            </div>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(SynchronousMemberList);


