import React from 'react';
import { connect } from 'dva';
import { Modal,Form  } from "antd";
import { Table } from 'fl-pro';
import './UploadRecord.less';
import UploadResult from '../UploadResult'
class UploadRecord extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
      postData:{
        PageIndex: 1,
        PageSize: 10,
      },
      total:0,
      dataSource:[],
      showUploadResult:false,
      SpImportId:''
		}
  }

  componentDidMount(){
    this.getRecrdList()
  }

  getRecrdList=()=>{
    const {postData}=this.state;
    const {UploadRecordList} = this.props
    let params = {
      MemberId: UploadRecordList.memberId,
      ProductSpGroupMemberId:UploadRecordList.productSpGroupMemberId,
      ClientId:UploadRecordList.clientId
    }
    this.props.dispatch({
      type: 'search/GetRecrdList', 
      payload: {
         ...postData,
         ...params
      } 
    });
  }
  
  handleLook=(record)=>{
    this.setState({
      showUploadResult:true,
      SpImportId:record.id
    })
  }

  closeUploadResult=()=>{
    this.setState({
      showUploadResult:false
    })
  }

  componentWillReceiveProps(nextProps) {
    const {GetRecrdList} = nextProps.search;
    // 获取导入记录
    if (GetRecrdList && GetRecrdList !== this.props.search.GetRecrdList) {
        if(GetRecrdList.code==="0"){
          this.setState({
            dataSource:GetRecrdList.data?GetRecrdList.data.list:[],
            total:GetRecrdList.data?GetRecrdList.data.Total:0
          })           
        }else{
            message.destroy();
            message.error(GetRecrdList.message);
        }
    }
}


	render() {
    const {dataSource,postData,total,showUploadResult,SpImportId} = this.state;
    let columns = [
      {
        key:"1",
        title: '序号',
        width:60,
        dataIndex: 'key',
        align: 'center',
        render: (text, record, index) => {
          return (postData.PageIndex-1) * postData.PageSize + index + 1
        }
    }, 
      {
          key:"2",
          title: '导入时间',
          width:300,
          align: 'left',
          dataIndex:"createdTime",
      },
      {
          key:"3",
          title: '状态',
          align: 'left',
          render:(text,record)=>{
            if(record.status==1){
              return "导入成功"
            }else if(record.status==2){
              return "导入失败"
            }else if(record.status==0){
              return "导入中"
            }else{
              return "--"
            }
          }
      },
      {
        key:"4",
        title: '操作',
        align: 'center',
        render:(text,record)=>(
          <i className="iconfont" style={{cursor:"pointer",fontSize:'16px',color:"#4b9ae0"}}  title="查看" onClick={()=>{this.handleLook(record)}}>&#xe611;</i>
        )
      }
    ];
    const pagination = {
      total,
      hideOnSinglePage: false,
      pageSize: postData.PageSize,
      current: postData.PageIndex,
      onShowSizeChange: (current, pageSize) => {
        postData.PageIndex=1;
        postData.PageSize=pageSize;
        Object.assign(postData, { PageSize: pageSize })
        this.setState({ postData }, () => {
          this.getRecrdList()
        })
      },
      onChange: (current) => {
        postData.PageIndex=current; 
        Object.assign(postData, { PageIndex: current })
        this.setState({ postData }, () => {
          this.getRecrdList()
        })
      },
  };
		return (
      <div className="UploadRecord">
          <Modal
              wrapClassName="modal-server"
              width="800px"
              title="导入记录"
              visible={true}
              footer={null}
              onCancel={() =>{
                  this.props.closeUploadRecords();
              }}
            >
              <Table dataSource={dataSource}  pagination={pagination} columns={columns}  pagination={false} rowKey="index"/>
          </Modal>
          {showUploadResult?<UploadResult memberId={this.props.UploadRecordList.memberId} SpImportId={SpImportId} closeUploadResult={this.closeUploadResult}/>:''}
      </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(UploadRecord));