import React from 'react';
import { connect } from 'dva';
import { Modal,Form,message  } from "antd";
import { Table } from 'fl-pro';
import './UploadResult.less';
import findIndex from 'lodash/findIndex';
class UploadResult extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
      postData:{
        PageIndex: 1,
        PageSize: 10,
      },
      total:0,
      dataList:[],
      reduceList:[]
		}
  }

  componentDidMount(){
    this.GetImportSecretDetail()
  }

  GetImportSecretDetail=()=>{
    this.props.dispatch({
      type: 'search/GetImportSecretDetail', 
      payload: {
        MemberId:this.props.memberId,
        SpImportId:this.props.SpImportId 
      } 
    });
  }

  componentWillReceiveProps(nextProps) {
    const {GetImportSecretDetail,ReImportSecret} = nextProps.search;
    // 获取无效商品
    if (GetImportSecretDetail && GetImportSecretDetail !== this.props.search.GetImportSecretDetail) {
        if(GetImportSecretDetail.code==="0"){
          this.setState({
            dataList:GetImportSecretDetail.data?GetImportSecretDetail.data:[]
          })           
        }else{
            message.destroy();
            message.error(GetImportSecretDetail.message);
        }
    }
    //重新导入成功
    if (ReImportSecret && ReImportSecret !== this.props.search.ReImportSecret) {
      if(ReImportSecret.code==="0"){
        message.destroy();
        message.success("导入成功")        
      }else{
          message.destroy();
          message.error(ReImportSecret.message);
      }
    }
  }

  reImportSecret=(type)=>{
    this.props.dispatch({
      type: 'search/ReImportSecret', 
      payload: {
        MemberId :this.props.memberId,
        SpImportId :this.props.SpImportId,
        Status:type 
      } 
    });
  }


	render() {
    const {dataList,postData} = this.state;
    let columns = [
      {
        key:"1",
        title: '序号',
        width:60,
        dataIndex: 'key',
        align: 'center',
        render: (text, record, index) => {
          return (postData.PageIndex-1) * postData.PageSize + index + 1
        }
    }, 
      {
          key:"2",
          title: '商品品类',
          width:200,
          align: 'left',
          dataIndex:"productCategoryName",
      },
      {
          key:"3",
          title: '商品编号',
          align: 'left',
          dataIndex:"productId",
      },
      {
        key:"4",
        title: '商品名称',
        width:200,
        align: 'left',
        dataIndex:"productName",
    },
    {
        key:"5",
        title: '商品面值',
        align: 'left',
        dataIndex:"faceValue",
    },
    {
      key:"6",
      title: '密价',
      align: 'left',
      dataIndex:"secretPrice",
    },
    {
      key:"7",
      title: '折扣',
      align: 'left',
      dataIndex:"discount",
    }
  ];
		return (
      <div className="UploadResult">
          <Modal
            wrapClassName="modal-server"
            width="850px"
            title="密价商品导入结果"
            visible={true}
            footer={null}
            onCancel={() =>{
                this.props.closeUploadResult();
            }}
            >
              <div style={{width:'100%',height:'100%',overflow:'hidden'}}>
                <div className="importtotal" style={{padding: '15px',background: '#F2F2F2',width:'100%',float:'left'}}>
                  <span>导入成功：<span className="SuccessCount" style={{color: '#339900'}}>{dataList.successCount}</span> 条</span>
                  <span style={{margin:'0 10px'}}>|</span>
                  <span>密价百分比≥15%：<span className="FifteenPercentCount" style={{color: '#0000FF'}}>{dataList.fifteenPercentCount}</span> 条</span>
                  <span style={{marginLeft: '30px'}}>未导入：<span className="FailCount" style={{color: '#FD0000'}}>{dataList.failCount}</span>条</span>
                  <span style={{margin:'0 10px'}}>|</span>
                  <span>负利润密价商品：<span className="OutNegativeCount" style={{color: '#0000FD'}}>{dataList.outNegativeCount}</span> 条</span>
                  <span style={{margin:'0 10px'}}>|</span>
                  <span>无效密价商品：<span className="OutExistsCount" style={{color: '#0000FF'}}>{dataList.outExistsCount}</span> 条</span>
                </div>
                <div id="reducemodel" style={{display:dataList.outNegativeProfitList&&dataList.outNegativeProfitList.length>0?'block':'none',float:'left'}}>
                  <div style={{margin:'20px 0 10px '}}>以下为负利润商品 {(findIndex(window.getAuthButtons(), { enCode: 'lr__outNegativeProfitList_upload' }) !== -1)?<a  className="exportReduce" onClick={()=>{this.reImportSecret('2')}} style={{color: '#3366CC',cursor: 'pointer'}}>继续导入</a>:''}
                  </div>
                  <div className="table-box" >
                    <Table dataSource={dataList?dataList.outNegativeProfitList:[]} scroll={{y:dataList.outNegativeProfitList&&dataList.outNegativeProfitList.length>0?120:390}}   columns={columns}  pagination={false} rowKey="index"/>
                  </div>
                </div>
                <div id="NOdatamodel" style={{display:dataList.outExistsList&&dataList.outExistsList.length>0?'block':'none',float:'left'}}>
                  <div style={{margin:'20px 0 10px '}}>以下为无效密价商品 {(findIndex(window.getAuthButtons(), { enCode: 'lr__outExistsList_upload' }) !== -1)?<a  className="exportNOdata" onClick={()=>{this.reImportSecret('3')}}  style={{color: '#3366CC',cursor: 'pointer'}}>继续导入</a>:""}
                  </div>
                  <div className="table-box">
                    <Table dataSource={dataList?dataList.outExistsList:[]} scroll={{y:dataList.outNegativeProfitList&&dataList.outNegativeProfitList.length>0?120:390}} columns={columns}  pagination={false} rowKey="index"/>
                  </div>
                </div>
              </div>
          </Modal>
      </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(UploadResult));