import React, { Component } from 'react';
import { connect } from 'dva';
import {Spin,Button,message} from 'antd';
import { Table } from 'fl-pro';
import SearchForm from '../../../../components/SearchForm';
import commonFun from '../../../../utils/utils';
import statusText from '../../../../utils/statusText';
class Grouping extends Component {
    constructor(props) {
        super(props);
        this.state = {
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            dataList:[],
            total:0,
        }
    }
    
    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.GetCardOwnerGroupList();
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetCardOwnerGroupList()
        });
    }

     // 分页查询
     searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData,
        },() => {
            this.GetCardOwnerGroupList()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 卡密商品池所属分组
    GetCardOwnerGroupList=()=>{
        const { postData, condition} = this.state;
        this.props.dispatch({
            type: 'cardStock/GetCardOwnerGroupList', 
            payload: {
                ...postData,
                ...condition, 
                ProductId:this.props.commonParams.productId
            } 
        }); 
    }
    

    componentWillReceiveProps(nextProps){
        const { GetCardOwnerGroupList} = nextProps.cardStock;
        // 卡密商品池所属分组 
        if (GetCardOwnerGroupList && GetCardOwnerGroupList !== this.props.cardStock.GetCardOwnerGroupList) {
            if(GetCardOwnerGroupList.code==="0"){
                GetCardOwnerGroupList.data.list&&GetCardOwnerGroupList.data.list.map((item,i)=>{
                    item.key=i
                })
                this.setState({
                    dataList:GetCardOwnerGroupList.data&&GetCardOwnerGroupList.data.list?GetCardOwnerGroupList.data.list:[],
                    total:GetCardOwnerGroupList.data.total
                })
            }else{
                message.destroy();
                message.warning(GetCardOwnerGroupList.message);
            }
        }
    }


    render() {
        const {postData,dataList,total} = this.state;
        const {loading} = this.props;
        let columns = [
            {
                key:"1",
                title: '分组编号',
                width:150,
                align: 'left',
                dataIndex:"groupCode",
            },
            {
                key:"2",
                title: '分组名称',
                width:210,
                align: 'left',
                dataIndex:"groupName",
            },
            {
                key:"3",
                title: '分组类型',
                width:150,
                align: 'left',
                dataIndex:"mode",
                render:(text,record)=>{
                    return statusText['Mode']["card"][text]
                }
            },
            {
                key:"4",
                title: '备注',
                align: 'left',
                dataIndex:"remarks",
            },
        ];

        const pagination = {
            total,
            hideOnSinglePage: true,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current;
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
               
            },
        };

        return(
            <div className="AddPriceMerchants">
                <div className="AddPriceMerchants-containter">
                    <SearchForm name="Grouping"
                     init={this.init} 
                     search={this.search} 
                     getFormData={this.getFormData} 
                    />
                    <Spin spinning={loading.effects['cardStock/GetCardOwnerGroupList']}>
                        <div className="tableBox">
                            <Table 
                                columns={columns}
                                dataSource={dataList?dataList:[]}
                                pagination={pagination}
                            />
                        </div>
                    </Spin>
                </div>
                <div className="footerstaff">
                    <Button  className="btnok" onClick={this.props.handleAddCancel}>取消</Button>
                </div>
            </div>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(Grouping);


