import React from 'react';
import { connect } from 'dva';
import {Spin,Tabs,Form,Button  } from  "antd";
const { TabPane } = Tabs;
import './less/index.less';
import BreadCrumb from '../../../../components/Breadcrumb';
import SearchForm from '../../../../components/SearchForm';
import GoodsGroup from '../GoodsGroup';
import CardGoods from '../CardGoods';
import CreatCardGroup from '../GoodsGroup/CreatCardGroup';
import commonFun from '../../../../utils/utils';
import findIndex from 'lodash/findIndex';
class CommonTabs extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            postData1:{
                PageIndex: 1,
                PageSize: 10,
            },
            tabType:commonFun.GetQueryString(location.search.split('?')[1], "tabType")?commonFun.GetQueryString(location.search.split('?')[1], "tabType"):'1'
            ,
            dataResource:[],
            total:0,
            showCreatCardGroup:false,
            params:{}
        }
    }
    

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.getDataResource()
        });
    }

    // 查询
    search = () => {
        const { postData,condition,postData1,tabType } = this.state;
        if(tabType=='1'){
            postData.PageIndex=1
            this.setState({ 
                condition,
                postData 
            },() => {
                this.getDataResource()
            });
        }else{
            postData1.PageIndex=1
            this.setState({ 
                condition,
                postData1 
            },() => {
                this.getDataResource()
            });
        }
        
    }

     // 分页查询
     searchPagination= (postDatas)=> {
        const { condition,postData1,postData,tabType } = this.state;
        this.setState({ 
            condition,
            postData1:tabType=='1'?postData1:postDatas, 
            postData:tabType=='1'?postDatas:postData
        },() => {
            this.getDataResource()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    callback=(type)=>{
        const {postData,postData1 } = this.state;
        this.setState({
            tabType:type,
            postData,
            postData1,
            dataResource:[]
        },()=>{
            this.getDataResource()
        })
    }

    getnewData=(type)=>{
        this.setState({
            tabType:type
        },()=>{
            this.getDataResource()
        })
    }

    // 获取列表数据源
    getDataResource = ()=>{
        const {postData,condition,tabType,postData1 } =this.state;
        if(tabType=='1'){
            this.props.dispatch({
                type: 'cardStock/GetCardPoolProductList', 
                payload: {
                    ...postData,
                    ...condition,
                } 
            });
        }else{
            this.props.dispatch({
                type: 'cardStock/GetCardGroupList', 
                payload: {
                    ...postData1,
                    ...condition,
                    tabType
                } 
            });
        }
    }

    createCardGroup=()=>{
        this.setState({
            showCreatCardGroup:true,
            params:{
                title:'创建卡密库存组'
            },
        })
    }

    closeCardGroup=()=>{
        this.setState({
            showCreatCardGroup:false
        },()=>{
            this.getDataResource()
        })
    }

    componentWillReceiveProps(nextProps) {
        const {GetCardGroupList,GetCardPoolProductList } = nextProps.cardStock;
        const { location } = this.props;
        // 获取列表数据源
        if (GetCardGroupList && GetCardGroupList !== this.props.cardStock.GetCardGroupList) {
            if(GetCardGroupList.code==="0"){
              this.setState({
                dataResource:GetCardGroupList.data.list,
                total:GetCardGroupList.data.total
              })
            }else{
                message.destroy();
                message.warning(GetCardGroupList.message);
            }
        }
        if (GetCardPoolProductList && GetCardPoolProductList !== this.props.cardStock.GetCardPoolProductList) {
            if(GetCardPoolProductList.code==="0"){
              this.setState({
                dataResource:GetCardPoolProductList.data.list,
                total:GetCardPoolProductList.data.total
              })
            }else{
                message.destroy();
                message.warning(GetCardPoolProductList.message);
            }
        }
        //路由参数变化重新渲染页面
        if(location.search !== nextProps.location.search){
            this.setState({
                tabType:commonFun.GetQueryString(nextProps.location.search.split('?')[1], "tabType")
            },()=>{
                this.getDataResource()
            })
        }

    }

	render() {
        const { tabType,postData,postData1,condition,dataResource,total,showCreatCardGroup }= this.state;
        console.log(tabType)
        const { loading } = this.props;
        const breadcrumbList = [
            {
                name:"市场选货",
                href:""
            },
            {
                name:"卡密货源管理",
                href:"/stock/card?tabType=1&t="+new Date().getTime()
            },
            {
                name:tabType&&tabType=='2'?"卡密库存组":"卡密库存池",
                href:""
            }
        ];
		return (
			<div className="commontabs">
                <BreadCrumb paramsList={breadcrumbList} />
                <div className="commontabs-containter">
                    <SearchForm name={tabType&&tabType=='2'?'cardgoodsGroup':'cardgoodsHome'}
                        init={this.init} 
                        search={this.search} 
                        getFormData={this.getFormData} 
                    />
                    <div className="tabs">
                        {tabType=='2'&&(findIndex(window.getAuthButtons(), { enCode: 'lr_card_createdGroup' }) !== -1)?<Button type="primary" className="creatcardStock" onClick={this.createCardGroup}>
                            创建卡密库存组
                        </Button>:''}
                    </div>
                    <Tabs onChange={this.callback} type="card" defaultActiveKey={tabType} activeKey={tabType}>
                        <TabPane tab="卡密库存池" key="1" >
                        {tabType=='1'&&<Spin spinning={loading.effects['cardStock/GetCardPoolProductList']}>
                                <CardGoods total={total} dataResource={dataResource} condition={condition} postData={postData}  searchPagination={this.searchPagination}  getnewData={this.getnewData}/>
                            </Spin>}
                        </TabPane>
                        <TabPane tab="卡密库存组" key="2" >
                            {tabType=='2'&&<Spin spinning={loading.effects['cardStock/GetCardGroupList']}>
                                <GoodsGroup total={total} dataResource={dataResource} condition={condition} postData={postData1} searchPagination={this.searchPagination} getnewData={this.getnewData}/>
                            </Spin>}
                        </TabPane>
                    </Tabs>
                    {showCreatCardGroup?<CreatCardGroup closeCardGroup={this.closeCardGroup} params={this.state.params} getnewData={this.getnewData}/>:''}
                </div>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(CommonTabs));