import React, { Component } from 'react';
import { connect } from 'dva';
import {Spin,Button,message} from 'antd';
import { Table } from 'fl-pro';
import SearchForm from '../../../../components/SearchForm';
import commonFun from '../../../../utils/utils';
import statusText from '../../../../utils/statusText';
import findIndex from 'lodash/findIndex';
class AddGoods extends Component {
    constructor(props) {
        super(props);
        this.state = {
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            dataList:[],
            total:0,
            selectedRowData:[],
            DepartmentList:[],
            PositionList:[],
            screenHeight:960,
            selectedRowKeys:[],
            CurrentMonthExpiresList:[
                { label: '是', value: '1' },
                { label: '否', value: '0' },
            ],
            commonParams:sessionStorage.getItem("goodsGroupData")?JSON.parse(sessionStorage.getItem("goodsGroupData")):null,
            issubmit:false
        }
    }
    
    componentDidMount (){
        this.setState({screenHeight:window.innerHeight});
    }

    componentWillUnmount() {
        //一定要最后移除监听器，以防多个组件之间导致this的指向紊乱
        window.removeEventListener('resize', this.handleResize.bind(this)) ;
    }


    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.GetCardPoolProductList();
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetCardPoolProductList()
        });
    }

     // 分页查询
     searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData,
            selectedRowData:[],
            selectedRowKeys:[]
        },() => {
            this.GetCardPoolProductList()
        });
    }

    handleResize = e => {
        this.setState({screenHeight:e.target.innerHeight});
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 卡密商品池商品列表
    GetCardPoolProductList=()=>{
        const { postData, condition,commonParams} = this.state;
        this.props.dispatch({
            type: 'cardStock/GetCardPoolProductList', 
            payload: {
                ...postData,
                ...condition, 
                GroupId:commonParams.id,
                FaceValue:commonParams.faceValue,
                InvoiceType:commonParams.invoiceType
            } 
        }); 
    }
    

    confirmData=()=>{
        const {selectedRowData,commonParams} = this.state;
        if(selectedRowData&&selectedRowData.length>0){
            this.setState({
                issubmit:true
            })
            const postData = {
                groupCode:commonParams.groupCode,
                groupName:commonParams.groupName,
                entities:selectedRowData.map((item)=>{
                    return {
                        productPoolId:item.id,
                        productId: item.productId,
                        cardGroupId: commonParams.id,
                        Sort: 0
                    }
                })
            }
            this.props.dispatch({
                type: 'cardStock/CreateCardGroupProductDetail',
                payload: {
                    ...postData
                }
            });
        }else{
            message.destroy();
            message.warning("请选择商品")
            return false
        }
    }


    componentWillReceiveProps(nextProps){
        const { GetCardPoolProductList,CreateCardGroupProductDetail} = nextProps.cardStock;
        // 获得待加入密价组商户列表 
        if (GetCardPoolProductList && GetCardPoolProductList !== this.props.price.GetCardPoolProductList) {
            if(GetCardPoolProductList.code==="0"){
                GetCardPoolProductList.data.list&&GetCardPoolProductList.data.list.map((item,i)=>{
                    item.key=i
                })
                this.setState({
                    dataList:GetCardPoolProductList.data&&GetCardPoolProductList.data.list?GetCardPoolProductList.data.list:[],
                    total:GetCardPoolProductList.data.total
                })
            }else{
                message.destroy();
                message.warning(GetCardPoolProductList.message);
            }
        }

        if (CreateCardGroupProductDetail && CreateCardGroupProductDetail !== this.props.cardStock.CreateCardGroupProductDetail) {
            this.setState({
                issubmit:false
            })
            if(CreateCardGroupProductDetail.code==="0"){
                message.destroy();
                message.success("添加成功")
                this.props.handleAddCancel()
            }else{
                message.destroy();
                message.warning(CreateCardGroupProductDetail.message);
            }
        }

    }


    render() {
        const {postData,dataList,total,screenHeight,selectedRowKeys,issubmit } = this.state;
        const {loading} = this.props;
        let columns = [
            {
                key:"1",
                title: '供货商名称',
                width:150,
                align: 'left',
                dataIndex:"supMemberName",
            },
            {
                key:"2",
                title: '商品编号',
                width:150,
                align: 'left',
                dataIndex:"productId",
            },
            {
                key:"3",
                title: '商品名称',
                width:210,
                align: 'left',
                dataIndex:"productName",
            },
            {
                key:"4",
                title: '商品类型',
                align: 'left',
                dataIndex:"productType",
                width:80,
            },
            {
                key:"5",
                title: '进货价',
                align: 'left',
                dataIndex:"price",
                width:80,
            },
            {
                key:"6",
                title: '面值',
                width:80,
                align: 'left',
                dataIndex:"faceValue",
            },
            {
                key:"7",
                title: '销售状态',
                align: 'left',
                dataIndex:"salesStatus",
                width:100,
                render:(text)=>{
                    return statusText.KmSaleStatus[text]  
                }
            },
            {
                key:"8",
                title: '库存状态',
                align: 'left',
                dataIndex:"stockStatus",
                width:100,
                render:(text)=>{
                    return statusText.KmStockStatus[text]
                }
            },
        ];

        const pagination = {
            total,
            hideOnSinglePage: true,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current;
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
               
            },
        };

        const rowSelection = {
            selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRowData:selectedRows,
                    selectedRowKeys
                })
            },
        };
        return(
            <div className="AddPriceMerchants">
                <div className="AddPriceMerchants-containter">
                    <SearchForm name="addCardGroupGoods"
                     init={this.init} 
                     search={this.search} 
                     getFormData={this.getFormData} 
                    />
                    <Spin spinning={loading.effects['cardStock/GetCardPoolProductList']}>
                        <div className="tableBox">
                            <Table 
                                columns={columns}
                                dataSource={dataList?dataList:[]}
                                pagination={pagination}
                                rowSelection={rowSelection}
                            />
                        </div>
                    </Spin>
                </div>
                <div className="footerstaff">
                    {(findIndex(window.getAuthButtons(), { enCode: 'lr_card_addGroupGoodsConfirm' }) !== -1)?<Button type="primary" className="btnok" loading={issubmit} onClick={this.confirmData}>确定</Button>:''}
                    <Button className="btncancel" onClick={this.props.handleAddCancel} style={{marginRight:'10px'}}>取消</Button>
                </div>
            </div>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(AddGoods);


