import React from 'react';
import { connect } from 'dva';
import {Spin,Form,Input,message,Button,Modal} from  "antd";
const { confirm } = Modal;
import { Table } from  'fl-pro';
import './less/index.less';
import BreadCrumb from '../../../../components/Breadcrumb';
import SearchForm from '../../../../components/SearchForm';
import findIndex from 'lodash/findIndex';
import commonFun from '../../../../utils/utils';
import statusText from '../../../../utils/statusText';
import AddGoods from './AddGoods'
class GoodsDetail extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            selectedRowData:[],
            total:0,
            goodsResource:[],
            showAddGoods:false,
            commonParams:sessionStorage.getItem("goodsGroupData")?JSON.parse(sessionStorage.getItem("goodsGroupData")):null,
            addparams:null
        }
	}

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.getgoodsResource()
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getgoodsResource()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 分组商品明细
    getgoodsResource = ()=>{
        const {postData,condition,commonParams } =this.state;
        this.props.dispatch({
            type: 'cardStock/GetCardGroupProductDetailList', 
            payload: {
                ...postData,
                ...condition,
                CardGroupId: commonParams.id
            } 
        });
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.getgoodsResource()
        });
    }

    AddCardGoods=()=>{
        this.setState({
            showAddGoods:true,
        })
    }

    closeaddGoods=()=>{
        this.setState({
            showAddGoods:false
        },()=>{
            this.getgoodsResource()
        })
    }

    handleChange=(e,record,index)=>{
        const { goodsResource } =this.state;
        goodsResource[index].sort = e.target.value;
        this.setState({
            goodsResource
        })
    }

    updateSort=()=>{
        const { goodsResource } = this.state;
        if(goodsResource&&goodsResource.length>0){
            this.props.dispatch({
                type: 'cardStock/UpdateCardGroupProduct', 
                payload: goodsResource.map((item)=>{
                    return {
                        id:item.id,
                        sort:item.sort
                    }
                })
            });
        }
        
    }

    delete=()=>{
        const { selectedRowData,commonParams } = this.state;
        const _this = this;
        if(selectedRowData&&selectedRowData.length>0){
            confirm({
                title: '确定删除我吗？',
                content: '确定删除我吗？',
                okText:"确定",
                cancelText:"取消",
                onOk() {
                    _this.props.dispatch({
                        type: 'cardStock/DeleteCardGroupProductDetail', 
                        payload:{
                            groupCode: commonParams.groupCode,
                            groupName: commonParams.groupName,
                            idsList:selectedRowData.map((item)=>{
                                return {
                                    id:item.id,
                                    productId:item.productId
                                }
                            })
                        }
                    }); 
                },
                onCancel() {
                  
                },
            });
        }else{
            message.destroy();
            message.error("请选择需要删除的商品")
        }
    }


	componentWillReceiveProps(nextProps) {
        const { GetCardGroupProductDetailList,UpdateCardGroupProduct,DeleteCardGroupProductDetail } = nextProps.cardStock;
        // 分组商品明细
        if (GetCardGroupProductDetailList && GetCardGroupProductDetailList !== this.props.cardStock.GetCardGroupProductDetailList) {
            if(GetCardGroupProductDetailList.code==="0"){
              this.setState({
                goodsResource:GetCardGroupProductDetailList.data.list,
                total:GetCardGroupProductDetailList.data.total
              })
            }else{
                message.destroy();
                message.warning(GetCardGroupProductDetailList.message);
            }
        }
        // 更新排序
        if (UpdateCardGroupProduct && UpdateCardGroupProduct !== this.props.cardStock.UpdateCardGroupProduct) {
            if(UpdateCardGroupProduct.code==="0"){
              message.destroy();
              message.success("排序成功")
              this.getgoodsResource()
            }else{
                message.destroy();
                message.warning(UpdateCardGroupProduct.message);
            }
        }
        // 分组商品明细
        if (DeleteCardGroupProductDetail && DeleteCardGroupProductDetail !== this.props.cardStock.DeleteCardGroupProductDetail) {
            if(DeleteCardGroupProductDetail.code==="0"){
                message.destroy();
                message.success("删除成功")
                this.getgoodsResource()
            }else{
                message.destroy();
                message.warning(DeleteCardGroupProductDetail.message);
            }
        }
    }

	render() {
        const {loading} = this.props;
        const {total,postData,showAddGoods,goodsResource,commonParams} = this.state;
        const breadcrumbList = [
            {
                name:"库存管理",
                href:""
            },
            {
                name:"卡密库存管理",
                href:"/stock/card?tabType=1"
            },
            {
                name:"卡密商品池分组",
                href: "/stock/card?tabType=2"
            },
            {
                name:"商品明细",
                href: ""
            }
        ];
       
        
        let columns = [
            {
                key:"1",
                title: '供货商名称',
                width:150,
                align: 'left',
                dataIndex:"supMemberName",
                fixed: 'left',
            },
            {
                key:"2",
                title: '商品名称',
                width:200,
                align: 'left',
                dataIndex:"productName",
            },
            {
                key:"3",
                title: '商品编号',
                width:150,
                align: 'left',
                dataIndex:"productId",
            },
            {
                key:"4",
                title: '票据类型',
                align: 'left',
                dataIndex:"invoiceType",
                render:(text,record)=>{
                    return statusText.InvoiceType[text]    
                }
            },
            {
                key:"5",
                title: '二级票据类型',
                align: 'left',
                dataIndex:"secondInvoiceType",
                render:(text,record)=>{
                    if (record.secondInvoiceType === "0" || record.secondInvoiceType === 0) {
                        return "无票";
                    } else if (record.secondInvoiceType == 1) {
                        return  commonFun.calc(record.invoiceRate, "*", 100) + "%普票";
                    } else if (record.secondInvoiceType == 2) {
                        return  commonFun.calc(record.invoiceRate, "*", 100) + "%专票";
                    } else {
                        return "";
                    }
                }
            },
            {
                key:"6",
                title: '单价',
                align: 'right',
                dataIndex:"price",
            },
            {
                key:"7",
                title: '销售状态',
                align: 'left',
                dataIndex:"salesStatus",
                render:(text)=>{
                    return statusText.KmSaleStatus[text]
                }
            },
            {
                key:"8",
                title: '排序',
                width:150,
                align: 'left',
                fixed: 'right',
                dataIndex:"sort",
                render:(text,record,index)=>(
                    <div style={{color:"#4b9ae0"}}>
                       <Input value={record.sort} onChange={(e) => this.handleChange(e,record,index)}/>
                    </div>
                )
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };

        const rowSelection = {
            onChange: (selectedRowKeys, selectedRows) => {
              this.setState({
                selectedRowData:selectedRows
              })
            },
            // getCheckboxProps: record => ({
            //   disabled: record.name === 'Disabled User', 
            //   name: record.name,
            // }),
        };
		return (
			<div className="cardGoods">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="cardGoods-containter">
                    <Spin spinning={loading.effects['cardStock/GetCardGroupProductDetailList']}>
                    <SearchForm name="cardGroupgoodslist"
                        onRef={(ref) => { this.child = ref }}
                        init={this.init} 
                        search={this.search} 
                        getFormData={this.getFormData} 
                    />
                    <div style={{textAlign:"right",marginBottom:"10px"}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_card_addGroupGoods' }) !== -1)?<Button type="primary" style={{marginRight:'10px'}}  onClick={this.AddCardGoods}>
                            添加商品
                        </Button>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_card_UpdateSort' }) !== -1)?<Button type="primary" ghost   style={{marginRight:'10px'}} onClick={this.updateSort}>
                            更新排序
                        </Button>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_card_delGroupGoods' }) !== -1)?<Button  onClick={this.delete}>
                            删除商品
                        </Button>:''}
                    </div>
                    <Table 
                        columns={columns}
                        rowSelection={rowSelection}
                        dataSource={goodsResource?goodsResource:[]}
                        pagination={pagination}
                        scroll={{x:1200}}
                    />
                    </Spin>
                    {
                        showAddGoods&&
                        <Modal
                        width="1300px"
                        title="添加商品"
                        visible={showAddGoods}
                        onCancel={this.closeaddGoods}
                        footer={null}
                        className="addCommodityModal"
                        >
                            <AddGoods handleAddCancel={this.closeaddGoods} />
                        </Modal>  
                    }  
                </div>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(GoodsDetail))