import React from 'react';
import { connect } from 'dva';
import {Modal,Form,Input,message,Button,Select,InputNumber,Spin  } from  "antd";
import statusText from '../../../../utils/statusText';
const {TextArea} = Input;
const createForm = Form.create;
const { confirm } = Modal;
class CreatCardGroup extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            isSubmit:false,
            InvoiceArr1 : [
                { type: "1", rate: "3", unit: "%" },
                { type: "2", rate: "3", unit: "%" },
                { type: "1", rate: "6", unit: "%" },
                { type: "2", rate: "6", unit: "%" },
                { type: "1", rate: "10", unit: "%" },
                { type: "2", rate: "10", unit: "%" },
                { type: "1", rate: "13", unit: "%" },
                { type: "2", rate: "13", unit: "%" },
                { type: "1", rate: "16", unit: "%" },
                { type: "2", rate: "16", unit: "%" }
            ],
            InvoiceArr0 : [
                { type: "1", rate: "0", unit: "%" },
                { type: "0", rate: "", unit: "" }
            ],
            secondInvoiceTypeList:[],
            ishaveProduct:false
        }
	}

    componentDidMount (){
        if(this.props.params.title=="编辑卡密库存组"){
            this.initEditFormData();
            this.CheckCardGroupProduct()
            this.setState({
                ishaveProduct:true
            })
        }
    }

    initEditFormData=()=>{
        const {groupName,faceValue,invoiceType,secondInvoiceType,invoiceRate,mode,remarks }  = this.props.params
        this.props.form.setFieldsValue({
            groupName,
            faceValue,
            invoiceType,
            secondInvoiceType:secondInvoiceType==0||secondInvoiceType=='0'?statusText.SecondInvoiceType[secondInvoiceType]: invoiceRate*100+'%' + statusText.SecondInvoiceType[secondInvoiceType],
            mode:mode,
            remarks
        })
    }


    CheckCardGroupProduct=()=>{
        this.props.dispatch({
            type: 'cardStock/CheckCardGroupProduct', 
            payload: {
                CardGroupId:this.props.params.id
            } 
        });
    }

   
    handleSubmit = (e) => {
        e.preventDefault();
        const _this=this;
        this.setState({
            isSubmit:true
        })
        const {id}  = this.props.params
        _this.props.form.validateFields((err, value) => {
            if(!err){
                if(this.props.params.title=='编辑卡密库存组'){
                    if(value.secondInvoiceType.indexOf('%')>-1){
                        let str = value.secondInvoiceType.split('%')
                        value.invoiceRate= str[0]/100
                        for (var key in statusText.SecondInvoiceType){ //6%  无票 0% 普票
                            if(str[1]==statusText.SecondInvoiceType[key]){
                                value.secondInvoiceType = key
                            }
                        }
                    }else{
                        value.secondInvoiceType=0;
                        value.invoiceRate = ''
                    }
                    
                    // if(value.mode == '异步提卡'){
                    //     value.mode = '1'
                    // }else if(value.mode == '同步提卡'){
                    //     value.mode = '2'
                    // }
                    _this.props.dispatch({
                        type: 'cardStock/UpdateCardGroup', 
                        payload: {
                            ...value,
                            stockId:'',
                            stockName:'',
                            id
                        } 
                    });
                }else{
                    _this.props.dispatch({
                        type: 'cardStock/CreateCardGroup', 
                        payload: {
                        ...value,
                        stockId:'',
                        stockName:'',
                        secondInvoiceType:value.secondInvoiceType.split('/')[0],
                        invoiceRate:value.secondInvoiceType.split('/')[1]/100
                        } 
                    });
                }
            }else{
                this.setState({
                    isSubmit:false
                }) 
            }
        });
    }

    renderSecondInvoiceType=(val)=>{
        const { InvoiceArr0,InvoiceArr1 } = this.state;
        let arr= []
        if(val=='0'){
            arr= InvoiceArr0&&InvoiceArr0.map((item)=>{
                return {
                    label:item.rate + item.unit + statusText.SecondInvoiceType[item.type],
                    value:item.type + '/' + item.rate
                }
            })
        }else  if(val=='1'){
            arr= InvoiceArr1&&InvoiceArr1.map((item)=>{
                return {
                    label:(item.rate + item.unit + statusText.SecondInvoiceType[item.type]),
                    value:item.type + '/' + item.rate
                }
            })
        }
        this.setState({
            secondInvoiceTypeList:arr
        })
    }

	componentWillReceiveProps(nextProps) {
        const { props } = this;
        const {CreateCardGroup,UpdateCardGroup,CheckCardGroupProduct} = nextProps.cardStock;
        // 添加分组
        if (CreateCardGroup && CreateCardGroup !== this.props.cardStock.CreateCardGroup) {
            this.setState({
                isSubmit:false
            })
            if(CreateCardGroup.code==="0"){
                message.destroy();
                message.success("添加成功"); 
                this.props.closeCardGroup();
            }else{
                message.destroy();
                message.error(CreateCardGroup.message);
            }
        }

        // 编辑分组
        if (UpdateCardGroup && UpdateCardGroup !== this.props.cardStock.UpdateCardGroup) {
            this.setState({
                isSubmit:false
            })
            if(UpdateCardGroup.code==="0"){
                message.destroy();
                message.success("编辑成功"); 
                this.props.closeCardGroup();
                this.props.getEditnewData()
            }else{
                message.destroy();
                message.error(UpdateCardGroup.message);
            }
        }

        // 判断卡密库存组下面是否有商品
        if (CheckCardGroupProduct && CheckCardGroupProduct !== this.props.cardStock.CheckCardGroupProduct) {
            if(CheckCardGroupProduct.code==="0"){
              this.setState({
                ishaveProduct:CheckCardGroupProduct.data
              })
            }else{
                message.destroy();
                message.error(CheckCardGroupProduct.message);
            }
        }

        
    }

	render() {
        const { getFieldDecorator } = this.props.form;
        const {title} = this.props.params
        const {isSubmit,secondInvoiceTypeList,ishaveProduct } = this.state;
        const { loading } = this.props;
        const formItemLayout = {
            labelCol: {
              span:5
            },
            wrapperCol: {
              span:18
            },
        }
		return (
			<div className="AddIntegral">
                <Modal
                title={title}
                width="700px"
                visible={true}
                onCancel={this.props.closeCardGroup}
                footer={[
                    <Button key="back" onClick={this.props.closeCardGroup}>
                        取消
                    </Button>,
                    <Button key="submit" type="primary" loading={isSubmit} disabled={ishaveProduct} onClick={this.handleSubmit}>
                        保存
                    </Button>
                ]}
                >
                 <div className="AddIntegralBox">
                    <Spin spinning={title=='编辑卡密库存组'?loading.effects['cardStock/CheckCardGroupProduct']:false}>
                        <Form  {...formItemLayout}>
                            <Form.Item style={{marginBottom:"16px"}}   label="分组名称">
                                {getFieldDecorator('groupName', {
                                    rules: [
                                        {
                                            required: true,
                                            message: '请输入分组名称',
                                        }
                                    ],
                                })(<Input className="formInput" disabled={ishaveProduct} placeholder="请输入分组名称"/>)}
                            </Form.Item>
                            <Form.Item style={{marginBottom:"16px"}}  label="库存类型">
                                {getFieldDecorator('stockType', {
                                    initialValue:'2',
                                    rules: [
                                        {
                                            required: true,
                                            message: '请选择库存类型',
                                        }
                                    ],
                                })(
                                    <Select  placeholder="请选择库存类型" disabled>
                                        <Select.Option value="2" key="2">供货商库存</Select.Option>
                                    </Select>
                                )}
                            </Form.Item>
                            <Form.Item style={{marginBottom:"16px"}}  label="面值">
                                {getFieldDecorator('faceValue', {
                                    rules: [
                                        {
                                            required: true,
                                            message: '请输入面值',
                                        }
                                    ],
                                })(
                                    <InputNumber min={0} disabled={ishaveProduct}/>
                                )}
                            </Form.Item>
                            <Form.Item style={{marginBottom:"16px"}}  label="库存票据类型">
                                {getFieldDecorator('invoiceType', {
                                    rules: [
                                        {
                                            required: true,
                                            message: '请选择库存票据类型',
                                        }
                                    ],
                                })(
                                    <Select onChange={this.renderSecondInvoiceType} disabled={title=='编辑卡密库存组'?true:false} placeholder="请选择库存票据类型">
                                        <Select.Option value="" key="0">--请选择--</Select.Option>
                                        <Select.Option value={0} key="1">寄售</Select.Option>
                                        <Select.Option value={1} key="2">自营</Select.Option>
                                    </Select>
                                )}
                            </Form.Item>
                            <Form.Item style={{marginBottom:"16px"}}  label="库存二级票据类型" >
                                {getFieldDecorator('secondInvoiceType', {
                                    rules: [
                                        {
                                            required: true,
                                            message: '请选择库存二级票据类型',
                                        }
                                    ],
                                })(
                                    <Select  placeholder="请选择库存二级票据类型" disabled={title=='编辑卡密库存组'?true:false}>
                                        <Select.Option value="" key="">--请选择--</Select.Option>
                                        {
                                            secondInvoiceTypeList&&secondInvoiceTypeList.map((item,i)=>{
                                                return <Select.Option value={item.value} key={i}>{item.label}</Select.Option>
                                            })
                                        }
                                    </Select>
                                )}
                            </Form.Item>
                            <Form.Item style={{marginBottom:"16px"}}  label="分组类型">
                                {getFieldDecorator('mode', {
                                    rules: [
                                        {
                                            required: true,
                                            message: '请选择分组类型',
                                        }
                                    ],
                                })(
                                    <Select  placeholder="请选择分组类型" disabled={ishaveProduct}>
                                        <Select.Option value="" key="">--请选择--</Select.Option>
                                        <Select.Option value={1} key={1}>同步提卡</Select.Option>
                                        <Select.Option value={2} key={2}>异步提卡</Select.Option>
                                    </Select>
                                )}
                            </Form.Item>
                            <Form.Item style={{marginBottom:"16px"}}  label="备注">
                                {getFieldDecorator('remarks', {
                                    rules: [
                                        {
                                            required: false,
                                            message: '请输入备注',
                                        }
                                    ],
                                })(<TextArea rows={4} disabled={ishaveProduct} className="formInput" placeholder="请输入备注"/>)}
                            </Form.Item>
                        </Form>
                    </Spin>
                 </div>
               </Modal>   
            </div>
            )
        }
    }

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(createForm()(CreatCardGroup));