import React from 'react';
import { connect } from 'dva';
import {Modal,Form,message} from  "antd";
const { confirm } = Modal;
import { Table } from "fl-pro";
import './less/index.less';
import {withRouter} from "react-router-dom";
import findIndex from 'lodash/findIndex';
import statusText from '../../../../utils/statusText';
import commonFun from '../../../../utils/utils';
import CreatCardGroup from './CreatCardGroup';
class GoodsGroup extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            showCreatCardGroup:false,
            cardGroupList:null,
        }
    }


    closeCardGroup=()=>{
        this.setState({
            showCreatCardGroup:false
        })
    }

    editCardStockGroup=(record)=>{
        this.setState({
            cardGroupList:{title:"编辑卡密库存组",...record},
            showCreatCardGroup:true,
        })
    }

    deleteCardStockGroup=(record)=>{
        const _this = this;
        let postData= [{
            id:record.id,
            groupName:record.groupName,
            groupCode:record.groupCode
        }]
        confirm({
            title: '提示信息',
            content: '您确定删除吗?',
            okText:"确定",
            cancelText:"取消",
            onOk() {
                _this.props.dispatch({
                    type: 'cardStock/DeleteCardGroup', 
                    payload: postData
                }); 
            }
        });
    }

    goGoodsDetail=(record)=>{
        this.props.history.push('/stock/card/goodsDetail')
        sessionStorage.setItem("goodsGroupData",JSON.stringify(record))
    }

    componentWillReceiveProps(nextProps){
        const { DeleteCardGroup } = nextProps.cardStock;
        if (DeleteCardGroup && DeleteCardGroup !== this.props.cardStock.DeleteCardGroup) {
            if(DeleteCardGroup.code==="0"){
                message.destroy();
                message.success("删除成功")
                this.props.getnewData('2')
            }else{
                message.destroy();
                message.warning(DeleteCardGroup.message);
            }
        }
    }

	render() {
        const {dataResource,postData,total} =  this.props
        const {showCreatCardGroup,cardGroupList} =this.state;
        let columns = [
            {
                key:"1",
                title: '分组编号',
                width:150,
                align: 'left',
                dataIndex: 'groupCode',
            }, 
            {
                key:"2",
                title: '分组名称',
                width:200,
                align: 'left',
                dataIndex:"groupName",
            },
            {
                key:"3",
                title: '库存票据类型',
                align: 'left',
                dataIndex:"invoiceType",
                render:(text,record)=>{
                    return statusText.InvoiceType[text]    
                }
            },
            {
                key:"4",
                title: '库存二级票据类型',
                align: 'left',
                dataIndex:"secondInvoiceType",
                render:(text,record)=>{
                    if (record.secondInvoiceType === "0" || record.secondInvoiceType === 0) {
                        return "无票";
                    } else if (record.secondInvoiceType == 1) {
                        return  commonFun.calc(record.invoiceRate, "*", 100) + "%普票";
                    } else if (record.secondInvoiceType == 2) {
                        return  commonFun.calc(record.invoiceRate, "*", 100) + "%专票";
                    } else {
                        return "";
                    }
                }
            },
            {
                key:"5",
                title: '分组类型',
                align: 'left',
                dataIndex:"mode",
                render:(text,record)=>{
                    return statusText['Mode']["card"][text]
                }
            },
            {
                key:"6",
                title: '面值(元)',
                align: 'right',
                dataIndex:"faceValue",
                render:(text,record)=>{
                    return commonFun.toDecimal4(text)
                }
            },
            {
                key:"7",
                title: '备注',
                align: 'left',
                dataIndex:"remarks",
            },
            {
                key:"8",
                title: '操作',
                width:120,
                align: 'left',
                fixed: 'right',
                render:(text,record)=>{
                    return <div className="ibox" style={{color:"#4b9ae0",fontSize:'13px'}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_card_editGroup' }) !== -1)?<i className="iconfont" style={{color:'#979797',cursor:"pointer",marginRight:"14px",fontSize:"16px"}}   title="编辑" onClick={()=>{this.editCardStockGroup(record)}} >&#xe616;</i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_card_lookGroupGoods' }) !== -1)?<i className="fa fa-sitemap fa-lg" data-toggle="tooltip" style={{cursor:"pointer",fontSize:'16px',marginRight:"14px",}}  title="分组商品" onClick={()=>{
                            this.goGoodsDetail(record)
                        }}></i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_card_deleteGroup' }) !== -1)?<i className="fa fa-trash-o fa-lg" style={{cursor:"pointer",marginRight:"14px",color:'#5a5a59',fontSize:'16px'}}   title="删除" onClick={()=>{this.deleteCardStockGroup(record)}}></i>:''}
                    </div>
                }
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData&&postData.PageSize,
            current: postData&&postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.props.searchPagination(postData);
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.props.searchPagination(postData);
                })
            },
        };
		return (
			<div className="GoodsGroup">
                <div style={{width:'100%'}}>
                    <div className="GoodsGroup-containter">
                        <Table 
                            columns={columns}
                            dataSource={dataResource?dataResource:[]}
                            pagination={pagination}
                            scroll={{x:1400}}
                        />
                        {showCreatCardGroup?<CreatCardGroup params={cardGroupList} closeCardGroup={this.closeCardGroup} getEditnewData={()=>{this.props.getnewData('2')}}/>:''}
                    </div>
                </div>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(withRouter(GoodsGroup)));