import React from 'react';
import { connect } from 'dva';
import {Spin,Tabs,Form,Button  } from  "antd";
const { TabPane } = Tabs;
import './less/index.less';
import BreadCrumb from '../../../../components/Breadcrumb';
import SearchForm from '../../../../components/SearchForm';
import RechargeGoodsGroup from '../RechargeGoodsGroup';
import RechargeGoodsList from '../RechargeGoodsList';
import CreatRechargeGroup from '../RechargeGoodsGroup/CreatRechargeGroup';
import commonFun from '../../../../utils/utils';
import findIndex from 'lodash/findIndex';
class CommonTabs extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            postData1:{
                PageIndex: 1,
                PageSize: 10,
            },
            tabType:commonFun.GetQueryString(location.search.split('?')[1], "tabType")?commonFun.GetQueryString(location.search.split('?')[1], "tabType"):'1'
            ,
            dataResource:[],
            total:0,
            showCreatRechargeGroup:false,
            params:{}
        }
    }

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.getDataResource()
        });
    }

    // 查询
    search = () => {
        const { postData,condition,postData1,tabType } = this.state;
        if(tabType=='1'){
            postData.PageIndex=1
            this.setState({ 
                condition,
                postData 
            },() => {
                this.getDataResource()
            });
        }else{
            postData1.PageIndex=1
            this.setState({ 
                condition,
                postData1 
            },() => {
                this.getDataResource()
            });
        }
        
    }

     // 分页查询
     searchPagination= (postDatas)=> {
        const { condition,postData1,postData,tabType } = this.state;
        this.setState({ 
            condition,
            postData1:tabType=='1'?postData1:postDatas, 
            postData:tabType=='1'?postDatas:postData
        },() => {
            this.getDataResource()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    callback=(type)=>{
        const {postData,postData1 } = this.state;
        this.setState({
            tabType:type,
            postData,
            postData1,
            dataResource:[]
        },()=>{
            this.getDataResource()
        })
    }

    getnewData=(type)=>{
        this.setState({
            tabType:type
        },()=>{
            this.getDataResource()
        })
    }

    // 获取列表数据源
    getDataResource = ()=>{
        const {postData,condition,tabType,postData1 } =this.state;
        if(tabType=='1'){
            this.props.dispatch({
                type: 'rechargeStock/GetDirectChargeDetailExcludeGroup', 
                payload: {
                    ...postData,
                    ...condition,
                } 
            });
        }else{
            this.props.dispatch({
                type: 'rechargeStock/GetDirectChargeGroupList', 
                payload: {
                    ...postData1,
                    ...condition,
                    tabType
                } 
            });
        }
    }

    createCardGroup=()=>{
        this.setState({
            showCreatRechargeGroup:true,
            params:{
                title:'创建直充库存组'
            },
        })
    }

    closeRechargeGroup=()=>{
        this.setState({
            showCreatRechargeGroup:false
        },()=>{
            this.getDataResource()
        })
    }

    componentWillReceiveProps(nextProps) {
        const {GetDirectChargeGroupList,GetDirectChargeDetailExcludeGroup} = nextProps.rechargeStock;
        const { location } = this.props;
        // 获取列表数据源
        if (GetDirectChargeGroupList && GetDirectChargeGroupList !== this.props.rechargeStock.GetDirectChargeGroupList) {
            if(GetDirectChargeGroupList.code==="0"){
              this.setState({
                dataResource:GetDirectChargeGroupList.data.list,
                total:GetDirectChargeGroupList.data.total
              })
            }else{
                message.destroy();
                message.warning(GetDirectChargeGroupList.message);
            }
        }
        if (GetDirectChargeDetailExcludeGroup && GetDirectChargeDetailExcludeGroup !== this.props.rechargeStock.GetDirectChargeDetailExcludeGroup) {
            if(GetDirectChargeDetailExcludeGroup.code==="0"){
              this.setState({
                dataResource:GetDirectChargeDetailExcludeGroup.data.list,
                total:GetDirectChargeDetailExcludeGroup.data.total
              })
            }else{
                message.destroy();
                message.warning(GetDirectChargeDetailExcludeGroup.message);
            }
        }

        //路由参数变化重新渲染页面
        if(location.search !== nextProps.location.search){
            this.setState({
                tabType:commonFun.GetQueryString(nextProps.location.search.split('?')[1], "tabType")
            },()=>{
                this.getDataResource()
            })
        }
    }

	render() {
        const { tabType,postData,postData1,condition,dataResource,total,showCreatRechargeGroup }= this.state;
        const { loading } = this.props;
        const breadcrumbList = [
            {
                name:"市场选货",
                href:""
            },
            {
                name:"直充货源管理",
                href:"/stock/recharge?tabType=1&t="+new Date().getTime()
            },
            {
                name:tabType&&tabType=='2'?"直充库存组":"直充库存池",
                href:""
            }
        ];
		return (
			<div className="commontabs">
                <BreadCrumb paramsList={breadcrumbList} />
                <div className="commontabs-containter">
                    <SearchForm name={tabType&&tabType=='2'?'RechargeGroup':'rechargeHome'}
                        init={this.init} 
                        search={this.search} 
                        getFormData={this.getFormData} 
                    />
                    <div className="tabs">
                        {tabType=='2'&&(findIndex(window.getAuthButtons(), { enCode: 'lr_recharge_createdGroup' }) !== -1)?<Button type="primary" className="creatcardStock" onClick={this.createCardGroup}>
                            创建直充库存组
                        </Button>:''}
                    </div>
                    <Tabs onChange={this.callback} type="card" defaultActiveKey={tabType} activeKey={tabType}>
                        <TabPane tab="直充库存池" key="1" >
                        {tabType=='1'&&
                            <Spin 
                            spinning={loading.effects['rechargeStock/GetDirectChargeDetailExcludeGroup']}
                            >
                                <RechargeGoodsList total={total} dataResource={dataResource} condition={condition} postData={postData}  searchPagination={this.searchPagination}  getnewData={this.getnewData}/>
                            </Spin>
                        }
                        </TabPane>
                        <TabPane tab="直充库存组" key="2" >
                            {tabType=='2'&&
                            <Spin spinning={loading.effects['rechargeStock/GetDirectChargeGroupList']}>
                                <RechargeGoodsGroup total={total} dataResource={dataResource} condition={condition} postData={postData1} searchPagination={this.searchPagination} getnewData={this.getnewData}/>
                            </Spin>
                            }
                        </TabPane>
                    </Tabs>
                    {showCreatRechargeGroup?<CreatRechargeGroup closeRechargeGroup={this.closeRechargeGroup} params={this.state.params} getnewData={this.getnewData}/>:''}
                </div>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(CommonTabs));