import React from 'react';
import { connect } from 'dva';
import {Modal,Form,Input,message,Button,Select,InputNumber  } from  "antd";
import statusText from '../../../../utils/statusText';
const {TextArea} = Input;
const createForm = Form.create;
const { confirm } = Modal;
import findIndex from 'lodash/findIndex';
class CreatRechargeGroup extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            isSubmit:false,
            InvoiceArr1 : [
                { type: "1", rate: "3", unit: "%" },
                { type: "2", rate: "3", unit: "%" },
                { type: "1", rate: "6", unit: "%" },
                { type: "2", rate: "6", unit: "%" },
                { type: "1", rate: "10", unit: "%" },
                { type: "2", rate: "10", unit: "%" },
                { type: "1", rate: "13", unit: "%" },
                { type: "2", rate: "13", unit: "%" },
                { type: "1", rate: "16", unit: "%" },
                { type: "2", rate: "16", unit: "%" }
            ],
            InvoiceArr0 : [
                { type: "1", rate: "0", unit: "%" },
                { type: "0", rate: "", unit: "" }
            ],
            secondInvoiceTypeList:[],
            ishaveProduct:false
        }
	}

    componentDidMount (){
        if(this.props.params.title=="编辑直充库存组"){
            this.initEditFormData()
            this.CheckDirectChargeProduct()
            this.setState({
                ishaveProduct:true
            })            

        }
    }

    initEditFormData=()=>{
        const {groupName,invoiceType,secondInvoiceType,invoiceRate,remarks }  = this.props.params
        this.props.form.setFieldsValue({
            groupName,
            invoiceType:statusText.InvoiceType[invoiceType],
            secondInvoiceType:secondInvoiceType==0||secondInvoiceType=='0'?statusText.SecondInvoiceType[secondInvoiceType]: invoiceRate*100+'%' + statusText.SecondInvoiceType[secondInvoiceType],
            remarks
        })
    }


    CheckDirectChargeProduct=()=>{
        this.props.dispatch({
            type: 'rechargeStock/CheckDirectChargeProduct', 
            payload: {
                Id:this.props.params.id
            } 
        });
    }

   
    handleSubmit = (e) => {
        e.preventDefault();
        const _this=this;
        this.setState({
            isSubmit:true
        })
        const {id}  = this.props.params
        _this.props.form.validateFields((err, value) => {
            if(!err){
                if(this.props.params.title=='编辑直充库存组'){
                    for (var key in statusText.InvoiceType){
                        if(value.invoiceType==statusText.InvoiceType[key]){
                            value.invoiceType = key
                        }
                    }

                    if(value.secondInvoiceType.indexOf('%')>-1){
                        let str = value.secondInvoiceType.split('%')
                        value.invoiceRate= str[0]/100
                        for (var key in statusText.SecondInvoiceType){ //6%  无票 0% 普票
                            if(str[1]==statusText.SecondInvoiceType[key]){
                                value.secondInvoiceType = key
                            }
                        }
                    }else{
                        value.secondInvoiceType=0;
                        value.invoiceRate = ''
                    }
                    
                    if(value.mode == '普通'){
                        value.mode = '1'
                    }else if(value.mode == '区域'){
                        value.mode = '2'
                    }else if(value.mode == '面值'){
                        value.mode = '3'
                    }else if(value.mode == '区域+面值'){
                        value.mode = '4'
                    }
                    _this.props.dispatch({
                        type: 'rechargeStock/UpdateDirectChargeGroup', 
                        payload: {
                            ...value,
                            id
                        } 
                    });
                }else{
                    _this.props.dispatch({
                        type: 'rechargeStock/CreateDirectChargeGroup', 
                        payload: {
                        ...value,
                        secondInvoiceType:value.secondInvoiceType.split('/')[0],
                        invoiceRate:value.secondInvoiceType.split('/')[1]/100
                        } 
                    });
                }
            }else{
                this.setState({
                    isSubmit:false
                }) 
            }
        });
    }

    renderSecondInvoiceType=(val)=>{
        const { InvoiceArr0,InvoiceArr1 } = this.state;
        let arr= []
        if(val=='0'){
            arr= InvoiceArr0&&InvoiceArr0.map((item)=>{
                return {
                    label:item.rate + item.unit + statusText.SecondInvoiceType[item.type],
                    value:item.type + '/' + item.rate
                }
            })
        }else  if(val=='1'){
            arr= InvoiceArr1&&InvoiceArr1.map((item)=>{
                return {
                    label:(item.rate + item.unit + statusText.SecondInvoiceType[item.type]),
                    value:item.type + '/' + item.rate
                }
            })
        }
        this.setState({
            secondInvoiceTypeList:arr
        })
    }

	componentWillReceiveProps(nextProps) {
        const { props } = this;
        const {CreateDirectChargeGroup,UpdateDirectChargeGroup,CheckDirectChargeProduct} = nextProps.rechargeStock;
        // 添加分组
        if (CreateDirectChargeGroup && CreateDirectChargeGroup !== this.props.rechargeStock.CreateDirectChargeGroup) {
            this.setState({
                isSubmit:false
            })
            if(CreateDirectChargeGroup.code==="0"){
                message.destroy();
                message.success("添加成功"); 
                this.props.closeRechargeGroup();
            }else{
                message.destroy();
                message.error(CreateDirectChargeGroup.message);
            }
        }

        // 编辑分组
        if (UpdateDirectChargeGroup && UpdateDirectChargeGroup !== this.props.rechargeStock.UpdateDirectChargeGroup) {
            this.setState({
                isSubmit:false
            })
            if(UpdateDirectChargeGroup.code==="0"){
                message.destroy();
                message.success("编辑成功"); 
                this.props.closeRechargeGroup();
                this.props.getEditnewData()
            }else{
                message.destroy();
                message.error(UpdateDirectChargeGroup.message);
            }
        }

        // 判断直冲库存组下面是否有商品
        if (CheckDirectChargeProduct && CheckDirectChargeProduct !== this.props.rechargeStock.CheckDirectChargeProduct) {
            if(CheckDirectChargeProduct.code==="0"){
              this.setState({
                ishaveProduct:CheckDirectChargeProduct.data
              })
            }else{
                message.destroy();
                message.error(CheckDirectChargeProduct.message);
            }
        }

        
    }

	render() {
        const { getFieldDecorator } = this.props.form;
        const {title} = this.props.params
        const {isSubmit,secondInvoiceTypeList,ishaveProduct } = this.state;
        const formItemLayout = {
            labelCol: {
              span:6
            },
            wrapperCol: {
              span:17
            },
        }
		return (
			<div className="AddIntegral">
                <Modal
                title={title}
                width="600px"
                visible={true}
                onCancel={this.props.closeRechargeGroup}
                footer={
                    <div>
                        <Button key="back" onClick={this.props.closeRechargeGroup}>
                            取消
                        </Button>
                       {(findIndex(window.getAuthButtons(), { enCode: 'lr_recharge_submitGroup' }) !== -1)?<Button key="submit" type="primary" loading={isSubmit} disabled={ishaveProduct} onClick={this.handleSubmit}>
                            保存
                        </Button>:''}
                    </div>
                }
                >
                 <div className="AddIntegralBox">
                    <Form  {...formItemLayout}>
                        <Form.Item style={{marginBottom:"16px"}}   label="分组名称">
                            {getFieldDecorator('groupName', {
                                rules: [
                                    {
                                        required: true,
                                        message: '请输入分组名称',
                                    }
                                ],
                            })(<Input className="formInput" disabled={ishaveProduct} placeholder="请输入分组名称"/>)}
                        </Form.Item>
                        <Form.Item style={{marginBottom:"16px"}}  label="分组类型">
                            {getFieldDecorator('mode', {
                                initialValue:'1',
                                rules: [
                                    {
                                        required: true,
                                        message: '请选择分组类型',
                                    }
                                ],
                            })(
                                <Select  placeholder="请选择分组类型" disabled>
                                    <Select.Option value={'1'} key={'1'}>普通</Select.Option>
                                </Select>
                            )}
                        </Form.Item>
                        <Form.Item style={{marginBottom:"16px"}}  label="库存票据类型">
                            {getFieldDecorator('invoiceType', {
                                rules: [
                                    {
                                        required: true,
                                        message: '请选择库存票据类型',
                                    }
                                ],
                            })(
                                <Select onChange={this.renderSecondInvoiceType} disabled={title=='编辑直充库存组'?true:false} placeholder="请选择库存票据类型">
                                    <Select.Option value="" key="0">--请选择--</Select.Option>
                                    <Select.Option value="0" key="1">寄售</Select.Option>
                                    <Select.Option value="1" key="2">自营</Select.Option>
                                </Select>
                            )}
                        </Form.Item>
                        <Form.Item style={{marginBottom:"16px"}}  label="库存二级票据类型" >
                            {getFieldDecorator('secondInvoiceType', {
                                rules: [
                                    {
                                        required: true,
                                        message: '请选择库存二级票据类型',
                                    }
                                ],
                            })(
                                <Select  placeholder="请选择库存二级票据类型" disabled={title=='编辑直充库存组'?true:false}>
                                    <Select.Option value="" key="">--请选择--</Select.Option>
                                    {
                                        secondInvoiceTypeList&&secondInvoiceTypeList.map((item,i)=>{
                                            return <Select.Option value={item.value} key={i}>{item.label}</Select.Option>
                                        })
                                    }
                                </Select>
                            )}
                        </Form.Item>
                        <Form.Item style={{marginBottom:"16px"}}  label="备注">
                            {getFieldDecorator('remarks', {
                                rules: [
                                    {
                                        required: false,
                                        message: '请输入备注',
                                    }
                                ],
                            })(<TextArea rows={4} className="formInput" disabled={ishaveProduct} placeholder="请输入备注"/>)}
                        </Form.Item>
                    </Form>
                 </div>
               </Modal>   
            </div>
            )
        }
    }

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(createForm()(CreatRechargeGroup));