import React from 'react';
import { connect } from 'dva';
import {Modal,Form,message,Button,Radio,Row,Col} from  "antd";
const { confirm } = Modal;
import { Table } from "fl-pro";
import {withRouter} from "react-router-dom";
import findIndex from 'lodash/findIndex';
import statusText from '../../../../utils/statusText';
import commonFun from '../../../../utils/utils';
import Grouping from './Grouping';
import ComModal from '../../../../components/ComModal'
class RechargeGoodsList extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            showGrouping:false,
            cardGroupList:null,
            fileList:null,
            CheckNegativeProfit:0,
            recordData:null,
            commonParams:null,
            showComModal:false,
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            goodsList:{
                dataSource:[],
                total:0,
            },
            radioValue:1,
            showRadio:false,
            goodsParams:null,
            isSubmit:false,
            recordData:null
        }
    }


    closeGrouping=()=>{
        this.setState({
            showGrouping:false
        })
    }

    deleteRechargeStockGoods=(record)=>{
        const _this = this;
        let postData= {
            id:record.id,
            productId:record.productId,
            productName:record.productName
        }
        confirm({
            title: '提示信息',
            content: '您确定删除吗?',
            okText:"确定",
            cancelText:"取消",
            onOk() {
                _this.props.dispatch({
                    type: 'rechargeStock/DeleteDirectChargeProductPool', 
                    payload: postData
                }); 
            }
        });
    }

    goGrouping=(record)=>{
        this.setState({
            showGrouping:true,
            commonParams:record
        })
    }

    getFormValue=(condition,postData,isrefresh)=>{
        this.setState({
            postData,
        },()=>{
            if(isrefresh){
                this.lookgoods(this.state.recordData)
            }
        })
    }

    
    closeModal=()=>{
        this.setState({
            showComModal:false
        })
    }

    lookgoods=(record)=>{
        this.setState({
            showComModal:true,
            recordData:record
        },()=>{
            this.props.dispatch({
                type: 'rechargeStock/GetFpDirectChargeProduct', 
                payload: {
                    SupProductId:record.productId,
                    ...this.state.postData
                }
            });
        })
    }

    onChangeRadioValue=(e)=>{
        this.setState({
            radioValue:e.target.value
        })
    }


    pushGoods=(record)=>{
        this.setState({
            radioValue:1,
            showRadio:true,
            goodsParams:record
        })
    }

    submitGoods=()=>{
        const { goodsParams,radioValue } = this.state;
        this.setState({
            isSubmit:true
        })
        const params ={
            supProductType:goodsParams.productType,
            supProductId:goodsParams.productId,
            value:radioValue
        }
        console.log(params)
        this.props.dispatch({
            type: 'cardStock/PublishSupProductToProduct', 
            payload: {
                ...params
            }
        });
    }

    cancelGoods=()=>{
        this.setState({
            showRadio:false,
            isSubmit:false
        })
    }


    componentWillReceiveProps(nextProps){
        const { DeleteDirectChargeProductPool,GetFpDirectChargeProduct } = nextProps.rechargeStock;
        const { PublishSupProductToProduct } = nextProps.cardStock;
        if (DeleteDirectChargeProductPool && DeleteDirectChargeProductPool !== this.props.rechargeStock.DeleteDirectChargeProductPool) {
            if(DeleteDirectChargeProductPool.code==="0"){
                message.destroy();
                message.success("删除成功")
                this.props.getnewData('1')
            }else{
                message.destroy();
                message.warning(DeleteDirectChargeProductPool.message);
            }
        }

        if (GetFpDirectChargeProduct && GetFpDirectChargeProduct !== this.props.rechargeStock.GetFpDirectChargeProduct) {
            if(GetFpDirectChargeProduct.code==="0"){
                this.state.goodsList.dataSource=GetFpDirectChargeProduct.data.list;
                this.state.goodsList.total = GetFpDirectChargeProduct.data.total
                this.setState({
                    goodsList:this.state.goodsList
                })
            }else{
                message.destroy();
                message.warning(GetFpDirectChargeProduct.message);
            }
        }

        if (PublishSupProductToProduct && PublishSupProductToProduct !== this.props.cardStock.PublishSupProductToProduct) {
            this.setState({
                isSubmit:false
            })
            if(PublishSupProductToProduct.code==="0"){
                this.setState({
                    showRadio:false
                })
                message.destroy();
                message.success("发布成功")
                this.props.getnewData('1')
            }else{
                message.destroy();
                message.warning(PublishSupProductToProduct.message);
            }
        }
        
        
    }

	render() {
        const {dataResource,postData,total} =  this.props
        const {showGrouping,cardGroupList,showComModal,showRadio,isSubmit} =this.state;
        let columns = [
            {
                key:"1",
                title: '供货商名称',
                width:150,
                align: 'left',
                dataIndex: 'supMemberName',
            }, 
            {
                key:"2",
                title: '商户号',
                width:150,
                align: 'left',
                dataIndex:"memberCode",
            },
            {
                key:"3",
                title: '商品编号',
                width:150,
                align: 'left',
                dataIndex:"productId",
            },
            {
                key:"4",
                title: '商品名称',
                width:200,
                align: 'left',
                dataIndex:"productName",
            },
            {
                key:"5",
                title: '商品类型',
                align: 'left',
                dataIndex:"productType",
            },
            {
                key:"6",
                title: '进货价(元)',
                align: 'right',
                dataIndex:"price",
                render:(text,record)=>{
                    return commonFun.toDecimal4(text)
                }
            },
            {
                key:"7",
                title: '面值(元)',
                align: 'right',
                dataIndex:"faceValue",
                render:(text,record)=>{
                    return commonFun.toDecimal4(text)
                }
            },
            {
                key:"8",
                title: '库存状态',
                align: 'left',
                dataIndex:"stockStatus",
                render:(text,record)=>{
                    return statusText.KmStockStatus[text]
                }
            },
            {
                key:"9",
                title: '销售状态',
                align: 'left',
                dataIndex:"salesStatus",
                render:(text,record)=>{
                    return statusText.KmSaleStatus[text]
                }
            },
            {
                key:"10",
                title: '创建时间',
                align: 'left',
                dataIndex:"createdTime",
            },
            {
                key:"11",
                title: '操作',
                width:100,
                align: 'left',
                fixed: 'right',
                render:(text,record)=>{
                    return <div className="ibox" style={{color:"#4b9ae0",fontSize:'16px'}}>
                        {/* {(findIndex(window.getAuthButtons(), { enCode: 'lr_recharge_grouping' }) !== -1)?<i className="fa fa-object-group"  style={{fontSize:'13px',marginRight:"5px",color:'#5a5a59',cursor:"pointer"}}  title="关联商品信息" onClick={()=>{
                            this.goGrouping(record)
                        }}></i>:''} */}
                        {/* {<i className="fa fa-trash-o fa-lg" style={{cursor:"pointer",marginRight:"5px",color:'#5a5a59',fontSize:'13px'}}   title="删除" onClick={()=>{this.deleteRechargeStockGoods(record)}}></i>} */}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_recharge_goodsmsg' }) !== -1)?<i className="iconfont" style={{cursor:'pointer',fontSize:'16px',marginRight:'14px'}} title="关联商品信息" onClick={()=>{this.lookgoods(record)}}>&#xe611;</i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_recharge_fabu' }) !== -1)?<i style={{cursor:'pointer',fontSize:'16px'}} title="一键发布"  className="iconfont" onClick={()=>{this.pushGoods(record)}}>&#xe615;</i>:''}
                    </div>
                }
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData&&postData.PageSize,
            current: postData&&postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.props.searchPagination(postData);
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.props.searchPagination(postData);
                })
            },
        };
		return (
			<div className="GoodsGroup">
                <div style={{width:'100%'}}>
                    <div className="GoodsGroup-containter">
                        <Table 
                            columns={columns}
                            dataSource={dataResource?dataResource:[]}
                            pagination={pagination}
                            scroll={{x:1600}}
                        />
                    </div>
                    {showComModal?<ComModal name='looktoRechargeGoods'  getFormValue={this.getFormValue} closeModal={this.closeModal}  dataResource={this.state.goodsList}/>:''}    
                    {
                        showGrouping&&
                        <Modal
                        width="1000px"
                        title="所属分组"
                        visible={true}
                        onCancel={this.closeGrouping}
                        footer={null}
                        className="addCommodityModal"
                        >
                            <Grouping handleAddCancel={this.closeGrouping} commonParams ={this.state.commonParams}/>
                        </Modal>  
                    }
                   {showRadio?<Modal
                        width="500px"
                        title="一键发布"
                        visible={true}
                        onCancel={this.cancelGoods}
                        footer={
                            <div>
                                <Button key="back" onClick={this.cancelGoods}>
                                    取消
                                </Button>
                                <Button key="submit" loading={isSubmit} type="primary" onClick={this.submitGoods}>
                                    一键发布
                                </Button>
                            </div>
                        }>
                        <Row style={{marginBottom:'20px'}}>
                            是否将此货源发布到商品列表？
                        </Row>
                        <Row  >
                            <Col span={4}>
                                商品状态：
                            </Col>
                            <Col span={20}>
                                <Radio.Group onChange={this.onChangeRadioValue} value={this.state.radioValue}>
                                    <Radio value={2}>上架</Radio>
                                    <Radio value={1}>下架</Radio>
                                </Radio.Group>
                            </Col>
                        </Row>
                    </Modal>:''}      
                </div>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(withRouter(RechargeGoodsList)));