import React from 'react';
import { connect } from 'dva';
import {Form,Input,message,Row,Col,Button} from  "antd";
import './less/InitiateLocks.less';
import BreadCrumb from '../../../../components/Breadcrumb';
import {WangEditor} from 'fl-pro';
import CommonModal from '../../../../components/CommonModal'; 
class InitiateLocks extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            total:0,
            editorContent:'',
            showModal:false,
            params:null,
            MethantselectData:[],
            MethantselectedRowKeys:[],
            type:'',
            supgoodselectData:[],
            goodselectedRowKeys:[],
            goodselectData:[],
            supselectedRowKeys:[],
            isSubmit:false
        }
	}


    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            if(this.state.type==="supGoods"){
                this.GetInventoryProductList()
            }else if(this.state.type==="merchants"){
                this.getMerchantsList()
            }else if(this.state.type==="goods"){
                this.getInventoryGroupsList()
            }
        });
    }

    // 查询
    searchFun  = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            if(this.state.type==="supGoods"){
                this.GetInventoryProductList()
            }else if(this.state.type==="merchants"){
                this.getMerchantsList()
            }else if(this.state.type==="goods"){
                this.getInventoryGroupsList()
            }
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 分页查询
    searchPagination= (postData)=> {
        const {condition,type } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            if(type==="supGoods"){
                this.GetInventoryProductList()
            }else if(type==="merchants"){
                this.getMerchantsList()
            }else if(this.state.type==="goods"){
                this.getInventoryGroupsList()
            }
        });
    }

    //获取进货商列表
    getMerchantsList=()=>{
        const {postData,condition} = this.state;
        this.props.dispatch({
            type: 'activity/GetActivityApplyMemberList', 
            payload: {
                ...postData,
                ...condition
            } 
        });
    }

    // 库存锁定选择商品
    GetInventoryProductList=()=>{
        const {postData,condition} = this.state;
        this.props.dispatch({
            type: 'stock/GetInventoryProductList', 
            payload: {
                ...postData,
                ...condition
            } 
        });
    }

     // 根据ID获取商品库存组商品信息列表
     getInventoryGroupsList=(record)=>{
        this.setState({
            goodselectData:[record],
            supselectedRowKeys:[record.id]
        },()=>{
            this.props.dispatch({
                type: 'goods/GetInventoryGroupsList',
                payload: {
                    id:record.id
                }
            });
        })
    }

    handleSupGoods=()=>{
        let params={
            width:1000,
            zIndex:10010,
            title:'选择供货商品',
            FormName:null,
            url:'goods/GetInventoryGroupsList',
            tableData:{
                type:2,
                rowKey:"supProductId",
                dataResource:this.state.params.tableData.dataResource,
                total:0,
                columns:[
                    {
                        key:"1",
                        title: '商品编号',
                        align: 'left',
                        dataIndex:"supProductId",
                    },
                    {
                        key:"2",
                        title: '商品名称',
                        align: 'left',
                        dataIndex:"supProductName",
                    },
                    {
                        key:"3",
                        title: '供货价格',
                        align: 'left',
                        dataIndex:"supProductPrice",
                    },
                    {
                        key:"4",
                        title: '剩余库存量',
                        align: 'left',
                        dataIndex:"remainingStockNum",
                    },
                    {
                        key:"6",
                        title: '销售状态',
                        align: 'left',
                        dataIndex:"supProductSaleStatus",
                        render:(text)=>{
                            if(text==0){
                                return '下架'
                            }else if(text==1){
                                return '上架'
                            }else{
                                return ''
                            }
                        }
                    }
                ]
            }
        }
        this.setState({
            showModal:true,
            params,
            type:"goods"
        })
    }

    changeEditorContent=(data)=>{
        this.setState({
            editorContent:data
        })
    }

    chooseMerchants=()=>{
        const {total,postData,MethantselectData } = this.state;
        let params={
            width:1200,
            title:'选择商户',
            zIndex:10010,
            FormName:'stockMechants',
            url:'activity/GetActivityApplyMemberList',
            tableData:{
                type:2,
                rowKey:"memberId",
                checkList:MethantselectData,
                dataResource:[],
                total,
                columns:[
                    {
                        key:"1",
                        title: '商户编号',
                        align: 'left',
                        dataIndex:"memberCode",
                    },
                    {
                        key:"2",
                        title: '商户名称',
                        align: 'left',
                        dataIndex:"memberName",
                    },
                    {
                        key:"3",
                        title: '主体名称',
                        align: 'left',
                        dataIndex:"memberAuthenticationName",
                    },
                    {
                        key:"4",
                        title: '商户类型',
                        align: 'left',
                        dataIndex:"memberType",
                        render:(text)=>{
                            if(text==1){
                                return '内部'
                            }else if(text==2){
                                return '外部'
                            }else{
                                return ''
                            }
                        }
                    }
                ]
            }
        }
        this.setState({
            showModal:true,
            params,
            type:"merchants"
        },()=>{
            this.getMerchantsList() 
        })
    }

    closeCommonModal=()=>{
        const { type } = this.state
        if(type=="goods"||type=="supGoods"){
            this.setState({
                showModal:false,
                supgoodselectData:[],
                goodselectedRowKeys:[],
                goodselectData:[],
                supselectedRowKeys:[]
            })  
        }else if(type=="merchants"){
            this.setState({
                showModal:false,
                MethantselectData:[],
                MethantselectedRowKeys:[],
            })  
        }
    }

    submitCommonModal=(MethantselectData,MethantselectedRowKeys)=>{
        const {type} = this.state;
        if(!MethantselectData||MethantselectData.length<=0){
            if(type=="goods"){
                message.destroy();
                message.warning("请选择供货商品")
            }else if(type=="merchants"){
                message.destroy();
                message.warning("请选择商户")
            }else{
                this.setState({
                    showModal:false,
                })
            }
            return false;
        }
        if(type=="goods"){
            this.setState({
                showModal:false,
                supgoodselectData:MethantselectData,
                goodselectedRowKeys:MethantselectedRowKeys,
            })

        }else if(type=="merchants"){
            this.setState({
                showModal:false,
                MethantselectData,
                MethantselectedRowKeys
            })
        }else {
            this.setState({
                showModal:false,
            })
        }
    }

    // 选择商品
    chooseGoods=()=>{
        let params={
            width:1200,
            title:'选择平台商品',
            zIndex:10010,
            FormName:'stockgoods',
            url:'stock/GetInventoryProductList',
            tableData:{
                type:0,
                rowKey:"id",
                dataResource:[],
                total:0,
                columns:[
                    {
                        key:"1",
                        title: '商品编号',
                        align: 'left',
                        dataIndex:"id",
                    },
                    {
                        key:"2",
                        title: '商品名称',
                        align: 'left',
                        dataIndex:"productName",
                        width:300
                    },
                    {
                        key:"3",
                        title: '面值(元)',
                        align: 'left',
                        dataIndex:"faceValue",
                    },
                    {
                        key:"4",
                        title: '销售状态',
                        align: 'left',
                        dataIndex:"saleStatus",
                        render:(text)=>{
                            if(text==1){
                                return '下架'
                            }else if(text==2){
                                return '上架'
                            }else if(text==3){
                                return '官方维护'
                            }else if(text==4){
                                return '库存维护'
                            }else{
                                return ''
                            }
                        }
                    },
                    {
                        key:"5",
                        title: '库存状态',
                        align: 'left',
                        dataIndex:"stockStatus",
                        render:(text)=>{
                            if(text==1){
                                return '断货'
                            }else if(text==2){
                                return '警报'
                            }else if(text==3){
                                return '充足'
                            }else{
                                return ''
                            }
                        }
                    },
                    {
                        key:"6",
                        title: '票据类型',
                        align: 'left',
                        dataIndex:"invoiceType",
                        render:(text)=>{
                            if(text==1){
                                return '自营'
                            }else if(text==0){
                                return '寄售'
                            }else{
                                return ''
                            }
                        }
                    },
                    {
                        key:"7",
                        title: '二级票据类型',
                        align: 'left',
                        dataIndex:"secondInvoiceType",
                        render:(text,record)=>{
                            if (record.secondInvoiceType === "0" || record.secondInvoiceType === 0) {
                                return  "无票";
                            } else if (record.secondInvoiceType == 1) {
                                return record.invoiceRate*100 + "%普票";
                            } else if (record.secondInvoiceType == 2) {
                                return record.invoiceRate*100 + "%专票";
                            } else {
                                return "";
                            }
                        }
                    },
                    {
                        key:"8",
                        title: '操作',
                        align: 'center',
                        width:100,
                        render:(text,record)=>{
                            return <i  className="iconfont" style={{cursor:'pointer',fontSize:'16px',color:"#4b9ae0"}}  title="查看供货商品" onClick={()=>{this.getInventoryGroupsList(record)}}>&#xe611;</i>
                        }
                    }
                ]
            }
        }
        this.setState({
            showModal:true,
            params,
            type:"supGoods"
        },()=>{
            this.GetInventoryProductList()
        })
    }

    renderProductType=(goodselectData)=>{
        if(goodselectData&&goodselectData[0]&&goodselectData[0].productType){
            if(goodselectData[0].productType==3){
                return "卡密"
            }else if(goodselectData[0].productType==4){
                return "直充"
            }else{
                return ''
            }
        }else{
            return ''
        }
    }

    handleSubmit=()=>{
        const { MethantselectData,supgoodselectData,goodselectData,editorContent } = this.state;
        const _this = this;
        this.setState({
            isSubmit:true
        })
        if(!MethantselectData||MethantselectData.length<=0){
            message.destroy()
            message.warning("请选择商户")
            this.setState({
                isSubmit:false
            })
            return false
        }
        if(!supgoodselectData||supgoodselectData.length<=0){
            message.destroy()
            message.warning(" 请选择供货商品")
            this.setState({
                isSubmit:false
            })
            return false
        }

        if(!goodselectData||goodselectData.length<=0){
            message.destroy()
            message.warning("请选择平台商品")
            this.setState({
                isSubmit:false
            })
            return false
        }
        let postData = {
            memberId:MethantselectData[0].memberId,
            memberName: MethantselectData[0].memberName,
            memberCode: MethantselectData[0].memberCode,
            supProductName: supgoodselectData[0].supProductName,
            supProductId: supgoodselectData[0].supProductId,
            productName:goodselectData[0].productName,
            productCode: goodselectData[0].productCode,
            productId: goodselectData[0].id,
            faceValue:goodselectData[0].faceValue,
            productType: goodselectData[0].productType,
            reMark: editorContent,
        }
        
        _this.props.form.validateFields((err, value) => {
            if(!err){
                _this.props.dispatch({
                    type: 'stock/AddStockLockApply', 
                    payload: {
                        ...postData,
                        applyCount: value.applyCount,
                    } 
                });
            }else{
                this.setState({
                    isSubmit:false
                })
            }
        });
    }

    componentWillReceiveProps(nextProps) {
        const { params } = this.state;
        const { GetActivityApplyMemberList } = nextProps.activity;
        const { GetInventoryProductList,AddStockLockApply } = nextProps.stock;
        const { GetInventoryGroupsList } = nextProps.goods;
        
        // 获取进货商列表  
        if (GetActivityApplyMemberList && GetActivityApplyMemberList !== this.props.activity.GetActivityApplyMemberList) {
            if(GetActivityApplyMemberList.code==="0"){
                params.tableData.dataResource = GetActivityApplyMemberList.data&&GetActivityApplyMemberList.data.list||[]
                this.setState({
                    params
                }) 
            }else{
                message.destroy();
                message.warning(GetActivityApplyMemberList.message);
            }
        } 

        // 库存锁定选择商品  
        if (GetInventoryProductList && GetInventoryProductList !== this.props.stock.GetInventoryProductList) {
            if(GetInventoryProductList.code==="0"){
                params.tableData.dataResource = GetInventoryProductList.data&&GetInventoryProductList.data.list||[];
                params.tableData.total = GetInventoryProductList.data&&GetInventoryProductList.data.total
                this.setState({
                    params,
                }) 
            }else{
                message.destroy();
                message.warning(GetInventoryProductList.message);
            }
        }

        // 根据ID获取商品库存组商品信息列表  
        if (GetInventoryGroupsList && GetInventoryGroupsList !== this.props.goods.GetInventoryGroupsList) {
            if(GetInventoryGroupsList.code==="0"){
                params.tableData.dataResource = GetInventoryGroupsList.data&&GetInventoryGroupsList.data.poolProductList||[];
                this.setState({
                    params
                },()=>{
                    this.handleSupGoods()
                }) 
            }else{
                message.destroy();
                message.warning(GetInventoryGroupsList.message);
            }
        }

         // 添加库存锁定  
         if (AddStockLockApply && AddStockLockApply !== this.props.stock.AddStockLockApply) {
            if(AddStockLockApply.code==="0"){
                message.destroy();
                message.success("添加成功");
                this.props.history.push("/tagmanage/treasury/locks")
                this.setState({
                    isSubmit:false
                })
            }else{
                message.destroy();
                message.warning(AddStockLockApply.message);
                this.setState({
                    isSubmit:false
                })
            }
        }  
    }

    validFunction = (rule, value, callback) => {
        let patter = /^[1-9]\d*$/;
        if(value){
            if(!patter.test(Number(value))){
                callback("请输入正整数");
                return;
            }else{
                if(value>50000){
                    callback("锁定数量不能超过50000");
                    return;
                }
            }
        }else{
            callback("请输入锁定数量");
            return;
        }
        callback();
    }


	render() {
        const {loading} = this.props;
        const { getFieldDecorator } = this.props.form;
        const {editorContent,showModal,params,MethantselectData,supgoodselectData,goodselectData,isSubmit} = this.state;
        const breadcrumbList = [
            {
                name:"运营管理",
                href:""
            },
            {
                name:"库存锁定",
                href:"/tagmanage/treasury/locks"
            },
            {
                name:"发起库存锁定",
                href:""
            }
        ];
        const formItemLayout = {
            labelCol: {
              span:4
            },
            wrapperCol: {
              span:7
            },
        }
        const formItemLayout1 = {
            labelCol: {
              span:3
            },
            wrapperCol: {
              span:21
            },
        }
		return (
			<div className="InitiateLocks">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="InitiateLocks-containter">
                    <Row style={{marginBottom:'16px'}}>
                        <Col  span={4} className="ant-form-item-label">
                            <label className="ant-form-item-required" title="选择商户">选择商户</label>
                        </Col>
                        <Col span={11} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                {
                                MethantselectData&&MethantselectData.length>0&&MethantselectData.map((item)=>{
                                    return <span className="balance">{item.memberName}</span>})
                                }
                            </div>
                        </Col>
                        <Col  span={9}>
                            <Button onClick={this.chooseMerchants}>添加/重选</Button>
                        </Col>
                    </Row>
                    <Row style={{marginBottom:'16px'}}>
                        <Col  span={4} className="ant-form-item-label">
                            <label className="ant-form-item-required" title="商品编号">商品编号</label>
                        </Col>
                        <Col span={2} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <span className="balance">{goodselectData&&goodselectData[0]&&goodselectData[0].id?goodselectData[0].id:''}</span>
                            </div>
                        </Col>
                        <Col  span={4} className="ant-form-item-label">
                            <label  title="商品名称">商品名称</label>
                        </Col>
                        <Col span={5} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <span className="balance productName" title={goodselectData&&goodselectData[0]&&goodselectData[0].productName?goodselectData[0].productName:''}>
                                {goodselectData&&goodselectData[0]&&goodselectData[0].productName?goodselectData[0].productName:''}
                                </span>
                            </div>
                        </Col>
                        <Col  span={8}>
                            <Button onClick={this.chooseGoods}>添加/重选</Button>
                        </Col>
                    </Row>
                    <Row style={{marginBottom:'16px'}}>
                        <Col  span={4} className="ant-form-item-label">
                            <label  title="供货商品编号">供货商品编号</label>
                        </Col>
                        <Col span={2} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <span className="balance">{supgoodselectData&&supgoodselectData[0]&&supgoodselectData[0].supProductId?supgoodselectData[0].supProductId:''}</span>
                            </div>
                        </Col>
                        <Col  span={4} className="ant-form-item-label">
                            <label  title="供货商品名称">供货商品名称</label>
                        </Col>
                        <Col span={8} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <span className="balance">
                                    {supgoodselectData&&supgoodselectData[0]&&supgoodselectData[0].supProductName?supgoodselectData[0].supProductName:''}
                                </span>
                            </div>
                        </Col>
                    </Row>
                    <Row style={{marginBottom:'16px'}}>
                        <Col  span={4} className="ant-form-item-label">
                            <label  title="商品属性">商品属性</label>
                        </Col>
                        <Col span={2} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <span className="balance">{
                                    this.renderProductType(goodselectData)
                                }</span>
                            </div>
                        </Col>
                        <Col  span={4} className="ant-form-item-label">
                            <label  title="面值">面值</label>
                        </Col>
                        <Col span={2} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <span className="balance">
                                    {goodselectData&&goodselectData[0]&&goodselectData[0].faceValue?goodselectData[0].faceValue:''}
                                </span>
                            </div>
                        </Col>
                    </Row>
                    <Row style={{marginBottom:'16px'}}>
                        <Col  span={24}>
                            <Form.Item {...formItemLayout}  label="锁定数量：">
                                {getFieldDecorator('applyCount', {
                                    initialValue:'',
                                    rules: [
                                        {
                                            validator: this.validFunction
                                        }
                                    ],
                                })(
                                    <Input className="formInput" placeholder="请输入锁定数量"/>
                                )}
                            </Form.Item>
                        </Col>
                    </Row>
                    <Row style={{marginTop:'10px'}}>
                        <Col  span={4} className="ant-form-item-label">
                            <label title="备注">备注</label>
                        </Col>
                        <Col span={4} className="ant-form-item-control-wrapper">
                            <div className="ant-form-item-control">
                                <WangEditor
                                width={800}
                                changeEditorContent={this.changeEditorContent}
                                editorContent={editorContent}
                                // uploadImgServer={'http://it.console.service.api-admin.suuyuu.cn/api/FileUpload/Upload'}
                                menus={[
                                    'head',  // 标题
                                    'bold',  // 粗体
                                    'fontSize',  // 字号
                                    'fontName',  // 字体
                                    'italic',  // 斜体
                                    'underline',  // 下划线
                                    'strikeThrough',  // 删除线
                                    'foreColor',  // 文字颜色
                                    'backColor',  // 背景颜色
                                    'link',  // 插入链接
                                    'list',  // 列表
                                    'justify',  // 对齐方式
                                    'quote',  // 引用
                                    'emoticon',  // 表情
                                    'image',  // 插入图片
                                    'table',  // 表格
                                    'video',  // 插入视频
                                    'code',  // 插入代码
                                    'undo',  // 撤销
                                    'redo'  // 重复
                                    ]}
                                />
                            </div>
                        </Col>
                    </Row>
                    <Row style={{marginTop:'20px'}}>
                        <Col span={14}>
                        </Col>
                        <Col span={4}>
                            <Button style={{marginLeft:'10px'}} size="large" className="btncancel" onClick={()=>{this.props.history.push("/tagmanage/treasury/locks")}}>取消</Button>
                            <Button style={{marginLeft:'10px'}} size="large" loading={isSubmit} type="primary" className="btnok" onClick={this.handleSubmit} >提交</Button>
                        </Col>
                    </Row>
                </div>  
                {showModal?<CommonModal params={params} init={this.init} searchFun={this.searchFun} searchPagination={this.searchPagination} getFormData={this.getFormData} closeModal={this.closeCommonModal} submitData={this.submitCommonModal} />:''}
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(InitiateLocks));