import React, { Component } from 'react';
import { connect } from 'dva';
import {message,Form,Row,Col,Modal} from 'antd';
import {WangEditor} from 'fl-pro' 
import './less/ReleaseTreasury.less';
class ReleaseTreasury extends Component {
    constructor(props) {
        super(props);
        this.state = {
            editorContent:''
        }
    }
    
    changeEditorContent=(data)=>{
        this.setState({
            editorContent:data
        })
    }
    

    confirmData=()=>{
        this.props.dispatch({
            type: 'stock/ReleaseStockLockApply',
            payload: {
                reMark:this.state.editorContent,
                id:this.props.releaseTreasuryData.id
            }
        });
    }

    componentWillReceiveProps(nextProps){
        const { ReleaseStockLockApply} = nextProps.stock;
        if (ReleaseStockLockApply && ReleaseStockLockApply !== this.props.stock.ReleaseStockLockApply) {
            if(ReleaseStockLockApply.code==="0"){
                message.destroy();
                message.success("锁定库存释放成功")
                this.props.closeReleaseTreasury()
            }else{
                message.destroy();
                message.warning(ReleaseStockLockApply.message);
            }
        }

    }


    render() {
        const {editorContent} = this.state
        const formItemLayout = {
            labelCol: {
              span:4
            },
            wrapperCol: {
              span:10
            },
        }
        return(
            <Modal
                className="ReleaseTreasury"
                width="700px"
                title="释放库存"
                okText="确定"
                cancelText="取消"
                visible={true}
                onCancel={
                    this.props.closeReleaseTreasury
                }
                onOk={
                    this.confirmData
                }
                >
                <Row style={{marginTop:'10px'}}>
                    <Col span={24}>
                        <Form.Item {...formItemLayout}  label="申请说明">
                            <WangEditor
                                width={500}
                                changeEditorContent={this.changeEditorContent}
                                editorContent={editorContent}
                                menus={[
                                    'head',  // 标题
                                    'bold',  // 粗体
                                    'fontSize',  // 字号
                                    'fontName',  // 字体
                                    'italic',  // 斜体
                                    'underline',  // 下划线
                                    'strikeThrough',  // 删除线
                                    'foreColor',  // 文字颜色
                                    'backColor',  // 背景颜色
                                    'link',  // 插入链接
                                    'list',  // 列表
                                    'justify',  // 对齐方式
                                    ]
                                }
                            />
                        </Form.Item>
                    </Col>
                </Row>
            </Modal>
        )
    }
}
export default connect(state => ({ ...state }))(Form.create()(ReleaseTreasury));


