import React from 'react';
import { connect } from 'dva';
import {Spin,Form,message,Button} from  "antd";
import { Table } from 'fl-pro';
import moment from 'moment';
import './less/TreasuryLocks.less';
import BreadCrumb from '../../../../components/Breadcrumb';
import SearchForm from '../../../../components/SearchForm';
import findIndex from 'lodash/findIndex';
import AddTreasury from '../AddTreasury'
import ReleaseTreasury from '../ReleaseTreasury';
class TreasuryLocks extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            treasuryLocksList:[],
            total:0,
            showAddTreasury:false,
            showReleaseTreasury:false,
            addTreasuryData:null,
            releaseTreasuryData:null
        }
	}

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.GetStockLockApplyList()
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetStockLockApplyList()
        });
    }

    getFormData=(params)=>{
        params.StartDate =params.lockTime&&params.lockTime[0]? moment(params.lockTime[0]).format('YYYY-MM-DD HH:mm:ss') : '';
        params.EndDate =params.lockTime&&params.lockTime[1]? moment(params.lockTime[1]).format('YYYY-MM-DD HH:mm:ss') : '';
        this.setState({
          condition: params,
        })
    }

    // 库存分页列表查询
    GetStockLockApplyList = ()=>{
        const {postData,condition} =this.state;
        this.props.dispatch({
            type: 'stock/GetStockLockApplyList', 
            payload: {
                ...postData,
                ...condition,
            } 
        });
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetStockLockApplyList()
        });
    }
    
    setAddTreasury=(record)=>{
        this.setState({
            showAddTreasury:true,
            addTreasuryData:record
        })
    }

    closeAddTreasury=()=>{
        this.setState({
            showAddTreasury:false
        })
    }

    setReleaseTreasury=(record)=>{
        this.setState({
            showReleaseTreasury:true,
            releaseTreasuryData:record
        })
    }

    closeReleaseTreasury=()=>{
        this.setState({
            showReleaseTreasury:false
        })
    }

    handleLook=(record)=>{
        this.props.history.push("/tagmanage/treasury/locks/detail?id="+record.id)
        sessionStorage.setItem("lockDetail",JSON.stringify(record))
    }

    initateLock=()=>{
        this.props.history.push("/tagmanage/treasury/locks/initiate")
    }

	componentWillReceiveProps(nextProps) {
        const {GetStockLockApplyList} = nextProps.stock;
        if (GetStockLockApplyList && GetStockLockApplyList !== this.props.stock.GetStockLockApplyList) {
            if(GetStockLockApplyList.code==="0"){
                this.setState({
                    treasuryLocksList:GetStockLockApplyList.data?GetStockLockApplyList.data.list:[],
                    total:GetStockLockApplyList.data?GetStockLockApplyList.data.total:0
                })           
            }else{
                message.destroy();
                message.error(GetStockLockApplyList.message);
            }
        }
    }

	render() {
        const {loading} = this.props;
        const {total,postData,treasuryLocksList,showAddTreasury,showReleaseTreasury,addTreasuryData,releaseTreasuryData  } = this.state;
        const breadcrumbList = [
            {
                name:"运营管理",
                href:""
            },
            {
                name:"库存锁定",
                href:""
            }
        ];
        let columns = [
            {
                key:"1",
                title: '主申请单号',
                align: 'left',
                dataIndex:"id",
                width:200,
                fixed:'left'
            },
            {
                key:"2",
                title: '商户编号',
                align: 'left',
                dataIndex:"memberCode",
            },
            {
                key:"3",
                title: '商户名称',
                align: 'left',
                dataIndex:"memberName",
                width:250
            },
            {
                key:"4",
                title: '商品编号',
                align: 'left',
                dataIndex:"productId",
            },
            {
                key:"5",
                title: '商品名称',
                align: 'left',
                dataIndex:"productName",
                width:380
            },
            {
                key:"6",
                title: '面值',
                align: 'left',
                dataIndex:"faceValue",
            },
            {
                key:"7",
                title: '商品属性',
                align: 'left',
                dataIndex:"productType",
                render:(text,record)=>{
                    if(text==3){
                        return "卡密"
                    }else if(text==4){
                        return "直充"
                    }else{
                        return ""
                    }
                }
            },
            {
                key:"8",
                title: '申请数量',
                align: 'left',
                dataIndex:"applyCount",
            },
            {
                
                key:"9",
                title: '消耗数量',
                align: 'left',
                dataIndex:"consumeNumber",
            }, {
                key:"10",
                title: '释放数量',
                align: 'left',
                dataIndex:"releaseCount",
            }, {
                key:"11",
                title: '剩余锁定',
                align: 'left',
                dataIndex:"remainNumber",
            }, {
                key:"12",
                title: '审批状态',
                align: 'left',
                dataIndex:"approvalStatus",
                render:(text,record)=>{
                    if(text==1){
                        return "待审核"
                    }else if(text==2){
                        return "已通过"
                    }else if(text==3){
                        return "未通过"
                    }else{
                        return ""
                    }
                }
            },
            {
                key:"13",
                title: '锁定开始时间',
                align: 'left',
                dataIndex:"lockTime",
                width:200
            },
            {
                key:"14",
                title: '库存释放时间',
                align: 'left',
                dataIndex:"releaseTime",
                width:200
            },

            {
                key:"15",
                title: '操作',
                width:120,
                align: 'left',
                fixed: 'right',
                render:(text,record)=>{
                    return <div style={{color:"#4b9ae0"}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_lock_detail' }) !== -1)?<i  className="iconfont" style={{cursor:'pointer',fontSize:'16px',marginRight:'14px'}}  title="详情" onClick={()=>{this.handleLook(record)}}>&#xe611;</i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_lock_add' }) !== -1)&&record.approvalStatus==2&&record.remainNumber>0?<i  style={{cursor:"pointer",fontSize:'16px',marginRight:'14px'}} className="iconfont"   title="补充" onClick={()=>{this.setAddTreasury(record)}}>&#xe610;</i>:''}
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_lock_release' }) !== -1)&&record.approvalStatus==2&&record.remainNumber>0?<i  style={{cursor:"pointer",fontSize:'16px',marginRight:'14px'}} className="iconfont"   title="释放" onClick={()=>{this.setReleaseTreasury(record)}}>&#xe613;</i>:''}
                        
                    </div>
                }
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            PageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, PageSize) => {
                postData.PageIndex=1;
                postData.PageSize=PageSize;
                Object.assign(postData, { PageSize: PageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };
		return (
			<div className="treasuryLocks">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="treasuryLocks-containter">
                    <Spin spinning={loading.effects['stock/GetStockLockApplyList']}>
                        <SearchForm name="treasuryLocks"
                            init={this.init} 
                            search={this.search} 
                            getFormData={this.getFormData} 
                        />
                        <div style={{textAlign:"right",marginBottom:"10px"}}>
                            {(findIndex(window.getAuthButtons(), { enCode: 'lr_lock_initiate' }) !== -1)?<Button type="primary"  className="setRole"  onClick={()=>{this.initateLock()}}>
                                发起
                            </Button>:''}
                        </div>
                        <Table 
                            columns={columns}
                            dataSource={treasuryLocksList?treasuryLocksList:[]}
                            pagination={pagination}
                            scroll={{y:window.innerHeight - 450,x:2200}}
                        />
                    </Spin>
                </div>  
                {
                    showAddTreasury?<AddTreasury closeAddTreasury={this.closeAddTreasury} addTreasuryData={addTreasuryData}/>:''
                }

                {
                    showReleaseTreasury?<ReleaseTreasury closeReleaseTreasury={this.closeReleaseTreasury} releaseTreasuryData={releaseTreasuryData}/>:''
                }
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(TreasuryLocks));