import React from 'react';
import { connect } from 'dva';
import {Spin,Form,Row,Col,message,Modal } from  "antd";
import { Table } from 'fl-pro';
import './less/TreasuryLocksDetail.less';
import BreadCrumb from '../../../../components/Breadcrumb';
import commonFun from '../../../../utils/utils';
class TreasuryLocksDetail extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            postData:{
                pageIndex: 1,
                pageSize: 10,
            },
            treasuryLocksList:[],
            total:0,
            id:commonFun.GetQueryString(location.search.split('?')[1], "id"),
            detailData:null,
            showDetail:false,
            lockDetailData:sessionStorage.getItem("lockDetail")?JSON.parse(sessionStorage.getItem("lockDetail")):'',
        }
	}

    componentDidMount (){
        this.GetStockLockApplyDetailList()
    }

    // 库存详情列表查询
    GetStockLockApplyDetailList = ()=>{
        const {id,postData } =this.state;
        this.props.dispatch({
            type: 'stock/GetStockLockApplyDetailList', 
            payload: {
               Id:id,
               ...postData
            } 
        });
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData } = this.state;
        this.setState({ 
            postData 
        },() => {
            this.GetStockLockApplyDetailList()
        });
    }

    lookdetail=(text)=>{
        this.setState({
            detailData:text,
            showDetail:true
        })
    }

    comfirmDetal=()=>{
        this.setState({
            showDetail:false
        })
    }
    
	componentWillReceiveProps(nextProps) {
        const { GetStockLockApplyDetailList } = nextProps.stock
        if (GetStockLockApplyDetailList && GetStockLockApplyDetailList !== this.props.stock.GetStockLockApplyDetailList) {
            if(GetStockLockApplyDetailList.code==="0"){
                this.setState({
                    treasuryLocksList:GetStockLockApplyDetailList.data?GetStockLockApplyDetailList.data.list:[],
                    total:GetStockLockApplyDetailList.data?GetStockLockApplyDetailList.data.total:0
                })           
            }else{
                message.destroy();
                message.error(GetStockLockApplyDetailList.message);
            }
        }
    }

	render() {
        const {loading} = this.props;
        const {total,postData,treasuryLocksList,detailData,showDetail,lockDetailData } = this.state;
        const breadcrumbList = [
            {
                name:"运营管理",
                href:""
            },
            {
                name:"库存锁定",
                href:"/tagmanage/treasury/locks"
            },
            {
                name:"库存锁定详情",
                href:""
            }
        ];
        let columns = [
            {
                key:"1",
                title:  '申请单号',
                align: 'left',
                dataIndex:"id",
            },
            {
                key:"2",
                title: '类型',
                align: 'left',
                dataIndex:"applyType",
                render:(text,record)=>{
                    if(text==1){
                        return "锁定"
                    }else if(text==2){
                        return "补充"
                    }else if(text==3){
                        return "释放"
                    }else {
                        return ""
                    }
                }
            },
            {
                key:"3",
                title: '申请数量',
                align: 'left',
                dataIndex:"applyCount",
            },
            {
                key:"4",
                title: '申请备注',
                align: 'left',
                dataIndex:"reMark",
                render:(text)=>{
                    return <span style={{color:"#1890ff",cursor:"pointer",fontSize:"13px"}} onClick={()=>{this.lookdetail(text)}}>查看</span>
                }
            },
            {
                key:"5",
                title: '提交时间',
                align: 'left',
                dataIndex:"applyTime",
            },
            {
                key:"6",
                title: '供货商审批',
                align: 'left',
                dataIndex:"approvalStatus",
                render:(text,record)=>{
                    if(text==1){
                        return "待审核"
                    }else if(text==2){
                        return "已通过"
                    }else if(text==3){
                        return "未通过"
                    }else {
                        return ""
                    }
                }
            },
            {
                key:"7",
                title: '供货商审批时间',
                align: 'left',
                dataIndex:"supApprovalTime",
            },
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };
		return (
			<div className="TreasuryLocksDetail">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="TreasuryLocksDetail-containter">
                    <h1 className="title">
                        商品详情
                        <span className="activeLine"></span>
                    </h1>
                    <Row style={{marginBottom:'16px'}}>
                        <Col span={8}>
                            <span>商户编号：</span>
                            <span>{lockDetailData&&lockDetailData.memberCode}</span>
                        </Col>
                        <Col span={8}>
                            <span>商户名称：</span>
                            <span>{lockDetailData&&lockDetailData.memberName}</span>
                        </Col>
                    </Row>
                    <Row style={{marginBottom:'16px'}}>
                        <Col span={8}>
                            <span>商品编号：</span>
                            <span>{lockDetailData&&lockDetailData.productId}</span>
                        </Col>
                        <Col span={8}>
                            <span>商品名称：</span>
                            <span>{lockDetailData&&lockDetailData.productName}</span>
                        </Col>
                    </Row>
                    <Row style={{marginBottom:'16px'}}>
                        <Col span={8}>
                            <span>锁定开始时间：</span>
                            <span>{lockDetailData&&lockDetailData.lockTime}</span>
                        </Col>
                    </Row>
                    <h1 className="title">
                        锁定申请记录
                        <span className="activeLine"></span>
                    </h1>
                    <Spin spinning={loading.effects['stock/GetStockLockApplyDetailList']}>
                        <Table 
                            columns={columns}
                            dataSource={treasuryLocksList?treasuryLocksList:[]}
                            pagination={pagination}
                            scroll={{y:window.innerHeight - 450}}
                        />
                    </Spin>
                </div>  
                <Modal
                    width="650px"
                    title="备注详情"
                    okText="确定"
                    cancelText="取消"
                    visible={showDetail}
                    onCancel={
                        this.comfirmDetal
                    }
                    onOk={
                        this.comfirmDetal
                    }
                >
                    <div style={{width:"100%",height:'100%',overflow:"hidden"}}>
                        <span style={{display:"inline-block",width:"100px",height:'100%',float:"left"}}>申请备注:</span>
                        <div
                            style={{display:"inline-block",width:"calc(100% - 100px)",height:'100%',float:"left"}}
                            dangerouslySetInnerHTML={{
                            __html:detailData
                            }}
                        >

                        </div>
                    </div>
                </Modal>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(TreasuryLocksDetail));