import React, { Component } from 'react';
import { connect } from 'dva';
import {Spin,Button,message,Checkbox,Form,Row,Col,Modal   } from 'antd';
import {WangEditor} from 'fl-pro' 
import './less/AddReport.less';
import commonFun from '../../../../utils/utils';
class AddReport extends Component {
    constructor(props) {
        super(props);
        this.state = {
            editorContent:'',
            memberId:commonFun.GetQueryString(location.search.split('?')[1], "memberId"),
        }
    }
    
    changeEditorContent=(data)=>{
        this.setState({
            editorContent:data
        })
    }
    

    confirmData=()=>{
        const { memberId,editorContent } = this.state;
        const { reportList } = this.props;
        let postData={
            memberId:memberId,
            supProductIds:reportList.supProductIds,
            remark:editorContent
        }
        this.props.dispatch({
            type: 'report/ApplySupReport',
            payload: {
               ...postData
            }
        });
    }

    componentWillReceiveProps(nextProps){
        const { ApplySupReport} = nextProps.report;

        if (ApplySupReport && ApplySupReport !== this.props.report.ApplySupReport) {
            if(ApplySupReport.code==="0"){
                message.destroy();
                message.success("添加成功")
                this.props.closeAddReport()
            }else{
                message.destroy();
                message.warning(ApplySupReport.message);
            }
        }

    }


    render() {
        const { editorContent } = this.state;
        const { reportList } = this.props;
        return(
                <Modal
                    className="addReport"
                    width="650px"
                    title="申请报备"
                    okText="确定"
                    cancelText="取消"
                    visible={true}
                    onCancel={() =>{
                        this.props.closeAddReport();
                    }}
                    onOk={
                        ()=>{
                          this.confirmData();
                        }
                    }
                    >
                    <Row style={{marginBottom:'10px'}}>
                        <Col span={3} style={{textAlign:'right'}}>
                            进货商：
                        </Col>
                        <Col span={21}>
                            {reportList.memberName}
                        </Col>
                    </Row>
                    <Row style={{marginBottom:'10px'}}>
                        <Col span={3} style={{textAlign:'right'}}>
                            供货商品：
                        </Col>
                        <Col span={21}>
                            {reportList&&reportList.supProductNameList&&reportList.supProductNameList.length>0?reportList.supProductNameList.join("，"):''}
                        </Col>
                    </Row>
                    {/* <Row style={{marginBottom:'10px'}}>
                        <Col span={3} style={{textAlign:'right'}}>
                            供货商：
                        </Col>
                        <Col span={21}>
                            {reportList.supMemberName}
                        </Col>
                    </Row> */}
                    <Row style={{marginBottom:'10px'}}>
                        <Col span={3}  style={{textAlign:'right'}}>
                            备注：
                        </Col>
                        <Col span={21}>
                        <WangEditor
                            width={500}
                            changeEditorContent={this.changeEditorContent}
                            editorContent={editorContent}
                            menus={[
                                'head',  // 标题
                                'bold',  // 粗体
                                'fontSize',  // 字号
                                'fontName',  // 字体
                                'italic',  // 斜体
                                'underline',  // 下划线
                                'strikeThrough',  // 删除线
                                'foreColor',  // 文字颜色
                                'backColor',  // 背景颜色
                                'link',  // 插入链接
                                'list',  // 列表
                                'justify',  // 对齐方式
                              ]
                          }
                        />

                        </Col>
                    </Row>
                    <Row style={{marginBottom:'10px'}}>
                        <Col span={3} style={{textAlign:'right'}}>
                            审核意见：
                        </Col>
                        <Col span={21}>
                            {reportList.auditRemark}
                        </Col>
                    </Row>
                </Modal>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(AddReport);


