import React from 'react';
import { connect } from 'dva';
import {Form,message,Button,Tabs,Spin  } from  "antd";
import { Table } from 'fl-pro';
const { TabPane } = Tabs;
import './less/ReportMerchants.less';
import BreadCrumb from '../../../../components/Breadcrumb';
import SearchForm from '../../../../components/SearchForm';
import findIndex from 'lodash/findIndex';
import AddReport from '../AddReport';                                                                     
import commonFun from '../../../../utils/utils';
class ReportMerchants extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                pageIndex: 1,
                pageSize: 10,
            },
            reportMerchantsList:[],
            total:0,
            showAddReport:false,
            reportList:null,
            memberId:commonFun.GetQueryString(location.search.split('?')[1], "memberId"),
            productType:'3',
            reportMsg:sessionStorage.getItem("reportMsg")?JSON.parse(sessionStorage.getItem("reportMsg")):'',
            selectedRowData:[],
            selectedRowKeys:[]
        }
	}

    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.GetProductByMemberList()
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.pageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetProductByMemberList()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 根据进货商户获取平台商品
    GetProductByMemberList = ()=>{
        const {postData,condition,memberId,productType} =this.state;
        let params = {
            memberId,
            productType
        }
        this.setState({
            comonParams:params
        },()=>{
            this.props.dispatch({
                type: 'report/GetProductByMemberList', 
                payload: {
                    ...postData,
                    ...condition,
                    ...params 
                } 
            });
        })
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetProductByMemberList()
        });
    }

    // 新增
    addGoods=()=>{
        this.setState({
            showaddPriceGoods:true,
            addPriceGoodsList:{title:"新增商品",showaddPriceGoods:true},
        })
    }

    callback=(type)=>{
        this.setState({
            productType:type,
            selectedRowData:[],
            selectedRowKeys:[],
            reportMerchantsList:[]
        },()=>{
            this.GetProductByMemberList()
        })
    }

    // 密价商户
    goMerchants=()=>{
        this.props.history.push("/price/group/merchants")
    }

    setAddReport=(type,record)=>{
        const {reportMsg,selectedRowData } = this.state
        if(type==1){
            record.supProductNameList =record&&record.supProductName?[record.supProductName]:'';
            record.supProductIds = record&&record.supProductId?[record.supProductId]:'';
            this.setState({
                showAddReport:true,
                reportList:{...record,memberName:reportMsg.name}
            })
        }else{
            if(selectedRowData&&selectedRowData.length>0){
                let supProductNameList = [];
                let supProductIds=[];
                selectedRowData.map((item)=>{
                    supProductNameList.push(item.supProductName);
                    supProductIds.push(item.supProductId) 
                })
                let obj={
                    memberName:reportMsg.name,
                    supProductNameList,
                    supProductIds
                }
                this.setState({
                    showAddReport:true,
                    reportList:obj
                }) 
            }else{
                message.destroy();
                message.warning("请选择要申请报备的商品")
            }
           
        }
       
    }

    closeAddReport=()=>{
        this.setState({
            showAddReport:false
        })
    }

	componentWillReceiveProps(nextProps) {
        const { props } = this;
        const {GetProductByMemberList } = nextProps.report;
        // 根据进货商户获取平台商品
        if (GetProductByMemberList && GetProductByMemberList !== this.props.report.GetProductByMemberList) {
            if(GetProductByMemberList.code==="0"){
              this.setState({
                reportMerchantsList:GetProductByMemberList.data&&GetProductByMemberList.data.list,
                total:GetProductByMemberList.data.total
              })
        
            }else{
                message.destroy();
                message.warning(GetProductByMemberList.message);
            }
        }
        
    }

	render() {
        const { getFieldDecorator } = this.props.form;
        const {loading} = this.props;
        const {total,postData,reportMerchantsList,showAddReport,selectedRowKeys,reportList,productType  } = this.state;
        const breadcrumbList = [
            {
                name:"运营管理",
                href:""
            },
            {
                name:"报备管理",
                href:"/tagmanage/report"
            },
            {
                name:"查看商户",
                href:""
            }
        ];
        let columns = [
            {
                key:"1",
                title: '平台商品',
                align: 'left',
                dataIndex:"productName",
                width:300
            },
            {
                key:"2",
                title: '平台商品编号',
                align: 'left',
                dataIndex:"id",
                width:200
            },
            {
                key:"3",
                title: '供货商品',
                align: 'left',
                dataIndex:"supProductName",
                width:350
            },
            {
                key:"4",
                title: '供货商品编号',
                align: 'left',
                dataIndex:"supProductId",
                width:200
            },
            {
                key:"5",
                title: '商品类型',
                align: 'left',
                dataIndex:"supProductType",
            },
            {
                key:"6",
                title: '供货商名称',
                align: 'left',
                dataIndex:"supMemberName",
                width:200
            },
            {
                key:"7",
                title: '商户号',
                align: 'left',
                dataIndex:"supMemberCode",
            },
            {
                key:"8",
                title: '商户类型',
                align: 'left',
                dataIndex:"memberType",
                render:(text)=>{
                    if(text==1){
                        return "内部"
                    }else if(text==2){
                        return "外部"
                    } else{
                        return ""
                    }
                }
            },
            {
                
                key:"9",
                title: '进货价',
                align: 'left',
                dataIndex:"supProductPrice",
                render:(text)=>{
                    return commonFun.formatMoney(text)
                }
            }, {
                key:"10",
                title: '面值',
                align: 'left',
                dataIndex:"faceValue",
                render:(text)=>{
                    return commonFun.formatMoney(text)
                }
            }, {
                key:"11",
                title: '票据类型',
                align: 'left',
                dataIndex:"invoiceType",
                render:(text)=>{
                    if(text==0){
                        return "寄售"
                    }else if(text==1){
                        return "自营"
                    }else{
                        return ""
                    }
                }
            }, {
                key:"12",
                title: '报备状态',
                align: 'left',
                dataIndex:"reportStatus",
                render:(text)=>{
                    if(text==0){
                        return "未报备"
                    }else if(text==1){
                        return "待审核"
                    }else if(text==2){
                        return "已报备"
                    }else if(text==3){
                        return "已拒绝"
                    }else{
                        return ""
                    }
                }
            },
            {
                key:"13",
                title: '报备起始时间',
                align: 'left',
                dataIndex:"reportBeginTime",
                width:200
            },
            {
                key:"14",
                title: '报备结束时间',
                align: 'left',
                dataIndex:"reportEndTime",
                width:200
            },
            {
                key:"15",
                title: '报备',
                width:100,
                align: 'center',
                fixed: 'right',
                render:(text,record)=>{
                    if((findIndex(window.getAuthButtons(), { enCode: 'lr_tag_repoortSingle' }) !== -1)&&(!record.reportStatus || record.reportStatus==0 || record.reportStatus==3)){
                        return <i  style={{cursor:"pointer",fontSize:'16px',color:"#4b9ae0",}} className="iconfont"   title="申请" onClick={()=>{this.setAddReport(1,record)}}>&#xe612;</i>
                    }
                }
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };
        const rowSelection = {
            selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
              this.setState({
                selectedRowData:selectedRows,
                selectedRowKeys
              })
            },
            // getCheckboxProps: record => ({
            //   disabled: record.name === 'Disabled User', 
            //   name: record.name,
            // }),
        };
		return (
			<div className="ReportMerchants">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="ReportMerchants-containter">
                    <Spin spinning={loading.effects['report/GetProductByMemberList']}>
                        <SearchForm name="reportMerchants"
                            init={this.init} 
                            search={this.search} 
                            getFormData={this.getFormData} 
                        />
                        <div className="tabs">
                            {(findIndex(window.getAuthButtons(), { enCode: 'lr_tag_merchants' }) !== -1)?<Button  className="addGoods"  onClick={()=>{this.setAddReport(2)}}>
                                一键申请
                            </Button>:''}
                            <Tabs onChange={this.callback} type="card" defaultActiveKey={3}>
                                <TabPane tab="卡密" key="3" >
                                   {productType=='3'&& <Table 
                                        columns={columns}
                                        rowSelection={rowSelection}
                                        dataSource={reportMerchantsList?reportMerchantsList:[]}
                                        pagination={pagination}
                                        scroll={{y:window.innerHeight - 450,x:2400}}
                                    />}
                                </TabPane>
                                <TabPane tab="直充" key="4" >
                                   {productType=='4'&& <Table 
                                        columns={columns}
                                        rowSelection={rowSelection}
                                        dataSource={reportMerchantsList?reportMerchantsList:[]}
                                        pagination={pagination}
                                        scroll={{y:window.innerHeight - 450,x:2400}}
                                    />}
                                </TabPane>
                            </Tabs>
                        </div>
                    </Spin>
                    {
                        showAddReport?<AddReport closeAddReport={this.closeAddReport} reportList={reportList}/>:''
                    }
                </div>  
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(ReportMerchants));