import React from 'react';
import { connect } from 'dva';
import {Form,message,Spin} from  "antd";
import { Table } from 'fl-pro';
import './less/TagmanageReport.less';
import BreadCrumb from '../../../../components/Breadcrumb';
import SearchForm from '../../../../components/SearchForm';
import findIndex from 'lodash/findIndex';
class TagmanageReport extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData:{
                pageIndex: 1,
                pageSize: 10,
            },
            total:0,
            purchaserMemberList:[],
        }
	}


    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
           this.GetPurchaserMemberList()
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetPurchaserMemberList()
        });
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetPurchaserMemberList()
        });
    }

    GetPurchaserMemberList=()=>{
        const {postData,condition } =this.state;
        this.props.dispatch({
            type: 'report/GetPurchaserMemberList', 
            payload: {
                ...postData,
                ...condition
            } 
        });
    }

    look=(record)=>{
        this.props.history.push("/tagmanage/report/merchants?memberId="+record.id)
        sessionStorage.setItem("reportMsg",JSON.stringify(record))
    }

	componentWillReceiveProps(nextProps) {
        const {GetPurchaserMemberList} = nextProps.report;
        // 获取报备管理列表
        if (GetPurchaserMemberList && GetPurchaserMemberList !== this.props.report.GetPurchaserMemberList) {
            if(GetPurchaserMemberList.code==="0"){
              this.setState({
                purchaserMemberList:GetPurchaserMemberList.data.list,
                total:GetPurchaserMemberList.data.total
              })
            }else{
                message.destroy();
                message.warning(GetPurchaserMemberList.message);
            }
        }
        
    }

	render() {
        const {loading} = this.props;
        const {total,postData,purchaserMemberList,} = this.state;
        const breadcrumbList = [
            {
                name:"运营管理",
                href:""
            },
            {
                name:"报备管理",
                href:""
            }
        ];
        let columns = [
            {
                key:"1",
                title: '商户名称',
                align: 'left',
                dataIndex:"name",
            },
            {
                key:"2",
                title: '商户号',
                align: 'left',
                dataIndex:"memberCode",
            },
            {
                key:"3",
                title: '主体名称',
                align: 'left',
                dataIndex:"affiliatedCompanyName",
            },
            {
                key:"4",
                title: '商户类型',
                align: 'left',
                dataIndex:"memberType",
                render:(text)=>{
                    if(text==1){
                        return "内部"
                    }else if(text==2){
                        return "外部"
                    }else{
                        return ''
                    }
                }
            },
            {
                key:"5",
                title: '报备',
                width:100,
                align: 'center',
                render:(text,record)=>(
                    <div style={{color:"#4b9ae0",cursor:'pointer'}}>
                        {(findIndex(window.getAuthButtons(), { enCode: 'lr_tag_report' }) !== -1)?<i className="iconfont" style={{cursor:'pointer',fontSize:'16px'}}  onClick={()=>{this.look(record)}}  title="查看">&#xe611;</i>:''}
                    </div>
                )
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };

		return (
			<div className="TagmanageReport">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="TagmanageReport-containter">
                    <Spin spinning={loading.effects['report/GetPurchaserMemberList']}>
                    <SearchForm name="tagmanageReport"
                        init={this.init} 
                        search={this.search} 
                        getFormData={this.getFormData} 
                    />
                    <Table 
                        columns={columns}
                        dataSource={purchaserMemberList?purchaserMemberList:[]}
                        pagination={pagination}
                        scroll={{y:window.innerHeight - 450}}
                    />
                    </Spin>
                </div>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(TagmanageReport));