import React from 'react';
import { connect } from 'dva';
import {Form,message,Row,Col,Button,Tabs,Checkbox  } from  "antd";
const { TabPane } = Tabs;
import './less/ActivityDetail.less';
import { Table } from 'fl-pro';
import BreadCrumb from '../../../../components/Breadcrumb';
import findIndex from 'lodash/findIndex';
import commonFun from '../../../../utils/utils';
import PlatformGoods from '../PlatformGoods';
import Registbuyer from '../Registbuyer';
import RegistSingle from '../RegistSingle';
class ActivityDetail extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            condition:[],
            postData1:{
                PageIndex: 1,
                PageSize: 10,
            },
            postData2:{
                PageIndex: 1,
                PageSize: 10,
            },
            activityDetailList:null,
            ativityApplyList:[],
            total1:0,
            total2:0,
            ActivityId:commonFun.GetQueryString(location.search.split('?')[1], "activityId"),
            activityRelationProductList:[],
            showPlatformGoods:false,
            PlatformGoodsData:null,
            ApplyStatus:'2',
            showRegistbuyer:false,
            showRegistSingle:false,
            registSingleList:null,
            applyCount:null
        }
	}

    componentDidMount (){
        this.GetActivityRelationProductList()
        this.GetActivityDetail()
        this.GetActivityApplyList()
        this.StasticActivityApplyCount()
    }

    // 分页查询
    searchPagination1= ()=> {
        const { postData1} = this.state;
        this.setState({ 
            postData1 
        },() => {
           this.GetActivityRelationProductList()
        });
    }

    GetActivityDetail=()=>{
        const {ActivityId} = this.state;
        this.props.dispatch({
            type: 'activity/GetActivityDetail', 
            payload: {
                ActivityId
            } 
        });
    }

    //获取活动关联商品
    GetActivityRelationProductList=()=>{
        const {ActivityId,postData1} = this.state;
        this.props.dispatch({
            type: 'activity/GetActivityRelationProductList', 
            payload: {
                ActivityId,
                ...postData1
            } 
        });
    }

    StasticActivityApplyCount=()=>{
        const {ActivityId} = this.state;
        this.props.dispatch({
            type: 'activity/StasticActivityApplyCount', 
            payload: {
                ActivityId
            } 
        });
    }

    lookPlatformGoods=(record)=>{
        this.setState({
            showPlatformGoods:true,
            PlatformGoodsData:record
        })
    }

    closePlatformGoods=()=>{
        this.setState({
            showPlatformGoods:false,
        },()=>{
            // this.GetActivityRelationProductList()
        })
    }

    //获取活动申请列表
    GetActivityApplyList=()=>{
        const {ActivityId,ApplyStatus,postData2} = this.state;
        this.props.dispatch({
            type: 'activity/GetActivityApplyList', 
            payload: {
                ActivityId,
                ApplyStatus,
                ...postData2
            } 
        });
    }

  

    renderStatus=(status)=>{
        if(status==0){
            return "未开始"
        }else if(status==1){
            return "进行中"
        }else if(status==2){
            return "已结束"
        }else if(status==3){
            return "禁用"
        }else{
            return '';
        }
    }

    callback=(type)=>{
        this.setState({
            ApplyStatus:type
        },()=>{
            this.GetActivityApplyList();
            this.StasticActivityApplyCount()
        })
    }

    registbuyer=()=>{
        this.setState({
            showRegistbuyer:true
        })
    }

    closeRegistbuyer=()=>{
        this.setState({
            showRegistbuyer:false
        },()=>{
            this.GetActivityApplyList()
            this.StasticActivityApplyCount()
        })
    }

    registSingle=(record)=>{
        this.setState({
            showRegistSingle:true,
            registSingleList:record
        })
    }

    closeRegistSingle=()=>{
        this.setState({
            showRegistSingle:false,
            registSingleList:null
        },()=>{
            this.GetActivityApplyList()
            this.StasticActivityApplyCount()
        })
    }
    
	componentWillReceiveProps(nextProps) {
        const {GetActivityDetail,GetActivityRelationProductList,GetActivityApplyList,StasticActivityApplyCount} = nextProps.activity;
        // 获取活动详情
        if (GetActivityDetail && GetActivityDetail !== this.props.activity.GetActivityDetail) {
            if(GetActivityDetail.code==="0"){
                if(GetActivityDetail&&GetActivityDetail.data&&GetActivityDetail.data.appList){
                    GetActivityDetail.data.checkList = GetActivityDetail.data.appList.map((item)=>{
                        return item.appName
                    })
                }
                this.setState({
                    activityDetailList:GetActivityDetail.data,
                })
            }else{
                message.destroy();
                message.warning(GetActivityDetail.message);
            }
        }

        // 获取活动关联商品
        if (GetActivityRelationProductList && GetActivityRelationProductList !== this.props.activity.GetActivityRelationProductList) {
            if(GetActivityRelationProductList.code==="0"){
                this.setState({
                    activityRelationProductList:GetActivityRelationProductList.data.list,
                    total1:GetActivityRelationProductList.total
                })
            }else{
                message.destroy();
                message.warning(GetActivityRelationProductList.message);
            }
        }

        // 获取活动申请列表
        if (GetActivityApplyList && GetActivityApplyList !== this.props.activity.GetActivityApplyList) {
            if(GetActivityApplyList.code==="0"){
                this.setState({
                    ativityApplyList:GetActivityApplyList.data.list,
                    total1:GetActivityApplyList.data.total
                })
            }else{
                message.destroy();
                message.warning(GetActivityApplyList.message);
            }
        }

        if (StasticActivityApplyCount && StasticActivityApplyCount !== this.props.activity.StasticActivityApplyCount) {
            if(StasticActivityApplyCount.code==="0"){
                this.setState({
                    applyCount:StasticActivityApplyCount.data
                })
            }else{
                message.destroy();
                message.warning(StasticActivityApplyCount.message);
            }
        }


        
    }

	render() {
        const {loading} = this.props;
        const {total1,postData1,total2,postData2,activityDetailList,ativityApplyList,activityRelationProductList,showPlatformGoods,PlatformGoodsData,showRegistbuyer,showRegistSingle,registSingleList,ApplyStatus,ActivityId,applyCount } = this.state;
        const breadcrumbList = [
            {
                name:"运营管理",
                href:""
            },
            {
                name:"上游活动报名",
                href:"/tagmanage/activity"
            },
            {
                name:"活动详情报名",
                href:""
            }
        ];
        let columns1 = [
            {
                key:"1",
                title:  '商品编号',
                align: 'left',
                dataIndex:"productId",
            },
            {
                key:"2",
                title: '商品名称',
                align: 'left',
                dataIndex:"productName",
                width:350
            },
            {
                key:"3",
                title: '面值',
                align: 'left',
                dataIndex:"productParValue",
            },
            {
                key:"4",
                title: '商品属性',
                align: 'left',
                dataIndex:"productType",
                render:(text)=>{
                    if(text==0){
                        return '在线直充'
                    }else if(text==1){
                        return '卡密直充'
                    }else if(text==2){
                        return '卡密'
                    }else if(text==3){
                        return '实时采卡'
                    }else{
                        return ''
                    }
                }
                
            },
            {
                key:"5",
                title: '票据',
                align: 'left',
                dataIndex:"billType",
                render:(text)=>{
                    if(text==0){
                        return '寄售'
                    }else if(text == 1){
                        return '自营'
                    }else {
                        return ''
                    }
                }
            },
            {
                key:"6",
                title: '税率',
                align: 'left',
                dataIndex:"ticketType",
                render:(text,record)=>{
                    if (record.ticketType === "0" || record.ticketType === 0) {
                        return  "无票";
                    } else if (record.ticketType == 1) {
                        return record.ticketRate*100 + "%普票";
                    } else if (record.ticketType == 2) {
                        return record.ticketRate*100 + "%专票";
                    } else {
                        return "";
                    }
                }
            },
            {
                key:"7",
                title: '供货价',
                align: 'left',
                dataIndex:"productPrice",
            },
            {
                key:"8",
                title: '官方售价',
                align: 'left',
                dataIndex:"officialPrice",
            },
            {
                key:"9",
                title: '活动价',
                align: 'left',
                dataIndex:"activityPrice",
            },
            {
                key:"10",
                title: '渠道限价',
                align: 'left',
                dataIndex:"channelMinPrice",
            },
            {
                key:"11",
                title: '终端限价',
                align: 'left',
                dataIndex:"terminalMinPrice",
            },
            {
                key:"12",
                title: '是否报备',
                align: 'left',
                dataIndex:"isReport",
                render(text) {
                  if(text){
                    return "是"
                  }else {
                      return"否"
                  }  
                },
            },
            {
                key:"13",
                title: '备注',
                align: 'left',
                dataIndex:"remark",
            },
            {
                key:"14",
                title: '操作',
                align: 'center',
                render:(text,record)=>{
                    if((findIndex(window.getAuthButtons(), { enCode: 'lr_activity_supGoods' }) !== -1)){
                        return <i className="iconfont" style={{color:"#4b9ae0",cursor:'pointer',fontSize:'16px'}}  onClick={()=>{this.lookPlatformGoods(record)}}  title="查看平台商品">&#xe611;</i>
                    }
                    
                }
            },
        ];
        let columns2 = [
            {
                key:"1",
                title:  '商户名称',
                align: 'left',
                dataIndex:"memberName",
            },
            {
                key:"2",
                title: '商户号',
                align: 'left',
                dataIndex:"memberCode",
            },
            {
                key:"3",
                title: '主体名称',
                align: 'left',
                dataIndex:"memberAuthenticationName",
            },
            {
                key:"4",
                title: '商户类型',
                align: 'left',
                dataIndex:"memberType",
                render:(text)=>{
                    if(text==1){
                        return "内部"
                    }else if(text==2){
                        return "外部"
                    }else{
                        return ''
                    }
                }
            },
            {
                key:"5",
                title: '预计销量',
                align: 'left',
                dataIndex:"preSaleNumber",
            },
            {
                key:"6",
                width:100,
                title: '报名',
                align: 'center',
                render:(text,record)=>{
                    if((findIndex(window.getAuthButtons(), { enCode: 'lr_activity_registSingle' }) !== -1)&&(activityDetailList&&activityDetailList.activityStatus==0||activityDetailList&&activityDetailList.activityStatus==1)&&ApplyStatus==3){
                        return <span onClick={()=>{this.registSingle(record)}} style={{fontSize:"13px",cursor:"pointer",color:"#1890ff"}}>报名</span>
                    }
                }
            }
        ];
        const pagination1 = {
            total1,
            hideOnSinglePage: false,
            pageSize: postData1.PageSize,
            current: postData1.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData1.PageIndex=1;
                postData1.PageSize=pageSize;
                Object.assign(postData1, { PageSize: pageSize })
                this.setState({ postData1 }, () => {
                    this.searchPagination1();
                })
            },
            onChange: (current) => {
                postData1.PageIndex=current; 
                Object.assign(postData1, { PageIndex: current })
                this.setState({ postData1 }, () => {
                    this.searchPagination1();
                })
            },
        };

        const pagination2 = {
            total2,
            hideOnSinglePage: false,
            pageSize: postData2.PageSize,
            current: postData2.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData2.PageIndex=1;
                postData2.PageSize=pageSize;
                Object.assign(postData2, { PageSize: pageSize })
                this.setState({ postData2 }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData2.PageIndex=current; 
                Object.assign(postData2, { PageIndex: current })
                this.setState({ postData2 }, () => {
                    this.searchPagination();
                })
            },
        };
		return (
			<div className="ActivityDetail">
                <BreadCrumb paramsList={breadcrumbList}/>
                <div className="ActivityDetail-containter">
                    <h1 className="title">
                        活动基本信息
                        <span className="activeLine"></span>
                    </h1>
                    <div className="comBox">
                        <Row style={{marginBottom:'16px'}}>
                            <Col span={24} className="ant-form-item-label">
                                <label>活动名称：</label>
                                <span>{activityDetailList&&activityDetailList.activityName?activityDetailList.activityName:''}</span>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col span={24} className="ant-form-item-label">
                                <label>活动类型：</label>
                                <span>{activityDetailList&&activityDetailList.reduceType==1?"立减":"折扣"}</span>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col span={24} className="ant-form-item-label" >
                                <label>活动折扣：</label>
                                <span>{`基于面值计算，折扣值 ${activityDetailList?activityDetailList.disCountValue:''}`}</span>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col span={24} className="ant-form-item-label">
                                <label>官方活动：</label>
                                <span>{activityDetailList?activityDetailList.isOfficial?"是":"否":''}</span>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col span={24} className="ant-form-item-label">
                                <label>活动标签：</label>
                                {
                                    activityDetailList&&activityDetailList.tagList&&activityDetailList.tagList.length>0&&activityDetailList.tagList.map((item)=>{
                                        return (
                                            <span>{item.tagName}</span>
                                        )
                                    })
                                }
                                
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col span={24} className="ant-form-item-label">
                                <label>活动时间：</label>
                                <span>{activityDetailList&&activityDetailList.beginTime?activityDetailList.beginTime:''}  至  {activityDetailList&&activityDetailList.endTime?activityDetailList.endTime:''}</span>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col span={24} className="ant-form-item-label">
                                <label>活动状态：</label>
                                <span>
                                    {
                                        activityDetailList?this.renderStatus(activityDetailList.activityStatus):''
                                    }
                                </span>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col span={24} className="ant-form-item-label">
                                <label>活动对象：</label>
                                <Checkbox.Group value={activityDetailList&&activityDetailList.checkList?activityDetailList.checkList:[]}>
                                    {   
                                        activityDetailList&&activityDetailList.appList&&activityDetailList.appList.length>0&&activityDetailList.appList.map((item,i)=>{
                                            return <Checkbox style={{float:"left"}} key={i} value={item.appName}>{item.appName}</Checkbox>
                                        })
                                    }
                                </Checkbox.Group>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col span={24} className="ant-form-item-label">
                                <label>活动规则：</label>
                                <p>
                                     {activityDetailList&&activityDetailList.remark?activityDetailList.remark:''}
                                </p>
                            </Col>
                        </Row>
                    </div>
                    <h1 className="title">
                        活动商品信息
                        <span className="activeLine"></span>
                    </h1>
                    <Table 
                        columns={columns1}
                        dataSource={activityRelationProductList?activityRelationProductList:[]}
                        pagination={pagination1}
                        scroll={{y:500,x:1400}}
                    />
                    <h1 className="title">
                        参加活动进货商
                        <span className="activeLine"></span>
                    </h1>
                    <div className="tabs">
                            {activityDetailList&&(activityDetailList.activityStatus==2||activityDetailList.activityStatus==3)?'':(findIndex(window.getAuthButtons(), { enCode: 'lr_activity_registMount' }) !== -1)?<Button type="primary" className="addGoods"  onClick={()=>{this.registbuyer()}}>报名</Button>:''}
                            <Tabs onChange={this.callback} type="card" defaultActiveKey={ApplyStatus}>
                                <TabPane tab={`已通过（${applyCount?applyCount.passCount:0}）`} key="2" >
                                    <Table 
                                        columns={columns2}
                                        dataSource={ativityApplyList?ativityApplyList:[]}
                                        pagination={pagination2}
                                        scroll={{y:500}}
                                    />
                                </TabPane>
                                <TabPane tab={`待审核（${applyCount?applyCount.pendingCount:0}）`} key="1" >
                                    <Table 
                                        columns={columns2}
                                        dataSource={ativityApplyList?ativityApplyList:[]}
                                        pagination={pagination2}
                                        scroll={{y:500}}
                                    />
                                </TabPane>
                                <TabPane tab={`未通过（${applyCount?applyCount.failCount:0}）`} key="3" >
                                    <Table 
                                        columns={columns2}
                                        dataSource={ativityApplyList?ativityApplyList:[]}
                                        pagination={pagination2}
                                        scroll={{y:500}}
                                    />
                                </TabPane>
                            </Tabs>
                        </div>
                </div>  
                {showPlatformGoods?<PlatformGoods closePlatformGoods={this.closePlatformGoods} PlatformGoodsData={PlatformGoodsData}/>:''}
                {showRegistbuyer?<Registbuyer closeRegistbuyer={this.closeRegistbuyer} dataParams={{merchantId:ativityApplyList&&ativityApplyList.merchantId,merchantName:ativityApplyList&&ativityApplyList.merchantName,ActivityId}}/>:''}
                {showRegistSingle?<RegistSingle closeRegistSingle={this.closeRegistSingle} registSingleList={registSingleList} dataParams={{ActivityId}}/>:''}
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(ActivityDetail));