import React, { Component } from 'react';
import { connect } from 'dva';
import {Spin,message,Modal} from 'antd';
import {Table} from 'fl-pro'; 
import './less/ChooseMerchants.less';
import SearchForm from '../../../../components/SearchForm';
import commonFun from '../../../../utils/utils';
class ChooseMerchants extends Component {
    constructor(props) {
        super(props);
        this.state = {
            condition:[],
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            MemberDataList:[],
            total:0,
            selectedRowData:[],
            DepartmentList:[],
            PositionList:[],
            screenHeight:960,
            selectedRowKeys:[],
            CurrentMonthExpiresList:[
                { label: '是', value: '1' },
                { label: '否', value: '0' },
            ],
        }
    }
    
    componentDidMount (){
        this.setState({screenHeight:window.innerHeight});
    }

    componentWillUnmount() {
        //一定要最后移除监听器，以防多个组件之间导致this的指向紊乱
        window.removeEventListener('resize', this.handleResize.bind(this)) ;
    }


    // 初始化查询表单
    init = (values) => {
        this.setState({ 
            condition: values 
        },() => {
            this.GetActivityApplyMemberList();
        });
    }

    // 查询
    search = () => {
        const { postData,condition } = this.state;
        postData.PageIndex=1
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetActivityApplyMemberList()
        });
    }

    // 分页查询
    searchPagination= ()=> {
        const { postData,condition } = this.state;
        this.setState({ 
            condition,
            postData 
        },() => {
            this.GetActivityApplyMemberList()
        });
    }

    handleResize = e => {
        this.setState({screenHeight:e.target.innerHeight});
    }

    getFormData=(params)=>{
        this.setState({
          condition: params,
        })
    }

    // 获取进货商列表
    GetActivityApplyMemberList=()=>{
        const { postData, condition} = this.state;
        let ProductSpGroupId = commonFun.GetQueryString(location.search.split('?')[1], "GroupId");
        this.props.dispatch({
            type: 'activity/GetActivityApplyMemberList', 
            payload: {
                ...postData,
                ...condition, 
                ProductSpGroupId
            } 
        }); 
    }

    changeCheckData=(e,record)=>{
        const {MemberDataList} = this.state;
        if(record.appList&&record.appList.length>0){
            record.appList.map((item)=>{
                if(e&&e.length>0){
                    e.map((el)=>{
                        if(el==item.clientId){
                            item.checked=1
                        }
                    })
                }
            })
        }
        record.checkedList=e;
        this.setState({
            MemberDataList
        })
       
    }


    componentWillReceiveProps(nextProps){
        const { GetActivityApplyMemberList,AddProductSpMember} = nextProps.activity;
        // 获取进货商列表 
        if (GetActivityApplyMemberList && GetActivityApplyMemberList !== this.props.activity.GetActivityApplyMemberList) {
            if(GetActivityApplyMemberList.code==="0"){
                GetActivityApplyMemberList.data.list&&GetActivityApplyMemberList.data.list.map((item,i)=>{
                    item.key=i
                })
                this.setState({
                    MemberDataList:GetActivityApplyMemberList.data.list,
                    total:GetActivityApplyMemberList.data.total
                })
            }else{
                message.destroy();
                message.warning(GetActivityApplyMemberList.message);
            }
        }

        if (AddProductSpMember && AddProductSpMember !== this.props.price.AddProductSpMember) {
            if(AddProductSpMember.code==="0"){
                message.destroy();
                message.success("添加成功")
                this.props.handleAddCancel()
            }else{
                message.destroy();
                message.warning(AddProductSpMember.message);
            }
        }

    }


    render() {
        const {postData,MemberDataList,total,screenHeight,selectedRowKeys,selectedRowData} = this.state;
        const {loading} = this.props;
        let columns = [
            {
                key:"1",
                title: '商户编号',
                width:200,
                align: 'left',
                dataIndex:"memberCode"
            },
            {
                key:"2",
                title: '商户名称',
                width:200,
                align: 'left',
                dataIndex:"memberName",
            },
            {
                key:"3",
                title: '主体名称',
                width:200,
                align: 'left',
                dataIndex:"memberAuthenticationName"
            },
            {
                key:"4",
                title: '商户类型',
                width:200,
                align: 'left',
                dataIndex:"memberType",
                render:(text)=>{
                    if(text==1){
                        return '内部'
                    }else if(text==2){
                        return '外部'
                    }else{
                        return ''
                    }
                }
            },
           
        ];

        const pagination = {
            total,
            hideOnSinglePage: true,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current;
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
               
            },
        };

        const rowSelection = {
            selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRowData:selectedRows,
                    selectedRowKeys
                }) 
            },
        };
        return(
            <Modal
                className="Registbuyer"
                width="1400px"
                title="选择商户"
                okText="确定"
                cancelText="取消"
                visible={true}
                onCancel={() =>{
                    this.props.closeChooseMerchants();
                }}
                onOk={
                    ()=>{
                        this.props.submitMerchants(selectedRowData)
                    }
                }
            >
                <SearchForm name="chooseMerchants"
                    init={this.init} 
                    search={this.search} 
                    getFormData={this.getFormData} 
                />
                <Spin spinning={loading.effects['activity/GetActivityApplyMemberList']}>
                    <div className="tableBox">
                        <Table 
                            rowKey="memberId"
                            columns={columns}
                            dataSource={MemberDataList?MemberDataList:[]}
                            pagination={pagination}
                            rowSelection={rowSelection}
                            scroll={{y:screenHeight - 550}}
                        />
                    </div>
                </Spin>
            </Modal>
        )
    }
}

const mapStateToProps = (state) => {
	return {
		...state,
	};
}

export default connect(mapStateToProps)(ChooseMerchants);


