import React from 'react';
import { connect } from 'dva';
import { Modal,Form  } from "antd";
import { Table } from 'fl-pro';
import './PlatformGoods.less';
class PlatformGoods extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            total:0,
            dataSource:[],
            SpImportId:''
		}
    }

    componentDidMount(){
        this.GetSupProductRelationProductList()
    }

    // 获取平台商品列表
    GetSupProductRelationProductList=()=>{
        const {postData}=this.state;
        const { productId } = this.props.PlatformGoodsData;
        this.props.dispatch({
            type: 'activity/GetSupProductRelationProductList', 
            payload: {
                ...postData,
                SupProductId:productId
            } 
        });
    }
  

    componentWillReceiveProps(nextProps) {
        const {GetSupProductRelationProductList} = nextProps.activity;
        // 获取平台商品列表
        if (GetSupProductRelationProductList && GetSupProductRelationProductList !== this.props.activity.GetSupProductRelationProductList) {
            if(GetSupProductRelationProductList.code==="0"){
                this.setState({
                    dataSource:GetSupProductRelationProductList.data?GetSupProductRelationProductList.data.list:[],
                    // total:GetSupProductRelationProductList.data?GetSupProductRelationProductList.data.Total:0
                })           
            }else{
                message.destroy();
                message.error(GetSupProductRelationProductList.message);
            }
        }
    }

	render() {
        const {dataSource,postData,total} = this.state;
        let columns = [
            {
                key:"1",
                title: '商品编号',
                dataIndex: 'key',
                align: 'left',
                dataIndex:"productId",
            }, 
            {
                key:"2",
                title: '商品名称',
                width:300,
                align: 'left',
                dataIndex:"productName",
            },
            {
                key:"3",
                title: '销售状态',
                align: 'left',
                render:(text,record)=>{
                    if(record.saleStatus==1){
                        return "上架"
                    }else if(record.saleStatus==2){
                        return "下架"
                    }else if(record.saleStatus==3){
                        return "维护中"
                    }else{
                        return "--"
                    }
                }
            },
            {
                key:"4",
                title: '库存状态',
                align: 'left',
                render:(text,record)=>{
                    if(record.stockStatus==1){
                        return "断货"
                    }else if(record.stockStatus==2){
                        return "警报"
                    }else if(record.stockStatus==3){
                        return "充足"
                    }else{
                        return "--"
                    }
                }
            },
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                this.GetSupProductRelationProductList()
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                this.GetSupProductRelationProductList()
                })
            },
        };
        return (
            <div className="PlatformGoods">
                <Modal
                    wrapClassName="modal-server"
                    width="800px"
                    title="查看平台商品"
                    visible={true}
                    footer={null}
                    onCancel={() =>{
                        this.props.closePlatformGoods();
                    }}
                    >
                    <Table dataSource={dataSource}  pagination={pagination} columns={columns} rowKey="index"/>
                </Modal>
            </div>
        )
    }
}

export default connect(state => ({ ...state }))(Form.create()(PlatformGoods));