import React from 'react';
import { connect } from 'dva';
import {Modal,Form,Input,message,Row,Col,Tabs  } from  "antd";
import './less/RegistSingle.less';
import {WangEditor} from 'fl-pro'; 
class RegistSingle extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            editorContent:'',
        }
	}

    changeEditorContent=(data)=>{
        this.setState({
            editorContent:data
        })
    }

    confirmData=()=>{
        const _this = this;
        const {ActivityId } = this.props.dataParams
        const { editorContent} = this.state; 
        _this.props.form.validateFields((err, value) => {
            let postData={
                applyId:this.props.registSingleList.id,
                preSaleNumber: value.preSaleNumber,
                remark: editorContent
            }
            if(!err){
                _this.props.dispatch({
                    type: 'activity/ReSubmitActivityApply', 
                    payload: {
                        ...postData,
                    } 
                });
            }
        });
    }

	componentWillReceiveProps(nextProps) {
        const { ReSubmitActivityApply } = nextProps.activity;
        // 提交活动报名
        if (ReSubmitActivityApply && ReSubmitActivityApply !== this.props.activity.ReSubmitActivityApply) {
            if(ReSubmitActivityApply.code==="0"){
             message.destroy();
             message.success("重新报名成功")
             this.props.closeRegistSingle();
            }else{
                message.destroy();
                message.warning(ReSubmitActivityApply.message);
            }
        }
    }
    

	render() {
        const {loading} = this.props;
        const { getFieldDecorator } = this.props.form;
        const {memberName,memberCode,id,memberAuthenticationName,memberType,preSaleNumber,applyStatus,remark,reason}= this.props.registSingleList
        const {editorContent} = this.state;
        const formItemLayout = {
            labelCol: {
              span:3
            },
            wrapperCol: {
              span:10
            },
        }
        
		return (
            <div>
                <Modal
                    className="RegistSingle"
                    width="700px"
                    title="进货商报名"
                    okText="提交"
                    cancelText="取消"
                    visible={true}
                    onCancel={() =>{
                        this.props.closeRegistSingle();
                    }}
                    onOk={
                        this.confirmData
                    }
                >
                    <Form>
                        <Row style={{marginBottom:'16px'}}>
                            <Col  span={3} className="ant-form-item-label">
                                <label  title="已选商户">已选商户</label>
                            </Col>
                            <Col span={20} className="ant-form-item-control-wrapper">
                                <div className="ant-form-item-control">
                                {memberName}
                                </div>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col  span={24}>
                                <Form.Item {...formItemLayout}  label="预计销量">
                                    {getFieldDecorator('preSaleNumber', {
                                        initialValue:'',
                                        rules: [
                                            {
                                                required: false,
                                                message: '',
                                            }
                                        ],
                                    })(
                                        <Input className="formInput" placeholder="请输入预计销量"/>
                                    )}
                                </Form.Item>
                            </Col>
                        </Row>
                        <Row style={{marginTop:'10px'}}>
                            <Col  span={3} className="ant-form-item-label">
                                <label  title="备注">备注</label>
                            </Col>
                            <Col span={21} className="ant-form-item-control-wrapper">
                                <div className="ant-form-item-control">
                                    <WangEditor
                                    width={500}
                                    changeEditorContent={this.changeEditorContent}
                                    editorContent={editorContent}
                                    menus={[
                                        'head',  // 标题
                                        'bold',  // 粗体
                                        'fontSize',  // 字号
                                        'fontName',  // 字体
                                        'italic',  // 斜体
                                        'underline',  // 下划线
                                        'strikeThrough',  // 删除线
                                        'foreColor',  // 文字颜色
                                        'backColor',  // 背景颜色
                                        'link',  // 插入链接
                                        'list',  // 列表
                                        'justify',  // 对齐方式
                                        ]}
                                    />
                                </div>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col  span={3} className="ant-form-item-label">
                                <label  title="审批意见">审批意见</label>
                            </Col>
                            <Col span={20} className="ant-form-item-control-wrapper">
                                <div className="ant-form-item-control">
                                {reason}
                                </div>
                            </Col>
                        </Row>
                    </Form>
                </Modal>
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(RegistSingle));