import React from 'react';
import { connect } from 'dva';
import {Modal,Form,Input,message,Row,Col,Button} from  "antd";
const { confirm } = Modal;
import './less/Registbuyer.less';
import {WangEditor,Table} from 'fl-pro'; 
import ChooseMerchants from '../ChooseMerchants';
class Registbuyer extends React.Component {
	constructor(props) {
        super(props);
        this.state={
            editorContent:'',
            total:0,
            postData:{
                PageIndex: 1,
                PageSize: 10,
            },
            showChooseMerchants:false,
            memberData:[]
        }
	}


    changeEditorContent=(editorContent)=>{
        this.setState({
            editorContent
        })
    }

    // 分页查询
    searchPagination1= ()=> {
        const { postData} = this.state;
        this.setState({ 
            postData 
        },() => {
           this.getRegistData()
        });
    }


    addMerchants=()=>{
        this.setState({
            showChooseMerchants:true
        })
    }

    closeChooseMerchants=()=>{
        this.setState({
            showChooseMerchants:false
        })
    }

    remove=(record)=>{
        const _this = this;
        const { memberData } = this.state;
        confirm({
            title: '确定移除我吗？',
            content: '确定移除我吗？',
            okText:"确定",
            cancelText:"取消",
            onOk() {
                if(memberData&&memberData.length>0){
                    memberData.map((item,i)=>{
                        if(item.memberId==record.memberId){
                            memberData.splice(i,1)
                        }
                    })
                }
                _this.setState({
                    memberData
                })
            },
            onCancel() {
              
            },
        });
       
    }

    // 获取商户
    submitMerchants=(data)=>{
        if(data&&data.length>0){
            this.setState({
                memberData:data
            },()=>{
                this.closeChooseMerchants()
            })
        }
    }

    confirmData=()=>{
        const _this = this;
        const {merchantId,merchantName,ActivityId } = this.props.dataParams
        const { memberData ,editorContent} = this.state; 
        _this.props.form.validateFields((err, value) => {
            let postData={
                supMemberId: merchantId,
                supMemberName: merchantName,
                activityId:ActivityId,
                memberIds: memberData&&memberData.length>0&&memberData.map((item)=>{
                    return item.memberId
                }),
                preSaleNumber: value.preSaleNumber,
                remark: editorContent
            }
            if(!err){
                _this.props.dispatch({
                    type: 'activity/SubmitActivityApply', 
                    payload: {
                        ...postData,
                    } 
                });
            }
        });
    }

	componentWillReceiveProps(nextProps) {
        const { SubmitActivityApply } = nextProps.activity;
        // 提交活动报名
        if (SubmitActivityApply && SubmitActivityApply !== this.props.activity.SubmitActivityApply) {
            if(SubmitActivityApply.code==="0"){
             message.destroy();
             message.success("报名成功")
             this.props.closeRegistbuyer();
            }else{
                message.destroy();
                message.warning(SubmitActivityApply.message);
            }
        }
    }

    

	render() {
        const {loading} = this.props;
        const { getFieldDecorator } = this.props.form;
        const {editorContent,postData,total,memberData,showChooseMerchants} = this.state;
        const formItemLayout = {
            labelCol: {
              span:3
            },
            wrapperCol: {
              span:10
            },
        }
        let columns = [
            {
                key:"1",
                title:  '商户编号',
                align: 'left',
                dataIndex:"memberCode",
            },
            {
                key:"2",
                title: '商户名称',
                align: 'left',
                dataIndex:"memberName",
            },
            {
                key:"6",
                width:100,
                title: '操作',
                align: 'center',
                render:(text,record)=>{
                    return <i className="fa fa-trash-o fa-lg" style={{cursor:"pointer",fontSize:'16px',color:"#4b9ae0"}}  data-toggle="tooltip" title="移除"  onClick={()=>{this.remove(record)}}></i>
                }
            }
        ];
        const pagination = {
            total,
            hideOnSinglePage: false,
            pageSize: postData.PageSize,
            current: postData.PageIndex,
            onShowSizeChange: (current, pageSize) => {
                postData.PageIndex=1;
                postData.PageSize=pageSize;
                Object.assign(postData, { PageSize: pageSize })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
            onChange: (current) => {
                postData.PageIndex=current; 
                Object.assign(postData, { PageIndex: current })
                this.setState({ postData }, () => {
                    this.searchPagination();
                })
            },
        };
        
		return (
            <div>
                <Modal
                    className="Registbuyer"
                    width="800px"
                    title="进货商报名"
                    okText="提交"
                    cancelText="取消"
                    visible={true}
                    onCancel={() =>{
                        this.props.closeRegistbuyer();
                    }}
                    onOk={
                        ()=>{
                        this.confirmData();
                        }
                    }
                >
                    <Form>
                        <Row style={{marginBottom:'16px'}}>
                            <Col  span={3} className="ant-form-item-label">
                                <label className="ant-form-item-required" title="添加商户">添加商户</label>
                            </Col>
                            <Col span={4} className="ant-form-item-control-wrapper">
                                <div className="ant-form-item-control">
                                <Button onClick={this.addMerchants}>添加</Button>
                                </div>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col  span={3} className="ant-form-item-label">
                                <label  title="已选商户">已选商户</label>
                            </Col>
                            <Col span={20} className="ant-form-item-control-wrapper">
                                <div className="ant-form-item-control">
                                    <Table 
                                        columns={columns}
                                        dataSource={memberData?memberData:[]}
                                        // pagination={pagination}
                                        scroll={{y:500}}
                                    />
                                </div>
                            </Col>
                        </Row>
                        <Row style={{marginBottom:'16px'}}>
                            <Col  span={24}>
                                <Form.Item {...formItemLayout}  label="预计销量">
                                    {getFieldDecorator('preSaleNumber', {
                                        initialValue:'',
                                        rules: [
                                            {
                                                required: false,
                                                message: '',
                                            }
                                        ],
                                    })(
                                        <Input className="formInput" placeholder="请输入预计销量"/>
                                    )}
                                </Form.Item>
                            </Col>
                        </Row>
                        <Row style={{marginTop:'10px'}}>
                            <Col  span={3} className="ant-form-item-label">
                                <label  title="备注">备注</label>
                            </Col>
                            <Col span={21} className="ant-form-item-control-wrapper">
                                <div className="ant-form-item-control">
                                    <WangEditor
                                    width={600}
                                    changeEditorContent={this.changeEditorContent}
                                    editorContent={editorContent}
                                    menus={[
                                        'head',  // 标题
                                        'bold',  // 粗体
                                        'fontSize',  // 字号
                                        'fontName',  // 字体
                                        'italic',  // 斜体
                                        'underline',  // 下划线
                                        'strikeThrough',  // 删除线
                                        'foreColor',  // 文字颜色
                                        'backColor',  // 背景颜色
                                        'link',  // 插入链接
                                        'list',  // 列表
                                        'justify',  // 对齐方式
                                        ]}
                                    />
                                </div>
                            </Col>
                        </Row>
                    </Form>
                </Modal>
                {showChooseMerchants?<ChooseMerchants closeChooseMerchants={this.closeChooseMerchants} submitMerchants={this.submitMerchants}/>:''}
            </div>
		)
	}
}

export default connect(state => ({ ...state }))(Form.create()(Registbuyer));